------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3821 $ $Date: 2011-01-24 17:14:50 +0300 (Mon, 24 Jan 2011) $
------------------------------------------------------------------------------
with Qt4.Designer_Custom_Widget_Interfaces.View;
private with Qt4.Designer_Form_Editor_Interfaces;
with Qt4.Objects;
private with Qt4.Objects.Directors;
private with Qt4.Strings;
private with Qt4.Widgets;

package Analog_Clock_Plugin is

   type Analog_Clock_Plugin is
     limited new Qt4.Objects.Q_Object
       and Qt4.Designer_Custom_Widget_Interfaces.Q_Designer_Custom_Widget_Interface
       with private;

private

   type Analog_Clock_Plugin is
     new Qt4.Objects.Directors.Q_Object_Director
       and Qt4.Designer_Custom_Widget_Interfaces.Q_Designer_Custom_Widget_Interface
         with record
      Q_Designer_Custom_Widget_Interface_View :
        Qt4.Designer_Custom_Widget_Interfaces.View.Q_Designer_Custom_Widget_Interface_View
         (Analog_Clock_Plugin'Access);
   end record;
   pragma Q_Export_Plugin (Analog_Clock_Plugin, Constructors.Create);

   overriding function Create_Widget
    (Self   : not null access Analog_Clock_Plugin;
     Parent : access Qt4.Widgets.Q_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   overriding function Include_File
    (Self : not null access Analog_Clock_Plugin)
       return Qt4.Strings.Q_String;

   overriding function Whats_This
    (Self : not null access Analog_Clock_Plugin)
       return Qt4.Strings.Q_String;

   overriding function Tool_Tip
    (Self : not null access Analog_Clock_Plugin)
       return Qt4.Strings.Q_String;

   overriding function Name
    (Self : not null access Analog_Clock_Plugin)
       return Qt4.Strings.Q_String;

   overriding function Group
    (Self : not null access Analog_Clock_Plugin)
       return Qt4.Strings.Q_String;

   overriding function Is_Container
    (Self : not null access Analog_Clock_Plugin)
       return Boolean;

   overriding function Is_Initialized
    (Self : not null access Analog_Clock_Plugin)
       return Boolean;

   overriding procedure Initialize
    (Self        : not null access Analog_Clock_Plugin;
     Form_Editor :
       not null access
         Qt4.Designer_Form_Editor_Interfaces.Q_Designer_Form_Editor_Interface'Class);

   overriding function Dom_Xml
    (Self : not null access Analog_Clock_Plugin)
       return Qt4.Strings.Q_String;

   package Constructors is

      function Create return not null access Analog_Clock_Plugin'Class;

   end Constructors;

end Analog_Clock_Plugin;
