------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3821 $ $Date: 2011-01-24 17:14:50 +0300 (Mon, 24 Jan 2011) $
------------------------------------------------------------------------------
with Qt4.Widgets;
private with Qt4.Paint_Events;
private with Qt4.Widgets.Directors;

package Analog_Clocks is

   type Analog_Clock is limited new Qt4.Widgets.Q_Widget with private;

   type Analog_Clock_Access is access all Analog_Clock'Class;

   package Constructors is

      function Create
       (Parent : access Qt4.Widgets.Q_Widget'Class := null)
          return not null Analog_Clock_Access;

   end Constructors;

private

   type Analog_Clock is
     limited new Qt4.Widgets.Directors.Q_Widget_Director with null record;
   pragma Q_Object (Analog_Clock, "QtAdaAnalogClock");

   overriding procedure Paint_Event
    (Self  : not null access Analog_Clock;
     Event : not null access Qt4.Paint_Events.Q_Paint_Event'Class);

end Analog_Clocks;
