------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 2738 $ $Date: 2008-05-14 09:42:31 +0400 (Wed, 14 May 2008) $
------------------------------------------------------------------------------
with Qt4.Graphics_Items;

with Nodes;

package Edges is

   use type Qt4.Graphics_Items.Graphics_Item_Type;

   type Edge is limited interface and Qt4.Graphics_Items.Q_Graphics_Item;

   --  Public Functions

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Adjust
   --!    <Purpose> XXX Если функция названа Adjust, компилятор ругается
   --! что она не переопределяется.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   procedure Adjust_1 (Self : not null access Edge)
     is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Dest_Node
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Dest_Node (Self : not null access Edge)
     return access Nodes.Node'Class
       is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Source_Node
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Source_Node (Self : not null access Edge)
     return access Nodes.Node'Class
       is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Set_Source_Node
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   procedure Set_Source_Node (Self : not null access Edge;
                              Node : not null        Nodes.Node_Access)
     is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Set_Dest_Node
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   procedure Set_Dest_Node (Self : not null access Edge;
                            Node : not null        Nodes.Node_Access)
     is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Item_Type
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Item_Type (Self : not null access Edge)
     return Qt4.Graphics_Items.Graphics_Item_Type
       is abstract;

   Graphics_Edge_Item : constant Qt4.Graphics_Items.Graphics_Item_Type
     := Qt4.Graphics_Items.Graphics_User_Item; -- + 2;

end Edges;
