------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 2738 $ $Date: 2008-05-14 09:42:31 +0400 (Wed, 14 May 2008) $
------------------------------------------------------------------------------
with Qt4.Graphics_Items;

limited with Edges;

package Nodes is

   type Node is limited interface and Qt4.Graphics_Items.Q_Graphics_Item;

   type Node_Access is access all Node'Class;

   use type Qt4.Graphics_Items.Graphics_Item_Type;

   Graphics_Node_Item : constant Qt4.Graphics_Items.Graphics_Item_Type
     := Qt4.Graphics_Items.Graphics_User_Item - 1;

   not overriding
   procedure Add_Edge (Self : not null access Node;
                       Edge : not null access Edges.Edge'Class)
     is abstract;

   not overriding
   procedure Calculate_Forces (Self : not null access Node)
     is abstract;

   not overriding
   function Advance (Self : not null access Node) return Boolean
     is abstract;

   not overriding
   function Item_Type (Self : not null access Node)
     return Qt4.Graphics_Items.Graphics_Item_Type
       is abstract;

end Nodes;
