------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3665 $ $Date: 2009-12-20 23:37:20 +0300 (Sun, 20 Dec 2009) $
------------------------------------------------------------------------------
with Gtk.Box;
with Gtk.Button;
with Gtk.Enums;
with Gtk.Window;

with Gtkada.Qt_Container;
with Qt4.Push_Buttons.Constructors;
with Qt4.Strings;
with Qt_Ada.Gtk_Application;

procedure Main is
   Main_Window : Gtk.Window.Gtk_Window;
   Box         : Gtk.Box.Gtk_Vbox;
   G_Button    : Gtk.Button.Gtk_Button;
   Q_Button    : Qt4.Push_Buttons.Q_Push_Button_Access;
   Container   : Gtkada.Qt_Container.Qt_Container;

begin
   Qt_Ada.Gtk_Application.Initialize;

   Gtk.Window.Gtk_New (Main_Window, Gtk.Enums.Window_Toplevel);

   Q_Button :=
     Qt4.Push_Buttons.Constructors.Create
      (Qt4.Strings.From_Utf_16 ("My Qt Button"));
   Gtkada.Qt_Container.Gtk_New (Container);
   Gtk.Box.Gtk_New_Vbox (Box);
   Gtk.Button.Gtk_New (G_Button, "My Gtk+ Button");

   Box.Pack_Start (G_Button);
   Box.Pack_Start (Container);
   Main_Window.Add (Box);
   Container.Embed (Q_Button);

   Main_Window.Show_All;
   Qt_Ada.Gtk_Application.Execute;
   Qt_Ada.Gtk_Application.Finalize;
end Main;
