------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3665 $ $Date: 2009-12-20 23:37:20 +0300 (Sun, 20 Dec 2009) $
------------------------------------------------------------------------------
with Gtk.Button;

with Qt4.Push_Buttons.Constructors;
with Qt4.Strings;
with Qt4.Widgets.Constructors;
with Qt4.V_Box_Layouts.Constructors;
with Qt_Ada.Gtk_Application;
with Qt_Ada.Gtk_Containers;

procedure Main is
   Main_Window : Qt4.Widgets.Q_Widget_Access;
   Layout      : Qt4.V_Box_Layouts.Q_V_Box_Layout_Access;
   G_Button    : Gtk.Button.Gtk_Button;
   Q_Button    : Qt4.Push_Buttons.Q_Push_Button_Access;
   Container   : Qt_Ada.Gtk_Containers.Gtk_Container_Access;

begin
   Qt_Ada.Gtk_Application.Initialize;

   Main_Window := Qt4.Widgets.Constructors.Create;
   Layout := Qt4.V_Box_Layouts.Constructors.Create (Main_Window);

   Q_Button :=
     Qt4.Push_Buttons.Constructors.Create
      (Qt4.Strings.From_Utf_16 ("My Qt Button"));
   Container := Qt_Ada.Gtk_Containers.Constructors.Create (Main_Window);
   Layout.Add_Widget (Q_Button);
   Layout.Add_Widget (Container);

   Gtk.Button.Gtk_New (G_Button, "My Gtk+ Button");
   G_Button.Show;
   Container.Embed (G_Button);

   Main_Window.Show;
   Qt_Ada.Gtk_Application.Execute;
   Qt_Ada.Gtk_Application.Finalize;
end Main;
