------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3266 $ $Date: 2009-04-18 13:27:41 +0400 (Sat, 18 Apr 2009) $
------------------------------------------------------------------------------
with Qt4.Main_Windows;
private with Qt4.Abstract_Item_Models;
with Qt4.Abstract_Item_Views;
private with Qt4.Item_Selection_Models;
private with Qt4.Main_Windows.Directors;

package Main_Windows is

   type Main_Window is limited new Qt4.Main_Windows.Q_Main_Window with private;

   type Main_Window_Access is access all Main_Window'Class;

   --  Public slots

   procedure Open_File (Self : not null access Main_Window'Class);
   pragma Q_Slot (Open_File, "openFile()");

   procedure Save_File (Self : not null access Main_Window'Class);
   pragma Q_Slot (Save_File, "saveFile()");

   package Constructors is

      function Create return not null Main_Window_Access;

   end Constructors;

private

   type Main_Window is
     new Qt4.Main_Windows.Directors.Q_Main_Window_Director with
   record
      Model           : Qt4.Abstract_Item_Models.Q_Abstract_Item_Model_Access;
      Pie_Chart       : Qt4.Abstract_Item_Views.Q_Abstract_Item_View_Access;
      Selection_Model :
        Qt4.Item_Selection_Models.Q_Item_Selection_Model_Access;
   end record;

   procedure Setup_Model (Self : not null access Main_Window'Class);

   procedure Setup_Views (Self : not null access Main_Window'Class);

end Main_Windows;
