------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3670 $ $Date: 2009-12-21 09:36:28 +0300 (Mon, 21 Dec 2009) $
------------------------------------------------------------------------------
with Emitters.Moc;
pragma Unreferenced (Emitters.Moc);

package body Emitters is

   ------------
   -- Create --
   ------------

   function Create return not null Emitter_Access is
   begin
      return Self : constant not null Emitter_Access
        := new Emitter
      do
         Qt4.Objects.Directors.Constructors.Initialize (Self);
      end return;
   end Create;

   --------------------
   -- Emit_Completed --
   --------------------

   procedure Emit_Completed (Self : not null access Emitter'Class)
     is separate;

   ---------------------------------
   -- Emit_Progress_Value_Changed --
   ---------------------------------

   procedure Emit_Progress_Value_Changed
    (Self  : not null access Emitter'Class;
     Value : Qt4.Q_Integer)
       is separate;

   ------------------------
   -- Set_Progress_Value --
   ------------------------

   procedure Set_Progress_Value
    (Self  : not null access Emitter'Class;
     Value : Qt4.Q_Integer)
   is
   begin
      Self.Emit_Progress_Value_Changed (Value);
   end Set_Progress_Value;

   -------------------
   -- Set_Completed --
   -------------------

   procedure Set_Completed (Self : not null access Emitter'Class) is
   begin
      Self.Emit_Completed;
   end Set_Completed;

end Emitters;
