------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3670 $ $Date: 2009-12-21 09:36:28 +0300 (Mon, 21 Dec 2009) $
------------------------------------------------------------------------------
with Qt4.Objects;
private with Qt4.Objects.Directors;

package Emitters is

   type Emitter is limited new Qt4.Objects.Q_Object with private;

   type Emitter_Access is access all Emitter'Class;

   procedure Set_Progress_Value
    (Self  : not null access Emitter'Class;
     Value : Qt4.Q_Integer);

   procedure Set_Completed (Self : not null access Emitter'Class);

   function Create return not null Emitter_Access;

private

   type Emitter is
     new Qt4.Objects.Directors.Q_Object_Director with null record;

   procedure Emit_Progress_Value_Changed
    (Self  : not null access Emitter'Class;
     Value : Qt4.Q_Integer);
   pragma Q_Signal (Emit_Progress_Value_Changed);

   procedure Emit_Completed (Self : not null access Emitter'Class);
   pragma Q_Signal (Emit_Completed);

end Emitters;
