------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3670 $ $Date: 2009-12-21 09:36:28 +0300 (Mon, 21 Dec 2009) $
------------------------------------------------------------------------------
with Qt4.Main_Windows;
private with Qt4.Main_Windows.Directors;
private with Qt4.Push_Buttons;
private with Qt4.Progress_Bars;

private with Jobs;

package Main_Windows is

   type Main_Window is limited new Qt4.Main_Windows.Q_Main_Window with private;

   type Main_Window_Access is access all Main_Window'Class;

   function Create return not null Main_Window_Access;

private

   type Main_Window is
     new Qt4.Main_Windows.Directors.Q_Main_Window_Director with record
      Progress_Bar : Qt4.Progress_Bars.Q_Progress_Bar_Access;
      Start_Button : Qt4.Push_Buttons.Q_Push_Button_Access;
      Stop_Button  : Qt4.Push_Buttons.Q_Push_Button_Access;
      Job          : Jobs.Job_Access;
   end record;

   procedure Start (Self : not null access Main_Window'Class);
   pragma Q_Slot (Start);

   procedure Stop (Self : not null access Main_Window'Class);
   pragma Q_Slot (Stop);

   procedure Completed (Self : not null access Main_Window'Class);
   pragma Q_Slot (Completed);

end Main_Windows;
