------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3266 $ $Date: 2009-04-18 13:27:41 +0400 (Sat, 18 Apr 2009) $
------------------------------------------------------------------------------

package body Echo_Plugin is

   ------------------
   -- Constructors --
   ------------------

   package body Constructors is

      function Create return not null Qt4.Objects.Q_Object_Access is
         Result : constant Echo_Plugin_Impl_Access := new Echo_Plugin_Impl;

      begin
         Qt4.Objects.Directors.Constructors.Initialize (Result);

         return Qt4.Objects.Q_Object_Access (Result);
      end Create;

   end Constructors;

   ----------
   -- Echo --
   ----------

   overriding function Echo
    (Self : not null access Echo_Plugin_Impl;
     Item : Qt4.Strings.Q_String)
       return Qt4.Strings.Q_String
   is
      pragma Unreferenced (Self);

   begin
      return Item;
   end Echo;

end Echo_Plugin;
