------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3266 $ $Date: 2009-04-18 13:27:41 +0400 (Sat, 18 Apr 2009) $
------------------------------------------------------------------------------
with Qt4.Strings;
with Qt4.Objects.Directors;

with Echo_Interfaces;

package Echo_Plugin is

   type Echo_Plugin_Impl is limited new Qt4.Objects.Q_Object
     and Echo_Interfaces.Echo_Interface with private;

   type Echo_Plugin_Impl_Access is access all Echo_Plugin_Impl'Class;

   overriding function Echo
    (Self : not null access Echo_Plugin_Impl;
     Item : Qt4.Strings.Q_String)
       return Qt4.Strings.Q_String;

   package Constructors is

      function Create return not null Qt4.Objects.Q_Object_Access;

   end Constructors;

private

   type Echo_Plugin_Impl is new Qt4.Objects.Directors.Q_Object_Director
     and Echo_Interfaces.Echo_Interface with null record;
   pragma Q_Export_Plugin (Echo_Plugin_Impl, Constructors.Create);

end Echo_Plugin;
