------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3266 $ $Date: 2009-04-18 13:27:41 +0400 (Sat, 18 Apr 2009) $
------------------------------------------------------------------------------
private with Qt4.Labels;
private with Qt4.Line_Edits;
with Qt4.Widgets;
private with Qt4.Widgets.Directors;

with Echo_Interfaces;

package Echo_Windows is

   type Echo_Window is limited new Qt4.Widgets.Q_Widget with private;

   type Echo_Window_Access is access all Echo_Window'Class;

   function Create (Echo : Echo_Interfaces.Echo_Interface_Access)
     return not null Echo_Window_Access;

private

   type Echo_Window is
     new Qt4.Widgets.Directors.Q_Widget_Director with record
      Echo      : Echo_Interfaces.Echo_Interface_Access;
      Label     : Qt4.Labels.Q_Label_Access;
      Line_Edit : Qt4.Line_Edits.Q_Line_Edit_Access;
   end record;

   procedure Send_Echo (Self : not null access Echo_Window'Class);
   pragma Q_Slot (Send_Echo, "sendEcho()");

end Echo_Windows;
