------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3266 $ $Date: 2009-04-18 13:27:41 +0400 (Sat, 18 Apr 2009) $
------------------------------------------------------------------------------
private with Qt4.LCD_Numbers;
private with Qt4.Push_Buttons;
private with Qt4.Sliders;
with Qt4.Widgets;
private with Qt4.Widgets.Directors;

package My_Widgets is

   type My_Widget is limited new Qt4.Widgets.Q_Widget with private;

   type My_Widget_Access is access all My_Widget'Class;

   function Create return not null My_Widget_Access;

private

   type My_Widget is new Qt4.Widgets.Directors.Q_Widget_Director with record
      Quit   : Qt4.Push_Buttons.Q_Push_Button_Access;
      LCD    : Qt4.LCD_Numbers.Q_LCD_Number_Access;
      Slider : Qt4.Sliders.Q_Slider_Access;
   end record;

end My_Widgets;
