------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3266 $ $Date: 2009-04-18 13:27:41 +0400 (Sat, 18 Apr 2009) $
------------------------------------------------------------------------------
with Qt4.Widgets;
private with Qt4.Sliders;
private with Qt4.Widgets.Directors;

package LCD_Ranges is

   type LCD_Range is limited new Qt4.Widgets.Q_Widget with private;

   type LCD_Range_Access is access all LCD_Range'Class;

   procedure Set_Value
    (Self  : not null access LCD_Range'Class;
     Value : Qt4.Q_Integer);
   pragma Q_Slot (Set_Value, "setValue(int)");

   function Create return not null LCD_Range_Access;

private

   type LCD_Range is new Qt4.Widgets.Directors.Q_Widget_Director with record
      Slider : Qt4.Sliders.Q_Slider_Access;
   end record;

   procedure Emit_Value_Changed
    (Self      : not null access LCD_Range'Class;
     New_Value : Qt4.Q_Integer);
   pragma Q_Signal (Emit_Value_Changed, "valueChanged(int)");

end LCD_Ranges;
