------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3266 $ $Date: 2009-04-18 13:27:41 +0400 (Sat, 18 Apr 2009) $
------------------------------------------------------------------------------
with Qt4.Widgets;
private with Qt4.Paint_Events;
private with Qt4.Widgets.Directors;

package Cannon_Fields is

   type Cannon_Field is limited new Qt4.Widgets.Q_Widget with private;

   type Cannon_Field_Access is access all Cannon_Field'Class;

   function Angle
    (Self : not null access constant Cannon_Field'Class)
       return Qt4.Q_Integer;

   procedure Set_Angle
    (Self  : not null access Cannon_Field'Class;
     Angle : Qt4.Q_Integer);
   pragma Q_Slot (Set_Angle, "setAngle(int)");

   package Constructors is

      function Create (Parent : access Qt4.Widgets.Q_Widget'Class := null)
        return not null Cannon_Field_Access;

   end Constructors;

private

   type Cannon_Field is new Qt4.Widgets.Directors.Q_Widget_Director with record
      Current_Angle : Qt4.Q_Integer;
   end record;

   overriding procedure Paint_Event
    (Self  : not null access Cannon_Field;
     Event : not null access Qt4.Paint_Events.Q_Paint_Event'Class);

   procedure Emit_Angle_Changed
    (Self       : not null access Cannon_Field'Class;
     New_Angele : Qt4.Q_Integer);
   pragma Q_Signal (Emit_Angle_Changed, "angleChanged(int)");

end Cannon_Fields;
