------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3266 $ $Date: 2009-04-18 13:27:41 +0400 (Sat, 18 Apr 2009) $
------------------------------------------------------------------------------
private with Qt4.Line_Edits;
with Qt4.Widgets;
private with Qt4.Widgets.Directors;

package My_Widgets is

   type My_Widget is limited new Qt4.Widgets.Q_Widget with private;

   type My_Widget_Access is access all My_Widget'Class;

   function Create return not null My_Widget_Access;

private

   type My_Widget is new Qt4.Widgets.Directors.Q_Widget_Director with record
      Access_Line_Edit     : Qt4.Line_Edits.Q_Line_Edit_Access;
      Alignment_Line_Edit  : Qt4.Line_Edits.Q_Line_Edit_Access;
      Echo_Line_Edit       : Qt4.Line_Edits.Q_Line_Edit_Access;
      Input_Mask_Line_Edit : Qt4.Line_Edits.Q_Line_Edit_Access;
      Validator_Line_Edit  : Qt4.Line_Edits.Q_Line_Edit_Access;
     end record;

   procedure Access_Changed
    (Self  : not null access My_Widget'Class;
     Value : Qt4.Q_Integer);
   pragma Q_Slot (Access_Changed, "accessChanged(int)");

   procedure Alignment_Changed
    (Self  : not null access My_Widget'Class;
     Value : Qt4.Q_Integer);
   pragma Q_Slot (Alignment_Changed, "alignmentChanged(int)");

   procedure Echo_Changed
    (Self  : not null access My_Widget'Class;
     Value : Qt4.Q_Integer);
   pragma Q_Slot (Echo_Changed, "echoChanged(int)");

   procedure Input_Mask_Changed
    (Self  : not null access My_Widget'Class;
     Value : Qt4.Q_Integer);
   pragma Q_Slot (Input_Mask_Changed, "inputMaskChanged(int)");

   procedure Validator_Changed
    (Self  : not null access My_Widget'Class;
     Value : Qt4.Q_Integer);
   pragma Q_Slot (Validator_Changed, "validatorChanged(int)");

end My_Widgets;
