//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3863 $ $Date: 2012-04-08 09:49:28 +0400 (Sun, 08 Apr 2012) $
//--------------------------------------------------------------------------//
#include <new>
#include <QByteArray>
#include <QString>
#include "qbytearraywrapper.h"

extern "C"
{

    QByteArray* __QtAda_inititialize_QByteArray(void* storage)
    {
        return new (storage) QByteArray();
    }

    QByteArray* __QtAda_adjust_QByteArray(void* storage, const QByteArray* from)
    {
        return new (storage) QByteArray(*from);
    }

    void __QtAda_finalize_QByteArray(QByteArray *item)
    {
        item->~QByteArray();
    }

    void __QtAda_QByteArray_append_QByteArrayCR(QByteArray* self, const QByteArray* ba)
    {
        self->append(*ba);
    }

    char __QtAda_QByteArray_at_int_Q(QByteArray* self, int i)
    {
        return self->at(i);
    }

    int __QtAda_QByteArray_capacity_Q(const QByteArray* self)
    {
        return self->capacity();
    }

    void __QtAda_QByteArray_chop_int(QByteArray* self, int n)
    {
        self->chop(n);
    }

    void __QtAda_QByteArray_clear(QByteArray* self)
    {
        self->clear();
    }

    unsigned __QtAda_QByteArray_contains_QByteArrayCR_Q(const QByteArray* self, const QByteArray* ba)
    {
        return (unsigned)(self->contains(*ba) == true);
    }

    int __QtAda_QByteArray_count_QByteArrayCR_Q(const QByteArray* self, const QByteArray* ba)
    {
        return self->count(*ba);
    }

    int __QtAda_QByteArray_count_Q(const QByteArray* self)
    {
        return self->count();
    }

    unsigned __QtAda_QByteArray_endsWith_QByteArrayCR_Q(const QByteArray* self, const QByteArray* ba)
    {
        return (unsigned)self->endsWith(*ba);
    }

    int __QtAda_QByteArray_indexOf_QByteArrayCR_int_Q(const QByteArray* self, const QByteArray* ba, int from)
    {
        return self->indexOf(*ba, from);
    }

    void __QtAda_QByteArray_insert_int_QByteArrayCR(QByteArray* self, int index, const QByteArray* ba)
    {
        self->insert(index, *ba);
    }

    unsigned __QtAda_QByteArray_isEmpty_Q(const QByteArray* self)
    {
        return (unsigned)self->isEmpty();
    }

    unsigned __QtAda_QByteArray_isNull_Q(const QByteArray* self)
    {
        return (unsigned)self->isNull();
    }

    int __QtAda_QByteArray_lastIndexOf_QByteArrayCR_int_Q(const QByteArray* self, const QByteArray* ba, int from)
    {
        return self->lastIndexOf(*ba, from);
    }

    void __QtAda_QByteArray_left_int_Q(QByteArray* returns, const QByteArray* self, int length)
    {
        *returns = self->left(length);
    }

    int __QtAda_QByteArray_length_Q(const QByteArray* self)
    {
        return self->length();
    }

    void __QtAda_QByteArray_mid_int_int_Q(QByteArray* returns, const QByteArray* self, int pos, int length)
    {
        *returns = self->mid(pos, length);
    }

    void __QtAda_QByteArray_prepend_QByteArrayCR(QByteArray* self, const QByteArray* ba)
    {
        self->prepend(*ba);
    }

    void __QtAda_QByteArray_remove_int_int(QByteArray* self, int pos, int len)
    {
        self->remove(pos, len);
    }

    void __QtAda_QByteArray_repeated_int_Q(QByteArray* returns, const QByteArray* self, int times)
    {
        *returns = self->repeated(times);
    }

    void __QtAda_QByteArray_replace_int_int_QByteArrayCR(QByteArray* self, int pos, int len, const QByteArray* after)
    {
        self->replace(pos, len, *after);
    }

    void __QtAda_QByteArray_replace_QByteArrayCR_QByteArrayCR(QByteArray* self, const QByteArray* before, const QByteArray* after)
    {
        self->replace(*before, *after);
    }

    void __QtAda_QByteArray_reserve_int(QByteArray* self, int size)
    {
        self->reserve(size);
    }

    void __QtAda_QByteArray_resize_int(QByteArray* self, int size)
    {
        self->resize(size);
    }

    void __QtAda_QByteArray_right_int_Q(QByteArray* returns, const QByteArray* self, int length)
    {
        *returns = self->right(length);
    }

    void __QtAda_QByteArray_simplified_Q(QByteArray* returns, const QByteArray* self)
    {
        *returns = self->simplified();
    }

    int __QtAda_QByteArray_size_Q(const QByteArray* self)
    {
        return self->size();
    }

    void __QtAda_QByteArray_squeeze(QByteArray* self)
    {
        self->squeeze();
    }

    unsigned __QtAda_QByteArray_startsWith_QByteArrayCR_Q(const QByteArray* self, const QByteArray* ba)
    {
        return (unsigned)self->startsWith(*ba);
    }

    void __QtAda_QByteArray_toBase64_Q(QByteArray* returns, const QByteArray* self)
    {
        *returns = self->toBase64();
    }

    void __QtAda_QByteArray_toHex_Q(QByteArray* returns, const QByteArray* self)
    {
        *returns = self->toHex();
    }

    void __QtAda_QByteArray_trimmed(QByteArray* self)
    {
        self->trimmed();
    }

    void __QtAda_QByteArray_truncate_int(QByteArray* self, int pos)
    {
        self->truncate(pos);
    }

    void __QtAda_QByteArray_fromBase64_QByteArrayCR_S(QByteArray* returns, const QByteArray* base64)
    {
        *returns = QByteArray::fromBase64(*base64);
    }

    void __QtAda_QByteArray_fromHex_QByteArrayCR_S(QByteArray* returns, const QByteArray* hexEncoded)
    {
        *returns = QByteArray::fromHex(*hexEncoded);
    }

    unsigned __QtAda_QByteArray_eq_QByteArrayCR_Q(const QByteArray* self, const QByteArray* s)
    {
        return (unsigned)self->operator==(*s);
    }

    unsigned __QtAda_QByteArray_lt_QByteArrayCR_Q(const QByteArray* self, const QByteArray* s)
    {
        return (unsigned)self->operator<(*s);
    }

    unsigned __QtAda_QByteArray_gt_QByteArrayCR_Q(const QByteArray* self, const QByteArray* s)
    {
        return (unsigned)self->operator>(*s);
    }

    unsigned __QtAda_QByteArray_le_QByteArrayCR_Q(const QByteArray* self, const QByteArray* s)
    {
        return (unsigned)self->operator<=(*s);
    }

    unsigned __QtAda_QByteArray_ge_QByteArrayCR_Q(const QByteArray* self, const QByteArray* s)
    {
        return (unsigned)self->operator>=(*s);
    }

};

