//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QDate>
#include <QDateTime>
#include <QString>
#include <QTime>
#include "qdatetimewrapper.h"

extern "C"
{

    QDateTime* __QtAda_inititialize_QDateTime(void* storage)
    {
        return new (storage) QDateTime();
    }

    QDateTime* __QtAda_inititialize_QDateTime_QDateCR(void* storage, const QDate* date)
    {
        return new (storage) QDateTime(*date);
    }

    QDateTime* __QtAda_inititialize_QDateTime_QDateCR_QTimeCR_TimeSpec(void* storage, const QDate* date, const QTime* time, unsigned spec)
    {
        return new (storage) QDateTime(*date, *time, (Qt::TimeSpec)spec);
    }

    QDateTime* __QtAda_adjust_QDateTime(void* storage, const QDateTime* from)
    {
        return new (storage) QDateTime(*from);
    }

    void __QtAda_finalize_QDateTime(QDateTime *item)
    {
        item->~QDateTime();
    }

    void __QtAda_QDateTime_addDays_int_Q(QDateTime* returns, const QDateTime* self, int days)
    {
        *returns = self->addDays(days);
    }

    void __QtAda_QDateTime_addMSecs_qint64_Q(QDateTime* returns, const QDateTime* self, qint64 msecs)
    {
        *returns = self->addMSecs(msecs);
    }

    void __QtAda_QDateTime_addMonths_int_Q(QDateTime* returns, const QDateTime* self, int days)
    {
        *returns = self->addMonths(days);
    }

    void __QtAda_QDateTime_addSecs_int_Q(QDateTime* returns, const QDateTime* self, int days)
    {
        *returns = self->addSecs(days);
    }

    void __QtAda_QDateTime_addYears_int_Q(QDateTime* returns, const QDateTime* self, int days)
    {
        *returns = self->addYears(days);
    }

    void __QtAda_QDateTime_date_Q(QDate* returns, const QDateTime* self)
    {
        *returns = self->date();
    }

    int __QtAda_QDateTime_daysTo_QDateTimeCR_Q(const QDateTime* self, const QDateTime* other)
    {
        return self->daysTo(*other);
    }

    unsigned __QtAda_QDateTime_isNull_Q(const QDateTime* self)
    {
        return (unsigned)self->isNull();
    }

    unsigned __QtAda_QDateTime_isValid_Q(const QDateTime* self)
    {
        return (unsigned)self->isValid();
    }

    int __QtAda_QDateTime_secsTo_QDateTimeCR_Q(const QDateTime* self, const QDateTime* other)
    {
        return self->secsTo(*other);
    }

    void __QtAda_QDateTime_setDate_QDateCR(QDateTime* self, const QDate* date)
    {
        self->setDate(*date);
    }

    void __QtAda_QDateTime_setTime_QTimeCR(QDateTime* self, const QTime* time)
    {
        self->setTime(*time);
    }

    void __QtAda_QDateTime_setTimeSpec_TimeSpec(QDateTime* self, unsigned spec)
    {
        self->setTimeSpec((Qt::TimeSpec)spec);
    }

    void __QtAda_QDateTime_time_Q(QTime* returns, const QDateTime* self)
    {
        *returns = self->time();
    }

    unsigned __QtAda_QDateTime_timeSpec_Q(const QDateTime* self)
    {
        return (unsigned)self->timeSpec();
    }

    void __QtAda_QDateTime_toLocalTime_Q(QDateTime* returns, const QDateTime* self)
    {
        *returns = self->toLocalTime();
    }

    void __QtAda_QDateTime_toString_QStringCR_Q(QString* returns, const QDateTime* self, const QString* format)
    {
        *returns = self->toString(*format);
    }

    void __QtAda_QDateTime_toString_DateFormat_Q(QString* returns, const QDateTime* self, unsigned f)
    {
        *returns = self->toString((Qt::DateFormat)f);
    }

    void __QtAda_QDateTime_toTimeSpec_TimeSpec_Q(QDateTime* returns, const QDateTime* self, unsigned spec)
    {
        *returns = self->toTimeSpec((Qt::TimeSpec)spec);
    }

    void __QtAda_QDateTime_toUTC_Q(QDateTime* returns, const QDateTime* self)
    {
        *returns = self->toUTC();
    }

    void __QtAda_QDateTime_currentDateTime_S(QDateTime* returns)
    {
        *returns = QDateTime::currentDateTime();
    }

    void __QtAda_QDateTime_fromString_QStringCR_DateFormat_S(QDateTime* returns, const QString* s, unsigned f)
    {
        *returns = QDateTime::fromString(*s, (Qt::DateFormat)f);
    }

    void __QtAda_QDateTime_fromString_QStringCR_QStringCR_S(QDateTime* returns, const QString* s, const QString* format)
    {
        *returns = QDateTime::fromString(*s, *format);
    }

    unsigned __QtAda_QDateTime_eq_QDateTimeCR_Q(const QDateTime* self, const QDateTime* other)
    {
        return (unsigned)self->operator==(*other);
    }

    unsigned __QtAda_QDateTime_lt_QDateTimeCR_Q(const QDateTime* self, const QDateTime* other)
    {
        return (unsigned)self->operator<(*other);
    }

    unsigned __QtAda_QDateTime_le_QDateTimeCR_Q(const QDateTime* self, const QDateTime* other)
    {
        return (unsigned)self->operator<=(*other);
    }

    unsigned __QtAda_QDateTime_gt_QDateTimeCR_Q(const QDateTime* self, const QDateTime* other)
    {
        return (unsigned)self->operator>(*other);
    }

    unsigned __QtAda_QDateTime_ge_QDateTimeCR_Q(const QDateTime* self, const QDateTime* other)
    {
        return (unsigned)self->operator>=(*other);
    }

};

