//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3863 $ $Date: 2012-04-08 09:49:28 +0400 (Sun, 08 Apr 2012) $
//--------------------------------------------------------------------------//
#include <new>
#include "qlistofintwrapper.h"

extern "C"
{

    QList<int>* __QtAda_initialize_QListOfint(void* storage)
    {
        return new (storage) QList<int>();
    }

    QList<int>* __QtAda_adjust_QListOfint(void* storage, const QList<int>* from)
    {
        return new (storage) QList<int>(*from);
    }

    void __QtAda_finalize_QListOfint(QList<int>* item)
    {
        item->~QList<int>();
    }

    void __QtAda_QListOfint_append_int(QList<int>* self, int value)
    {
        self->append(value);
    }

    int __QtAda_QListOfint_size(QList<int>* self)
    {
        return self->size();
    }

    int __QtAda_QListOfint_value_int(QList<int>* self, int i)
    {
        return self->value(i);
    }

}
