//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2010-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3863 $ $Date: 2012-04-08 09:49:28 +0400 (Sun, 08 Apr 2012) $
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include <QStringList>
#include "qprocessenvironmentwrapper.h"

extern "C"
{

    QProcessEnvironment* __QtAda_inititialize_QProcessEnvironment(void* storage)
    {
        return new (storage) QProcessEnvironment();
    }

    QProcessEnvironment* __QtAda_adjust_QProcessEnvironment(void* storage, const QProcessEnvironment* from)
    {
        return new (storage) QProcessEnvironment(*from);
    }

    void __QtAda_finalize_QProcessEnvironment(QProcessEnvironment *item)
    {
        item->~QProcessEnvironment();
    }

    void __QtAda_QProcessEnvironment_clear(QProcessEnvironment* self)
    {
        self->clear();
    }

    unsigned __QtAda_QProcessEnvironment_contains_QStringCR_Q(const QProcessEnvironment* self, const QString* name)
    {
        return (unsigned)self->contains(*name);
    }

    void __QtAda_QProcessEnvironment_insert_QStringCR_QStringCR(QProcessEnvironment* self, const QString* name, const QString* value)
    {
        self->insert(*name, *value);
    }

    unsigned __QtAda_QProcessEnvironment_isEmpty_Q(const QProcessEnvironment* self)
    {
        return (unsigned)self->isEmpty();
    }

    void __QtAda_QProcessEnvironment_remove_QStringCR(QProcessEnvironment* self, const QString* name)
    {
        self->remove(*name);
    }

    void __QtAda_QProcessEnvironment_toStringList_Q(QStringList* returns, const QProcessEnvironment* self)
    {
        *returns = self->toStringList();
    }

    void __QtAda_QProcessEnvironment_value_QStringCR_QStringCR_Q(QString* returns, const QProcessEnvironment* self, const QString* name, const QString* defaultValue)
    {
        *returns = self->value(*name, *defaultValue);
    }

    unsigned __QtAda_QProcessEnvironment_eq_QProcessEnvironmentCR_Q(const QProcessEnvironment* self, const QProcessEnvironment* s)
    {
        return (unsigned)self->operator==(*s);
    }

    void __QtAda_QProcessEnvironment_systemEnvironment_S(QProcessEnvironment* returns)
    {
        *returns = QProcessEnvironment::systemEnvironment();
    }

};

