//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QPointF>
#include <QRect>
#include <QRectF>
#include <QSizeF>
#include <QString>
#include "qrectfwrapper.h"

extern "C"
{

    QRectF* __QtAda_inititialize_QRectF(void* storage)
    {
        return new (storage) QRectF();
    }

    QRectF* __QtAda_inititialize_QRectF_QPointFCR_QSizeFCR(void* storage, const QPointF* topleft, const QSizeF* size)
    {
        return new (storage) QRectF(*topleft, *size);
    }

    QRectF* __QtAda_inititialize_QRectF_QPointFCR_QPointFCR(void* storage, const QPointF* topleft, const QPointF* bottomRight)
    {
        return new (storage) QRectF(*topleft, *bottomRight);
    }

    QRectF* __QtAda_inititialize_QRectF_qreal_qreal_qreal_qreal(void* storage, double left, double top, double width, double height)
    {
        return new (storage) QRectF((qreal)left, (qreal)top, (qreal)width, (qreal)height);
    }

    QRectF* __QtAda_inititialize_QRectF_QRectCR(void* storage, const QRect* rect)
    {
        return new (storage) QRectF(*rect);
    }

    QRectF* __QtAda_adjust_QRectF(void* storage, const QRectF* from)
    {
        return new (storage) QRectF(*from);
    }

    void __QtAda_finalize_QRectF(QRectF *item)
    {
        item->~QRectF();
    }

    QRectF* __Qt4Ada_copy_QRectF(const QRectF* cpp_object)
    {
        return new QRectF(*cpp_object);
    }

    void __QtAda_QRectF_adjust_qreal_qreal_qreal_qreal(QRectF* self, double x1, double y1, double x2, double y2)
    {
        self->adjust((qreal)x1, (qreal)y1, (qreal)x2, (qreal)y2);
    }

    void __QtAda_QRectF_adjusted_qreal_qreal_qreal_qreal_Q(QRectF* returns, const QRectF* self, double x1, double y1, double x2, double y2)
    {
        *returns = self->adjusted((qreal)x1, (qreal)y1, (qreal)x2, (qreal)y2);
    }

    double __QtAda_QRectF_bottom_Q(const QRectF* self)
    {
        return (double)self->bottom();
    }

    void __QtAda_QRectF_bottomLeft_Q(QPointF* returns, const QRectF* self)
    {
        *returns = self->bottomLeft();
    }

    void __QtAda_QRectF_bottomRight_Q(QPointF* returns, const QRectF* self)
    {
        *returns = self->bottomRight();
    }

    void __QtAda_QRectF_center_Q(QPointF* returns, const QRectF* self)
    {
        *returns = self->center();
    }

    unsigned __QtAda_QRectF_contains_QPointFCR_Q(const QRectF* self, const QPointF* p)
    {
        return (unsigned)self->contains(*p);
    }

    unsigned __QtAda_QRectF_contains_qreal_qreal_Q(const QRectF* self, double x, double y)
    {
        return (unsigned)self->contains((qreal)x, (qreal)y);
    }

    unsigned __QtAda_QRectF_contains_QRectFCR_Q(const QRectF* self, const QRectF* r)
    {
        return (unsigned)self->contains(*r);
    }

    void __QtAda_QRectF_getCoords_qrealP_qrealP_qrealP_qrealP_Q(const QRectF* self, double* x1, double* y1, double* x2, double* y2)
    {
        self->getCoords(x1, y1, x2, y2);
    }

    void __QtAda_QRectF_getRect_qrealP_qrealP_qrealP_qrealP_Q(const QRectF* self, double* x, double* y, double* w, double* h)
    {
        self->getRect(x, y, w, h);
    }

    double __QtAda_QRectF_height_Q(const QRectF* self)
    {
        return (double)self->height();
    }

    void __QtAda_QRectF_intersected_QRectFCR_Q(QRectF* returns, const QRectF* self, const QRectF* other)
    {
        *returns = self->intersected(*other);
    }

    unsigned __QtAda_QRectF_intersects_QRectFCR_Q(const QRectF* self, const QRectF* r)
    {
        return (unsigned)self->intersects(*r);
    }

    unsigned __QtAda_QRectF_isEmpty_Q(const QRectF* self)
    {
        return (unsigned)self->isEmpty();
    }

    unsigned __QtAda_QRectF_isNull_Q(const QRectF* self)
    {
        return (unsigned)self->isNull();
    }

    unsigned __QtAda_QRectF_isValid_Q(const QRectF* self)
    {
        return (unsigned)self->isValid();
    }

    double __QtAda_QRectF_left_Q(const QRectF* self)
    {
        return (double)self->left();
    }

    void __QtAda_QRectF_moveBottom_qreal(QRectF* self, double pos)
    {
        self->moveBottom((qreal)pos);
    }

    void __QtAda_QRectF_moveBottomLeft_QPointFCR(QRectF* self, const QPointF* p)
    {
        self->moveBottomLeft(*p);
    }

    void __QtAda_QRectF_moveBottomRight_QPointFCR(QRectF* self, const QPointF* p)
    {
        self->moveBottomRight(*p);
    }

    void __QtAda_QRectF_moveCenter_QPointFCR(QRectF* self, const QPointF* p)
    {
        self->moveCenter(*p);
    }

    void __QtAda_QRectF_moveLeft_qreal(QRectF* self, double pos)
    {
        self->moveLeft((qreal)pos);
    }

    void __QtAda_QRectF_moveRight_qreal(QRectF* self, double pos)
    {
        self->moveRight((qreal)pos);
    }

    void __QtAda_QRectF_moveTo_qreal_qreal(QRectF* self, double x, double t)
    {
        self->moveTo((qreal)x, (qreal)t);
    }

    void __QtAda_QRectF_moveTo_QPointFCR(QRectF* self, const QPointF* p)
    {
        self->moveTo(*p);
    }

    void __QtAda_QRectF_moveTop_qreal(QRectF* self, double pos)
    {
        self->moveTop((qreal)pos);
    }

    void __QtAda_QRectF_moveTopLeft_QPointFCR(QRectF* self, const QPointF* p)
    {
        self->moveTopLeft(*p);
    }

    void __QtAda_QRectF_moveTopRight_QPointFCR(QRectF* self, const QPointF* p)
    {
        self->moveTopRight(*p);
    }

    void __QtAda_QRectF_normalized_Q(QRectF* returns, const QRectF* self)
    {
        *returns = self->normalized();
    }

    double __QtAda_QRectF_right_Q(const QRectF* self)
    {
        return (double)self->right();
    }

    void __QtAda_QRectF_setBottom_qreal(QRectF* self, double pos)
    {
        self->setBottom((qreal)pos);
    }

    void __QtAda_QRectF_setBottomLeft_QPointFCR(QRectF* self, const QPointF* p)
    {
        self->setBottomLeft(*p);
    }

    void __QtAda_QRectF_setBottomRight_QPointFCR(QRectF* self, const QPointF* p)
    {
        self->setBottomRight(*p);
    }

    void __QtAda_QRectF_setCoords_qreal_qreal_qreal_qreal(QRectF* self, double x1, double y1, double x2, double y2)
    {
        self->setCoords((qreal)x1, (qreal)y1, (qreal)x2, (qreal)y2);
    }

    void __QtAda_QRectF_setHeight_qreal(QRectF* self, double pos)
    {
        self->setHeight((qreal)pos);
    }

    void __QtAda_QRectF_setLeft_qreal(QRectF* self, double pos)
    {
        self->setLeft((qreal)pos);
    }

    void __QtAda_QRectF_setRect_qreal_qreal_qreal_qreal(QRectF* self, double x, double y, double w, double h)
    {
        self->setRect((qreal)x, (qreal)y, (qreal)w, (qreal)h);
    }

    void __QtAda_QRectF_setRight_qreal(QRectF* self, double pos)
    {
        self->setRight((qreal)pos);
    }

    void __QtAda_QRectF_setSize_QSizeFCR(QRectF* self, const QSizeF* s)
    {
        self->setSize(*s);
    }

    void __QtAda_QRectF_setTop_qreal(QRectF* self, double pos)
    {
        self->setTop((qreal)pos);
    }

    void __QtAda_QRectF_setTopLeft_QPointFCR(QRectF* self, const QPointF* p)
    {
        self->setTopLeft(*p);
    }

    void __QtAda_QRectF_setTopRight_QPointFCR(QRectF* self, const QPointF* p)
    {
        self->setTopRight(*p);
    }

    void __QtAda_QRectF_setWidth_qreal(QRectF* self, double pos)
    {
        self->setWidth((qreal)pos);
    }

    void __QtAda_QRectF_setX_qreal(QRectF* self, double pos)
    {
        self->setX((qreal)pos);
    }

    void __QtAda_QRectF_setY_qreal(QRectF* self, double pos)
    {
        self->setY((qreal)pos);
    }

    void __QtAda_QRectF_size_Q(QSizeF* returns, const QRectF* self)
    {
        *returns = self->size();
    }

    void __QtAda_QRectF_toAlignedRect_Q(QRect* returns, const QRectF* self)
    {
        *returns = self->toAlignedRect();
    }

    void __QtAda_QRectF_toRect_Q(QRect* returns, const QRectF* self)
    {
        *returns = self->toRect();
    }

    double __QtAda_QRectF_top_Q(const QRectF* self)
    {
        return (double)self->top();
    }

    void __QtAda_QRectF_topLeft_Q(QPointF* returns, const QRectF* self)
    {
        *returns = self->topLeft();
    }

    void __QtAda_QRectF_topRight_Q(QPointF* returns, const QRectF* self)
    {
        *returns = self->topRight();
    }

    void __QtAda_QRectF_translate_qreal_qreal(QRectF* self, double dx, double dy)
    {
        self->translate((qreal)dx, (qreal)dy);
    }

    void __QtAda_QRectF_translate_QPointFCR(QRectF* self, const QPointF* p)
    {
        self->translate(*p);
    }

    void __QtAda_QRectF_translated_qreal_qreal_Q(QRectF* returns, const QRectF* self, double dx, double dy)
    {
        *returns = self->translated((qreal)dx, (qreal)dy);
    }

    void __QtAda_QRectF_translated_QPointFCR_Q(QRectF* returns, const QRectF* self, const QPointF* p)
    {
        *returns = self->translated(*p);
    }

    void __QtAda_QRectF_united_QRectFCR_Q(QRectF* returns, const QRectF* self, const QRectF* other)
    {
        *returns = self->united(*other);
    }

    double __QtAda_QRectF_width_Q(const QRectF* self)
    {
        return (double)self->width();
    }

    double __QtAda_QRectF_x_Q(const QRectF* self)
    {
        return (double)self->x();
    }

    double __QtAda_QRectF_y_Q(const QRectF* self)
    {
        return (double)self->y();
    }

    unsigned __QtAda_eq_QRectFCR_QRectFCR(const QRectF* r1, const QRectF* r2)
    {
        return (unsigned)operator==(*r1, *r2);
    }

};

