//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QPoint>
#include <QRect>
#include <QSize>
#include <QString>
#include "qrectwrapper.h"

extern "C"
{

    QRect* __QtAda_inititialize_QRect(void* storage)
    {
        return new (storage) QRect();
    }

    QRect* __QtAda_inititialize_QRect_QPointCR_QPointCR(void* storage, const QPoint* topleft, const QPoint* bottomright)
    {
        return new (storage) QRect(*topleft, *bottomright);
    }

    QRect* __QtAda_inititialize_QRect_QPointCR_QSizeCR(void* storage, const QPoint* topleft, const QSize* size)
    {
        return new (storage) QRect(*topleft, *size);
    }

    QRect* __QtAda_inititialize_QRect_int_int_int_int(void* storage, int left, int top, int width, int height)
    {
        return new (storage) QRect(left, top, width, height);
    }

    QRect* __QtAda_adjust_QRect(void* storage, const QRect* from)
    {
        return new (storage) QRect(*from);
    }

    void __QtAda_finalize_QRect(QRect *item)
    {
        item->~QRect();
    }

    QRect *__Qt4Ada_copy_QRect(const QRect *cpp_object)
    {
        return new QRect (*cpp_object);
    }

    void __QtAda_QRect_adjust_int_int_int_int(QRect* self, int x1, int y1, int x2, int y2)
    {
        self->adjust(x1, y1, x2, y2);
    }

    void __QtAda_QRect_adjusted_int_int_int_int_Q(QRect* returns, const QRect* self, int x1, int y1, int x2, int y2)
    {
        *returns = self->adjusted(x1, y1, x2, y2);
    }

    int __QtAda_QRect_bottom_Q(const QRect* self)
    {
        return self->bottom();
    }

    void __QtAda_QRect_bottomRight_Q(QPoint* returns, const QRect* self)
    {
        *returns = self->bottomRight();
    }

    void __QtAda_QRect_bottomLeft_Q(QPoint* returns, const QRect* self)
    {
        *returns = self->bottomLeft();
    }

    void __QtAda_QRect_center_Q(QPoint* returns, const QRect* self)
    {
        *returns = self->center();
    }

    unsigned __QtAda_QRect_contains_QPointCR_bool_Q(const QRect* self, const QPoint* p, unsigned proper)
    {
        return (unsigned)self->contains(*p, (bool)proper);
    }

    unsigned __QtAda_QRect_contains_int_int_Q(const QRect* self, int x, int y)
    {
        return (unsigned)self->contains(x, y);
    }

    unsigned __QtAda_QRect_contains_int_int_bool_Q(const QRect* self, int x, int y, unsigned proper)
    {
        return (unsigned)self->contains(x, y, (bool)proper);
    }

    unsigned __QtAda_QRect_contains_QRectCR_bool_Q(const QRect* self, const QRect* r, unsigned proper)
    {
        return (unsigned)self->contains(*r, (bool)proper);
    }

    void __QtAda_QRect_getCoords_intP_intP_intP_intP_Q(const QRect* self, int* x1, int* y1, int* x2, int* y2)
    {
        self->getCoords(x1, y1, x2, y2);
    }

    void __QtAda_QRect_getRect_intP_intP_intP_intP_Q(const QRect* self, int* x, int* y, int* w, int* h)
    {
        self->getRect(x, y, w, h);
    }

    int __QtAda_QRect_height_Q(const QRect* self)
    {
        return self->height();
    }

    void __QtAda_QRect_intersected_QRectCR_Q(QRect* returns, const QRect* self, const QRect* other)
    {
        *returns = self->intersected(*other);
    }

    unsigned __QtAda_QRect_intersects_QRectCR_Q(const QRect* self, const QRect* r)
    {
        return (unsigned)self->intersects(*r);
    }

    unsigned __QtAda_QRect_isEmpty_Q(const QRect* self)
    {
        return (unsigned)self->isEmpty();
    }

    unsigned __QtAda_QRect_isNull_Q(const QRect* self)
    {
        return (unsigned)self->isNull();
    }

    unsigned __QtAda_QRect_isValid_Q(const QRect* self)
    {
        return (unsigned)self->isValid();
    }

    int __QtAda_QRect_left_Q(const QRect* self)
    {
        return self->left();
    }

    void __QtAda_QRect_moveBottom_int(QRect* self, int pos)
    {
        self->moveBottom(pos);
    }

    void __QtAda_QRect_moveBottomLeft_QPointCR(QRect* self, const QPoint* p)
    {
        self->moveBottomLeft(*p);
    }

    void __QtAda_QRect_moveBottomRight_QPointCR(QRect* self, const QPoint* p)
    {
        self->moveBottomRight(*p);
    }

    void __QtAda_QRect_moveCenter_QPointCR(QRect* self, const QPoint* p)
    {
        self->moveCenter(*p);
    }

    void __QtAda_QRect_moveLeft_int(QRect* self, int pos)
    {
        self->moveLeft(pos);
    }

    void __QtAda_QRect_moveRight_int(QRect* self, int pos)
    {
        self->moveRight(pos);
    }

    void __QtAda_QRect_moveTo_int_int(QRect* self, int x, int y)
    {
        self->moveTo(x, y);
    }

    void __QtAda_QRect_moveTo_QPointCR(QRect* self, const QPoint* p)
    {
        self->moveTo(*p);
    }

    void __QtAda_QRect_moveTop_int(QRect* self, int pos)
    {
        self->moveTop(pos);
    }

    void __QtAda_QRect_moveTopLeft_QPointCR(QRect* self, const QPoint* p)
    {
        self->moveTopLeft(*p);
    }

    void __QtAda_QRect_moveTopRight_QPointCR(QRect* self, const QPoint* p)
    {
        self->moveTopRight(*p);
    }

    void __QtAda_QRect_normalized_Q(QRect* returns, const QRect* self)
    {
        *returns = self->normalized();
    }

    int __QtAda_QRect_right_Q(const QRect* self)
    {
        return self->right();
    }

    void __QtAda_QRect_setBottom_int(QRect* self, int pos)
    {
        self->setBottom(pos);
    }

    void __QtAda_QRect_setBottomLeft_QPointCR(QRect* self, const QPoint* p)
    {
        self->setBottomLeft(*p);
    }

    void __QtAda_QRect_setBottomRight_QPointCR(QRect* self, const QPoint* p)
    {
        self->setBottomRight(*p);
    }

    void __QtAda_QRect_setCoords_int_int_int_int(QRect* self, int x1, int y1, int x2, int y2)
    {
        self->setCoords(x1, y1, x2, y2);
    }

    void __QtAda_QRect_setHeight_int(QRect* self, int h)
    {
        self->setHeight(h);
    }

    void __QtAda_QRect_setLeft_int(QRect* self, int pos)
    {
        self->setLeft(pos);
    }

    void __QtAda_QRect_setRect_int_int_int_int(QRect* self, int x, int y, int w, int h)
    {
        self->setRect(x, y, w, h);
    }

    void __QtAda_QRect_setRight_int(QRect* self, int pos)
    {
        self->setRight(pos);
    }

    void __QtAda_QRect_setSize_QSizeCR(QRect* self, const QSize* s)
    {
        self->setSize(*s);
    }

    void __QtAda_QRect_setTop_int(QRect* self, int pos)
    {
        self->setTop(pos);
    }

    void __QtAda_QRect_setTopLeft_QPointCR(QRect* self, const QPoint* p)
    {
        self->setTopLeft(*p);
    }

    void __QtAda_QRect_setTopRight_QPointCR(QRect* self, const QPoint* p)
    {
        self->setTopRight(*p);
    }

    void __QtAda_QRect_setWidth_int(QRect* self, int w)
    {
        self->setWidth(w);
    }

    void __QtAda_QRect_setX_int(QRect* self, int x)
    {
        self->setX(x);
    }

    void __QtAda_QRect_setY_int(QRect* self, int y)
    {
        self->setY(y);
    }

    void __QtAda_QRect_size_Q(QSize* returns, const QRect* self)
    {
        *returns = self->size();
    }

    int __QtAda_QRect_top_Q(const QRect* self)
    {
        return self->top();
    }

    void __QtAda_QRect_topLeft_Q(QPoint* returns, const QRect* self)
    {
        *returns = self->topLeft();
    }

    void __QtAda_QRect_topRight_Q(QPoint* returns, const QRect* self)
    {
        *returns = self->topRight();
    }

    void __QtAda_QRect_translate_int_int(QRect* self, int dx, int dy)
    {
        self->translate(dx, dy);
    }

    void __QtAda_QRect_translate_QPointCR(QRect* self, const QPoint* p)
    {
        self->translate(*p);
    }

    void __QtAda_QRect_translated_int_int_Q(QRect* returns, const QRect* self, int dx, int dy)
    {
        *returns = self->translated(dx, dy);
    }

    void __QtAda_QRect_translated_QPointCR_Q(QRect* returns, const QRect* self, const QPoint* p)
    {
        *returns = self->translated(*p);
    }

    void __QtAda_QRect_united_QRectCR_Q(QRect* returns, const QRect* self, const QRect* other)
    {
        *returns = self->united(*other);
    }

    int __QtAda_QRect_width_Q(const QRect* self)
    {
        return self->width();
    }

    int __QtAda_QRect_x_Q(const QRect* self)
    {
        return self->x();
    }

    int __QtAda_QRect_y_Q(const QRect* self)
    {
        return self->y();
    }

    unsigned __QtAda_eq_QRectCR_QRectCR(const QRect* r1, const QRect* r2)
    {
        return (unsigned)operator==(*r1, *r2);
    }

};

