//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QSize>
#include <QSizeF>
#include <QString>
#include "qsizefwrapper.h"

extern "C"
{

    QSizeF* __QtAda_inititialize_QSizeF(void* storage)
    {
        return new (storage) QSizeF();
    }

    QSizeF* __QtAda_inititialize_QSizeF_QSizeCR(void* storage, const QSize* sz)
    {
        return new (storage) QSizeF(*sz);
    }

    QSizeF* __QtAda_inititialize_QSizeF_qreal_qreal(void* storage, double w, double h)
    {
        return new (storage) QSizeF((qreal)w, (qreal)h);
    }

    QSizeF* __QtAda_adjust_QSizeF(void* storage, const QSizeF* from)
    {
        return new (storage) QSizeF(*from);
    }

    void __QtAda_finalize_QSizeF(QSizeF *item)
    {
        item->~QSizeF();
    }

    QSizeF* __Qt4Ada_copy_QSizeF(const QSizeF* cpp_object)
    {
        return new QSizeF(*cpp_object);
    }

    void __QtAda_QSizeF_boundedTo_QSizeFCR_Q(QSizeF* returns, const QSizeF* self, const QSizeF* otherSize)
    {
        *returns = self->boundedTo(*otherSize);
    }

    void __QtAda_QSizeF_expandedTo_QSizeFCR_Q(QSizeF* returns, const QSizeF* self, const QSizeF* otherSize)
    {
        *returns = self->expandedTo(*otherSize);
    }

    double __QtAda_QSizeF_height_Q(const QSizeF* self)
    {
        return (double)self->height();
    }

    unsigned __QtAda_QSizeF_isEmpty_Q(const QSizeF* self)
    {
        return (unsigned)self->isEmpty();
    }

    unsigned __QtAda_QSizeF_isNull_Q(const QSizeF* self)
    {
        return (unsigned)self->isNull();
    }

    unsigned __QtAda_QSizeF_isValid_Q(const QSizeF* self)
    {
        return (unsigned)self->isValid();
    }

    void __QtAda_QSizeF_scale_qreal_qreal_AspectRatioMode(QSizeF* self, double w, double h, unsigned mode)
    {
        self->scale((qreal)w, (qreal)h, (Qt::AspectRatioMode)mode);
    }

    void __QtAda_QSizeF_scale_QSizeFCR_AspectRatioMode(QSizeF* self, const QSizeF* h, unsigned mode)
    {
        self->scale(*h, (Qt::AspectRatioMode)mode);
    }

    void __QtAda_QSizeF_setHeight_qreal(QSizeF* self, double h)
    {
        self->setHeight((qreal)h);
    }

    void __QtAda_QSizeF_setWidth_qreal(QSizeF* self, double w)
    {
        self->setWidth((qreal)w);
    }

    void __QtAda_QSizeF_toSize_Q(QSize* returns, const QSizeF* self)
    {
        *returns = self->toSize();
    }

    void __QtAda_QSizeF_transpose(QSizeF* self)
    {
        self->transpose();
    }

    double __QtAda_QSizeF_width_Q(const QSizeF* self)
    {
        return (double)self->width();
    }

    unsigned __QtAda_eq_QSizeFCR_QSizeFCR(const QSizeF* s1, const QSizeF* s2)
    {
        return (unsigned)operator==(*s1, *s2);
    }

    void __QtAda_plus_QSizeFCR_QSizeFCR(QSizeF* returns, const QSizeF* s1, const QSizeF* s2)
    {
        *returns = operator+(*s1, *s2);
    }

    void __QtAda_minus_QSizeFCR_QSizeFCR(QSizeF* returns, const QSizeF* s1, const QSizeF* s2)
    {
        *returns = operator-(*s1, *s2);
    }

    void __QtAda_multiplication_QSizeFCR_qreal(QSizeF* returns, const QSizeF* s, double factor)
    {
        *returns = operator*(*s, (qreal)factor);
    }

    void __QtAda_multiplication_qreal_QSizeFCR(QSizeF* returns, double factor, const QSizeF* s)
    {
        *returns = operator*((qreal)factor, *s);
    }

    void __QtAda_division_QSizeFCR_qreal(QSizeF* returns, const QSizeF* s, double factor)
    {
        *returns = operator/(*s, (qreal)factor);
    }

};

