//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3863 $ $Date: 2012-04-08 09:49:28 +0400 (Sun, 08 Apr 2012) $
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include <QStringList>
#include "qstringlistwrapper.h"

extern "C"
{

    //  XXX For integration with old code only.
    QStringList* __Qt4Ada_copy_QStringList (const QStringList* cpp_object)
    {
        return new QStringList (*cpp_object);
    }

    QStringList* __QtAda_inititialize_QStringList(void* storage)
    {
        return new (storage) QStringList();
    }

    QStringList* __QtAda_inititialize_QStringList_QStringCR(void* storage, const QString* i)
    {
        return new (storage) QStringList(*i);
    }

    QStringList* __QtAda_adjust_QStringList(void* storage, const QStringList* from)
    {
        return new (storage) QStringList(*from);
    }

    void __QtAda_finalize_QStringList(QStringList *item)
    {
        item->~QStringList();
    }

    void __QtAda_QStringList_append_QStringCR(QStringList* self, const QString* str)
    {
	self->append(*str);
    }

    void __QtAda_QStringList_value_int_Q(QString* returns, const QStringList* self, int i)
    {
	*returns = self->value(i);
    }

    int __QtAda_QStringList_size_Q(const QStringList* self)
    {
	return self->size();
    }

    void __QtAda_QStringList_filter_QStringCR_CaseSensitivity_Q(QStringList* returns, const QStringList* self, const QString* str, unsigned cs)
    {
        *returns = self->filter(*str, (Qt::CaseSensitivity)cs);
    }

    void __QtAda_QStringList_filter_QRegExpCR_Q(QStringList* returns, const QStringList* self, const QRegExp* rx)
    {
        *returns = self->filter(*rx);
    }

    int __QtAda_QStringList_indexOf_QRegExpCR_int_Q(const QStringList* self, const QRegExp* rx, int from)
    {
        return self->indexOf(*rx, from);
    }

    void __QtAda_QStringList_join_QStringCR_Q(QString* returns, const QStringList* self, const QString* sep)
    {
        *returns = self->join(*sep);
    }

    int __QtAda_QStringList_lastIndexOf_QRegExpCR_int_Q(const QStringList* self, const QRegExp* rx, int from)
    {
        return self->lastIndexOf(*rx, from);
    }

    void __QtAda_QStringList_replaceInStrings_QStringCR_QStringCR_CaseSensitivity(QStringList* self, const QString* before, const QString* after, unsigned cs)
    {
        self->replaceInStrings(*before, *after, (Qt::CaseSensitivity)cs);
    }

    void __QtAda_QStringList_replaceInStrings_QRegExpCR_QStringCR(QStringList* self, const QRegExp* rx, const QString* after)
    {
        self->replaceInStrings(*rx, *after);
    }

    void __QtAda_QStringList_removeFirst(QStringList* self)
    {
        self->removeFirst();
    }

    void __QtAda_QStringList_removeLast(QStringList* self)
    {
        self->removeLast();
    }

    void __QtAda_QStringList_sort(QStringList* self)
    {
        self->sort();
    }

    unsigned __QtAda_QStringList_eq_QStringListCR_Q(const QStringList* self, const QStringList* l)
    {
        return (unsigned)self->operator==(*l);
    }

};

