//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3806 $ $Date: 2010-11-30 14:14:00 +0300 (Tue, 30 Nov 2010) $
//--------------------------------------------------------------------------//
#include <QString>

extern "C"
{
    extern QString* __Qt4Ada_copy_QString (const QString*);
    extern QString* __QtAda_inititialize_QString(void*);
    extern QString* __QtAda_inititialize_QString_QChar(void*, QChar*);
    extern QString* __QtAda_adjust_QString(void*, const QString*);
    extern void __QtAda_finalize_QString(QString*);

    extern void __QtAda_QString_append_QStringCR(QString*, const QString*);
    extern void __QtAda_QString_append_QChar(QString*, QChar*);
    extern void __QtAda_QString_at_int_Q(QChar*, const QString*, int);
    extern int __QtAda_QString_capacity_Q(const QString*);
    extern void __QtAda_QString_chop_int(QString*, int);
    extern void __QtAda_QString_clear(QString*);
    extern int __QtAda_QString_compare_QStringCR_Q(const QString*, const QString*);
    extern int __QtAda_QString_compare_QStringCR_CaseSensitivity_Q(const QString*, const QString*, unsigned);
    extern unsigned __QtAda_QString_contains_QStringCR_CaseSensitivity_Q(const QString*, const QString*, unsigned);
    extern unsigned __QtAda_QString_contains_QChar_CaseSensitivity_Q(const QString*, QChar*, unsigned);
    extern unsigned __QtAda_QString_contains_QRegExpCR_Q(const QString*, const QRegExp*);
    extern int __QtAda_QString_count_QStringCR_CaseSensitivity_Q(const QString*, const QString*, unsigned);
    extern int __QtAda_QString_count_QChar_CaseSensitivity_Q(const QString*, QChar*, unsigned);
    extern int __QtAda_QString_count_QRegExpCR_Q(const QString*, const QRegExp*);
    extern int __QtAda_QString_count_Q(const QString*);
    extern unsigned __QtAda_QString_endsWith_QStringCR_CaseSensitivity_Q(const QString*, const QString*, unsigned);
    extern unsigned __QtAda_QString_endsWith_QCharCR_CaseSensitivity_Q(const QString*, const QChar*, unsigned);
    extern void __QtAda_QString_fill_QChar_int(QString*, QChar*, int);
    extern int __QtAda_QString_indexOf_QStringCR_int_CaseSensitivity_Q(const QString*, const QString*, int, unsigned);
    extern int __QtAda_QString_indexOf_QChar_int_CaseSensitivity_Q(const QString*, QChar*, int, unsigned);
    extern int __QtAda_QString_indexOf_QRegExpCR_int_Q(const QString*, const QRegExp*, int);
    extern void __QtAda_QString_insert_int_QStringCR(QString*, int, const QString*);
    extern void __QtAda_QString_insert_int_QChar(QString*, int, QChar*);
    extern unsigned __QtAda_QString_isEmpty_Q(const QString*);
    extern unsigned __QtAda_QString_isNull_Q(const QString*);
    extern int __QtAda_QString_lastIndexOf_QStringCR_int_CaseSensitivity_Q(const QString*, const QString*, int, unsigned);
    extern int __QtAda_QString_lastIndexOf_QChar_int_CaseSensitivity_Q(const QString*, QChar*, int, unsigned);
    extern int __QtAda_QString_lastIndexOf_QRegExpCR_int_Q(const QString*, const QRegExp*, int);
    extern void __QtAda_QString_left_int_Q(QString*, const QString*, int);
    extern void __QtAda_QString_leftJustified_int_QChar_bool_Q(QString*, const QString*, int, QChar*, unsigned);
    extern int __QtAda_QString_length_Q(const QString*);
    extern int __QtAda_QString_localeAwareCompare_QStringCR_Q(const QString*, const QString*);
    extern void __QtAda_QString_mid_int_int_Q(QString*, const QString*, int, int);
    extern void __QtAda_QString_normalized_NormalizationForm_Q(QString*, const QString*, unsigned);
    extern void __QtAda_QString_normalized_NormalizationForm_UnicodeVersion_Q(QString*, const QString*, unsigned, unsigned);
    extern void __QtAda_QString_prepend_QStringCR(QString*, const QString*);
    extern void __QtAda_QString_prepend_QChar(QString*, QChar*);
    extern void __QtAda_QString_remove_int_int(QString*, int, int);
    extern void __QtAda_QString_remove_QStringCR_CaseSensitivity(QString*, const QString*, unsigned);
    extern void __QtAda_QString_remove_QChar_CaseSensitivity(QString*, QChar*, unsigned);
    extern void __QtAda_QString_remove_QRegExpCR(QString*, const QRegExp*);
    extern void __QtAda_QString_replace_int_int_QStringCR(QString*, int, int, const QString*);
    extern void __QtAda_QString_replace_int_int_QChar(QString*, int, int, QChar*);
    extern void __QtAda_QString_replace_QStringCR_QStringCR_CaseSensitivity(QString*, const QString*, const QString*, unsigned);
    extern void __QtAda_QString_replace_QChar_QStringCR_CaseSensitivity(QString*, QChar*, const QString*, unsigned);
    extern void __QtAda_QString_replace_QChar_QChar_CaseSensitivity(QString*, QChar*, QChar*, unsigned);
    extern void __QtAda_QString_replace_QRegExpCR_QStringCR(QString*, const QRegExp*, const QString*);
    extern void __QtAda_QString_reserve_int(QString*, int);
    extern void __QtAda_QString_resize_int(QString*, int);
    extern void __QtAda_QString_right_int_Q(QString*, const QString*, int);
    extern void __QtAda_QString_rightJustified_int_QChar_bool_Q(QString*, const QString*, int, QChar*, unsigned);
    extern void __QtAda_QString_simplified_Q(QString*, const QString*);
    extern int __QtAda_QString_size_Q(const QString*);
    extern void __QtAda_QString_split_QStringCR_SplitBehavior_CaseSensitivity_Q(QStringList*, const QString*, const QString*, unsigned, unsigned);
    extern void __QtAda_QString_split_QCharCR_SplitBehavior_CaseSensitivity_Q(QStringList*, const QString*, const QChar*, unsigned, unsigned);
    extern void __QtAda_QString_split_QRegExpCR_SplitBehavior_Q(QStringList*, const QString*, const QRegExp*, unsigned);
    extern void __QtAda_QString_squeeze(QString*);
    extern unsigned __QtAda_QString_startsWith_QStringCR_CaseSensitivity_Q(const QString*, const QString*, unsigned);
    extern unsigned __QtAda_QString_startsWith_QCharCR_CaseSensitivity_Q(const QString*, const QChar*, unsigned);
    extern void __QtAda_QString_toCaseFolded_Q(QString*, const QString*);
    extern void __QtAda_QString_toLatin1_Q(QByteArray*, const QString*);
    extern void __QtAda_QString_toLocal8Bit_Q(QByteArray*, const QString*);
    extern void __QtAda_QString_toLower_Q(QString*, const QString*);
    extern void __QtAda_QString_toUpper_Q(QString*, const QString*);
    extern void __QtAda_QString_toUtf8_Q(QByteArray*, const QString*);
    extern void __QtAda_QString_trimmed_Q(QString*, const QString*);
    extern void __QtAda_QString_truncate_int(QString*, int);
    extern unsigned __QtAda_QString_eq_QStringCR_Q(const QString*, const QString*);
    extern unsigned __QtAda_QString_lt_QStringCR_Q(const QString*, const QString*);
    extern unsigned __QtAda_QString_gt_QStringCR_Q(const QString*, const QString*);
    extern unsigned __QtAda_QString_le_QStringCR_Q(const QString*, const QString*);
    extern unsigned __QtAda_QString_ge_QStringCR_Q(const QString*, const QString*);
    extern void __QtAda_QString_fromUtf8_S(QString*, const char*);
    extern void __QtAda_QString_fromUtf16_S(QString*, const ushort*);
    extern void __QtAda_QString_fromUcs4_S(QString*, const uint*);
    extern void __QtAda_QString_fromLocal8Bit_S(QString*, const char*);
    extern void __QtAda_QString_toUtf8_Q_1(char*, QString*);
    extern void __QtAda_QString_utf16_Q(ushort*, QString*);
    extern void __QtAda_QString_toUcs4_Q(uint*, QString*);
    extern void __QtAda_QString_toLocal8Bit_Q_1(char*, QString*);
    extern void __QtAda_plus_QStringCR_QStringCR(QString*, QString*, QString*);

};

