------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Child_Events;
limited with Qt4.Events;
with Qt4.Meta_Objects;
with Qt4.Objects.Directors;
limited with Qt4.Timer_Events;

package Qt4.Abstract_Item_Models.Directors is

   type Q_Abstract_Item_Model_Director is
     abstract new Qt4.Objects.Directors.Q_Object_Director
       and Q_Abstract_Item_Model with null record;

   overriding
   function Buddy
    (Self : not null access constant Q_Abstract_Item_Model_Director;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index;

   overriding
   function Can_Fetch_More
    (Self : not null access constant Q_Abstract_Item_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   overriding
   function Column_Count
    (Self : not null access constant Q_Abstract_Item_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Qt4.Q_Integer
         is abstract;

   overriding
   function Drop_Mime_Data
    (Self : not null access Q_Abstract_Item_Model_Director;
     Data : access Qt4.Mime_Datas.Q_Mime_Data'Class;
     Action : Qt4.Drop_Action;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   overriding
   procedure Fetch_More
    (Self : not null access Q_Abstract_Item_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index);

   overriding
   function Has_Children
    (Self : not null access constant Q_Abstract_Item_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean;

   overriding
   function Has_Index
    (Self : not null access constant Q_Abstract_Item_Model_Director;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean;

   overriding
   function Index
    (Self : not null access constant Q_Abstract_Item_Model_Director;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Qt4.Model_Indices.Q_Model_Index
         is abstract;

   overriding
   function Insert_Columns
    (Self : not null access Q_Abstract_Item_Model_Director;
     Column : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean;

   overriding
   function Insert_Rows
    (Self : not null access Q_Abstract_Item_Model_Director;
     Row : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean;

   overriding
   function Mime_Data
    (Self : not null access constant Q_Abstract_Item_Model_Director;
     Indexes : Qt4.Model_Index_Lists.Q_Model_Index_List)
       return access Qt4.Mime_Datas.Q_Mime_Data'Class;

   overriding
   function Mime_Types
    (Self : not null access constant Q_Abstract_Item_Model_Director)
       return Qt4.String_Lists.Q_String_List;

   overriding
   function Parent
    (Self : not null access constant Q_Abstract_Item_Model_Director;
     Child : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index
         is abstract;

   overriding
   function Remove_Columns
    (Self : not null access Q_Abstract_Item_Model_Director;
     Column : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean;

   overriding
   function Remove_Rows
    (Self : not null access Q_Abstract_Item_Model_Director;
     Row : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean;

   overriding
   function Row_Count
    (Self : not null access constant Q_Abstract_Item_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Qt4.Q_Integer
         is abstract;

   overriding
   function Span
    (Self : not null access constant Q_Abstract_Item_Model_Director;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Sizes.Q_Size;

   overriding
   procedure Revert
    (Self : not null access Q_Abstract_Item_Model_Director);

   overriding
   function Submit
    (Self : not null access Q_Abstract_Item_Model_Director)
       return Standard.Boolean;

   not overriding
   procedure Emit_Data_Changed
    (Self : not null access Q_Abstract_Item_Model_Director;
     Top_Left : Qt4.Model_Indices.Q_Model_Index;
     Bottom_Right : Qt4.Model_Indices.Q_Model_Index);

   not overriding
   procedure Emit_Header_Data_Changed
    (Self : not null access Q_Abstract_Item_Model_Director;
     Orientation : Qt4.Orientation;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   not overriding
   procedure Emit_Layout_About_To_Be_Changed
    (Self : not null access Q_Abstract_Item_Model_Director);

   not overriding
   procedure Emit_Layout_Changed
    (Self : not null access Q_Abstract_Item_Model_Director);

   not overriding
   procedure Begin_Insert_Columns
    (Self : not null access Q_Abstract_Item_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   not overriding
   procedure Begin_Insert_Rows
    (Self : not null access Q_Abstract_Item_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   not overriding
   function Begin_Move_Columns
    (Self : not null access Q_Abstract_Item_Model_Director;
     Source_Parent : Qt4.Model_Indices.Q_Model_Index;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : Qt4.Model_Indices.Q_Model_Index;
     Destination_Child : Qt4.Q_Integer)
       return Standard.Boolean;

   not overriding
   function Begin_Move_Rows
    (Self : not null access Q_Abstract_Item_Model_Director;
     Source_Parent : Qt4.Model_Indices.Q_Model_Index;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : Qt4.Model_Indices.Q_Model_Index;
     Destination_Child : Qt4.Q_Integer)
       return Standard.Boolean;

   not overriding
   procedure Begin_Remove_Columns
    (Self : not null access Q_Abstract_Item_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   not overriding
   procedure Begin_Remove_Rows
    (Self : not null access Q_Abstract_Item_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   not overriding
   procedure Begin_Reset_Model
    (Self : not null access Q_Abstract_Item_Model_Director);

   not overriding
   procedure Change_Persistent_Index
    (Self : not null access Q_Abstract_Item_Model_Director;
     From : Qt4.Model_Indices.Q_Model_Index;
     To : Qt4.Model_Indices.Q_Model_Index);

   not overriding
   procedure End_Insert_Columns
    (Self : not null access Q_Abstract_Item_Model_Director);

   not overriding
   procedure End_Insert_Rows
    (Self : not null access Q_Abstract_Item_Model_Director);

   not overriding
   procedure End_Move_Columns
    (Self : not null access Q_Abstract_Item_Model_Director);

   not overriding
   procedure End_Move_Rows
    (Self : not null access Q_Abstract_Item_Model_Director);

   not overriding
   procedure End_Remove_Columns
    (Self : not null access Q_Abstract_Item_Model_Director);

   not overriding
   procedure End_Remove_Rows
    (Self : not null access Q_Abstract_Item_Model_Director);

   not overriding
   procedure End_Reset_Model
    (Self : not null access Q_Abstract_Item_Model_Director);

   not overriding
   procedure Reset
    (Self : not null access Q_Abstract_Item_Model_Director);

   overriding
   procedure Child_Event
    (Self : not null access Q_Abstract_Item_Model_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class);

   overriding
   procedure Custom_Event
    (Self : not null access Q_Abstract_Item_Model_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   procedure Timer_Event
    (Self : not null access Q_Abstract_Item_Model_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class);

   overriding
   function Sender
    (Self : not null access constant Q_Abstract_Item_Model_Director)
       return access Qt4.Objects.Q_Object'Class;

   not overriding
   function Create_Index
    (Self : not null access constant Q_Abstract_Item_Model_Director;
     Row  : Qt4.Q_Integer;
     Col  : Qt4.Q_Integer;
     Ptr  : System.Address := System.Null_Address)
       return Qt4.Model_Indices.Q_Model_Index;

   overriding
   function Data
    (Self  : not null access Q_Abstract_Item_Model_Director;
     Index : Qt4.Model_Indices.Q_Model_Index;
     Role  : Item_Data_Role := Display_Role)
       return Qt4.Variants.Q_Variant
         is abstract;
   --  GNAT GPL 2010: compiler generates wrong code when this declaration is
   --  absent.

   overriding
   function Flags
    (Self  : not null access constant Q_Abstract_Item_Model_Director;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Item_Flags;

   overriding
   function Header_Data
    (Self        : not null access Q_Abstract_Item_Model_Director;
     Section     : Qt4.Q_Integer;
     Orientation : Qt4.Orientations;
     Role        : Qt4.Item_Data_Role := Qt4.Display_Role)
       return Qt4.Variants.Q_Variant;

   overriding
   function Set_Data
    (Self  : not null access Q_Abstract_Item_Model_Director;
     Index : Qt4.Model_Indices.Q_Model_Index;
     Value : Qt4.Variants.Q_Variant;
     Role  : Qt4.Item_Data_Role := Edit_Role)
       return Boolean;

   overriding
   function Set_Header_Data
    (Self    : not null access Q_Abstract_Item_Model_Director;
     Section : Qt4.Q_Integer;
     Orient  : Qt4.Orientation;
     Value   : Qt4.Variants.Q_Variant;
     Role    : Qt4.Item_Data_Role := Qt4.Edit_Role)
       return Boolean;

   package Constructors is

      procedure Initialize
       (Self   : not null access Q_Abstract_Item_Model_Director'Class;
        Parent : access Qt4.Objects.Q_Object'Class := null);
      --  Creates C++ director and associate it with the specified object.

   end Constructors;

   Static_Meta_Object : access constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C, Static_Meta_Object,
                  "__Qt4Ada_QAbstractItemModel_staticMetaObject");

end Qt4.Abstract_Item_Models.Directors;
