------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Child_Events;
limited with Qt4.Events;
with Qt4.Meta_Objects;
with Qt4.Objects.Directors;
limited with Qt4.Timer_Events;

package Qt4.IO_Devices.Directors is

   type Q_IO_Device_Director is
     abstract new Qt4.Objects.Directors.Q_Object_Director
       and Q_IO_Device with null record;

   overriding
   function At_End
    (Self : not null access constant Q_IO_Device_Director)
       return Standard.Boolean;

   overriding
   function Bytes_Available
    (Self : not null access constant Q_IO_Device_Director)
       return Qt4.Q_Integer_64;

   overriding
   function Bytes_To_Write
    (Self : not null access constant Q_IO_Device_Director)
       return Qt4.Q_Integer_64;

   overriding
   function Can_Read_Line
    (Self : not null access constant Q_IO_Device_Director)
       return Standard.Boolean;

   overriding
   procedure Close
    (Self : not null access Q_IO_Device_Director);

   overriding
   function Is_Sequential
    (Self : not null access constant Q_IO_Device_Director)
       return Standard.Boolean;

   overriding
   function Pos
    (Self : not null access constant Q_IO_Device_Director)
       return Qt4.Q_Integer_64;

   overriding
   function Reset
    (Self : not null access Q_IO_Device_Director)
       return Standard.Boolean;

   overriding
   function Seek
    (Self : not null access Q_IO_Device_Director;
     Pos : Qt4.Q_Integer_64)
       return Standard.Boolean;

   overriding
   function Size
    (Self : not null access constant Q_IO_Device_Director)
       return Qt4.Q_Integer_64;

   not overriding
   procedure Emit_About_To_Close
    (Self : not null access Q_IO_Device_Director);

   not overriding
   procedure Emit_Bytes_Written
    (Self : not null access Q_IO_Device_Director;
     Bytes : Qt4.Q_Integer_64);

   not overriding
   procedure Emit_Read_Channel_Finished
    (Self : not null access Q_IO_Device_Director);

   not overriding
   procedure Emit_Ready_Read
    (Self : not null access Q_IO_Device_Director);

   not overriding
   procedure Set_Error_String
    (Self : not null access Q_IO_Device_Director;
     Error_String : Qt4.Strings.Q_String);

   overriding
   procedure Child_Event
    (Self : not null access Q_IO_Device_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class);

   overriding
   procedure Custom_Event
    (Self : not null access Q_IO_Device_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   procedure Timer_Event
    (Self : not null access Q_IO_Device_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class);

   overriding
   function Sender
    (Self : not null access constant Q_IO_Device_Director)
       return access Qt4.Objects.Q_Object'Class;

   Static_Meta_Object : access constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C, Static_Meta_Object,
                  "__Qt4Ada_QIODevice_staticMetaObject");

end Qt4.IO_Devices.Directors;
