------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3764 $ $Date: 2010-10-23 23:13:39 +0400 (Sat, 23 Oct 2010) $
------------------------------------------------------------------------------
private with Ada.Finalization;
private with Qt_Ada.Internals.Value_Class_Sizes;
with System;

package Qt4.List_Of_Q_Byte_Arrays is

   type Q_List_Of_Q_Byte_Array is tagged private;

   package Internals is

      type QListOfQByteArray is private;

      type QListOfQByteArray_Access is access all QListOfQByteArray;
      pragma Convention (C, QListOfQByteArray_Access);

      function QListOfQByteArray_View
       (Item : Q_List_Of_Q_Byte_Array'Class)
          return QListOfQByteArray_Access;
      pragma Inline (QListOfQByteArray_View);

      function To_Pointer
       (Address : System.Address)
          return QListOfQByteArray_Access;
      pragma Inline (To_Pointer);

      function To_Address
       (Pointer : QListOfQByteArray_Access)
          return System.Address;
      pragma Inline (To_Address);

      function Create_Wrapper
       (Item : Internals.QListOfQByteArray_Access)
          return Q_List_Of_Q_Byte_Array;

   private

      type QListOfQByteArray is record
         Placeholder : Interfaces.C.char_array (1 .. Qt_Ada.Internals.Value_Class_Sizes.QListOfQByteArray_C_Size_Of);
      end record;
      pragma Convention (C, QListOfQByteArray);

   end Internals;

private

   type Q_List_Of_Q_Byte_Array is new Ada.Finalization.Controlled with record
      Storage : aliased Internals.QListOfQByteArray;
      Object  : Internals.QListOfQByteArray_Access := null;
      Wrapper : Boolean := False;
   end record;

   overriding
   procedure Adjust (Self : in out Q_List_Of_Q_Byte_Array);

   overriding
   procedure Finalize (Self : in out Q_List_Of_Q_Byte_Array);

   overriding
   procedure Initialize (Self : in out Q_List_Of_Q_Byte_Array);

end Qt4.List_Of_Q_Byte_Arrays;
