------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
private with Ada.Finalization;

with Qt4.Objects;
private with Qt_Ada.Internals.Value_Class_Sizes;

package Qt4.List_Of_Q_Objects is

   type Q_List_Of_Q_Object is tagged private;

   function Size (Self : Q_List_Of_Q_Object'Class) return Qt4.Q_Integer;

   function Value
    (Self  : Q_List_Of_Q_Object'Class;
     Index : Qt4.Q_Integer)
       return access Qt4.Objects.Q_Object'Class;

   package Internals is

      type QListOfQObject is private;

      type QListOfQObject_Access is access all QListOfQObject;
      pragma Convention (C, QListOfQObject_Access);

      function QListOfQObject_View
       (Item : Q_List_Of_Q_Object'Class) return QListOfQObject_Access;
      pragma Inline (QListOfQObject_View);

   private

      type QListOfQObject is record
         Placeholder : Interfaces.C.char_array (1 .. Qt_Ada.Internals.Value_Class_Sizes.QListOfQObject_C_Size_Of);
      end record;
      pragma Convention (C, QListOfQObject);

   end Internals;

private

   type Q_List_Of_Q_Object is new Ada.Finalization.Controlled with record
      Storage : aliased Internals.QListOfQObject;
      Object  : Internals.QListOfQObject_Access := null;
      Wrapper : Boolean := False;
   end record;

   overriding
   procedure Adjust (Self : in out Q_List_Of_Q_Object);

   overriding
   procedure Finalize (Self : in out Q_List_Of_Q_Object);

   overriding
   procedure Initialize (Self : in out Q_List_Of_Q_Object);

end Qt4.List_Of_Q_Objects;
