------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 2932 $ $Date: 2008-12-05 20:22:47 +0300 (Fri, 05 Dec 2008) $
------------------------------------------------------------------------------

package Qt4.Meta_Types is

   type Meta_Type_Type is new Interfaces.C.unsigned;

   C_Void              : constant Meta_Type_Type := 0;
   C_Bool              : constant Meta_Type_Type := 1;
   C_Int               : constant Meta_Type_Type := 2;
   C_U_Int             : constant Meta_Type_Type := 3;
   C_Long_Long         : constant Meta_Type_Type := 4;
   C_U_Long_Long       : constant Meta_Type_Type := 5;
   C_Double            : constant Meta_Type_Type := 6;
   Q_Char              : constant Meta_Type_Type := 7;
   Q_Variant_Map       : constant Meta_Type_Type := 8;
   Q_Variant_List      : constant Meta_Type_Type := 9;
   Q_String            : constant Meta_Type_Type := 10;
   Q_String_List       : constant Meta_Type_Type := 11;
   Q_Byte_Array        : constant Meta_Type_Type := 12;
   Q_Bit_Array         : constant Meta_Type_Type := 13;
   Q_Date              : constant Meta_Type_Type := 14;
   Q_Time              : constant Meta_Type_Type := 15;
   Q_Date_Time         : constant Meta_Type_Type := 16;
   Q_Url               : constant Meta_Type_Type := 17;
   Q_Locale            : constant Meta_Type_Type := 18;
   Q_Rect              : constant Meta_Type_Type := 19;
   Q_Rect_F            : constant Meta_Type_Type := 20;
   Q_Size              : constant Meta_Type_Type := 21;
   Q_Size_F            : constant Meta_Type_Type := 22;
   Q_Line              : constant Meta_Type_Type := 23;
   Q_Line_F            : constant Meta_Type_Type := 24;
   Q_Point             : constant Meta_Type_Type := 25;
   Q_Point_F           : constant Meta_Type_Type := 26;
   Q_Reg_Exp           : constant Meta_Type_Type := 27;
   Last_Core_Type      : constant Meta_Type_Type := 27; -- QRegExp
   First_Gui_Type      : constant Meta_Type_Type := 63; -- QColorGroup
   Q_Font              : constant Meta_Type_Type := 64;
   Q_Pixmap            : constant Meta_Type_Type := 65;
   Q_Brush             : constant Meta_Type_Type := 66;
   Q_Color             : constant Meta_Type_Type := 67;
   Q_Palette           : constant Meta_Type_Type := 68;
   Q_Icon              : constant Meta_Type_Type := 69;
   Q_Image             : constant Meta_Type_Type := 70;
   Q_Polygon           : constant Meta_Type_Type := 71;
   Q_Region            : constant Meta_Type_Type := 72;
   Q_Bitmap            : constant Meta_Type_Type := 73;
   Q_Cursor            : constant Meta_Type_Type := 74;
   Q_Size_Policy       : constant Meta_Type_Type := 75;
   Q_Key_Sequence      : constant Meta_Type_Type := 76;
   Q_Pen               : constant Meta_Type_Type := 77;
   Q_Text_Length       : constant Meta_Type_Type := 78;
   Q_Text_Format       : constant Meta_Type_Type := 79;
   Q_Matrix            : constant Meta_Type_Type := 80;
   Last_Gui_Type       : constant Meta_Type_Type := 80; -- QMatrix
   First_Core_Ext_Type : constant Meta_Type_Type := 128; -- VoidStar
   C_Void_Star         : constant Meta_Type_Type := 128;
   C_Long              : constant Meta_Type_Type := 129;
   C_Short             : constant Meta_Type_Type := 130;
   C_Char              : constant Meta_Type_Type := 131;
   C_U_Long            : constant Meta_Type_Type := 132;
   C_U_Short           : constant Meta_Type_Type := 133;
   C_U_Char            : constant Meta_Type_Type := 134;
   C_Float             : constant Meta_Type_Type := 135;
   Q_Object_Star       : constant Meta_Type_Type := 136;
   Q_Widget_Star       : constant Meta_Type_Type := 137;
   Last_Core_Ext_Type  : constant Meta_Type_Type := 137; -- QWidgetStar
   User                : constant Meta_Type_Type := 256;

end Qt4.Meta_Types;
