------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Events;
with Qt4.Meta_Objects;
with Qt4.Strings;
with Qt4.Variants;
with Qt_Ada.Generic_Object_Pointers;
with Qt_Ada.Internals.Objects;
pragma Elaborate (Qt_Ada.Generic_Object_Pointers);

package Qt4.Objects is

   type Q_Object is limited interface
     and Qt_Ada.Internals.Objects.Q_Object_Base;

   type Q_Object_Access is
     access all Q_Object'Class;
   for Q_Object_Access'Storage_Size use 0;

   type Q_Object_Pointer is tagged;

   function Block_Signals
    (Self : not null access Q_Object'Class;
     B : Standard.Boolean)
       return Standard.Boolean;

   not overriding
   function Event
    (Self : not null access Q_Object;
     E : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean
         is abstract;

   not overriding
   function Event_Filter
    (Self : not null access Q_Object;
     Watched : not null access Qt4.Objects.Q_Object'Class;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean
         is abstract;

   procedure Install_Event_Filter
    (Self : not null access Q_Object'Class;
     Filter_Obj : not null access Qt4.Objects.Q_Object'Class);

   function Is_Widget_Type
    (Self : not null access constant Q_Object'Class)
       return Standard.Boolean;

   function Object_Name
    (Self : not null access constant Q_Object'Class)
       return Qt4.Strings.Q_String;

   function Parent
    (Self : not null access constant Q_Object'Class)
       return not null access Qt4.Objects.Q_Object'Class;

   function Property
    (Self : not null access constant Q_Object'Class;
     Name : String)
       return Qt4.Variants.Q_Variant;

   procedure Remove_Event_Filter
    (Self : not null access Q_Object'Class;
     Obj : not null access Qt4.Objects.Q_Object'Class);

   procedure Set_Object_Name
    (Self : not null access Q_Object'Class;
     Name : Qt4.Strings.Q_String);

   procedure Set_Parent
    (Self : not null access Q_Object'Class;
     Parent : not null access Qt4.Objects.Q_Object'Class);

   procedure Set_Property
    (Self : not null access Q_Object'Class;
     Name : String;
     Value : Qt4.Variants.Q_Variant);

   function Signals_Blocked
    (Self : not null access constant Q_Object'Class)
       return Standard.Boolean;

   procedure Delete_Later
    (Self : not null access Q_Object'Class);

   function Meta_Object (Self : not null access Q_Object'Class)
     return not null access constant Qt4.Meta_Objects.Q_Meta_Object;

   procedure Connect
    (Self     : not null access Q_Object'Class;
     Sender   : not null access Q_Object'Class;
     Signal   : Qt4.Signal_Name;
     Method   : Qt4.Slot_Name;
     The_Type : Qt4.Connection_Type := Qt4.Auto_Connection);

   procedure Connect
    (Self     : not null access Q_Object'Class;
     Sender   : not null access Q_Object'Class;
     Signal   : Qt4.Signal_Name;
     Method   : Qt4.Signal_Name;
     The_Type : Qt4.Connection_Type := Qt4.Auto_Connection);

   procedure Connect
    (Sender   : not null access Q_Object'Class;
     Signal   : Qt4.Signal_Name;
     Receiver : not null access Q_Object'Class;
     Method   : Qt4.Slot_Name;
     The_Type : Qt4.Connection_Type := Qt4.Auto_Connection);

   procedure Connect
    (Sender   : not null access Q_Object'Class;
     Signal   : Qt4.Signal_Name;
     Receiver : not null access Q_Object'Class;
     Method   : Qt4.Signal_Name;
     The_Type : Qt4.Connection_Type := Qt4.Auto_Connection);

   function Start_Timer
    (Self     : not null access Q_Object'Class;
     Interval : Duration)
       return Qt4.Q_Integer;

   procedure Kill_Timer
    (Self : not null access Q_Object'Class;
     Id   : Qt4.Q_Integer);

   function Find_Child
    (Self : not null access constant Q_Object'Class;
     Name : Qt4.Strings.Q_String := Qt4.Strings.Create)
       return access Qt4.Objects.Q_Object'Class;

   package Q_Object_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Object, Q_Object_Access);

   type Q_Object_Pointer is
     new Q_Object_Pointers.Q_Pointer with null record;

end Qt4.Objects;
