------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 2924 $ $Date: 2008-12-04 00:20:07 +0300 (Thu, 04 Dec 2008) $
------------------------------------------------------------------------------

package Qt4.Settings.Constructors is

   function Create
    (Organization : Qt4.Strings.Q_String;
     Application  : Qt4.Strings.Q_String := Qt4.Strings.Create;
     Parent       : access Qt4.Objects.Q_Object'Class := null)
       return not null Qt4.Settings.Q_Settings_Access;
   --  Returns new QSettings object.

   function Create
    (Scope        : Qt4.Settings.Settings_Scope;
     Organization : Qt4.Strings.Q_String;
     Application  : Qt4.Strings.Q_String := Qt4.Strings.Create;
     Parent       : access Qt4.Objects.Q_Object'Class := null)
       return not null Qt4.Settings.Q_Settings_Access;
   --  Returns new QSettings object.

   function Create
    (Format       : Qt4.Settings.Settings_Format;
     Scope        : Qt4.Settings.Settings_Scope;
     Organization : Qt4.Strings.Q_String;
     Application  : Qt4.Strings.Q_String := Qt4.Strings.Create;
     Parent       : access Qt4.Objects.Q_Object'Class := null)
       return not null Qt4.Settings.Q_Settings_Access;
   --  Returns new QSettings object.

   function Create
    (File_Name : Qt4.Strings.Q_String;
     Format    : Qt4.Settings.Settings_Format;
     Parent    : access Qt4.Objects.Q_Object'Class := null)
       return not null Qt4.Settings.Q_Settings_Access;
   --  Returns new QSettings object.

   function Create (Parent : access Qt4.Objects.Q_Object'Class := null)
     return not null Qt4.Settings.Q_Settings_Access;
   --  Returns new QSettings object.

end Qt4.Settings.Constructors;
