------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3348 $ $Date: 2009-05-08 21:33:55 +0400 (Fri, 08 May 2009) $
------------------------------------------------------------------------------

package Qt4_Entities.Constructors is

   pragma Preelaborate;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Initialize_Container
   --!    <Purpose> Производит инициализацию в режиме контейнера.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   procedure Initialize_Container
    (Self       : not null access Entity'Class;
     Cpp_Object : not null access Cpp_Class);

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Initialize_Container
   --!    <Purpose> Производит инициализацию в режиме контейнера.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   procedure Initialize_Container
    (Self       : not null access Limited_Entity'Class;
     Cpp_Object : not null access Cpp_Class);

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Initialize_Director
   --!    <Purpose> Производит инициализацию в режиме директора.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   procedure Initialize_Director
    (Self       : not null access Entity'Class;
     Cpp_Object : not null access Cpp_Class);

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Initialize_Director
   --!    <Purpose> Производит инициализацию в режиме директора.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   procedure Initialize_Director
    (Self       : not null access Limited_Entity'Class;
     Cpp_Object : not null access Cpp_Class);

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Initialize_Wrapper
   --!    <Purpose> Производит инициализацию в режиме обёртки.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   procedure Initialize_Wrapper
    (Self       : not null access Entity'Class;
     Cpp_Object : not null access Cpp_Class);

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Initialize_Wrapper
   --!    <Purpose> Производит инициализацию в режиме обёртки.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   procedure Initialize_Wrapper
    (Self       : not null access Limited_Entity'Class;
     Cpp_Object : not null access Cpp_Class);

end Qt4_Entities.Constructors;
