//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2733 $ $Date: 2008-05-14 08:54:18 +0400 (Wed, 14 May 2008) $
//----------------------------------------------------------------------------
#ifndef __QT4ADADIRECTORS_H__
#define __QT4ADADIRECTORS_H__

//
//  Объявления типов, соответствующих Ada типам Entity и LimitedEntity.
//

typedef void Entity;
typedef void LimitedEntity;

//
//  Объявления функций уничтожения Ada объектов, импортируемые из Ada.
//

extern "C" {

    extern void __Qt4Ada_free_Entity(Entity *);
    extern void __Qt4Ada_free_LimitedEntity(LimitedEntity *);

};

//
//  Базовый класс-директор для Entity.
//

class Qt4AdaEntityDirector {
protected:
    Qt4AdaEntityDirector(Entity *);
    ~Qt4AdaEntityDirector();

protected:
    Entity *ada_object;
};

//
//  Базовый класс-директор для Limited_Entity.
//

class Qt4AdaLimitedEntityDirector {
protected:
    Qt4AdaLimitedEntityDirector(LimitedEntity*, bool);
    ~Qt4AdaLimitedEntityDirector();

protected:
    LimitedEntity *ada_object;
    bool          free_ada_object;
    //  If true then free associated Ada object at the destruction.

private:
    Qt4AdaLimitedEntityDirector(const Qt4AdaLimitedEntityDirector&);
};

#endif // __QT4ADADIRECTORS_H__
