------------------------------------------------------------------------------
--                                                                          --
--                 An Ada2005 binding to the Qt C++ library                 --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3131 $ $Date: 2009-02-22 19:07:52 +0300 (Sun, 22 Feb 2009) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

procedure Qt_Ada.Object_Unchecked_Deallocation (Item : in out Object_Access) is

   procedure delete_QObject
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, delete_QObject, "__Qt4Ada_delete_QObject");

begin
   delete_QObject (Item.QObject_View);
   Item := null;
end Qt_Ada.Object_Unchecked_Deallocation;
