//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 3134 $ $Date: 2009-02-23 10:44:53 +0300 (Mon, 23 Feb 2009) $
//----------------------------------------------------------------------------

#include "qtadacoreapplication.h"

QtAdaCoreApplication::QtAdaCoreApplication(int& argc, char** argv) :
    QCoreApplication(argc, argv)
{
}

bool QtAdaCoreApplication::notify(QObject* receiver, QEvent* event)
{
    return __QtAdaCoreApplication_ada_notify(this, receiver, event);
}

extern "C" {

    //  XXX GNAT BEGIN
    //  Для подстановка параметров командной строки используются переменные,
    //  сохраняемые бибилотекой времени выполнения компилятора GNAT.

    extern int gnat_argc;
    extern char **gnat_argv;

    //  XXX GNAT END

    void __QtAda_new_QtAdaCoreApplication()
    {
        new QtAdaCoreApplication(gnat_argc, gnat_argv);
    }

    int __QtAdaCoreApplication_cpp_notify(QtAdaCoreApplication* self, QObject* receiver, QEvent* event)
    {
        return self->QCoreApplication::notify(receiver, event);
    }
}
