//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QByteArray>
#include <QString>
#include <QStringList>
#include <QUrl>
#include "qurlwrapper.h"

extern "C"
{

    QUrl* __QtAda_inititialize_QUrl(void* storage)
    {
        return new (storage) QUrl();
    }

    QUrl* __QtAda_inititialize_QUrl_QStringCR(void* storage, const QString* url)
    {
        return new (storage) QUrl(*url);
    }

    QUrl* __QtAda_inititialize_QUrl_QStringCR_ParsingMode(void* storage, const QString* url, unsigned mode)
    {
        return new (storage) QUrl(*url, (QUrl::ParsingMode)mode);
    }

    QUrl* __QtAda_adjust_QUrl(void* storage, const QUrl* from)
    {
        return new (storage) QUrl(*from);
    }

    void __QtAda_finalize_QUrl(QUrl *item)
    {
        item->~QUrl();
    }

    void __QtAda_QUrl_addEncodedQueryItem_QByteArrayCR_QByteArrayCR(QUrl* self, const QByteArray* key, const QByteArray* value)
    {
        self->addEncodedQueryItem(*key, *value);
    }

    void __QtAda_QUrl_addQueryItem_QStringCR_QStringCR(QUrl* self, const QString* key, const QString* value)
    {
        self->addQueryItem(*key, *value);
    }

    void __QtAda_QUrl_allQueryItemValues_QStringCR_Q(QStringList* returns, const QUrl* self, const QString* key)
    {
        *returns = self->allQueryItemValues(*key);
    }

    void __QtAda_QUrl_authority_Q(QString* returns, const QUrl* self)
    {
        *returns = self->authority();
    }

    void __QtAda_QUrl_clear(QUrl* self)
    {
        self->clear();
    }

    void __QtAda_QUrl_encodedFragment_Q(QByteArray* returns, const QUrl* self)
    {
        *returns = self->encodedFragment();
    }

    void __QtAda_QUrl_encodedHost_Q(QByteArray* returns, const QUrl* self)
    {
        *returns = self->encodedHost();
    }

    void __QtAda_QUrl_encodedPassword_Q(QByteArray* returns, const QUrl* self)
    {
        *returns = self->encodedPassword();
    }

    void __QtAda_QUrl_encodedPath_Q(QByteArray* returns, const QUrl* self)
    {
        *returns = self->encodedPath();
    }

    void __QtAda_QUrl_encodedQuery_Q(QByteArray* returns, const QUrl* self)
    {
        *returns = self->encodedQuery();
    }

    void __QtAda_QUrl_encodedQueryItemValue_QByteArrayCR_Q(QByteArray* returns, const QUrl* self, const QByteArray* key)
    {
        *returns = self->encodedQueryItemValue(*key);
    }

    void __QtAda_QUrl_encodedUserName_Q(QByteArray* returns, const QUrl* self)
    {
        *returns = self->encodedUserName();
    }

    void __QtAda_QUrl_errorString_Q(QString* returns, const QUrl* self)
    {
        *returns = self->errorString();
    }

    void __QtAda_QUrl_fragment_Q(QString* returns, const QUrl* self)
    {
        *returns = self->fragment();
    }

    unsigned __QtAda_QUrl_hasEncodedQueryItem_QByteArrayCR_Q(const QUrl* self, const QByteArray* key)
    {
        return (unsigned)self->hasEncodedQueryItem(*key);
    }

    unsigned __QtAda_QUrl_hasFragment_Q(const QUrl* self)
    {
        return (unsigned)self->hasFragment();
    }

    unsigned __QtAda_QUrl_hasQuery_Q(const QUrl* self)
    {
        return (unsigned)self->hasQuery();
    }

    unsigned __QtAda_QUrl_hasQueryItem_QStringCR_Q(const QUrl* self, const QString* key)
    {
        return (unsigned)self->hasQueryItem(*key);
    }

    void __QtAda_QUrl_host_Q(QString* returns, const QUrl* self)
    {
        *returns = self->host();
    }

    unsigned __QtAda_QUrl_isEmpty_Q(const QUrl* self)
    {
        return (unsigned)self->isEmpty();
    }

    unsigned __QtAda_QUrl_isParentOf_QUrlCR_Q(const QUrl* self, const QUrl* childUrl)
    {
        return (unsigned)self->isParentOf(*childUrl);
    }

    unsigned __QtAda_QUrl_isRelative_Q(const QUrl* self)
    {
        return (unsigned)self->isRelative();
    }

    unsigned __QtAda_QUrl_isValid_Q(const QUrl* self)
    {
        return (unsigned)self->isValid();
    }

    void __QtAda_QUrl_password_Q(QString* returns, const QUrl* self)
    {
        *returns = self->password();
    }

    void __QtAda_QUrl_path_Q(QString* returns, const QUrl* self)
    {
        *returns = self->path();
    }

    int __QtAda_QUrl_port_Q(const QUrl* self)
    {
        return self->port();
    }

    int __QtAda_QUrl_port_int_Q(const QUrl* self, int defaultPort)
    {
        return self->port(defaultPort);
    }

    void __QtAda_QUrl_queryItemValue_QStringCR_Q(QString* returns, const QUrl* self, const QString* key)
    {
        *returns = self->queryItemValue(*key);
    }

    void __QtAda_QUrl_removeAllEncodedQueryItems_QByteArrayCR(QUrl* self, const QByteArray* key)
    {
        self->removeAllEncodedQueryItems(*key);
    }

    void __QtAda_QUrl_removeAllQueryItems_QStringCR(QUrl* self, const QString* key)
    {
        self->removeAllQueryItems(*key);
    }

    void __QtAda_QUrl_removeEncodedQueryItem_QByteArrayCR(QUrl* self, const QByteArray* key)
    {
        self->removeEncodedQueryItem(*key);
    }

    void __QtAda_QUrl_removeQueryItem_QStringCR(QUrl* self, const QString* key)
    {
        self->removeQueryItem(*key);
    }

    void __QtAda_QUrl_resolved_QUrlCR_Q(QUrl* returns, const QUrl* self, const QUrl* relative)
    {
        *returns = self->resolved(*relative);
    }

    void __QtAda_QUrl_scheme_Q(QString* returns, const QUrl* self)
    {
        *returns = self->scheme();
    }

    void __QtAda_QUrl_setAuthority_QStringCR(QUrl* self, const QString* authority)
    {
        self->setAuthority(*authority);
    }

    void __QtAda_QUrl_setEncodedFragment_QByteArrayCR(QUrl* self, const QByteArray* fragment)
    {
        self->setEncodedFragment(*fragment);
    }

    void __QtAda_QUrl_setEncodedHost_QByteArrayCR(QUrl* self, const QByteArray* host)
    {
        self->setEncodedHost(*host);
    }

    void __QtAda_QUrl_setEncodedPassword_QByteArrayCR(QUrl* self, const QByteArray* password)
    {
        self->setEncodedPassword(*password);
    }

    void __QtAda_QUrl_setEncodedPath_QByteArrayCR(QUrl* self, const QByteArray* path)
    {
        self->setEncodedPath(*path);
    }

    void __QtAda_QUrl_setEncodedQuery_QByteArrayCR(QUrl* self, const QByteArray* query)
    {
        self->setEncodedQuery(*query);
    }

    void __QtAda_QUrl_setEncodedUrl_QByteArrayCR(QUrl* self, const QByteArray* encodedUrl)
    {
        self->setEncodedUrl(*encodedUrl);
    }

    void __QtAda_QUrl_setEncodedUrl_QByteArrayCR_ParsingMode(QUrl* self, const QByteArray* encodedUrl, unsigned mode)
    {
        self->setEncodedUrl(*encodedUrl, (QUrl::ParsingMode)mode);
    }

    void __QtAda_QUrl_setEncodedUserName_QByteArrayCR(QUrl* self, const QByteArray* userName)
    {
        self->setEncodedUserName(*userName);
    }

    void __QtAda_QUrl_setFragment_QStringCR(QUrl* self, const QString* fragment)
    {
        self->setFragment(*fragment);
    }

    void __QtAda_QUrl_setHost_QStringCR(QUrl* self, const QString* host)
    {
        self->setHost(*host);
    }

    void __QtAda_QUrl_setPassword_QStringCR(QUrl* self, const QString* password)
    {
        self->setPassword(*password);
    }

    void __QtAda_QUrl_setPath_QStringCR(QUrl* self, const QString* path)
    {
        self->setPath(*path);
    }

    void __QtAda_QUrl_setPort_int(QUrl* self, int port)
    {
        self->setPort(port);
    }

    void __QtAda_QUrl_setScheme_QStringCR(QUrl* self, const QString* scheme)
    {
        self->setScheme(*scheme);
    }

    void __QtAda_QUrl_setUrl_QStringCR(QUrl* self, const QString* url)
    {
        self->setUrl(*url);
    }

    void __QtAda_QUrl_setUrl_QStringCR_ParsingMode(QUrl* self, const QString* url, unsigned mode)
    {
        self->setUrl(*url, (QUrl::ParsingMode)mode);
    }

    void __QtAda_QUrl_setUserInfo_QStringCR(QUrl* self, const QString* userInfo)
    {
        self->setUserInfo(*userInfo);
    }

    void __QtAda_QUrl_setUserName_QStringCR(QUrl* self, const QString* userName)
    {
        self->setUserName(*userName);
    }

    void __QtAda_QUrl_toLocalFile_Q(QString* returns, const QUrl* self)
    {
        *returns = self->toLocalFile();
    }

    void __QtAda_QUrl_userInfo_Q(QString* returns, const QUrl* self)
    {
        *returns = self->userInfo();
    }

    void __QtAda_QUrl_userName_Q(QString* returns, const QUrl* self)
    {
        *returns = self->userName();
    }

    unsigned __QtAda_QUrl_eq_QUrlCR_Q(const QUrl* self, const QUrl* url)
    {
        return (unsigned)self->operator==(*url);
    }

    void __QtAda_QUrl_fromAce_QByteArrayCR_S(QString* returns, const QByteArray* domain)
    {
        *returns = QUrl::fromAce(*domain);
    }

    void __QtAda_QUrl_fromEncoded_QByteArrayCR_S(QUrl* returns, const QByteArray* input)
    {
        *returns = QUrl::fromEncoded(*input);
    }

    void __QtAda_QUrl_fromEncoded_QByteArrayCR_ParsingMode_S(QUrl* returns, const QByteArray* input, unsigned mode)
    {
        *returns = QUrl::fromEncoded(*input, (QUrl::ParsingMode)mode);
    }

    void __QtAda_QUrl_fromLocalFile_QStringCR_S(QUrl* returns, const QString* localFile)
    {
        *returns = QUrl::fromLocalFile(*localFile);
    }

    void __QtAda_QUrl_fromPercentEncoding_QByteArrayCR_S(QString* returns, const QByteArray* domain)
    {
        *returns = QUrl::fromPercentEncoding(*domain);
    }

    void __QtAda_QUrl_idnWhitelist_S(QStringList* returns)
    {
        *returns = QUrl::idnWhitelist();
    }

    void __QtAda_QUrl_setIdnWhitelist_QStringListCR_S(const QStringList* list)
    {
        QUrl::setIdnWhitelist(*list);
    }

    void __QtAda_QUrl_toAce_QStringCR_S(QByteArray* returns, const QString* domain)
    {
        *returns = QUrl::toAce(*domain);
    }

    void __QtAda_QUrl_toPercentEncoding_QStringCR_QByteArrayCR_QByteArrayCR_S(QByteArray* returns, const QString* input, const QByteArray* exclude, const QByteArray* include)
    {
        *returns = QUrl::toPercentEncoding(*input, *exclude, *include);
    }

};

