//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2733 $ $Date: 2008-05-14 08:54:18 +0400 (Wed, 14 May 2008) $
//----------------------------------------------------------------------------
#include "qdesignercustomwidgetinterfacedirector.h"
#include <QtGui/QWidget>
#include <QtCore/QObject>

QDesignerCustomWidgetInterfaceDirector::QDesignerCustomWidgetInterfaceDirector
  (void*o) :
     QDesignerCustomWidgetInterface (),
     ada_object (o)
{
}

QString QDesignerCustomWidgetInterfaceDirector::name() const
{
    QString *aux =__Qt4Ada_QDesignerCustomWidgetInterface_name_dispatch(this->ada_object);
    QString result = *aux;
    delete aux;

    return result;
}

QString QDesignerCustomWidgetInterfaceDirector::group() const
{
    QString *aux = __Qt4Ada_QDesignerCustomWidgetInterface_group_dispatch(this->ada_object);
    QString result = *aux;
    delete aux;

    return result;
}

QString QDesignerCustomWidgetInterfaceDirector::toolTip() const
{
    QString *aux = __Qt4Ada_QDesignerCustomWidgetInterface_toolTip_dispatch(this->ada_object);
    QString result = *aux;
    delete aux;

    return result;
}

QString QDesignerCustomWidgetInterfaceDirector::whatsThis() const
{
    QString *aux = __Qt4Ada_QDesignerCustomWidgetInterface_whatsThis_dispatch(this->ada_object);
    QString result = *aux;
    delete aux;

    return result;
}

QString QDesignerCustomWidgetInterfaceDirector::includeFile() const
{
    QString *aux = __Qt4Ada_QDesignerCustomWidgetInterface_includeFile_dispatch(this->ada_object);
    QString result = *aux;
    delete aux;

    return result;
}

QString QDesignerCustomWidgetInterfaceDirector::domXml() const
{
    QString *aux = __Qt4Ada_QDesignerCustomWidgetInterface_domXml_dispatch(this->ada_object);
    QString result = *aux;
    delete aux;

    return result;
}

bool QDesignerCustomWidgetInterfaceDirector::isContainer() const
{
    return __Qt4Ada_QDesignerCustomWidgetInterface_isContainer_dispatch(this->ada_object);
}

QIcon QDesignerCustomWidgetInterfaceDirector::icon() const
{
    return QIcon ();
}

QWidget *QDesignerCustomWidgetInterfaceDirector::createWidget(QWidget *parent)
{
    return dynamic_cast <QWidget*>(__Qt4Ada_QDesignerCustomWidgetInterface_createWidget_dispatch(this->ada_object, dynamic_cast<QObject*>(parent)));
}

bool QDesignerCustomWidgetInterfaceDirector::isInitialized() const
{
    return __Qt4Ada_QDesignerCustomWidgetInterface_isInitialized_dispatch(this->ada_object);
}

 void QDesignerCustomWidgetInterfaceDirector::initialize
          (QDesignerFormEditorInterface* formEditor)
{
    __Qt4Ada_QDesignerCustomWidgetInterface_initialize_dispatch
        (this->ada_object, dynamic_cast<QObject*>(formEditor));
}

extern "C" {

    QDesignerCustomWidgetInterface*
      __Qt4Ada_new_QDesignerCustomWidgetInterfaceDirector (void* ada_object)
    {
        return new QDesignerCustomWidgetInterfaceDirector (ada_object);
    }

}
