------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3793 $ $Date: 2010-10-29 20:53:24 +0400 (Fri, 29 Oct 2010) $
------------------------------------------------------------------------------
with Ada.Finalization;

package Qt4.Designer_Custom_Widget_Interfaces.View is

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> new_QDesignerCustomWidgetInterfaceDirector
   --!    <Purpose> Подпрограмма создаёт директор класса
   --! QDesignerCustomWidgetInterfaces.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function new_QDesignerCustomWidgetInterfaceDirector
             (Self : not null access Q_Designer_Custom_Widget_Interface'Class)
                return System.Address;
   pragma Import (C,
                  new_QDesignerCustomWidgetInterfaceDirector,
                  "__Qt4Ada_new_QDesignerCustomWidgetInterfaceDirector");
   pragma Warnings (Off, new_QDesignerCustomWidgetInterfaceDirector);

   type Q_Designer_Custom_Widget_Interface_View
    (Owner : not null access Q_Designer_Custom_Widget_Interface'Class) is
       new Ada.Finalization.Limited_Controlled
         and Q_Designer_Custom_Widget_Interface with
           record
              Cpp_Object : System.Address
                := new_QDesignerCustomWidgetInterfaceDirector
                    (Q_Designer_Custom_Widget_Interface_View'Access);
           end record;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Include_File
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::includeFile.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   function Include_File
    (Self  : not null access Q_Designer_Custom_Widget_Interface_View)
       return Qt4.Strings.Q_String;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Whats_This
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::whatsThis.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   function Whats_This
    (Self  : not null access Q_Designer_Custom_Widget_Interface_View)
       return Qt4.Strings.Q_String;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Tool_Tip
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::toolTip.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   function Tool_Tip
    (Self  : not null access Q_Designer_Custom_Widget_Interface_View)
       return Qt4.Strings.Q_String;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Name
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::name.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   function Name
    (Self  : not null access Q_Designer_Custom_Widget_Interface_View)
       return Qt4.Strings.Q_String;

   overriding function Create_Widget
    (Self   : not null access Q_Designer_Custom_Widget_Interface_View;
     Parent : access Qt4.Widgets.Q_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Group
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::group.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   function Group
    (Self  : not null access Q_Designer_Custom_Widget_Interface_View)
       return Qt4.Strings.Q_String;

   overriding procedure Initialize
    (Self        : not null access Q_Designer_Custom_Widget_Interface_View;
     Form_Editor : not null access
       Qt4.Designer_Form_Editor_Interfaces.Q_Designer_Form_Editor_Interface'Class);

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Is_Container
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::isContainer.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   function Is_Container
    (Self  : not null access Q_Designer_Custom_Widget_Interface_View)
       return Boolean;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Is_Initialized
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::isInitialized.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   function Is_Initialized
    (Self  : not null access Q_Designer_Custom_Widget_Interface_View)
       return Boolean;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Dom_Xml
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::domXml.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   function Dom_Xml
    (Self : not null access Q_Designer_Custom_Widget_Interface_View)
     return Qt4.Strings.Q_String;

end Qt4.Designer_Custom_Widget_Interfaces.View;
