------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3793 $ $Date: 2010-10-29 20:53:24 +0400 (Fri, 29 Oct 2010) $
------------------------------------------------------------------------------
with Qt4.Designer_Form_Editor_Interfaces;
with Qt4.Strings;
with Qt4.Widgets;

package Qt4.Designer_Custom_Widget_Interfaces is

   type Q_Designer_Custom_Widget_Interface is limited interface;
   pragma Warnings (Off);
   pragma Q_Declare_Interface
           (Q_Designer_Custom_Widget_Interface,
            "com.trolltech.Qt.Designer.CustomWidget");
   pragma Warnings (On);

   not overriding function Create_Widget
    (Self   : not null access Q_Designer_Custom_Widget_Interface;
     Parent : access Qt4.Widgets.Q_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class
         is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Include_File
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::includeFile.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Include_File
    (Self  : not null access Q_Designer_Custom_Widget_Interface)
       return Qt4.Strings.Q_String
         is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Whats_This
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::whatsThis.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Whats_This
    (Self  : not null access Q_Designer_Custom_Widget_Interface)
       return Qt4.Strings.Q_String
         is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Tool_Tip
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::toolTip.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Tool_Tip
    (Self  : not null access Q_Designer_Custom_Widget_Interface)
       return Qt4.Strings.Q_String
         is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Name
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::name.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Name
    (Self  : not null access Q_Designer_Custom_Widget_Interface)
       return Qt4.Strings.Q_String
         is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Group
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::group.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Group
    (Self  : not null access Q_Designer_Custom_Widget_Interface)
       return Qt4.Strings.Q_String
         is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Is_Container
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::isContainer.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Is_Container
    (Self  : not null access Q_Designer_Custom_Widget_Interface)
       return Boolean
         is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Is_Initialized
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::isInitialized.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Is_Initialized
    (Self  : not null access Q_Designer_Custom_Widget_Interface)
       return Boolean
         is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Dom_Xml
   --!    <Purpose> Подпрограмма-обёртка вызова функции
   --! QDesignerCustomWidgetInterfaces::domXml.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Dom_Xml
    (Self : not null access Q_Designer_Custom_Widget_Interface)
     return Qt4.Strings.Q_String
       is abstract;

   not overriding procedure Initialize
    (Self        : not null access Q_Designer_Custom_Widget_Interface;
     Form_Editor : not null access
       Qt4.Designer_Form_Editor_Interfaces.Q_Designer_Form_Editor_Interface'Class)
       is abstract;

end Qt4.Designer_Custom_Widget_Interfaces;
