------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3660 $ $Date: 2009-12-20 22:52:51 +0300 (Sun, 20 Dec 2009) $
------------------------------------------------------------------------------
with Interfaces.C.Strings;

with Glib.Object;

with Qt4.V_Box_Layouts.Constructors;
with Qt4.X11_Embed_Widgets.Constructors;

package body Gtkada.Qt_Container is

   Class_Record : Glib.Object.GObject_Class := Glib.Object.Uninitialized_Class;

   -----------
   -- Embed --
   -----------

   procedure Embed
    (Self   : not null access Qt_Container_Record'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class)
   is
      Layout : Qt4.V_Box_Layouts.Q_V_Box_Layout_Access;

   begin
      Layout := Qt4.V_Box_Layouts.Constructors.Create;
      Layout.Set_Contents_Margins (0, 0, 0, 0);

      Self.Embed_Widget.Embed_Into (Qt4.W_Id (Self.Get_Id));
      Layout.Add_Widget (Widget);
      Self.Embed_Widget.Set_Layout (Layout);
      Self.Embed_Widget.Show;
   end Embed;

   -------------
   -- Gtk_New --
   -------------

   procedure Gtk_New (Container : out Qt_Container) is
   begin
      Container := new Qt_Container_Record;
      Initialize (Container);
   end Gtk_New;

   ----------------
   -- Initialize --
   ----------------

   procedure Initialize (Self   : not null access Qt_Container_Record'Class) is
   begin
      Gtk.Socket.Initialize (Self);
      Glib.Object.Initialize_Class_Record
       (Self,
        Interfaces.C.Strings.chars_ptr_array'
         (1 .. 0 => Interfaces.C.Strings.Null_Ptr),
        Class_Record,
        "QtContainer");

      Self.Embed_Widget := Qt4.X11_Embed_Widgets.Constructors.Create;
   end Initialize;

end Gtkada.Qt_Container;
