------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3660 $ $Date: 2009-12-20 22:52:51 +0300 (Sun, 20 Dec 2009) $
------------------------------------------------------------------------------
with Gtk.Widget;
with Gtk.Socket;

with Qt4.Widgets;
private with Qt4.X11_Embed_Widgets;

package Gtkada.Qt_Container is

   type Qt_Container_Record is
     new Gtk.Widget.Gtk_Widget_Record with private;

   type Qt_Container is access all Qt_Container_Record;

   procedure Gtk_New (Container : out Qt_Container);

   procedure Initialize
    (Self : not null access Qt_Container_Record'Class);

   procedure Embed
    (Self   : not null access Qt_Container_Record'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);
   --  Qt widget can be embedded into the Gtk+ widget only when Gtk+ widget
   --  attached to toplevel GtkWindow or one of its children. Otherwise, Qt
   --  widget will be opended in separate window and warning will be issued.

private

   type Qt_Container_Record is
     new Gtk.Socket.Gtk_Socket_Record with
   record
      Embed_Widget : Qt4.X11_Embed_Widgets.Q_X11_Embed_Widget_Access;
   end record;
   --  QtContainer must be derived from GtkBin, but GtkAda 2.14 doesn't
   --  support GtkBin subclassing.

end Gtkada.Qt_Container;
