------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3660 $ $Date: 2009-12-20 22:52:51 +0300 (Sun, 20 Dec 2009) $
------------------------------------------------------------------------------
with Glib;
with Gtk.Plug;

with Qt_Ada.Gtk_Containers.Moc;
pragma Unreferenced (Qt_Ada.Gtk_Containers.Moc);

package body Qt_Ada.Gtk_Containers is

   ------------------
   -- Constructors --
   ------------------

   package body Constructors is

      procedure Initialize
       (Self   : not null access Gtk_Container'Class;
        Parent : not null access Qt4.Widgets.Q_Widget'Class);

      ------------
      -- Create --
      ------------

      function Create
       (Parent : not null access Qt4.Widgets.Q_Widget'Class)
          return Qt_Ada.Gtk_Containers.Gtk_Container_Access
      is
      begin
         return Self : constant Qt_Ada.Gtk_Containers.Gtk_Container_Access
           := new Qt_Ada.Gtk_Containers.Gtk_Container
         do
            Initialize (Self, Parent);
         end return;
      end Create;

      ----------------
      -- Initialize --
      ----------------

      procedure Initialize
       (Self   : not null access Gtk_Container'Class;
        Parent : not null access Qt4.Widgets.Q_Widget'Class)
      is
      begin
         Qt4.X11_Embed_Containers.Directors.Constructors.Initialize
          (Self, Parent);
      end Initialize;

   end Constructors;

   -----------
   -- Embed --
   -----------

   procedure Embed
    (Self   : not null access Gtk_Container'Class;
     Widget : not null access Gtk.Widget.Gtk_Widget_Record'Class)
   is
      Plug : Gtk.Plug.Gtk_Plug;

   begin
      Gtk.Plug.Gtk_New (Plug, Glib.Guint32 (Self.Win_Id));
      Plug.Add (Widget);
      Plug.Show;
   end Embed;

end Qt_Ada.Gtk_Containers;
