------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3776 $ $Date: 2010-10-24 10:47:15 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Gtk.Widget;

with Qt4.Widgets;
with Qt4.X11_Embed_Containers;
private with Qt4.X11_Embed_Containers.Directors;

package Qt_Ada.Gtk_Containers is

   type Gtk_Container is
     limited new Qt4.X11_Embed_Containers.Q_X11_Embed_Container with private;

   type Gtk_Container_Access is access all Gtk_Container'Class;

   procedure Embed
    (Self   : not null access Gtk_Container'Class;
     Widget : not null access Gtk.Widget.Gtk_Widget_Record'Class);
   --  Embed specified GtkAda widget into the container.

   package Constructors is

      function Create (Parent : not null access Qt4.Widgets.Q_Widget'Class)
        return Qt_Ada.Gtk_Containers.Gtk_Container_Access;
      --  Creates new GtkContainer widget.

   end Constructors;

private

   type Gtk_Container is
     limited new Qt4.X11_Embed_Containers.Directors.Q_X11_Embed_Container_Director
       with null record;

end Qt_Ada.Gtk_Containers;
