//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QColor>
#include <QMatrix>
#include <QPixmap>
#include <QString>
#include <QTransform>
#include "qbrushwrapper.h"

extern "C"
{

    QBrush* __QtAda_inititialize_QBrush(void* storage)
    {
        return new (storage) QBrush();
    }

    QBrush* __QtAda_inititialize_QBrush_BrushStyle(void* storage, unsigned bs)
    {
        return new (storage) QBrush((Qt::BrushStyle)bs);
    }

    QBrush* __QtAda_inititialize_QBrush_QColorCR_BrushStyle(void* storage, const QColor* color, unsigned bs)
    {
        return new (storage) QBrush(*color, (Qt::BrushStyle)bs);
    }

    QBrush* __QtAda_inititialize_QBrush_GlobalColor_BrushStyle(void* storage, unsigned color, unsigned bs)
    {
        return new (storage) QBrush((Qt::GlobalColor)color, (Qt::BrushStyle)bs);
    }

    QBrush* __QtAda_inititialize_QBrush_QColorCR_QPixmapCR(void* storage, const QColor* color, const QPixmap* pixmap)
    {
        return new (storage) QBrush(*color, *pixmap);
    }

    QBrush* __QtAda_inititialize_QBrush_GlobalColor_QPixmapCR(void* storage, unsigned color, const QPixmap* pixmap)
    {
        return new (storage) QBrush((Qt::GlobalColor)color, *pixmap);
    }

    QBrush* __QtAda_inititialize_QBrush_QPixmapCR(void* storage, const QPixmap* pixmap)
    {
        return new (storage) QBrush(*pixmap);
    }

    QBrush* __QtAda_inititialize_QBrush_QGradientCR(void* storage, const QGradient* gradient)
    {
        return new (storage) QBrush(*gradient);
    }

    QBrush* __QtAda_adjust_QBrush(void* storage, const QBrush* from)
    {
        return new (storage) QBrush(*from);
    }

    void __QtAda_finalize_QBrush(QBrush *item)
    {
        item->~QBrush();
    }

    void __QtAda_QBrush_color_Q(QColor* returns, const QBrush* self)
    {
        *returns = self->color();
    }

    unsigned __QtAda_QBrush_isDetached_Q(const QBrush* self)
    {
        return (unsigned)self->isDetached();
    }

    unsigned __QtAda_QBrush_isOpaque_Q(const QBrush* self)
    {
        return (unsigned)self->isOpaque();
    }

    void __QtAda_QBrush_matrix_Q(QMatrix* returns, const QBrush* self)
    {
        *returns = self->matrix();
    }

    void __QtAda_QBrush_setColor_QColorCR(QBrush* self, const QColor* color)
    {
        self->setColor(*color);
    }

    void __QtAda_QBrush_setColor_GlobalColor(QBrush* self, unsigned color)
    {
        self->setColor((Qt::GlobalColor)color);
    }

    void __QtAda_QBrush_setMatrix_QMatrixCR(QBrush* self, const QMatrix* mat)
    {
        self->setMatrix(*mat);
    }

    void __QtAda_QBrush_setStyle_BrushStyle(QBrush* self, unsigned style)
    {
        self->setStyle((Qt::BrushStyle)style);
    }

    void __QtAda_QBrush_setTexture_QPixmapCR(QBrush* self, const QPixmap* pixmap)
    {
        self->setTexture(*pixmap);
    }

    void __QtAda_QBrush_setTransform_QTransformCR(QBrush* self, const QTransform* t)
    {
        self->setTransform(*t);
    }

    unsigned __QtAda_QBrush_style_Q(const QBrush* self)
    {
        return (unsigned)self->style();
    }

    void __QtAda_QBrush_texture_Q(QPixmap* returns, const QBrush* self)
    {
        *returns = self->texture();
    }

    void __QtAda_QBrush_transform_Q(QTransform* returns, const QBrush* self)
    {
        *returns = self->transform();
    }

    unsigned __QtAda_QBrush_eq_QBrushCR_Q(const QBrush* self, const QBrush* b)
    {
        return (unsigned)self->operator==(*b);
    }

};

