//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3863 $ $Date: 2012-04-08 09:49:28 +0400 (Sun, 08 Apr 2012) $
//--------------------------------------------------------------------------//
#include <new>
#include <QColor>
#include <QString>
#include "qcolorwrapper.h"

extern "C"
{

    QColor* __QtAda_inititialize_QColor(void* storage)
    {
        return new (storage) QColor();
    }

    QColor* __QtAda_inititialize_QColor_int_int_int_int(void* storage, int r, int g, int b, int a)
    {
        return new (storage) QColor(r, g, b, a);
    }

    QColor* __QtAda_inititialize_QColor_QRgb(void* storage, QRgb rgb)
    {
        return new (storage) QColor(rgb);
    }

    QColor* __QtAda_inititialize_QColor_QStringCR(void* storage, const QString* name)
    {
        return new (storage) QColor(*name);
    }

    QColor* __QtAda_inititialize_QColor_GlobalColor(void* storage, unsigned color)
    {
        return new (storage) QColor((Qt::GlobalColor)color);
    }

    QColor* __QtAda_adjust_QColor(void* storage, const QColor* from)
    {
        return new (storage) QColor(*from);
    }

    void __QtAda_finalize_QColor(QColor *item)
    {
        item->~QColor();
    }

    int __QtAda_QColor_alpha_Q(const QColor* self)
    {
        return self->alpha();
    }

    double __QtAda_QColor_alphaF_Q(const QColor* self)
    {
        return (double)self->alphaF();
    }

    int __QtAda_QColor_black_Q(const QColor* self)
    {
        return self->black();
    }

    double __QtAda_QColor_blackF_Q(const QColor* self)
    {
        return (double)self->blackF();
    }

    int __QtAda_QColor_blue_Q(const QColor* self)
    {
        return self->blue();
    }

    double __QtAda_QColor_blueF_Q(const QColor* self)
    {
        return (double)self->blueF();
    }

    void __QtAda_QColor_convertTo_Spec_Q(QColor* returns, const QColor* self, unsigned spec)
    {
        *returns = self->convertTo((QColor::Spec)spec);
    }

    int __QtAda_QColor_cyan_Q(const QColor* self)
    {
        return self->cyan();
    }

    double __QtAda_QColor_cyanF_Q(const QColor* self)
    {
        return (double)self->cyanF();
    }

    void __QtAda_QColor_darker_int_Q(QColor* returns, const QColor* self, int f)
    {
        *returns = self->darker(f);
    }

    int __QtAda_QColor_green_Q(const QColor* self)
    {
        return self->green();
    }

    double __QtAda_QColor_greenF_Q(const QColor* self)
    {
        return (double)self->greenF();
    }

    int __QtAda_QColor_hue_Q(const QColor* self)
    {
        return self->hue();
    }

    double __QtAda_QColor_hueF_Q(const QColor* self)
    {
        return (double)self->hueF();
    }

    unsigned __QtAda_QColor_isValid_Q(const QColor* self)
    {
        return (unsigned)self->isValid();
    }

    void __QtAda_QColor_lighter_int_Q(QColor* returns, const QColor* self, int f)
    {
        *returns = self->lighter(f);
    }

    int __QtAda_QColor_magenta_Q(const QColor* self)
    {
        return self->magenta();
    }

    double __QtAda_QColor_magentaF_Q(const QColor* self)
    {
        return (double)self->magentaF();
    }

    void __QtAda_QColor_name_Q(QString* returns, const QColor* self)
    {
        *returns = self->name();
    }

    int __QtAda_QColor_red_Q(const QColor* self)
    {
        return self->red();
    }

    double __QtAda_QColor_redF_Q(const QColor* self)
    {
        return (double)self->redF();
    }

    QRgb __QtAda_QColor_rgb_Q(const QColor* self)
    {
        return self->rgb();
    }

    QRgb __QtAda_QColor_rgba_Q(const QColor* self)
    {
        return self->rgba();
    }

    int __QtAda_QColor_saturation_Q(const QColor* self)
    {
        return self->saturation();
    }

    double __QtAda_QColor_saturationF_Q(const QColor* self)
    {
        return (double)self->saturationF();
    }

    void __QtAda_QColor_setAlpha_int(QColor* self, int alpha)
    {
        self->setAlpha(alpha);
    }

    void __QtAda_QColor_setAlphaF_qreal(QColor* self, double alpha)
    {
        self->setAlphaF((qreal)alpha);
    }

    void __QtAda_QColor_setBlue_int(QColor* self, int blue)
    {
        self->setBlue(blue);
    }

    void __QtAda_QColor_setBlueF_qreal(QColor* self, double blue)
    {
        self->setBlueF((qreal)blue);
    }

    void __QtAda_QColor_setCmyk_int_int_int_int_int(QColor* self, int c, int m, int y, int k, int a)
    {
        self->setCmyk(c, m, y, k, a);
    }

    void __QtAda_QColor_setCmykF_qreal_qreal_qreal_qreal_qreal(QColor* self, double c, double m, double y, double k, double a)
    {
        self->setCmykF((qreal)c, (qreal)m, (qreal)y, (qreal)k, (qreal)a);
    }

    void __QtAda_QColor_setGreen_int(QColor* self, int green)
    {
        self->setGreen(green);
    }

    void __QtAda_QColor_setGreenF_qreal(QColor* self, double green)
    {
        self->setGreenF((qreal)green);
    }

    void __QtAda_QColor_setHsv_int_int_int_int(QColor* self, int h, int s, int v, int a)
    {
        self->setHsv(h, s, v, a);
    }

    void __QtAda_QColor_setHsvF_qreal_qreal_qreal_qreal(QColor* self, double h, double s, double v, double a)
    {
        self->setHsvF((qreal)h, (qreal)s, (qreal)v, (qreal)a);
    }

    void __QtAda_QColor_setNamedColor_QStringCR(QColor* self, const QString* name)
    {
        self->setNamedColor(*name);
    }

    void __QtAda_QColor_setRed_int(QColor* self, int red)
    {
        self->setRed(red);
    }

    void __QtAda_QColor_setRedF_qreal(QColor* self, double red)
    {
        self->setRedF((qreal)red);
    }

    void __QtAda_QColor_setRgb_QRgb(QColor* self, QRgb rgb)
    {
        self->setRgb(rgb);
    }

    void __QtAda_QColor_setRgb_int_int_int_int(QColor* self, int r, int g, int b, int a)
    {
        self->setRgb(r, g, b, a);
    }

    void __QtAda_QColor_setRgbF_qreal_qreal_qreal_qreal(QColor* self, double r, double g, double b, double a)
    {
        self->setRgbF((qreal)r, (qreal)g, (qreal)b, (qreal)a);
    }

    void __QtAda_QColor_setRgba_QRgb(QColor* self, QRgb rgba)
    {
        self->setRgba(rgba);
    }

    unsigned __QtAda_QColor_spec_Q(const QColor* self)
    {
        return (unsigned)self->spec();
    }

    void __QtAda_QColor_toCmyk_Q(QColor* returns, const QColor* self)
    {
        *returns = self->toCmyk();
    }

    void __QtAda_QColor_toHsv_Q(QColor* returns, const QColor* self)
    {
        *returns = self->toHsv();
    }

    void __QtAda_QColor_toRgb_Q(QColor* returns, const QColor* self)
    {
        *returns = self->toRgb();
    }

    int __QtAda_QColor_value_Q(const QColor* self)
    {
        return self->value();
    }

    double __QtAda_QColor_valueF_Q(const QColor* self)
    {
        return (double)self->valueF();
    }

    int __QtAda_QColor_yellow_Q(const QColor* self)
    {
        return self->yellow();
    }

    double __QtAda_QColor_yellowF_Q(const QColor* self)
    {
        return (double)self->yellowF();
    }

    unsigned __QtAda_QColor_eq_QColorCR_Q(const QColor* self, const QColor* color)
    {
        return (unsigned)self->operator==(*color);
    }

    void __QtAda_QColor_fromCmyk_int_int_int_int_int_S(QColor* returns, int c, int m, int y, int k, int a)
    {
        *returns = QColor::fromCmyk(c, m, y, k, a);
    }

    void __QtAda_QColor_fromCmykF_qreal_qreal_qreal_qreal_qreal_S(QColor* returns, double c, double m, double y, double k, double a)
    {
        *returns = QColor::fromCmykF((qreal)c, (qreal)m, (qreal)y, (qreal)k, (qreal)a);
    }

    void __QtAda_QColor_fromHsv_int_int_int_int_S(QColor* returns, int h, int s, int v, int a)
    {
        *returns = QColor::fromHsv(h, s, v, a);
    }

    void __QtAda_QColor_fromHsvF_qreal_qreal_qreal_qreal_S(QColor* returns, double h, double s, double v, double a)
    {
        *returns = QColor::fromHsvF((qreal)h, (qreal)s, (qreal)v, (qreal)a);
    }

    void __QtAda_QColor_fromRgb_QRgb_S(QColor* returns, QRgb rgb)
    {
        *returns = QColor::fromRgb(rgb);
    }

    void __QtAda_QColor_fromRgb_int_int_int_int_S(QColor* returns, int r, int g, int b, int a)
    {
        *returns = QColor::fromRgb(r, g, b, a);
    }

    void __QtAda_QColor_fromRgbF_qreal_qreal_qreal_qreal_S(QColor* returns, double r, double g, double b, double a)
    {
        *returns = QColor::fromRgbF((qreal)r, (qreal)g, (qreal)b, (qreal)a);
    }

    void __QtAda_QColor_fromRgba_QRgb_S(QColor* returns, QRgb rgba)
    {
        *returns = QColor::fromRgba(rgba);
    }

};

