//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3640 $ $Date: 2009-11-27 11:34:03 +0300 (Fri, 27 Nov 2009) $
//--------------------------------------------------------------------------//
#include <QColor>

extern "C"
{
    extern QColor* __QtAda_inititialize_QColor(void*);
    extern QColor* __QtAda_inititialize_QColor_int_int_int_int(void*, int, int, int, int);
    extern QColor* __QtAda_inititialize_QColor_QRgb(void*, QRgb);
    extern QColor* __QtAda_inititialize_QColor_QStringCR(void*, const QString*);
    extern QColor* __QtAda_inititialize_QColor_GlobalColor(void*, unsigned);
    extern QColor* __QtAda_adjust_QColor(void*, const QColor*);
    extern void __QtAda_finalize_QColor(QColor*);

    extern int __QtAda_QColor_alpha_Q(const QColor*);
    extern double __QtAda_QColor_alphaF_Q(const QColor*);
    extern int __QtAda_QColor_black_Q(const QColor*);
    extern double __QtAda_QColor_blackF_Q(const QColor*);
    extern int __QtAda_QColor_blue_Q(const QColor*);
    extern double __QtAda_QColor_blueF_Q(const QColor*);
    extern void __QtAda_QColor_convertTo_Spec_Q(QColor*, const QColor*, unsigned);
    extern int __QtAda_QColor_cyan_Q(const QColor*);
    extern double __QtAda_QColor_cyanF_Q(const QColor*);
    extern void __QtAda_QColor_darker_int_Q(QColor*, const QColor*, int);
    extern int __QtAda_QColor_green_Q(const QColor*);
    extern double __QtAda_QColor_greenF_Q(const QColor*);
    extern int __QtAda_QColor_hue_Q(const QColor*);
    extern double __QtAda_QColor_hueF_Q(const QColor*);
    extern unsigned __QtAda_QColor_isValid_Q(const QColor*);
    extern void __QtAda_QColor_lighter_int_Q(QColor*, const QColor*, int);
    extern int __QtAda_QColor_magenta_Q(const QColor*);
    extern double __QtAda_QColor_magentaF_Q(const QColor*);
    extern void __QtAda_QColor_name_Q(QString*, const QColor*);
    extern int __QtAda_QColor_red_Q(const QColor*);
    extern double __QtAda_QColor_redF_Q(const QColor*);
    extern QRgb __QtAda_QColor_rgb_Q(const QColor*);
    extern QRgb __QtAda_QColor_rgba_Q(const QColor*);
    extern int __QtAda_QColor_saturation_Q(const QColor*);
    extern double __QtAda_QColor_saturationF_Q(const QColor*);
    extern void __QtAda_QColor_setAlpha_int(QColor*, int);
    extern void __QtAda_QColor_setAlphaF_qreal(QColor*, double);
    extern void __QtAda_QColor_setBlue_int(QColor*, int);
    extern void __QtAda_QColor_setBlueF_qreal(QColor*, double);
    extern void __QtAda_QColor_setCmyk_int_int_int_int_int(QColor*, int, int, int, int, int);
    extern void __QtAda_QColor_setCmykF_qreal_qreal_qreal_qreal_qreal(QColor*, double, double, double, double, double);
    extern void __QtAda_QColor_setGreen_int(QColor*, int);
    extern void __QtAda_QColor_setGreenF_qreal(QColor*, double);
    extern void __QtAda_QColor_setHsv_int_int_int_int(QColor*, int, int, int, int);
    extern void __QtAda_QColor_setHsvF_qreal_qreal_qreal_qreal(QColor*, double, double, double, double);
    extern void __QtAda_QColor_setNamedColor_QStringCR(QColor*, const QString*);
    extern void __QtAda_QColor_setRed_int(QColor*, int);
    extern void __QtAda_QColor_setRedF_qreal(QColor*, double);
    extern void __QtAda_QColor_setRgb_QRgb(QColor*, QRgb);
    extern void __QtAda_QColor_setRgb_int_int_int_int(QColor*, int, int, int, int);
    extern void __QtAda_QColor_setRgbF_qreal_qreal_qreal_qreal(QColor*, double, double, double, double);
    extern void __QtAda_QColor_setRgba_QRgb(QColor*, QRgb);
    extern unsigned __QtAda_QColor_spec_Q(const QColor*);
    extern void __QtAda_QColor_toCmyk_Q(QColor*, const QColor*);
    extern void __QtAda_QColor_toHsv_Q(QColor*, const QColor*);
    extern void __QtAda_QColor_toRgb_Q(QColor*, const QColor*);
    extern int __QtAda_QColor_value_Q(const QColor*);
    extern double __QtAda_QColor_valueF_Q(const QColor*);
    extern int __QtAda_QColor_yellow_Q(const QColor*);
    extern double __QtAda_QColor_yellowF_Q(const QColor*);
    extern unsigned __QtAda_QColor_eq_QColorCR_Q(const QColor*, const QColor*);
    extern void __QtAda_QColor_fromCmyk_int_int_int_int_int_S(QColor*, int, int, int, int, int);
    extern void __QtAda_QColor_fromCmykF_qreal_qreal_qreal_qreal_qreal_S(QColor*, double, double, double, double, double);
    extern void __QtAda_QColor_fromHsv_int_int_int_int_S(QColor*, int, int, int, int);
    extern void __QtAda_QColor_fromHsvF_qreal_qreal_qreal_qreal_S(QColor*, double, double, double, double);
    extern void __QtAda_QColor_fromRgb_QRgb_S(QColor*, QRgb);
    extern void __QtAda_QColor_fromRgb_int_int_int_int_S(QColor*, int, int, int, int);
    extern void __QtAda_QColor_fromRgbF_qreal_qreal_qreal_qreal_S(QColor*, double, double, double, double);
    extern void __QtAda_QColor_fromRgba_QRgb_S(QColor*, QRgb);

};

