//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QBitmap>
#include <QPixmap>
#include <QPoint>
#include <QString>
#include "qcursorwrapper.h"

extern "C"
{

    QCursor* __QtAda_inititialize_QCursor(void* storage)
    {
        return new (storage) QCursor();
    }

    QCursor* __QtAda_inititialize_QCursor_CursorShape(void* storage, unsigned shape)
    {
        return new (storage) QCursor((Qt::CursorShape)shape);
    }

    QCursor* __QtAda_inititialize_QCursor_QBitmapCR_QBitmapCR_int_int(void* storage, const QPixmap* bitmap, const QPixmap* mask, int hotX, int hotY)
    {
        return new (storage) QCursor(*static_cast<const QBitmap*>(bitmap), *static_cast<const QBitmap*>(mask), hotX, hotY);
    }

    QCursor* __QtAda_inititialize_QCursor_QPixmapCR_int_int(void* storage, const QPixmap* pixmap, int hotX, int hotY)
    {
        return new (storage) QCursor(*pixmap, hotX, hotY);
    }

    QCursor* __QtAda_adjust_QCursor(void* storage, const QCursor* from)
    {
        return new (storage) QCursor(*from);
    }

    void __QtAda_finalize_QCursor(QCursor *item)
    {
        item->~QCursor();
    }

    void __QtAda_QCursor_bitmap_Q(QPixmap* returns, const QCursor* self)
    {
        *static_cast<QBitmap*>(returns) = *self->bitmap();
    }

    void __QtAda_QCursor_hotSpot_Q(QPoint* returns, const QCursor* self)
    {
        *returns = self->hotSpot();
    }

    void __QtAda_QCursor_mask_Q(QPixmap* returns, const QCursor* self)
    {
        *static_cast<QBitmap*>(returns) = *self->mask();
    }

    void __QtAda_QCursor_pixmap_Q(QPixmap* returns, const QCursor* self)
    {
        *returns = self->pixmap();
    }

    void __QtAda_QCursor_setShape_CursorShape(QCursor* self, unsigned shape)
    {
        self->setShape((Qt::CursorShape)shape);
    }

    unsigned __QtAda_QCursor_shape_Q(const QCursor* self)
    {
        return (unsigned)self->shape();
    }

    void __QtAda_QCursor_pos_S(QPoint* returns)
    {
        *returns = QCursor::pos();
    }

    void __QtAda_QCursor_setPos_int_int_S(int x, int y)
    {
        QCursor::setPos(x, y);
    }

    void __QtAda_QCursor_setPos_QPointCR_S(const QPoint* p)
    {
        QCursor::setPos(*p);
    }

};

