//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2733 $ $Date: 2008-05-14 08:54:18 +0400 (Wed, 14 May 2008) $
//----------------------------------------------------------------------------
#include "qgradientwrapper.h"

extern "C"
{

    QGradient* __Qt4Ada_new_QGradient ()
    {
        return new QGradient ();
    }

    QGradient* __Qt4Ada_copy_QGradient (const QGradient* cpp_object)
    {
      switch (cpp_object->type ())
      {
         case QGradient::LinearGradient :
            return new QLinearGradient (*(static_cast<const QLinearGradient*> (cpp_object)));
            break;

         case QGradient::RadialGradient :
            return new QRadialGradient (*(static_cast<const QRadialGradient*> (cpp_object)));
            break;

         case QGradient::ConicalGradient :
            return new QConicalGradient(*(static_cast<const QConicalGradient*>(cpp_object)));
            break;

         case QGradient::NoGradient :
            return new QGradient (*cpp_object);
            break;
         default :
            return new QGradient (*cpp_object);
            break;
      }
    }

    void __Qt4Ada_delete_QGradient (QGradient* cpp_object)
    {
        delete cpp_object;
    }

    int __Qt4Ada_QGradient_type_wrapper (QGradient*cpp_object)
    {
        return cpp_object->QGradient::type ();
    }

    void __Qt4Ada_QGradient_setColorAt_wrapper (QGradient*cpp_object,double pos, QColor*color)
    {
       cpp_object->setColorAt (pos, *color);
    }

}
