//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2733 $ $Date: 2008-05-14 08:54:18 +0400 (Wed, 14 May 2008) $
//----------------------------------------------------------------------------
#include "qobjectdirector.h"
#include "qhelpeventwrapper.h"

extern "C" {

    QPoint* __Qt4Ada_QHelpEvent_globalPos_wrapper (QEvent* cpp_object)
    {
      QPoint p = dynamic_cast <QHelpEvent*> (cpp_object) -> globalPos ();
      return (new QPoint (p.x(), p.y()));
    }

    QPoint* __Qt4Ada_QHelpEvent_pos_wrapper (QEvent* cpp_object)
    {
      QPoint p = dynamic_cast <QHelpEvent*> (cpp_object) -> pos ();
      return (new QPoint (p.x(), p.y()));
    }

    int __Qt4Ada_QHelpEvent_globalX_wrapper (QEvent* cpp_object)
    {
      return dynamic_cast <QHelpEvent*> (cpp_object) -> globalX ();
    }

    int __Qt4Ada_QHelpEvent_globalY_wrapper (QEvent* cpp_object)
    {
      return dynamic_cast <QHelpEvent*> (cpp_object) -> globalY ();
    }

    int __Qt4Ada_QHelpEvent_x_wrapper (QEvent* cpp_object)
    {
      return dynamic_cast <QHelpEvent*> (cpp_object) -> x ();
    }

    int __Qt4Ada_QHelpEvent_y_wrapper (QEvent* cpp_object)
    {
      return dynamic_cast <QHelpEvent*> (cpp_object) -> y ();
    }

    QEvent* __Qt4Ada_new_QHelpEvent_wrapper (int type, QPoint* pos, QPoint* global_pos)
    {
      return dynamic_cast <QEvent*> (new QHelpEvent ((QEvent::Type)type,
                                                      *pos,
                                                      *global_pos));
    }

}
