//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2010-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3863 $ $Date: 2012-04-08 09:49:28 +0400 (Sun, 08 Apr 2012) $
//--------------------------------------------------------------------------//
#include <new>
#include <QByteArray>
#include <QColor>
#include <QImage>
#include <QList>
#include <QRect>
#include <QSize>
#include <QString>
#include <QStringList>
#include "qimagereaderwrapper.h"

extern "C"
{

    QImageReader* __QtAda_inititialize_QImageReader(void* storage)
    {
        return new (storage) QImageReader();
    }

    QImageReader* __QtAda_inititialize_QImageReader_QStringCR_QByteArrayCR(void* storage, const QString* fileName, const QByteArray* format)
    {
        return new (storage) QImageReader(*fileName, *format);
    }

    void __QtAda_finalize_QImageReader(QImageReader *item)
    {
        item->~QImageReader();
    }

    unsigned __QtAda_QImageReader_autoDetectImageFormat_Q(const QImageReader* self)
    {
        return (unsigned)self->autoDetectImageFormat();
    }

    void __QtAda_QImageReader_backgroundColor_Q(QColor* returns, const QImageReader* self)
    {
        *returns = self->backgroundColor();
    }

    unsigned __QtAda_QImageReader_canRead_Q(const QImageReader* self)
    {
        return (unsigned)self->canRead();
    }

    void __QtAda_QImageReader_clipRect_Q(QRect* returns, const QImageReader* self)
    {
        *returns = self->clipRect();
    }

    int __QtAda_QImageReader_currentImageNumber_Q(const QImageReader* self)
    {
        return self->currentImageNumber();
    }

    void __QtAda_QImageReader_currentImageRect_Q(QRect* returns, const QImageReader* self)
    {
        *returns = self->currentImageRect();
    }

    unsigned __QtAda_QImageReader_decideFormatFromContent_Q(const QImageReader* self)
    {
        return (unsigned)self->decideFormatFromContent();
    }

    unsigned __QtAda_QImageReader_error_Q(const QImageReader* self)
    {
        return (unsigned)self->error();
    }

    void __QtAda_QImageReader_errorString_Q(QString* returns, const QImageReader* self)
    {
        *returns = self->errorString();
    }

    void __QtAda_QImageReader_fileName_Q(QString* returns, const QImageReader* self)
    {
        *returns = self->fileName();
    }

    void __QtAda_QImageReader_format_Q(QByteArray* returns, const QImageReader* self)
    {
        *returns = self->format();
    }

    int __QtAda_QImageReader_imageCount_Q(const QImageReader* self)
    {
        return self->imageCount();
    }

    unsigned __QtAda_QImageReader_imageFormat_Q(const QImageReader* self)
    {
        return (unsigned)self->imageFormat();
    }

    unsigned __QtAda_QImageReader_jumpToImage_int(QImageReader* self, int imageNumber)
    {
        return (unsigned)self->jumpToImage(imageNumber);
    }

    unsigned __QtAda_QImageReader_jumpToNextImage(QImageReader* self)
    {
        return (unsigned)self->jumpToNextImage();
    }

    int __QtAda_QImageReader_loopCount_Q(const QImageReader* self)
    {
        return self->loopCount();
    }

    int __QtAda_QImageReader_nextImageDelay_Q(const QImageReader* self)
    {
        return self->nextImageDelay();
    }

    int __QtAda_QImageReader_quality_Q(const QImageReader* self)
    {
        return self->quality();
    }

    void __QtAda_QImageReader_read(QImage* returns, QImageReader* self)
    {
        *returns = self->read();
    }

    unsigned __QtAda_QImageReader_read_QImageP(QImageReader* self, QImage* image)
    {
        return (unsigned)self->read(image);
    }

    void __QtAda_QImageReader_scaledClipRect_Q(QRect* returns, const QImageReader* self)
    {
        *returns = self->scaledClipRect();
    }

    void __QtAda_QImageReader_scaledSize_Q(QSize* returns, const QImageReader* self)
    {
        *returns = self->scaledSize();
    }

    void __QtAda_QImageReader_setAutoDetectImageFormat_bool(QImageReader* self, unsigned enabled)
    {
        self->setAutoDetectImageFormat((bool)enabled);
    }

    void __QtAda_QImageReader_setBackgroundColor_QColorCR(QImageReader* self, const QColor* color)
    {
        self->setBackgroundColor(*color);
    }

    void __QtAda_QImageReader_setClipRect_QRectCR(QImageReader* self, const QRect* rect)
    {
        self->setClipRect(*rect);
    }

    void __QtAda_QImageReader_setDecideFormatFromContent_bool(QImageReader* self, unsigned ignored)
    {
        self->setDecideFormatFromContent((bool)ignored);
    }

    void __QtAda_QImageReader_setFileName_QStringCR(QImageReader* self, const QString* fileName)
    {
        self->setFileName(*fileName);
    }

    void __QtAda_QImageReader_setFormat_QByteArrayCR(QImageReader* self, const QByteArray* format)
    {
        self->setFormat(*format);
    }

    void __QtAda_QImageReader_setQuality_int(QImageReader* self, int quality)
    {
        self->setQuality(quality);
    }

    void __QtAda_QImageReader_setScaledClipRect_QRectCR(QImageReader* self, const QRect* rect)
    {
        self->setScaledClipRect(*rect);
    }

    void __QtAda_QImageReader_setScaledSize_QSizeCR(QImageReader* self, const QSize* size)
    {
        self->setScaledSize(*size);
    }

    void __QtAda_QImageReader_size_Q(QSize* returns, const QImageReader* self)
    {
        *returns = self->size();
    }

    unsigned __QtAda_QImageReader_supportsAnimation_Q(const QImageReader* self)
    {
        return (unsigned)self->supportsAnimation();
    }

    unsigned __QtAda_QImageReader_supportsOption_ImageOption_Q(const QImageReader* self, unsigned option)
    {
        return (unsigned)self->supportsOption((QImageIOHandler::ImageOption)option);
    }

    void __QtAda_QImageReader_text_QStringCR_Q(QString* returns, const QImageReader* self, const QString* key)
    {
        *returns = self->text(*key);
    }

    void __QtAda_QImageReader_textKeys_Q(QStringList* returns, const QImageReader* self)
    {
        *returns = self->textKeys();
    }

    void __QtAda_QImageReader_imageFormat_QStringCR_S(QByteArray* returns, const QString* fileName)
    {
        *returns = QImageReader::imageFormat(*fileName);
    }

    void __QtAda_QImageReader_supportedImageFormats_S(QList<QByteArray>* returns)
    {
        *returns = QImageReader::supportedImageFormats();
    }

};

