//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3863 $ $Date: 2012-04-08 09:49:28 +0400 (Sun, 08 Apr 2012) $
//--------------------------------------------------------------------------//
#include <new>
#include <QImage>
#include <QMatrix>
#include <QPoint>
#include <QRect>
#include <QSize>
#include <QString>
#include <QStringList>
#include <QTransform>
#include "qimagewrapper.h"

extern "C"
{

    QImage* __QtAda_inititialize_QImage(void* storage)
    {
        return new (storage) QImage();
    }

    QImage* __QtAda_inititialize_QImage_QSizeCR_Format(void* storage, const QSize* size, unsigned format)
    {
        return new (storage) QImage(*size, (QImage::Format)format);
    }

    QImage* __QtAda_inititialize_QImage_int_int_Format(void* storage, int width, int height, unsigned format)
    {
        return new (storage) QImage(width, height, (QImage::Format)format);
    }

    QImage* __QtAda_adjust_QImage(void* storage, const QImage* from)
    {
        return new (storage) QImage(*from);
    }

    void __QtAda_finalize_QImage(QImage *item)
    {
        item->~QImage();
    }

    unsigned __QtAda_QImage_allGray_Q(const QImage* self)
    {
        return (unsigned)self->allGray();
    }

    void __QtAda_QImage_alphaChannel_Q(QImage* returns, const QImage* self)
    {
        *returns = self->alphaChannel();
    }

    int __QtAda_QImage_bytesPerLine_Q(const QImage* self)
    {
        return self->bytesPerLine();
    }

    qint64 __QtAda_QImage_cacheKey_Q(const QImage* self)
    {
        return self->cacheKey();
    }

    void __QtAda_QImage_copy_QRectCR_Q(QImage* returns, const QImage* self, const QRect* rectangle)
    {
        *returns = self->copy(*rectangle);
    }

    void __QtAda_QImage_copy_int_int_int_int_Q(QImage* returns, const QImage* self, int x, int y, int width, int height)
    {
        *returns = self->copy(x, y, width, height);
    }

    void __QtAda_QImage_createHeuristicMask_bool_Q(QImage* returns, const QImage* self, unsigned clipTight)
    {
        *returns = self->createHeuristicMask((bool)clipTight);
    }

    int __QtAda_QImage_depth_Q(const QImage* self)
    {
        return self->depth();
    }

    int __QtAda_QImage_dotsPerMeterX_Q(const QImage* self)
    {
        return self->dotsPerMeterX();
    }

    int __QtAda_QImage_dotsPerMeterY_Q(const QImage* self)
    {
        return self->dotsPerMeterY();
    }

    void __QtAda_QImage_fill(QImage* self, unsigned pixel)
    {
        self->fill(pixel);
    }

    unsigned __QtAda_QImage_format_Q(const QImage* self)
    {
        return (unsigned)self->format();
    }

    unsigned __QtAda_QImage_hasAlphaChannel_Q(const QImage* self)
    {
        return (unsigned)self->hasAlphaChannel();
    }

    int __QtAda_QImage_height_Q(const QImage* self)
    {
        return self->height();
    }

    void __QtAda_QImage_invertPixels_InvertMode(QImage* self, unsigned mode)
    {
        self->invertPixels((QImage::InvertMode)mode);
    }

    unsigned __QtAda_QImage_isGrayscale_Q(const QImage* self)
    {
        return (unsigned)self->isGrayscale();
    }

    unsigned __QtAda_QImage_isNull_Q(const QImage* self)
    {
        return (unsigned)self->isNull();
    }

    void __QtAda_QImage_mirrored_bool_bool_Q(QImage* returns, const QImage* self, unsigned horizontally, unsigned vertically)
    {
        *returns = self->mirrored((bool)horizontally, (bool)vertically);
    }

    int __QtAda_QImage_numBytes_Q(const QImage* self)
    {
        return self->numBytes();
    }

    int __QtAda_QImage_numColors_Q(const QImage* self)
    {
        return self->numColors();
    }

    void __QtAda_QImage_offset_Q(QPoint* returns, const QImage* self)
    {
        *returns = self->offset();
    }

    QRgb __QtAda_QImage_pixel_QPointCR_Q(const QImage* self, const QPoint* position)
    {
        return self->pixel(*position);
    }

    QRgb __QtAda_QImage_pixel_int_int_Q(const QImage* self, int x, int y)
    {
        return self->pixel(x, y);
    }

    int __QtAda_QImage_pixelIndex_QPointCR_Q(const QImage* self, const QPoint* position)
    {
        return self->pixelIndex(*position);
    }

    int __QtAda_QImage_pixelIndex_int_int_Q(const QImage* self, int x, int y)
    {
        return self->pixelIndex(x, y);
    }

    void __QtAda_QImage_rect_Q(QRect* returns, const QImage* self)
    {
        *returns = self->rect();
    }

    void __QtAda_QImage_rgbSwapped_Q(QImage* returns, const QImage* self)
    {
        *returns = self->rgbSwapped();
    }

    void __QtAda_QImage_scaled_QSizeCR_AspectRatioMode_TransformationMode_Q(QImage* returns, const QImage* self, const QSize* size, unsigned aspectMode, unsigned mode)
    {
        *returns = self->scaled(*size, (Qt::AspectRatioMode)aspectMode, (Qt::TransformationMode)mode);
    }

    void __QtAda_QImage_scaled_int_int_AspectRatioMode_TransformationMode_Q(QImage* returns, const QImage* self, int width, int height, unsigned aspectMode, unsigned mode)
    {
        *returns = self->scaled(width, height, (Qt::AspectRatioMode)aspectMode, (Qt::TransformationMode)mode);
    }

    void __QtAda_QImage_scaledToHeight_int_TransformationMode_Q(QImage* returns, const QImage* self, int height, unsigned mode)
    {
        *returns = self->scaledToHeight(height, (Qt::TransformationMode)mode);
    }

    void __QtAda_QImage_scaledToWidth_int_TransformationMode_Q(QImage* returns, const QImage* self, int width, unsigned mode)
    {
        *returns = self->scaledToWidth(width, (Qt::TransformationMode)mode);
    }

    void __QtAda_QImage_setAlphaChannel_QImageCR(QImage* self, const QImage* alphaChannel)
    {
        self->setAlphaChannel(*alphaChannel);
    }

    void __QtAda_QImage_setDotsPerMeterX_int(QImage* self, int x)
    {
        self->setDotsPerMeterX(x);
    }

    void __QtAda_QImage_setDotsPerMeterY_int(QImage* self, int y)
    {
        self->setDotsPerMeterY(y);
    }

    void __QtAda_QImage_setNumColors_int(QImage* self, int numColors)
    {
        self->setNumColors(numColors);
    }

    void __QtAda_QImage_setOffset_QPointCR(QImage* self, const QPoint* offset)
    {
        self->setOffset(*offset);
    }

    void __QtAda_QImage_setPixel_QPointCR_uint(QImage* self, const QPoint* position, uint index)
    {
        self->setPixel(*position, index);
    }

    void __QtAda_QImage_setPixel_int_int_uint(QImage* self, int x, int y, uint index)
    {
        self->setPixel(x, y, index);
    }

    void __QtAda_QImage_setText_QStringCR_QStringCR(QImage* self, const QString* key, const QString* text)
    {
        self->setText(*key, *text);
    }

    void __QtAda_QImage_size_Q(QSize* returns, const QImage* self)
    {
        *returns = self->size();
    }

    void __QtAda_QImage_text_QStringCR_Q(QString* returns, const QImage* self, const QString* key)
    {
        *returns = self->text(*key);
    }

    void __QtAda_QImage_textKeys_Q(QStringList* returns, const QImage* self)
    {
        *returns = self->textKeys();
    }

    void __QtAda_QImage_transformed_QMatrixCR_TransformationMode_Q(QImage* returns, const QImage* self, const QMatrix* matrix, unsigned mode)
    {
        *returns = self->transformed(*matrix, (Qt::TransformationMode)mode);
    }

    void __QtAda_QImage_transformed_QTransformCR_TransformationMode_Q(QImage* returns, const QImage* self, const QTransform* matrix, unsigned mode)
    {
        *returns = self->transformed(*matrix, (Qt::TransformationMode)mode);
    }

    unsigned __QtAda_QImage_valid_QPointCR_Q(const QImage* self, const QPoint* pos)
    {
        return (unsigned)self->valid(*pos);
    }

    unsigned __QtAda_QImage_valid_int_int_Q(const QImage* self, int x, int y)
    {
        return (unsigned)self->valid(x, y);
    }

    int __QtAda_QImage_width_Q(const QImage* self)
    {
        return self->width();
    }

    unsigned __QtAda_QImage_eq_QImageCR_Q(const QImage* self, const QImage* image)
    {
        return (unsigned)self->operator==(*image);
    }

    void __QtAda_QImage_trueMatrix_QMatrixCR_int_int_S(QMatrix* returns, const QMatrix* matrix, int width, int height)
    {
        *returns = QImage::trueMatrix(*matrix, width, height);
    }

    void __QtAda_QImage_trueMatrix_QTransformCR_int_int_S(QTransform* returns, const QTransform* matrix, int width, int height)
    {
        *returns = QImage::trueMatrix(*matrix, width, height);
    }

    QPaintDevice* __QtAda_QImage_QPaintDevice_View(QImage* self)
    {
        return static_cast<QPaintDevice*>(self);
    }

};

