//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3713 $ $Date: 2010-01-22 13:13:26 +0300 (Fri, 22 Jan 2010) $
//--------------------------------------------------------------------------//
#include <QImage>

extern "C"
{
    extern QImage* __QtAda_inititialize_QImage(void*);
    extern QImage* __QtAda_inititialize_QImage_QSizeCR_Format(void*, const QSize*, unsigned);
    extern QImage* __QtAda_inititialize_QImage_int_int_Format(void*, int, int, unsigned);
    extern QImage* __QtAda_adjust_QImage(void*, const QImage*);
    extern void __QtAda_finalize_QImage(QImage*);

    extern unsigned __QtAda_QImage_allGray_Q(const QImage*);
    extern void __QtAda_QImage_alphaChannel_Q(QImage*, const QImage*);
    extern int __QtAda_QImage_bytesPerLine_Q(const QImage*);
    extern qint64 __QtAda_QImage_cacheKey_Q(const QImage*);
    extern void __QtAda_QImage_copy_QRectCR_Q(QImage*, const QImage*, const QRect*);
    extern void __QtAda_QImage_copy_int_int_int_int_Q(QImage*, const QImage*, int, int, int, int);
    extern void __QtAda_QImage_createHeuristicMask_bool_Q(QImage*, const QImage*, unsigned);
    extern int __QtAda_QImage_depth_Q(const QImage*);
    extern int __QtAda_QImage_dotsPerMeterX_Q(const QImage*);
    extern int __QtAda_QImage_dotsPerMeterY_Q(const QImage*);
    extern void __QtAda_QImage_fill(QImage*, unsigned);
    extern unsigned __QtAda_QImage_format_Q(const QImage*);
    extern unsigned __QtAda_QImage_hasAlphaChannel_Q(const QImage*);
    extern int __QtAda_QImage_height_Q(const QImage*);
    extern void __QtAda_QImage_invertPixels_InvertMode(QImage*, unsigned);
    extern unsigned __QtAda_QImage_isGrayscale_Q(const QImage*);
    extern unsigned __QtAda_QImage_isNull_Q(const QImage*);
    extern void __QtAda_QImage_mirrored_bool_bool_Q(QImage*, const QImage*, unsigned, unsigned);
    extern int __QtAda_QImage_numBytes_Q(const QImage*);
    extern int __QtAda_QImage_numColors_Q(const QImage*);
    extern void __QtAda_QImage_offset_Q(QPoint*, const QImage*);
    extern QRgb __QtAda_QImage_pixel_QPointCR_Q(const QImage*, const QPoint*);
    extern QRgb __QtAda_QImage_pixel_int_int_Q(const QImage*, int, int);
    extern int __QtAda_QImage_pixelIndex_QPointCR_Q(const QImage*, const QPoint*);
    extern int __QtAda_QImage_pixelIndex_int_int_Q(const QImage*, int, int);
    extern void __QtAda_QImage_rect_Q(QRect*, const QImage*);
    extern void __QtAda_QImage_rgbSwapped_Q(QImage*, const QImage*);
    extern void __QtAda_QImage_scaled_QSizeCR_AspectRatioMode_TransformationMode_Q(QImage*, const QImage*, const QSize*, unsigned, unsigned);
    extern void __QtAda_QImage_scaled_int_int_AspectRatioMode_TransformationMode_Q(QImage*, const QImage*, int, int, unsigned, unsigned);
    extern void __QtAda_QImage_scaledToHeight_int_TransformationMode_Q(QImage*, const QImage*, int, unsigned);
    extern void __QtAda_QImage_scaledToWidth_int_TransformationMode_Q(QImage*, const QImage*, int, unsigned);
    extern void __QtAda_QImage_setAlphaChannel_QImageCR(QImage*, const QImage*);
    extern void __QtAda_QImage_setDotsPerMeterX_int(QImage*, int);
    extern void __QtAda_QImage_setDotsPerMeterY_int(QImage*, int);
    extern void __QtAda_QImage_setNumColors_int(QImage*, int);
    extern void __QtAda_QImage_setOffset_QPointCR(QImage*, const QPoint*);
    extern void __QtAda_QImage_setPixel_QPointCR_uint(QImage*, const QPoint*, uint);
    extern void __QtAda_QImage_setPixel_int_int_uint(QImage*, int, int, uint);
    extern void __QtAda_QImage_setText_QStringCR_QStringCR(QImage*, const QString*, const QString*);
    extern void __QtAda_QImage_size_Q(QSize*, const QImage*);
    extern void __QtAda_QImage_text_QStringCR_Q(QString*, const QImage*, const QString*);
    extern void __QtAda_QImage_textKeys_Q(QStringList*, const QImage*);
    extern void __QtAda_QImage_transformed_QMatrixCR_TransformationMode_Q(QImage*, const QImage*, const QMatrix*, unsigned);
    extern void __QtAda_QImage_transformed_QTransformCR_TransformationMode_Q(QImage*, const QImage*, const QTransform*, unsigned);
    extern unsigned __QtAda_QImage_valid_QPointCR_Q(const QImage*, const QPoint*);
    extern unsigned __QtAda_QImage_valid_int_int_Q(const QImage*, int, int);
    extern int __QtAda_QImage_width_Q(const QImage*);
    extern unsigned __QtAda_QImage_eq_QImageCR_Q(const QImage*, const QImage*);
    extern void __QtAda_QImage_trueMatrix_QMatrixCR_int_int_S(QMatrix*, const QMatrix*, int, int);
    extern void __QtAda_QImage_trueMatrix_QTransformCR_int_int_S(QTransform*, const QTransform*, int, int);

    extern QPaintDevice* __QtAda_QImage_QPaintDevice_View(QImage*);

};

