//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2010-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3863 $ $Date: 2012-04-08 09:49:28 +0400 (Sun, 08 Apr 2012) $
//--------------------------------------------------------------------------//
#include <new>
#include <QByteArray>
#include <QList>
#include <QString>
#include "qimagewriterwrapper.h"

extern "C"
{

    QImageWriter* __QtAda_inititialize_QImageWriter(void* storage)
    {
        return new (storage) QImageWriter();
    }

    QImageWriter* __QtAda_inititialize_QImageWriter_QStringCR_QByteArrayCR(void* storage, const QString* fileName, const QByteArray* format)
    {
        return new (storage) QImageWriter(*fileName, *format);
    }

    void __QtAda_finalize_QImageWriter(QImageWriter *item)
    {
        item->~QImageWriter();
    }

    unsigned __QtAda_QImageWriter_canWrite_Q(const QImageWriter* self)
    {
        return (unsigned)self->canWrite();
    }

    int __QtAda_QImageWriter_compression_Q(const QImageWriter* self)
    {
        return self->compression();
    }

    unsigned __QtAda_QImageWriter_error_Q(const QImageWriter* self)
    {
        return (unsigned)self->error();
    }

    void __QtAda_QImageWriter_errorString_Q(QString* returns, const QImageWriter* self)
    {
        *returns = self->errorString();
    }

    void __QtAda_QImageWriter_fileName_Q(QString* returns, const QImageWriter* self)
    {
        *returns = self->fileName();
    }

    void __QtAda_QImageWriter_format_Q(QByteArray* returns, const QImageWriter* self)
    {
        *returns = self->format();
    }

    float __QtAda_QImageWriter_gamma_Q(const QImageWriter* self)
    {
        return self->gamma();
    }

    int __QtAda_QImageWriter_quality_Q(const QImageWriter* self)
    {
        return self->quality();
    }

    void __QtAda_QImageWriter_setCompression_int(QImageWriter* self, int compression)
    {
        self->setCompression(compression);
    }

    void __QtAda_QImageWriter_setFileName_QStringCR(QImageWriter* self, const QString* fileName)
    {
        self->setFileName(*fileName);
    }

    void __QtAda_QImageWriter_setFormat_QByteArrayCR(QImageWriter* self, const QByteArray* format)
    {
        self->setFormat(*format);
    }

    void __QtAda_QImageWriter_setGamma_float(QImageWriter* self, float gamma)
    {
        self->setGamma(gamma);
    }

    void __QtAda_QImageWriter_setQuality_int(QImageWriter* self, int quality)
    {
        self->setQuality(quality);
    }

    void __QtAda_QImageWriter_setText_QStringCR_QStringCR(QImageWriter* self, const QString* key, const QString* text)
    {
        self->setText(*key, *text);
    }

    unsigned __QtAda_QImageWriter_supportsOption_ImageOption_Q(const QImageWriter* self, unsigned option)
    {
        return (unsigned)self->supportsOption((QImageIOHandler::ImageOption)option);
    }

    unsigned __QtAda_QImageWriter_write_QImageCR(QImageWriter* self, const QImage* image)
    {
        return (unsigned)self->write(*image);
    }

    void __QtAda_QImageWriter_supportedImageFormats_S(QList<QByteArray>* returns)
    {
        *returns = QImageWriter::supportedImageFormats();
    }

};

