//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 3779 $ $Date: 2010-10-24 14:24:12 +0400 (Sun, 24 Oct 2010) $
//----------------------------------------------------------------------------
#include "qobjectdirector.h"
#include "qkeyeventwrapper.h"

extern "C" {

    int __Qt4Ada_QKeyEvent_count_wrapper (QEvent*cpp_object)
    {
         return dynamic_cast <QKeyEvent*>(cpp_object)->count();
    }

    bool __Qt4Ada_QKeyEvent_isAutoRepeat_wrapper (QEvent*cpp_object)
    {
         return dynamic_cast <QKeyEvent*>(cpp_object)->isAutoRepeat();
    }

    unsigned __Qt4Ada_QKeyEvent_key_wrapper (QEvent*cpp_object)
    {
         return (unsigned) dynamic_cast <QKeyEvent*>(cpp_object)->key();
    }

    unsigned int __Qt4Ada_QKeyEvent_nativeModifiers_wrapper (QEvent*cpp_object)
    {
         return dynamic_cast <QKeyEvent*>(cpp_object)->nativeModifiers();
    }

    unsigned int __Qt4Ada_QKeyEvent_nativeScanCode_wrapper (QEvent*cpp_object)
    {
         return dynamic_cast <QKeyEvent*>(cpp_object)->nativeScanCode();
    }

    unsigned int __Qt4Ada_QKeyEvent_nativeVirtualKey_wrapper (QEvent*cpp_object)
    {
         return dynamic_cast <QKeyEvent*>(cpp_object)->nativeVirtualKey();
    }

    QString* __Qt4Ada_QKeyEvent_text_wrapper (QEvent*cpp_object)
    {
         return new QString (dynamic_cast <QKeyEvent*>(cpp_object)->text());
    }

    QEvent*__Qt4Ada_new_QKeyEvent_wrapper (int type,
                                           int key,
                                           unsigned modifiers,
                                           const char *text,
                                           bool autorep,
                                           ushort count)
    {
      return dynamic_cast <QEvent*> (new QKeyEvent ((QEvent::Type)type,
                                                     key,
                                                     (Qt::KeyboardModifiers)modifiers,
                                                     QString (text),
                                                     autorep,
                                                     count));
    }
}
