//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2733 $ $Date: 2008-05-14 08:54:18 +0400 (Wed, 14 May 2008) $
//----------------------------------------------------------------------------
#include <QWidget>
#include <QLayout>
#include "qlayoutitemdirector.h"

/*
// QSize QLayoutItemDirector::sizeHint()
// {
//     return __Qt4Ada_QLayoutItem_sizeHint_dispatch(this->ada_object);
// }
//
// QSize QLayoutItemDirector::minimumSize()
// {
//     return __Qt4Ada_QLayoutItem_minimumSize_dispatch(this->ada_object);
// }
//
// QSize QLayoutItemDirector::maximumSize()
// {
//     return __Qt4Ada_QLayoutItem_maximumSize_dispatch(this->ada_object);
// }

Qt::Orientations QLayoutItemDirector::expandingDirections()
{
    return __Qt4Ada_QLayoutItem_expandingDirections_dispatch(this->ada_object);
}

// void QLayoutItemDirector::setGeometry(const QRect&_p1)
// {
//     __Qt4Ada_QLayoutItem_setGeometry_dispatch(this->ada_object,_p1);
// }
//
// QRect QLayoutItemDirector::geometry()
// {
//     return __Qt4Ada_QLayoutItem_geometry_dispatch(this->ada_object);
// }

bool QLayoutItemDirector::isEmpty()
{
    return __Qt4Ada_QLayoutItem_isEmpty_dispatch(this->ada_object);
}

bool QLayoutItemDirector::hasHeightForWidth()
{
    return __Qt4Ada_QLayoutItem_hasHeightForWidth_0_dispatch(this->ada_object);
}

int QLayoutItemDirector::heightForWidth(int _p1)
{
    return __Qt4Ada_QLayoutItem_heightForWidth_dispatch(this->ada_object,_p1);
}

// int QLayoutItemDirector::minimumHeightForWidth(int _p1)
// {
//     return __Qt4Ada_QLayoutItem_minimumHeightForWidth_dispatch(this->ada_object,_p1);
// }

void QLayoutItemDirector::invalidate()
{
    __Qt4Ada_QLayoutItem_invalidate_dispatch(this->ada_object);
}

// QWidget*QLayoutItemDirector::widget()
// {
//     return dynamic_cast<QWidget*>(__Qt4Ada_QLayoutItem_widget_dispatch(this->ada_object));
// }
//
// QLayout*QLayoutItemDirector::layout()
// {
//     return dynamic_cast<QLayout*>(__Qt4Ada_QLayoutItem_layout_dispatch(this->ada_object));
// }
//
// QSpacerItem*QLayoutItemDirector::spacerItem()
// {
//     return dynamic_cast<QSpacerItem*>(__Qt4Ada_QLayoutItem_spacerItem_dispatch(this->ada_object));
// }

*/

extern "C" {

    Qt::Orientations __Qt4Ada_QLayoutItem_expandingDirections_virtual(QLayoutItem*cpp_this)
    {
        return cpp_this->expandingDirections();
    }

//     void __Qt4Ada_QLayoutItem_setGeometry_virtual(QLayoutItem*cpp_this,const QRect&_p1)
//     {
//     cpp_this->setGeometry(_p1);
//     }
//
//     QRect __Qt4Ada_QLayoutItem_geometry_virtual(QLayoutItem*cpp_this)
//     {
//         return cpp_this->geometry();
//     }

    bool __Qt4Ada_QLayoutItem_hasHeightForWidth_0_virtual(QLayoutItem*cpp_this)
    {
        return cpp_this->hasHeightForWidth();
    }

    bool __Qt4Ada_QLayoutItem_hasHeightForWidth_0_wrapper(QLayoutItem*cpp_this)
    {
        return cpp_this->QLayoutItem::hasHeightForWidth();
    }

    int __Qt4Ada_QLayoutItem_heightForWidth_0_virtual(QLayoutItem*cpp_this,int _p1)
    {
        return cpp_this->heightForWidth(_p1);
    }

    int __Qt4Ada_QLayoutItem_heightForWidth_0_wrapper(QLayoutItem*cpp_this,int _p1)
    {
        return cpp_this->QLayoutItem::heightForWidth(_p1);
    }

    bool __Qt4Ada_QLayoutItem_isEmpty_0_virtual(QLayoutItem*cpp_this)
    {
        return cpp_this->isEmpty();
    }

    void __Qt4Ada_QLayoutItem_invalidate_0_virtual(QLayoutItem*cpp_this)
    {
        cpp_this->invalidate();
    }

    void __Qt4Ada_QLayoutItem_invalidate_0_wrapper(QLayoutItem*cpp_this)
    {
        cpp_this->QLayoutItem::invalidate();
    }

    QObject* __Qt4Ada_QLayoutItem_layout_0_virtual(QLayoutItem*cpp_this)
    {
        return static_cast<QObject*>(cpp_this->layout());
    }

    QObject*__Qt4Ada_QLayoutItem_layout_0_wrapper(QLayoutItem*cpp_this)
    {
        return static_cast<QObject*>(cpp_this->QLayoutItem::layout());
    }

    void __Qt4Ada_QLayoutItem_maximumSize_0_virtual(QLayoutItem* cpp_object, QSize* returns)
    {
        *returns = cpp_object->maximumSize();
    }

    int __Qt4Ada_QLayoutItem_minimumHeightForWidth_0_virtual(QLayoutItem*cpp_this,int _p1)
    {
        return cpp_this->minimumHeightForWidth(_p1);
    }

    int __Qt4Ada_QLayoutItem_minimumHeightForWidth_0_wrapper(QLayoutItem*cpp_this,int _p1)
    {
        return cpp_this->QLayoutItem::minimumHeightForWidth(_p1);
    }

    void __Qt4Ada_QLayoutItem_minimumSize_0_virtual(QLayoutItem* cpp_object, QSize* returns)
    {
        *returns = cpp_object->minimumSize();
    }

    void __Qt4Ada_QLayoutItem_sizeHint_0_virtual(QLayoutItem* cpp_object, QSize* returns)
    {
        *returns = cpp_object->sizeHint();
    }

    QObject*__Qt4Ada_QLayoutItem_widget_0_virtual(QLayoutItem*cpp_this)
    {
        return static_cast<QObject*>(cpp_this->widget());
    }

    QObject*__Qt4Ada_QLayoutItem_widget_0_wrapper(QLayoutItem*cpp_this)
    {
        return static_cast<QObject*>(cpp_this->QLayoutItem::widget());
    }

//     QLayoutItem*__Qt4Ada_QLayoutItem_spacerItem_virtual(QLayoutItem*cpp_this)
//     {
//         return cpp_this->spacerItem();
//     }
//
//     Qt::Orientations __Qt4Ada_QLayoutItem_expandingDirections_wrapper(QLayoutItem*cpp_this)
//     {
//         return cpp_this->QLayoutItem::expandingDirections();
//     }
//
//     void __Qt4Ada_QLayoutItem_setGeometry_wrapper(QLayoutItem*cpp_this,const QRect&_p1)
//     {
//     cpp_this->QLayoutItem::setGeometry(_p1);
//     }
//
//     QRect __Qt4Ada_QLayoutItem_geometry_wrapper(QLayoutItem*cpp_this)
//     {
//         return cpp_this->QLayoutItem::geometry();
//     }

//     QLayoutItem*__Qt4Ada_QLayoutItem_spacerItem_wrapper(QLayoutItem*cpp_this)
//     {
//         return cpp_this->QLayoutItem::spacerItem();
//     }

}
