//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2733 $ $Date: 2008-05-14 08:54:18 +0400 (Wed, 14 May 2008) $
//----------------------------------------------------------------------------
#ifndef __QLAYOUTITEMDIRECTOR_H__
#define __QLAYOUTITEMDIRECTOR_H__

#include <QLayoutItem>
#include "qobjectdirector.h"

extern "C" {

    //  Declarations of exported functions

    extern Qt::Orientations __Qt4Ada_QLayoutItem_expandingDirections_dispatch(void *);
//     extern void __Qt4Ada_QLayoutItem_setGeometry_dispatch(void *,const QRect&);
//     extern QRect __Qt4Ada_QLayoutItem_geometry_dispatch(void *);
    extern bool __Qt4Ada_QLayoutItem_hasHeightForWidth_0_dispatch(void *);
    extern int __Qt4Ada_QLayoutItem_heightForWidth_0_dispatch(void *,int );
    extern void __Qt4Ada_QLayoutItem_invalidate_0_dispatch(void *);
    extern bool __Qt4Ada_QLayoutItem_isEmpty_0_dispatch(void *);
    extern QObject*__Qt4Ada_QLayoutItem_layout_0_dispatch(void *);
    extern QSize* __Qt4Ada_QLayoutItem_maximumSize_0_dispatch(void*);
    extern QSize* __Qt4Ada_QLayoutItem_minimumSize_0_dispatch(void*);
    extern QSize* __Qt4Ada_QLayoutItem_sizeHint_0_dispatch(void*);
    extern QObject*__Qt4Ada_QLayoutItem_widget_0_dispatch(void *);
    extern int __Qt4Ada_QLayoutItem_minimumHeightForWidth_0_dispatch(void *,int );
//     extern QLayoutItem*__Qt4Ada_QLayoutItem_spacerItem_dispatch(void *);

    //  Declarations of wrapper functions for virtual call

    extern Qt::Orientations __Qt4Ada_QLayoutItem_expandingDirections_virtual(QLayoutItem*);
//     extern void __Qt4Ada_QLayoutItem_setGeometry_virtual(QLayoutItem*,const QRect&);
//     extern QRect __Qt4Ada_QLayoutItem_geometry_virtual(QLayoutItem*);
    extern bool __Qt4Ada_QLayoutItem_hasHeightForWidth_0_virtual(QLayoutItem*);
    extern int __Qt4Ada_QLayoutItem_heightForWidth_0_virtual(QLayoutItem*,int );
    extern void __Qt4Ada_QLayoutItem_invalidate_0_virtual(QLayoutItem*);
    extern bool __Qt4Ada_QLayoutItem_isEmpty_0_virtual(QLayoutItem*);
    extern QObject*__Qt4Ada_QLayoutItem_layout_0_virtual(QLayoutItem*);
    extern void __Qt4Ada_QLayoutItem_maximumSize_0_virtual(QLayoutItem*, QSize*);
    extern void __Qt4Ada_QLayoutItem_minimumSize_0_virtual(QLayoutItem*, QSize*);
    extern void __Qt4Ada_QLayoutItem_sizeHint_0_virtual(QLayoutItem*, QSize*);
    extern QObject*__Qt4Ada_QLayoutItem_widget_0_virtual(QLayoutItem*);
    extern int __Qt4Ada_QLayoutItem_minimumHeightForWidth_0_virtual(QLayoutItem*,int );
//     extern QLayoutItem*__Qt4Ada_QLayoutItem_spacerItem_virtual(QLayoutItem*);

    //  Declarations of wrapper functions for static call

//     extern Qt::Orientations __Qt4Ada_QLayoutItem_expandingDirections_wrapper(QLayoutItem*);
//     extern void __Qt4Ada_QLayoutItem_setGeometry_wrapper(QLayoutItem*,const QRect&);
//     extern QRect __Qt4Ada_QLayoutItem_geometry_wrapper(QLayoutItem*);
    extern bool __Qt4Ada_QLayoutItem_hasHeightForWidth_0_wrapper(QLayoutItem*);
    extern int __Qt4Ada_QLayoutItem_heightForWidth_0_wrapper(QLayoutItem*,int );
    extern void __Qt4Ada_QLayoutItem_invalidate_0_wrapper(QLayoutItem*);
    extern QObject*__Qt4Ada_QLayoutItem_layout_0_wrapper(QLayoutItem*);
    extern QObject*__Qt4Ada_QLayoutItem_widget_0_wrapper(QLayoutItem*);
    extern int __Qt4Ada_QLayoutItem_minimumHeightForWidth_0_wrapper(QLayoutItem*,int );
//     extern QLayoutItem*__Qt4Ada_QLayoutItem_spacerItem_wrapper(QLayoutItem*);

}

/*
class QLayoutItemDirector : public QLayoutItem, public Qt4AdaLimitedEntityDirector
{
protected:
    QLayoutItemDirector();

    virtual QSize sizeHint();
    virtual QSize minimumSize();
    virtual QSize maximumSize();
    virtual Qt::Orientations expandingDirections();
    virtual void setGeometry(const QRect&);
    virtual QRect geometry();
    virtual bool isEmpty();
    virtual bool hasHeightForWidth();
    virtual int heightForWidth(int );
    virtual int minimumHeightForWidth(int );
    virtual void invalidate();
    virtual QWidget*widget();
    virtual QLayout*layout();
    virtual QSpacerItem*spacerItem();


};
*/

#endif // __QLAYOUTITEMDIRECTOR_H__
