//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2733 $ $Date: 2008-05-14 08:54:18 +0400 (Wed, 14 May 2008) $
//----------------------------------------------------------------------------
#include "qlistofqgraphicsitemwrapper.h"

extern "C"
{

    QList<QGraphicsItem*>* __Qt4Ada_new_QListOfQGraphicsItem()
    {
        return new QList<QGraphicsItem*>;
    }

    QList<QGraphicsItem*>* __Qt4Ada_copy_QListOfQGraphicsItem
       (const QList<QGraphicsItem*>* cpp_object)
    {
        return new QList<QGraphicsItem*>(*cpp_object);
    }

    void __Qt4Ada_delete_QListOfQGraphicsItem (QList<QGraphicsItem*>* cpp_object)
    {
        delete cpp_object;
    }

    bool __Qt4Ada_comparison_QListOfQGraphicsItem_wrapper
        (const QList<QGraphicsItem*>* const left, const QList<QGraphicsItem*>* const right)
    {
        return (*left == *right);
    }

    QGraphicsItem* __Qt4Ada_QListOfQGraphicsItem_value_wrapper
        (QList<QGraphicsItem*>* const cpp_object, int i)
    {
        return cpp_object->value(i);
    }

    void __Qt4Ada_QListOfQGraphicsItem_append_wrapper(QList<QGraphicsItem*>* const cpp_object,
                                                      QGraphicsItem*               value)
    {
        cpp_object->append(value);
    }

    int __Qt4Ada_QListOfQGraphicsItem_count_wrapper(QList<QGraphicsItem*>* const cpp_object)
    {
        return cpp_object->count();
    }

}
