//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QLine>
#include <QLineF>
#include <QMatrix>
#include <QPainterPath>
#include <QPoint>
#include <QPointF>
#include <QPolygon>
#include <QPolygonF>
#include <QRect>
#include <QRectF>
#include <QRegion>
#include <QString>
#include "qmatrixwrapper.h"

extern "C"
{

    QMatrix* __QtAda_inititialize_QMatrix(void* storage)
    {
        return new (storage) QMatrix();
    }

    QMatrix* __QtAda_inititialize_QMatrix_qreal_qreal_qreal_qreal_qreal_qreal(void* storage, double m11, double m12, double m21, double m22, double dx, double dy)
    {
        return new (storage) QMatrix((qreal)m11, (qreal)m12, (qreal)m21, (qreal)m22, (qreal)dx, (qreal)dy);
    }

    QMatrix* __QtAda_adjust_QMatrix(void* storage, const QMatrix* from)
    {
        return new (storage) QMatrix(*from);
    }

    void __QtAda_finalize_QMatrix(QMatrix *item)
    {
        item->~QMatrix();
    }

    double __QtAda_QMatrix_m11_Q(const QMatrix* self)
    {
        return (double)self->m11();
    }

    double __QtAda_QMatrix_m12_Q(const QMatrix* self)
    {
        return (double)self->m12();
    }

    double __QtAda_QMatrix_m21_Q(const QMatrix* self)
    {
        return (double)self->m21();
    }

    double __QtAda_QMatrix_m22_Q(const QMatrix* self)
    {
        return (double)self->m22();
    }

    double __QtAda_QMatrix_det_Q(const QMatrix* self)
    {
        return (double)self->det();
    }

    double __QtAda_QMatrix_dx_Q(const QMatrix* self)
    {
        return (double)self->dx();
    }

    double __QtAda_QMatrix_dy_Q(const QMatrix* self)
    {
        return (double)self->dy();
    }

    void __QtAda_QMatrix_inverted_Q(QMatrix* returns, const QMatrix* self)
    {
        *returns = self->inverted();
    }

    unsigned __QtAda_QMatrix_isIdentity_Q(const QMatrix* self)
    {
        return (unsigned)self->isIdentity();
    }

    unsigned __QtAda_QMatrix_isInvertible_Q(const QMatrix* self)
    {
        return (unsigned)self->isInvertible();
    }

    void __QtAda_QMatrix_map_qreal_qreal_qrealP_qrealP_Q(const QMatrix* self, double x, double y, double* tx, double* ty)
    {
        self->map((qreal)x, (qreal)y, tx, ty);
    }

    void __QtAda_QMatrix_map_int_int_intP_intP_Q(const QMatrix* self, int x, int y, int* tx, int* ty)
    {
        self->map(x, y, tx, ty);
    }

    void __QtAda_QMatrix_map_QPointCR_Q(QPoint* returns, const QMatrix* self, const QPoint* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QMatrix_map_QPointFCR_Q(QPointF* returns, const QMatrix* self, const QPointF* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QMatrix_map_QLineCR_Q(QLine* returns, const QMatrix* self, const QLine* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QMatrix_map_QLineFCR_Q(QLineF* returns, const QMatrix* self, const QLineF* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QMatrix_map_QPolygonCR_Q(QPolygon* returns, const QMatrix* self, const QPolygon* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QMatrix_map_QPolygonFCR_Q(QPolygonF* returns, const QMatrix* self, const QPolygonF* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QMatrix_map_QRegionCR_Q(QRegion* returns, const QMatrix* self, const QRegion* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QMatrix_map_QPainterPathCR_Q(QPainterPath* returns, const QMatrix* self, const QPainterPath* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QMatrix_mapRect_QRectCR_Q(QRect* returns, const QMatrix* self, const QRect* p)
    {
        *returns = self->mapRect(*p);
    }

    void __QtAda_QMatrix_mapRect_QRectFCR_Q(QRectF* returns, const QMatrix* self, const QRectF* p)
    {
        *returns = self->mapRect(*p);
    }

    void __QtAda_QMatrix_mapToPolygon_QRectCR_Q(QPolygon* returns, const QMatrix* self, const QRect* p)
    {
        *returns = self->mapToPolygon(*p);
    }

    void __QtAda_QMatrix_reset(QMatrix* self)
    {
        self->reset();
    }

    void __QtAda_QMatrix_rotate_qreal(QMatrix* self, double a)
    {
        self->rotate((qreal)a);
    }

    void __QtAda_QMatrix_scale_qreal_qreal(QMatrix* self, double sx, double sy)
    {
        self->scale((qreal)sx, (qreal)sy);
    }

    void __QtAda_QMatrix_setMatrix_qreal_qreal_qreal_qreal_qreal_qreal(QMatrix* self, double m11, double m12, double m21, double m22, double dx, double dy)
    {
        self->setMatrix((qreal)m11, (qreal)m12, (qreal)m21, (qreal)m22, (qreal)dx, (qreal)dy);
    }

    void __QtAda_QMatrix_shear_qreal_qreal(QMatrix* self, double sh, double sv)
    {
        self->shear((qreal)sh, (qreal)sv);
    }

    void __QtAda_QMatrix_translate_qreal_qreal(QMatrix* self, double dx, double dy)
    {
        self->translate((qreal)dx, (qreal)dy);
    }

    unsigned __QtAda_QMatrix_eq_QMatrixCR_Q(const QMatrix* self, const QMatrix* matrix)
    {
        return (unsigned)self->operator==(*matrix);
    }

    void __QtAda_QMatrix_multiplication_QMatrixCR_Q(QMatrix* returns, const QMatrix* self, const QMatrix* o)
    {
        *returns = self->operator*(*o);
    }

    void __QtAda_multiplication_QPointCR_QMatrixCR(QPoint* returns, const QPoint* p, const QMatrix* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QPointFCR_QMatrixCR(QPointF* returns, const QPointF* p, const QMatrix* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QLineCR_QMatrixCR(QLine* returns, const QLine* p, const QMatrix* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QLineFCR_QMatrixCR(QLineF* returns, const QLineF* p, const QMatrix* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QPolygonCR_QMatrixCR(QPolygon* returns, const QPolygon* p, const QMatrix* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QPolygonFCR_QMatrixCR(QPolygonF* returns, const QPolygonF* p, const QMatrix* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QRegionCR_QMatrixCR(QRegion* returns, const QRegion* p, const QMatrix* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QPainterPathCR_QMatrixCR(QPainterPath* returns, const QPainterPath* p, const QMatrix* m)
    {
        *returns = operator*(*p, *m);
    }

};

