//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2733 $ $Date: 2008-05-14 08:54:18 +0400 (Wed, 14 May 2008) $
//----------------------------------------------------------------------------
#include "qobjectdirector.h"
#include "qmouseeventwrapper.h"

extern "C" {

    void __Qt4Ada_QMouseEvent_globalPos_wrapper (QEvent*cpp_object,QPoint* returns)
    {
      *returns = dynamic_cast <QMouseEvent*> (cpp_object) -> globalPos ();
    }

    void __Qt4Ada_QMouseEvent_pos_wrapper (QEvent*cpp_object, QPoint*returns)
    {
      *returns = dynamic_cast <QMouseEvent*> (cpp_object) -> pos ();
    }

    Qt::MouseButton __Qt4Ada_QMouseEvent_button_wrapper (QEvent*cpp_object)
    {
      return dynamic_cast <QMouseEvent*> (cpp_object) -> button ();
    }

    unsigned __Qt4Ada_QMouseEvent_buttons_wrapper (QEvent*cpp_object)
    {
      return dynamic_cast <QMouseEvent*> (cpp_object) -> buttons ();
    }

    int __Qt4Ada_QMouseEvent_globalX_wrapper (QEvent*cpp_object)
    {
      return dynamic_cast <QMouseEvent*> (cpp_object) -> globalX ();
    }
    int __Qt4Ada_QMouseEvent_globalY_wrapper (QEvent*cpp_object)
    {
      return dynamic_cast <QMouseEvent*> (cpp_object) -> globalY ();
    }
    int __Qt4Ada_QMouseEvent_x_wrapper (QEvent*cpp_object)
    {
      return dynamic_cast <QMouseEvent*> (cpp_object) -> x ();
    }
    int __Qt4Ada_QMouseEvent_y_wrapper (QEvent*cpp_object)
    {
      return dynamic_cast <QMouseEvent*> (cpp_object) -> y ();
    }

    QEvent* __Qt4Ada_new_QMouseEvent_wrapper
              (int      type,
               QPoint*  position,
               unsigned button,
               unsigned buttons,
               unsigned modifiers)
    {
        return dynamic_cast <QEvent*>
           (new QMouseEvent (static_cast<QEvent::Type>(type),
                             *position,
                             (Qt::MouseButton) button,
                             (Qt::MouseButtons) buttons,
                             (Qt::KeyboardModifiers) modifiers));
    }

    QEvent* __Qt4Ada_new_QMouseEvent_with_global_pos_wrapper
              (int      type,
               QPoint*  position,
               QPoint*  globalpos,
               unsigned button,
               unsigned buttons,
               unsigned modifiers)
    {
      return dynamic_cast <QEvent*>
          (new QMouseEvent ((QEvent::Type)(type),
                            *position,
                            *globalpos,
                             (Qt::MouseButton) button,
                             (Qt::MouseButtons) buttons,
                             (Qt::KeyboardModifiers) modifiers));
    }
}
