//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 3257 $ $Date: 2009-04-16 10:07:26 +0400 (Thu, 16 Apr 2009) $
//----------------------------------------------------------------------------
#include <QPaintDevice>
#include "qpaintdevicedirector.h"

QPaintEngine*QPaintDeviceDirector::paintEngine()
{
    return __Qt4Ada_QPaintDevice_paintEngine_dispatch(this->ada_self);
}

int QPaintDeviceDirector::metric(QPaintDevice::PaintDeviceMetric _p1) const
{
    return __Qt4Ada_QPaintDevice_metric_0_dispatch(this->ada_self, _p1);
}

extern "C" {

    QPaintEngine*__Qt4Ada_QPaintDevice_paintEngine_virtual(QPaintDevice*cpp_this)
    {
        return cpp_this->paintEngine();
    }

    int __Qt4Ada_QPaintDevice_metric_wrapper(QPaintDevice*cpp_this,QPaintDevice::PaintDeviceMetric _p1)
    {
        return (dynamic_cast<QPaintDeviceDirector*>(cpp_this))->QPaintDevice::metric(_p1);
    }

    int __QtAda_QPaintDevice_depth_C(QPaintDevice* self)
    {
        return self->depth();
    }

    int __QtAda_QPaintDevice_height_C(QPaintDevice* self)
    {
        return self->height();
    }

    int __QtAda_QPaintDevice_heightMM_C(QPaintDevice* self)
    {
        return self->heightMM();
    }

    int __QtAda_QPaintDevice_logicalDpiX_C(QPaintDevice* self)
    {
        return self->logicalDpiX();
    }

    int __QtAda_QPaintDevice_logicalDpiY_C(QPaintDevice* self)
    {
        return self->logicalDpiY();
    }

    int __QtAda_QPaintDevice_numColors_C(QPaintDevice* self)
    {
        return self->numColors();
    }

    int __QtAda_QPaintDevice_paintingActive_C(QPaintDevice* self)
    {
        return (int)self->paintingActive();
    }

    int __QtAda_QPaintDevice_physicalDpiX_C(QPaintDevice* self)
    {
        return self->physicalDpiX();
    }

    int __QtAda_QPaintDevice_physicalDpiY_C(QPaintDevice* self)
    {
        return self->physicalDpiY();
    }

    int __QtAda_QPaintDevice_width_C(QPaintDevice* self)
    {
        return self->width();
    }

    int __QtAda_QPaintDevice_widthMM_C(QPaintDevice* self)
    {
        return self->widthMM();
    }

}
