//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QPainterPath>
#include <QPointF>
#include <QPolygonF>
#include <QRectF>
#include <QString>
#include "qpainterpathwrapper.h"

extern "C"
{

    QPainterPath* __QtAda_inititialize_QPainterPath(void* storage)
    {
        return new (storage) QPainterPath();
    }

    QPainterPath* __QtAda_inititialize_QPainterPath_QPointFCR(void* storage, const QPointF* startPoint)
    {
        return new (storage) QPainterPath(*startPoint);
    }

    QPainterPath* __QtAda_adjust_QPainterPath(void* storage, const QPainterPath* from)
    {
        return new (storage) QPainterPath(*from);
    }

    void __QtAda_finalize_QPainterPath(QPainterPath *item)
    {
        item->~QPainterPath();
    }

    void __QtAda_QPainterPath_addEllipse_QRectFCR(QPainterPath* self, const QRectF* rect)
    {
        self->addEllipse(*rect);
    }

    void __QtAda_QPainterPath_addEllipse_qreal_qreal_qreal_qreal(QPainterPath* self, double x, double y, double w, double h)
    {
        self->addEllipse((qreal)x, (qreal)y, (qreal)w, (qreal)h);
    }

    void __QtAda_QPainterPath_addEllipse_QPointFCR_qreal_qreal(QPainterPath* self, const QPointF* center, double rx, double ry)
    {
        self->addEllipse(*center, (qreal)rx, (qreal)ry);
    }

    void __QtAda_QPainterPath_addPath_QPainterPathCR(QPainterPath* self, const QPainterPath* path)
    {
        self->addPath(*path);
    }

    void __QtAda_QPainterPath_addPolygon_QPolygonFCR(QPainterPath* self, const QPolygonF* polygon)
    {
        self->addPolygon(*polygon);
    }

    void __QtAda_QPainterPath_addRect_QRectFCR(QPainterPath* self, const QRectF* rect)
    {
        self->addRect(*rect);
    }

    void __QtAda_QPainterPath_addRect_qreal_qreal_qreal_qreal(QPainterPath* self, double x, double y, double w, double h)
    {
        self->addRect((qreal)x, (qreal)y, (qreal)w, (qreal)h);
    }

    void __QtAda_QPainterPath_addRegion_QRegionCR(QPainterPath* self, const QRegion* region)
    {
        self->addRegion(*region);
    }

    void __QtAda_QPainterPath_addRoundedRect_QRectFCR_qreal_qreal_SizeMode(QPainterPath* self, const QRectF* rect, double xRadius, double yRadius, unsigned mode)
    {
        self->addRoundedRect(*rect, (qreal)xRadius, (qreal)yRadius, (Qt::SizeMode)mode);
    }

    void __QtAda_QPainterPath_addRoundedRect_qreal_qreal_qreal_qreal_qreal_qreal_SizeMode(QPainterPath* self, double x, double y, double w, double h, double xRadius, double yRadius, unsigned mode)
    {
        self->addRoundedRect((qreal)x, (qreal)y, (qreal)w, (qreal)h, (qreal)xRadius, (qreal)yRadius, (Qt::SizeMode)mode);
    }

    void __QtAda_QPainterPath_addText_QPointFCR_QFontCR_QStringCR(QPainterPath* self, const QPointF* point, const QFont* font, const QString* text)
    {
        self->addText(*point, *font, *text);
    }

    void __QtAda_QPainterPath_addText_qreal_qreal_QFontCR_QStringCR(QPainterPath* self, double x, double y, const QFont* font, const QString* text)
    {
        self->addText((qreal)x, (qreal)y, *font, *text);
    }

    double __QtAda_QPainterPath_angleAtPercent_qreal_Q(const QPainterPath* self, double t)
    {
        return (double)self->angleAtPercent((qreal)t);
    }

    void __QtAda_QPainterPath_arcMoveTo_QRectFCR_qreal(QPainterPath* self, const QRectF* rectangle, double angle)
    {
        self->arcMoveTo(*rectangle, (qreal)angle);
    }

    void __QtAda_QPainterPath_arcMoveTo_qreal_qreal_qreal_qreal_qreal(QPainterPath* self, double x, double y, double width, double height, double angle)
    {
        self->arcMoveTo((qreal)x, (qreal)y, (qreal)width, (qreal)height, (qreal)angle);
    }

    void __QtAda_QPainterPath_arcTo_QRectFCR_qreal_qreal(QPainterPath* self, const QRectF* rectangle, double startAngle, double sweepLength)
    {
        self->arcTo(*rectangle, (qreal)startAngle, (qreal)sweepLength);
    }

    void __QtAda_QPainterPath_arcTo_qreal_qreal_qreal_qreal_qreal_qreal(QPainterPath* self, double x, double y, double width, double height, double startAngle, double sweepLength)
    {
        self->arcTo((qreal)x, (qreal)y, (qreal)width, (qreal)height, (qreal)startAngle, (qreal)sweepLength);
    }

    void __QtAda_QPainterPath_boundingRect_Q(QRectF* returns, const QPainterPath* self)
    {
        *returns = self->boundingRect();
    }

    void __QtAda_QPainterPath_closeSubpath(QPainterPath* self)
    {
        self->closeSubpath();
    }

    void __QtAda_QPainterPath_connectPath_QPainterPathCR(QPainterPath* self, const QPainterPath* path)
    {
        self->connectPath(*path);
    }

    unsigned __QtAda_QPainterPath_contains_QPointFCR_Q(const QPainterPath* self, const QPointF* point)
    {
        return (unsigned)self->contains(*point);
    }

    unsigned __QtAda_QPainterPath_contains_QRectFCR_Q(const QPainterPath* self, const QRectF* rectangle)
    {
        return (unsigned)self->contains(*rectangle);
    }

    unsigned __QtAda_QPainterPath_contains_QPainterPathCR_Q(const QPainterPath* self, const QPainterPath* path)
    {
        return (unsigned)self->contains(*path);
    }

    void __QtAda_QPainterPath_controlPointRect_Q(QRectF* returns, const QPainterPath* self)
    {
        *returns = self->controlPointRect();
    }

    void __QtAda_QPainterPath_cubicTo_QPointFCR_QPointFCR_QPointFCR(QPainterPath* self, const QPointF* c1, const QPointF* c2, const QPointF* endPoint)
    {
        self->cubicTo(*c1, *c2, *endPoint);
    }

    void __QtAda_QPainterPath_cubicTo_qreal_qreal_qreal_qreal_qreal_qreal(QPainterPath* self, double c1X, double c1Y, double c2X, double c2Y, double endPointX, double endPointY)
    {
        self->cubicTo((qreal)c1X, (qreal)c1Y, (qreal)c2X, (qreal)c2Y, (qreal)endPointX, (qreal)endPointY);
    }

    void __QtAda_QPainterPath_currentPosition_Q(QPointF* returns, const QPainterPath* self)
    {
        *returns = self->currentPosition();
    }

    int __QtAda_QPainterPath_elementCount_Q(const QPainterPath* self)
    {
        return self->elementCount();
    }

    unsigned __QtAda_QPainterPath_fillRule_Q(const QPainterPath* self)
    {
        return (unsigned)self->fillRule();
    }

    void __QtAda_QPainterPath_intersected_QPainterPathCR_Q(QPainterPath* returns, const QPainterPath* self, const QPainterPath* path)
    {
        *returns = self->intersected(*path);
    }

    unsigned __QtAda_QPainterPath_intersects_QRectFCR_Q(const QPainterPath* self, const QRectF* rectangle)
    {
        return (unsigned)self->intersects(*rectangle);
    }

    unsigned __QtAda_QPainterPath_intersects_QPainterPathCR_Q(const QPainterPath* self, const QPainterPath* path)
    {
        return (unsigned)self->intersects(*path);
    }

    unsigned __QtAda_QPainterPath_isEmpty_Q(const QPainterPath* self)
    {
        return (unsigned)self->isEmpty();
    }

    double __QtAda_QPainterPath_length_Q(const QPainterPath* self)
    {
        return (double)self->length();
    }

    void __QtAda_QPainterPath_lineTo_QPointFCR(QPainterPath* self, const QPointF* endPoint)
    {
        self->lineTo(*endPoint);
    }

    void __QtAda_QPainterPath_lineTo_qreal_qreal(QPainterPath* self, double x, double y)
    {
        self->lineTo((qreal)x, (qreal)y);
    }

    void __QtAda_QPainterPath_moveTo_QPointFCR(QPainterPath* self, const QPointF* endPoint)
    {
        self->moveTo(*endPoint);
    }

    void __QtAda_QPainterPath_moveTo_qreal_qreal(QPainterPath* self, double x, double y)
    {
        self->moveTo((qreal)x, (qreal)y);
    }

    double __QtAda_QPainterPath_percentAtLength_qreal_Q(const QPainterPath* self, double t)
    {
        return (double)self->percentAtLength((qreal)t);
    }

    void __QtAda_QPainterPath_pointAtPercent_qreal_Q(QPointF* returns, const QPainterPath* self, double t)
    {
        *returns = self->pointAtPercent((qreal)t);
    }

    void __QtAda_QPainterPath_quadTo_QPointFCR_QPointFCR(QPainterPath* self, const QPointF* c, const QPointF* endPoint)
    {
        self->quadTo(*c, *endPoint);
    }

    void __QtAda_QPainterPath_quadTo_qreal_qreal_qreal_qreal(QPainterPath* self, double cx, double cy, double endPointX, double endPointY)
    {
        self->quadTo((qreal)cx, (qreal)cy, (qreal)endPointX, (qreal)endPointY);
    }

    void __QtAda_QPainterPath_setElementPositionAt_int_qreal_qreal(QPainterPath* self, int index, double x, double y)
    {
        self->setElementPositionAt(index, (qreal)x, (qreal)y);
    }

    void __QtAda_QPainterPath_setFillRule_FillRule(QPainterPath* self, unsigned fillRule)
    {
        self->setFillRule((Qt::FillRule)fillRule);
    }

    void __QtAda_QPainterPath_simplified_Q(QPainterPath* returns, const QPainterPath* self)
    {
        *returns = self->simplified();
    }

    double __QtAda_QPainterPath_slopeAtPercent_qreal_Q(const QPainterPath* self, double t)
    {
        return (double)self->slopeAtPercent((qreal)t);
    }

    void __QtAda_QPainterPath_subtracted_QPainterPathCR_Q(QPainterPath* returns, const QPainterPath* self, const QPainterPath* path)
    {
        *returns = self->subtracted(*path);
    }

    void __QtAda_QPainterPath_toFillPolygon_QTransformCR_Q(QPolygonF* returns, const QPainterPath* self, const QTransform* matrix)
    {
        *returns = self->toFillPolygon(*matrix);
    }

    void __QtAda_QPainterPath_toFillPolygon_QMatrixCR_Q(QPolygonF* returns, const QPainterPath* self, const QMatrix* matrix)
    {
        *returns = self->toFillPolygon(*matrix);
    }

    void __QtAda_QPainterPath_toReversed_Q(QPainterPath* returns, const QPainterPath* self)
    {
        *returns = self->toReversed();
    }

    void __QtAda_QPainterPath_united_QPainterPathCR_Q(QPainterPath* returns, const QPainterPath* self, const QPainterPath* path)
    {
        *returns = self->united(*path);
    }

    unsigned __QtAda_QPainterPath_eq_QPainterPathCR_Q(const QPainterPath* self, const QPainterPath* path)
    {
        return (unsigned)self->operator==(*path);
    }

    QPainterPath* __Qt4Ada_copy_QPainterPath (const QPainterPath* cpp_object)
    {
        return new QPainterPath (*cpp_object);
    }

};

