//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3863 $ $Date: 2012-04-08 09:49:28 +0400 (Sun, 08 Apr 2012) $
//--------------------------------------------------------------------------//
#include <new>
#include <QBrush>
#include <QFont>
#include <QFontInfo>
#include <QFontMetrics>
#include <QMatrix>
#include <QPainterPath>
#include <QPen>
#include <QPoint>
#include <QRect>
#include <QRectF>
#include <QRegion>
#include <QString>
#include <QTransform>
#include "qpainterwrapper.h"

extern "C"
{

    QPainter* __QtAda_inititialize_QPainter(void* storage)
    {
        return new (storage) QPainter();
    }

    QPainter* __QtAda_inititialize_QPainter_QPaintDevice(void* storage, QPaintDevice* device)
    {
        return new (storage) QPainter(device);
    }

    void __QtAda_finalize_QPainter(QPainter *item)
    {
        item->~QPainter();
    }

    void __QtAda_QPainter_background_Q(QBrush* returns, const QPainter* self)
    {
        *returns = self->background();
    }

    unsigned __QtAda_QPainter_backgroundMode_Q(const QPainter* self)
    {
        return (unsigned)self->backgroundMode();
    }

    unsigned __QtAda_QPainter_begin_QPaintDevice(QPainter* self, QPaintDevice* device)
    {
        return (unsigned)self->begin(device);
    }

    void __QtAda_QPainter_boundingRect_QRectFCR_QStringCR_QTextOptionCR(QRectF* returns, QPainter* self, const QRectF* rect, const QString* text, const QTextOption* option)
    {
        *returns = self->boundingRect(*rect, *text, *option);
    }

    void __QtAda_QPainter_brush_Q(QBrush* returns, const QPainter* self)
    {
        *returns = self->brush();
    }

    void __QtAda_QPainter_brushOrigin_Q(QPoint* returns, const QPainter* self)
    {
        *returns = self->brushOrigin();
    }

    void __QtAda_QPainter_clipPath_Q(QPainterPath* returns, const QPainter* self)
    {
        *returns = self->clipPath();
    }

    void __QtAda_QPainter_clipRegion_Q(QRegion* returns, const QPainter* self)
    {
        *returns = self->clipRegion();
    }

    void __QtAda_QPainter_combinedMatrix_Q(QMatrix* returns, const QPainter* self)
    {
        *returns = self->combinedMatrix();
    }

    void __QtAda_QPainter_combinedTransform_Q(QTransform* returns, const QPainter* self)
    {
        *returns = self->combinedTransform();
    }

    unsigned __QtAda_QPainter_compositionMode_Q(const QPainter* self)
    {
        return (unsigned)self->compositionMode();
    }

    void __QtAda_QPainter_deviceMatrix_Q(QMatrix* returns, const QPainter* self)
    {
        *returns = self->deviceMatrix();
    }

    void __QtAda_QPainter_deviceTransform_Q(QTransform* returns, const QPainter* self)
    {
        *returns = self->deviceTransform();
    }

    void __QtAda_QPainter_drawArc_QRectFCR_int_int(QPainter* self, const QRectF* rect, int startAngle, int spanAngle)
    {
        self->drawArc(*rect, startAngle, spanAngle);
    }

    void __QtAda_QPainter_drawArc_QRectCR_int_int(QPainter* self, const QRect* rect, int startAngle, int spanAngle)
    {
        self->drawArc(*rect, startAngle, spanAngle);
    }

    void __QtAda_QPainter_drawArc_int_int_int_int_int_int(QPainter* self, int x, int y, int width, int height, int startAngle, int spanAngle)
    {
        self->drawArc(x, y, width, height, startAngle, spanAngle);
    }

    void __QtAda_QPainter_drawChord_QRectFCR_int_int(QPainter* self, const QRectF* rect, int startAngle, int spanAngle)
    {
        self->drawChord(*rect, startAngle, spanAngle);
    }

    void __QtAda_QPainter_drawChord_QRectCR_int_int(QPainter* self, const QRect* rect, int startAngle, int spanAngle)
    {
        self->drawChord(*rect, startAngle, spanAngle);
    }

    void __QtAda_QPainter_drawChord_int_int_int_int_int_int(QPainter* self, int x, int y, int width, int height, int startAngle, int spanAngle)
    {
        self->drawChord(x, y, width, height, startAngle, spanAngle);
    }

    void __QtAda_QPainter_drawConvexPolygon_QPolygonFCR(QPainter* self, const QPolygonF* polygon)
    {
        self->drawConvexPolygon(*polygon);
    }

    void __QtAda_QPainter_drawConvexPolygon_QPolygonCR(QPainter* self, const QPolygon* polygon)
    {
        self->drawConvexPolygon(*polygon);
    }

    void __QtAda_QPainter_drawEllipse_QRectFCR(QPainter* self, const QRectF* r)
    {
        self->drawEllipse(*r);
    }

    void __QtAda_QPainter_drawEllipse_QRectCR(QPainter* self, const QRect* r)
    {
        self->drawEllipse(*r);
    }

    void __QtAda_QPainter_drawEllipse_int_int_int_int(QPainter* self, int x, int y, int width, int height)
    {
        self->drawEllipse(x, y, width, height);
    }

    void __QtAda_QPainter_drawImage_QRectFCR_QImageCR_QRectFCR_Qt_ImageConversionFlags(QPainter* self, const QRectF* target, const QImage* image, const QRectF* source, unsigned flags)
    {
        self->drawImage(*target, *image, *source, (Qt::ImageConversionFlags)flags);
    }

    void __QtAda_QPainter_drawImage_QRectCR_QImageCR_QRectCR_Qt_ImageConversionFlags(QPainter* self, const QRect* target, const QImage* image, const QRect* source, unsigned flags)
    {
        self->drawImage(*target, *image, *source, (Qt::ImageConversionFlags)flags);
    }

    void __QtAda_QPainter_drawImage_QPointFCR_QImageCR(QPainter* self, const QPointF* point, const QImage* image)
    {
        self->drawImage(*point, *image);
    }

    void __QtAda_QPainter_drawImage_QPointCR_QImageCR(QPainter* self, const QPoint* point, const QImage* image)
    {
        self->drawImage(*point, *image);
    }

    void __QtAda_QPainter_drawImage_QPointFCR_QImageCR_QRectFCR_Qt_ImageConversionFlags(QPainter* self, const QPointF* point, const QImage* image, const QRectF* source, unsigned flags)
    {
        self->drawImage(*point, *image, *source, (Qt::ImageConversionFlags)flags);
    }

    void __QtAda_QPainter_drawImage_QPointCR_QImageCR_QRectCR_Qt_ImageConversionFlags(QPainter* self, const QPoint* point, const QImage* image, const QRect* source, unsigned flags)
    {
        self->drawImage(*point, *image, *source, (Qt::ImageConversionFlags)flags);
    }

    void __QtAda_QPainter_drawImage_QRectFCR_QImageCR(QPainter* self, const QRectF* rectangle, const QImage* image)
    {
        self->drawImage(*rectangle, *image);
    }

    void __QtAda_QPainter_drawImage_QRectCR_QImageCR(QPainter* self, const QRect* rectangle, const QImage* image)
    {
        self->drawImage(*rectangle, *image);
    }

    void __QtAda_QPainter_drawImage_int_int_QImageCR_int_int_int_int_Qt_ImageConversionFlags(QPainter* self, int x, int y, const QImage* image, int sx, int sy, int sw, int sh, unsigned flags)
    {
        self->drawImage(x, y, *image, sx, sy, sw, sh, (Qt::ImageConversionFlags)flags);
    }

    void __QtAda_QPainter_drawLine_QLineFCR(QPainter* self, const QLineF* line)
    {
        self->drawLine(*line);
    }

    void __QtAda_QPainter_drawLine_QLineCR(QPainter* self, const QLine* line)
    {
        self->drawLine(*line);
    }

    void __QtAda_QPainter_drawLine_QPointCR_QPointCR(QPainter* self, const QPoint* p1, const QPoint* p2)
    {
        self->drawLine(*p1, *p2);
    }

    void __QtAda_QPainter_drawLine_QPointFCR_QPointFCR(QPainter* self, const QPointF* p1, const QPointF* p2)
    {
        self->drawLine(*p1, *p2);
    }

    void __QtAda_QPainter_drawLine_int_int_int_int(QPainter* self, int x1, int y1, int x2, int y2)
    {
        self->drawLine(x1, y1, x2, y2);
    }

    void __QtAda_QPainter_drawPath_QPainterPathCR(QPainter* self, const QPainterPath* path)
    {
        self->drawPath(*path);
    }

    void __QtAda_QPainter_drawPie_QRectFCR_int_int(QPainter* self, const QRectF* rect, int startAngle, int spanAngle)
    {
        self->drawPie(*rect, startAngle, spanAngle);
    }

    void __QtAda_QPainter_drawPie_QRectCR_int_int(QPainter* self, const QRect* rect, int startAngle, int spanAngle)
    {
        self->drawPie(*rect, startAngle, spanAngle);
    }

    void __QtAda_QPainter_drawPie_int_int_int_int_int_int(QPainter* self, int x, int y, int width, int height, int startAngle, int spanAngle)
    {
        self->drawPie(x, y, width, height, startAngle, spanAngle);
    }

    void __QtAda_QPainter_drawPixmap_QRectFCR_QPixmapCR_QRectFCR(QPainter* self, const QRectF* targetRect, const QPixmap* pixmap, const QRectF* sourceRect)
    {
        self->drawPixmap(*targetRect, *pixmap, *sourceRect);
    }

    void __QtAda_QPainter_drawPixmap_QRectCR_QPixmapCR_QRectCR(QPainter* self, const QRect* targetRect, const QPixmap* pixmap, const QRect* sourceRect)
    {
        self->drawPixmap(*targetRect, *pixmap, *sourceRect);
    }

    void __QtAda_QPainter_drawPixmap_QPointFCR_QPixmapCR_QRectFCR(QPainter* self, const QPointF* point, const QPixmap* pixmap, const QRectF* source)
    {
        self->drawPixmap(*point, *pixmap, *source);
    }

    void __QtAda_QPainter_drawPixmap_QPointCR_QPixmapCR_QRectCR(QPainter* self, const QPoint* point, const QPixmap* pixmap, const QRect* source)
    {
        self->drawPixmap(*point, *pixmap, *source);
    }

    void __QtAda_QPainter_drawPixmap_QPointFCR_QPixmapCR(QPainter* self, const QPointF* point, const QPixmap* pixmap)
    {
        self->drawPixmap(*point, *pixmap);
    }

    void __QtAda_QPainter_drawPixmap_QPointCR_QPixmapCR(QPainter* self, const QPoint* point, const QPixmap* pixmap)
    {
        self->drawPixmap(*point, *pixmap);
    }

    void __QtAda_QPainter_drawPixmap_int_int_QPixmapCR(QPainter* self, int x, int y, const QPixmap* pixmap)
    {
        self->drawPixmap(x, y, *pixmap);
    }

    void __QtAda_QPainter_drawPixmap_QRectCR_QPixmapCR(QPainter* self, const QRect* rectangle, const QPixmap* pixmap)
    {
        self->drawPixmap(*rectangle, *pixmap);
    }

    void __QtAda_QPainter_drawPixmap_int_int_int_int_QPixmapCR(QPainter* self, int x, int y, int w, int h, const QPixmap* pixmap)
    {
        self->drawPixmap(x, y, w, h, *pixmap);
    }

    void __QtAda_QPainter_drawPixmap_int_int_int_int_QPixmapCR_int_int_int_int(QPainter* self, int x, int y, int w, int h, const QPixmap* pixmap, int sx, int sy, int sw, int sh)
    {
        self->drawPixmap(x, y, w, h, *pixmap, sx, sy, sw, sh);
    }

    void __QtAda_QPainter_drawPixmap_int_int_QPixmapCR_int_int_int_int(QPainter* self, int x, int y, const QPixmap* pixmap, int sx, int sy, int sw, int sh)
    {
        self->drawPixmap(x, y, *pixmap, sx, sy, sw, sh);
    }

    void __QtAda_QPainter_drawPoint_QPointFCR(QPainter* self, const QPointF* position)
    {
        self->drawPoint(*position);
    }

    void __QtAda_QPainter_drawPoint_QPointCR(QPainter* self, const QPoint* position)
    {
        self->drawPoint(*position);
    }

    void __QtAda_QPainter_drawPoint_int_int(QPainter* self, int x, int y)
    {
        self->drawPoint(x, y);
    }

    void __QtAda_QPainter_drawPoints_QPolygonFCR(QPainter* self, const QPolygonF* points)
    {
        self->drawPoints(*points);
    }

    void __QtAda_QPainter_drawPoints_QPolygonCR(QPainter* self, const QPolygon* points)
    {
        self->drawPoints(*points);
    }

    void __QtAda_QPainter_drawPolygon_QPolygonFCR_FillRule(QPainter* self, const QPolygonF* polygon, unsigned fillRule)
    {
        self->drawPolygon(*polygon, (Qt::FillRule)fillRule);
    }

    void __QtAda_QPainter_drawPolygon_QPolygonCR_FillRule(QPainter* self, const QPolygon* polygon, unsigned fillRule)
    {
        self->drawPolygon(*polygon, (Qt::FillRule)fillRule);
    }

    void __QtAda_QPainter_drawPolyline_QPolygonFCR(QPainter* self, const QPolygonF* points)
    {
        self->drawPolyline(*points);
    }

    void __QtAda_QPainter_drawPolyline_QPolygonCR(QPainter* self, const QPolygon* points)
    {
        self->drawPolyline(*points);
    }

    void __QtAda_QPainter_drawRect_QRectFCR(QPainter* self, const QRectF* rect)
    {
        self->drawRect(*rect);
    }

    void __QtAda_QPainter_drawRect_QRectCR(QPainter* self, const QRect* rect)
    {
        self->drawRect(*rect);
    }

    void __QtAda_QPainter_drawRect_int_int_int_int(QPainter* self, int x, int y, int width, int height)
    {
        self->drawRect(x, y, width, height);
    }

    void __QtAda_QPainter_drawRoundRect_QRectFCR_int_int(QPainter* self, const QRectF* rect, int xround, int yround)
    {
        self->drawRoundRect(*rect, xround, yround);
    }

    void __QtAda_QPainter_drawRoundRect_QRectCR_int_int(QPainter* self, const QRect* rect, int xround, int yround)
    {
        self->drawRoundRect(*rect, xround, yround);
    }

    void __QtAda_QPainter_drawRoundRect_int_int_int_int_int_int(QPainter* self, int x, int y, int width, int height, int xround, int yround)
    {
        self->drawRoundRect(x, y, width, height, xround, yround);
    }

    void __QtAda_QPainter_drawText_QPointFCR_QStringCR(QPainter* self, const QPointF* position, const QString* text)
    {
        self->drawText(*position, *text);
    }

    void __QtAda_QPainter_drawText_QPointCR_QStringCR(QPainter* self, const QPoint* position, const QString* text)
    {
        self->drawText(*position, *text);
    }

    void __QtAda_QPainter_drawText_int_int_QStringCR(QPainter* self, int x, int y, const QString* test)
    {
        self->drawText(x, y, *test);
    }

    void __QtAda_QPainter_drawText_QRectFCR_QStringCR_QTextOptionCR(QPainter* self, const QRectF* rectangle, const QString* text, const QTextOption* option)
    {
        self->drawText(*rectangle, *text, *option);
    }

    void __QtAda_QPainter_drawTiledPixmap_QRectFCR_QPixmapCR_QPointFCR(QPainter* self, const QRectF* rectangle, const QPixmap* pixmap, const QPointF* position)
    {
        self->drawTiledPixmap(*rectangle, *pixmap, *position);
    }

    void __QtAda_QPainter_drawTiledPixmap_QRectCR_QPixmapCR_QPointCR(QPainter* self, const QRect* rectangle, const QPixmap* pixmap, const QPoint* position)
    {
        self->drawTiledPixmap(*rectangle, *pixmap, *position);
    }

    void __QtAda_QPainter_drawTiledPixmap_int_int_int_int_QPixmapCR_int_int(QPainter* self, int x, int y, int width, int height, const QPixmap* pixmap, int sx, int sy)
    {
        self->drawTiledPixmap(x, y, width, height, *pixmap, sx, sy);
    }

    unsigned __QtAda_QPainter_end(QPainter* self)
    {
        return (unsigned)self->end();
    }

    void __QtAda_QPainter_eraseRect_QRectFCR(QPainter* self, const QRectF* rectangle)
    {
        self->eraseRect(*rectangle);
    }

    void __QtAda_QPainter_eraseRect_QRectCR(QPainter* self, const QRect* rectangle)
    {
        self->eraseRect(*rectangle);
    }

    void __QtAda_QPainter_eraseRect_int_int_int_int(QPainter* self, int x, int y, int width, int height)
    {
        self->eraseRect(x, y, width, height);
    }

    void __QtAda_QPainter_fillPath_QPainterPathCR_QBrushCR(QPainter* self, const QPainterPath* path, const QBrush* brush)
    {
        self->fillPath(*path, *brush);
    }

    void __QtAda_QPainter_fillRect_QRectFCR_QBrushCR(QPainter* self, const QRectF* rectangle, const QBrush* brush)
    {
        self->fillRect(*rectangle, *brush);
    }

    void __QtAda_QPainter_fillRect_QRectCR_QBrushCR(QPainter* self, const QRect* rectangle, const QBrush* brush)
    {
        self->fillRect(*rectangle, *brush);
    }

    void __QtAda_QPainter_fillRect_int_int_int_int_QBrushCR(QPainter* self, int x, int y, int width, int height, const QBrush* brush)
    {
        self->fillRect(x, y, width, height, *brush);
    }

    void __QtAda_QPainter_font_Q(QFont* returns, const QPainter* self)
    {
        *returns = self->font();
    }

    QFontInfo* __QtAda_QPainter_fontInfo_Q(const QPainter* self, void* storage)
    {
        return new (storage) QFontInfo(self->fontInfo());
    }

    QFontMetrics* __QtAda_QPainter_fontMetrics_Q(const QPainter* self, void* storage)
    {
        return new (storage) QFontMetrics(self->fontMetrics());
    }

    unsigned __QtAda_QPainter_hasClipping_Q(const QPainter* self)
    {
        return (unsigned)self->hasClipping();
    }

    unsigned __QtAda_QPainter_isActive_Q(const QPainter* self)
    {
        return (unsigned)self->isActive();
    }

    unsigned __QtAda_QPainter_layoutDirection_Q(const QPainter* self)
    {
        return (unsigned)self->layoutDirection();
    }

    void __QtAda_QPainter_matrix_Q(QMatrix* returns, const QPainter* self)
    {
        *returns = self->matrix();
    }

    unsigned __QtAda_QPainter_matrixEnabled_Q(const QPainter* self)
    {
        return (unsigned)self->matrixEnabled();
    }

    double __QtAda_QPainter_opacity_Q(const QPainter* self)
    {
        return (double)self->opacity();
    }

    void __QtAda_QPainter_pen_Q(QPen* returns, const QPainter* self)
    {
        *returns = self->pen();
    }

    void __QtAda_QPainter_resetMatrix(QPainter* self)
    {
        self->resetMatrix();
    }

    void __QtAda_QPainter_resetTransform(QPainter* self)
    {
        self->resetTransform();
    }

    void __QtAda_QPainter_restore(QPainter* self)
    {
        self->restore();
    }

    void __QtAda_QPainter_rotate_qreal(QPainter* self, double angle)
    {
        self->rotate((qreal)angle);
    }

    void __QtAda_QPainter_save(QPainter* self)
    {
        self->save();
    }

    void __QtAda_QPainter_scale_qreal_qreal(QPainter* self, double sx, double sy)
    {
        self->scale((qreal)sx, (qreal)sy);
    }

    void __QtAda_QPainter_setBackground_QBrushCR(QPainter* self, const QBrush* brush)
    {
        self->setBackground(*brush);
    }

    void __QtAda_QPainter_setBackgroundMode_BGMode(QPainter* self, unsigned mode)
    {
        self->setBackgroundMode((Qt::BGMode)mode);
    }

    void __QtAda_QPainter_setBrush_QBrushCR(QPainter* self, const QBrush* brush)
    {
        self->setBrush(*brush);
    }

    void __QtAda_QPainter_setBrush_BrushStyle(QPainter* self, unsigned style)
    {
        self->setBrush((Qt::BrushStyle)style);
    }

    void __QtAda_QPainter_setBrushOrigin_QPointFCR(QPainter* self, const QPointF* position)
    {
        self->setBrushOrigin(*position);
    }

    void __QtAda_QPainter_setBrushOrigin_QPointCR(QPainter* self, const QPoint* position)
    {
        self->setBrushOrigin(*position);
    }

    void __QtAda_QPainter_setBrushOrigin_int_int(QPainter* self, int x, int y)
    {
        self->setBrushOrigin(x, y);
    }

    void __QtAda_QPainter_setClipPath_QPainterPathCR_ClipOperation(QPainter* self, const QPainterPath* path, unsigned operation)
    {
        self->setClipPath(*path, (Qt::ClipOperation)operation);
    }

    void __QtAda_QPainter_setClipRect_QRectFCR_ClipOperation(QPainter* self, const QRectF* rectangle, unsigned operation)
    {
        self->setClipRect(*rectangle, (Qt::ClipOperation)operation);
    }

    void __QtAda_QPainter_setClipRect_int_int_int_int_ClipOperation(QPainter* self, int x, int y, int width, int height, unsigned operation)
    {
        self->setClipRect(x, y, width, height, (Qt::ClipOperation)operation);
    }

    void __QtAda_QPainter_setClipRect_QRectCR_ClipOperation(QPainter* self, const QRect* rectangle, unsigned operation)
    {
        self->setClipRect(*rectangle, (Qt::ClipOperation)operation);
    }

    void __QtAda_QPainter_setClipRegion_QRegionCR_ClipOperation(QPainter* self, const QRegion* region, unsigned operation)
    {
        self->setClipRegion(*region, (Qt::ClipOperation)operation);
    }

    void __QtAda_QPainter_setClipping_bool(QPainter* self, unsigned enable)
    {
        self->setClipping((bool)enable);
    }

    void __QtAda_QPainter_setCompositionMode_CompositionMode(QPainter* self, unsigned mode)
    {
        self->setCompositionMode((QPainter::CompositionMode)mode);
    }

    void __QtAda_QPainter_setFont_QFontCR(QPainter* self, const QFont* font)
    {
        self->setFont(*font);
    }

    void __QtAda_QPainter_setLayoutDirection_LayoutDirection(QPainter* self, unsigned direction)
    {
        self->setLayoutDirection((Qt::LayoutDirection)direction);
    }

    void __QtAda_QPainter_setOpacity_qreal(QPainter* self, double opacity)
    {
        self->setOpacity((qreal)opacity);
    }

    void __QtAda_QPainter_setPen_QPenCR(QPainter* self, const QPen* pen)
    {
        self->setPen(*pen);
    }

    void __QtAda_QPainter_setPen_QColorCR(QPainter* self, const QColor* color)
    {
        self->setPen(*color);
    }

    void __QtAda_QPainter_setPen_PenStyle(QPainter* self, unsigned style)
    {
        self->setPen((Qt::PenStyle)style);
    }

    void __QtAda_QPainter_setRenderHint_RenderHint_bool(QPainter* self, unsigned hint, unsigned enable)
    {
        self->setRenderHint((QPainter::RenderHint)hint, (bool)enable);
    }

    void __QtAda_QPainter_setMatrix_QMatrixCR_bool(QPainter* self, const QMatrix* matrix, unsigned combine)
    {
        self->setMatrix(*matrix, (bool)combine);
    }

    void __QtAda_QPainter_setMatrixEnabled_bool(QPainter* self, unsigned enable)
    {
        self->setMatrixEnabled((bool)enable);
    }

    void __QtAda_QPainter_setTransform_QTransformCR_bool(QPainter* self, const QTransform* transform, unsigned combine)
    {
        self->setTransform(*transform, (bool)combine);
    }

    void __QtAda_QPainter_setViewTransformEnabled_bool(QPainter* self, unsigned enable)
    {
        self->setViewTransformEnabled((bool)enable);
    }

    void __QtAda_QPainter_setViewport_QRectCR(QPainter* self, const QRect* viewport)
    {
        self->setViewport(*viewport);
    }

    void __QtAda_QPainter_setViewport_int_int_int_int(QPainter* self, int x, int y, int width, int height)
    {
        self->setViewport(x, y, width, height);
    }

    void __QtAda_QPainter_setWindow_QRectCR(QPainter* self, const QRect* window)
    {
        self->setWindow(*window);
    }

    void __QtAda_QPainter_setWindow_int_int_int_int(QPainter* self, int x, int y, int width, int height)
    {
        self->setWindow(x, y, width, height);
    }

    void __QtAda_QPainter_setWorldMatrix_QMatrixCR_bool(QPainter* self, const QMatrix* matrix, unsigned combine)
    {
        self->setWorldMatrix(*matrix, (bool)combine);
    }

    void __QtAda_QPainter_setWorldMatrixEnabled_bool(QPainter* self, unsigned enable)
    {
        self->setWorldMatrixEnabled((bool)enable);
    }

    void __QtAda_QPainter_setWorldTransform_QTransformCR_bool(QPainter* self, const QTransform* matrix, unsigned combine)
    {
        self->setWorldTransform(*matrix, (bool)combine);
    }

    void __QtAda_QPainter_shear_qreal_qreal(QPainter* self, double sh, double sv)
    {
        self->shear((qreal)sh, (qreal)sv);
    }

    void __QtAda_QPainter_strokePath_QPainterPathCR_QPenCR(QPainter* self, const QPainterPath* path, const QPen* pen)
    {
        self->strokePath(*path, *pen);
    }

    unsigned __QtAda_QPainter_testRenderHint_RenderHint_Q(const QPainter* self, unsigned hint)
    {
        return (unsigned)self->testRenderHint((QPainter::RenderHint)hint);
    }

    void __QtAda_QPainter_transform_Q(QTransform* returns, const QPainter* self)
    {
        *returns = self->transform();
    }

    void __QtAda_QPainter_translate_QPointFCR(QPainter* self, const QPointF* offset)
    {
        self->translate(*offset);
    }

    void __QtAda_QPainter_translate_QPointCR(QPainter* self, const QPoint* offset)
    {
        self->translate(*offset);
    }

    void __QtAda_QPainter_translate_qreal_qreal(QPainter* self, double dx, double dy)
    {
        self->translate((qreal)dx, (qreal)dy);
    }

    unsigned __QtAda_QPainter_viewTransformEnabled_Q(const QPainter* self)
    {
        return (unsigned)self->viewTransformEnabled();
    }

    void __QtAda_QPainter_viewport_Q(QRect* returns, const QPainter* self)
    {
        *returns = self->viewport();
    }

    void __QtAda_QPainter_window_Q(QRect* returns, const QPainter* self)
    {
        *returns = self->window();
    }

    void __QtAda_QPainter_worldMatrix_Q(QMatrix* returns, const QPainter* self)
    {
        *returns = self->worldMatrix();
    }

    unsigned __QtAda_QPainter_worldMatrixEnabled_Q(const QPainter* self)
    {
        return (unsigned)self->worldMatrixEnabled();
    }

    void __QtAda_QPainter_worldTransform_Q(QTransform* returns, const QPainter* self)
    {
        *returns = self->worldTransform();
    }

    void __Qt4Ada_QPainter_drawText_null_boundingRect_wrapper
            (QPainter* self,
             QRect* rectangle,
             int       flags,
             QString*  text)
    {
        self->drawText(*rectangle, flags, *text);
    }

};
