//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3644 $ $Date: 2009-11-27 13:22:59 +0300 (Fri, 27 Nov 2009) $
//--------------------------------------------------------------------------//
#include <QPainter>

extern "C"
{
    extern QPainter* __QtAda_inititialize_QPainter(void*);
    extern QPainter* __QtAda_inititialize_QPainter_QPaintDevice(void*, QPaintDevice*);
    extern void __QtAda_finalize_QPainter(QPainter*);

    extern void __QtAda_QPainter_background_Q(QBrush*, const QPainter*);
    extern unsigned __QtAda_QPainter_backgroundMode_Q(const QPainter*);
    extern void __QtAda_QPainter_boundingRect_QRectFCR_QStringCR_QTextOptionCR(QRectF*, QPainter*, const QRectF*, const QString*, const QTextOption*);
    extern unsigned __QtAda_QPainter_begin_QPaintDevice(QPainter*, QPaintDevice*);
    extern void __QtAda_QPainter_brush_Q(QBrush*, const QPainter*);
    extern void __QtAda_QPainter_brushOrigin_Q(QPoint*, const QPainter*);
    extern void __QtAda_QPainter_clipPath_Q(QPainterPath*, const QPainter*);
    extern void __QtAda_QPainter_clipRegion_Q(QRegion*, const QPainter*);
    extern void __QtAda_QPainter_combinedMatrix_Q(QMatrix*, const QPainter*);
    extern void __QtAda_QPainter_combinedTransform_Q(QTransform*, const QPainter*);
    extern unsigned __QtAda_QPainter_compositionMode_Q(const QPainter*);
    extern void __QtAda_QPainter_deviceMatrix_Q(QMatrix*, const QPainter*);
    extern void __QtAda_QPainter_deviceTransform_Q(QTransform*, const QPainter*);
    extern void __QtAda_QPainter_drawArc_QRectFCR_int_int(QPainter*, const QRectF*, int, int);
    extern void __QtAda_QPainter_drawArc_QRectCR_int_int(QPainter*, const QRect*, int, int);
    extern void __QtAda_QPainter_drawArc_int_int_int_int_int_int(QPainter*, int, int, int, int, int, int);
    extern void __QtAda_QPainter_drawChord_QRectFCR_int_int(QPainter*, const QRectF*, int, int);
    extern void __QtAda_QPainter_drawChord_QRectCR_int_int(QPainter*, const QRect*, int, int);
    extern void __QtAda_QPainter_drawChord_int_int_int_int_int_int(QPainter*, int, int, int, int, int, int);
    extern void __QtAda_QPainter_drawConvexPolygon_QPolygonFCR(QPainter*, const QPolygonF*);
    extern void __QtAda_QPainter_drawConvexPolygon_QPolygonCR(QPainter*, const QPolygon*);
    extern void __QtAda_QPainter_drawEllipse_QRectFCR(QPainter*, const QRectF*);
    extern void __QtAda_QPainter_drawEllipse_QRectCR(QPainter*, const QRect*);
    extern void __QtAda_QPainter_drawEllipse_int_int_int_int(QPainter*, int, int, int, int);
    extern void __QtAda_QPainter_drawImage_QRectFCR_QImageCR_QRectFCR_Qt_ImageConversionFlags(QPainter*, const QRectF*, const QImage*, const QRectF*, unsigned);
    extern void __QtAda_QPainter_drawImage_QRectCR_QImageCR_QRectCR_Qt_ImageConversionFlags(QPainter*, const QRect*, const QImage*, const QRect*, unsigned);
    extern void __QtAda_QPainter_drawImage_QPointFCR_QImageCR(QPainter*, const QPointF*, const QImage*);
    extern void __QtAda_QPainter_drawImage_QPointCR_QImageCR(QPainter*, const QPoint*, const QImage*);
    extern void __QtAda_QPainter_drawImage_QPointFCR_QImageCR_QRectFCR_Qt_ImageConversionFlags(QPainter*, const QPointF*, const QImage*, const QRectF*, unsigned);
    extern void __QtAda_QPainter_drawImage_QPointCR_QImageCR_QRectCR_Qt_ImageConversionFlags(QPainter*, const QPoint*, const QImage*, const QRect*, unsigned);
    extern void __QtAda_QPainter_drawImage_QRectFCR_QImageCR(QPainter*, const QRectF*, const QImage*);
    extern void __QtAda_QPainter_drawImage_QRectCR_QImageCR(QPainter*, const QRect*, const QImage*);
    extern void __QtAda_QPainter_drawImage_int_int_QImageCR_int_int_int_int_Qt_ImageConversionFlags(QPainter*, int, int, const QImage*, int, int, int, int, unsigned);
    extern void __QtAda_QPainter_drawLine_QLineFCR(QPainter*, const QLineF*);
    extern void __QtAda_QPainter_drawLine_QLineCR(QPainter*, const QLine*);
    extern void __QtAda_QPainter_drawLine_QPointCR_QPointCR(QPainter*, const QPoint*, const QPoint*);
    extern void __QtAda_QPainter_drawLine_QPointFCR_QPointFCR(QPainter*, const QPointF*, const QPointF*);
    extern void __QtAda_QPainter_drawLine_int_int_int_int(QPainter*, int, int, int, int);
    extern void __QtAda_QPainter_drawPath_QPainterPathCR(QPainter*, const QPainterPath*);
    extern void __QtAda_QPainter_drawPie_QRectFCR_int_int(QPainter*, const QRectF*, int, int);
    extern void __QtAda_QPainter_drawPie_QRectCR_int_int(QPainter*, const QRect*, int, int);
    extern void __QtAda_QPainter_drawPie_int_int_int_int_int_int(QPainter*, int, int, int, int, int, int);
    extern void __QtAda_QPainter_drawPixmap_QRectFCR_QPixmapCR_QRectFCR(QPainter*, const QRectF*, const QPixmap*, const QRectF*);
    extern void __QtAda_QPainter_drawPixmap_QRectCR_QPixmapCR_QRectCR(QPainter*, const QRect*, const QPixmap*, const QRect*);
    extern void __QtAda_QPainter_drawPixmap_QPointFCR_QPixmapCR_QRectFCR(QPainter*, const QPointF*, const QPixmap*, const QRectF*);
    extern void __QtAda_QPainter_drawPixmap_QPointCR_QPixmapCR_QRectCR(QPainter*, const QPoint*, const QPixmap*, const QRect*);
    extern void __QtAda_QPainter_drawPixmap_QPointFCR_QPixmapCR(QPainter*, const QPointF*, const QPixmap*);
    extern void __QtAda_QPainter_drawPixmap_QPointCR_QPixmapCR(QPainter*, const QPoint*, const QPixmap*);
    extern void __QtAda_QPainter_drawPixmap_int_int_QPixmapCR(QPainter*, int, int, const QPixmap*);
    extern void __QtAda_QPainter_drawPixmap_QRectCR_QPixmapCR(QPainter*, const QRect*, const QPixmap*);
    extern void __QtAda_QPainter_drawPixmap_int_int_int_int_QPixmapCR(QPainter*, int, int, int, int, const QPixmap*);
    extern void __QtAda_QPainter_drawPixmap_int_int_int_int_QPixmapCR_int_int_int_int(QPainter*, int, int, int, int, const QPixmap*, int, int, int, int);
    extern void __QtAda_QPainter_drawPixmap_int_int_QPixmapCR_int_int_int_int(QPainter*, int, int, const QPixmap*, int, int, int, int);
    extern void __QtAda_QPainter_drawPoint_QPointFCR(QPainter*, const QPointF*);
    extern void __QtAda_QPainter_drawPoint_QPointCR(QPainter*, const QPoint*);
    extern void __QtAda_QPainter_drawPoint_int_int(QPainter*, int, int);
    extern void __QtAda_QPainter_drawPoints_QPolygonFCR(QPainter*, const QPolygonF*);
    extern void __QtAda_QPainter_drawPoints_QPolygonCR(QPainter*, const QPolygon*);
    extern void __QtAda_QPainter_drawPolygon_QPolygonFCR_FillRule(QPainter*, const QPolygonF*, unsigned);
    extern void __QtAda_QPainter_drawPolygon_QPolygonCR_FillRule(QPainter*, const QPolygon*, unsigned);
    extern void __QtAda_QPainter_drawPolyline_QPolygonFCR(QPainter*, const QPolygonF*);
    extern void __QtAda_QPainter_drawPolyline_QPolygonCR(QPainter*, const QPolygon*);
    extern void __QtAda_QPainter_drawRect_QRectFCR(QPainter*, const QRectF*);
    extern void __QtAda_QPainter_drawRect_QRectCR(QPainter*, const QRect*);
    extern void __QtAda_QPainter_drawRect_int_int_int_int(QPainter*, int, int, int, int);
    extern void __QtAda_QPainter_drawRoundRect_QRectFCR_int_int(QPainter*, const QRectF*, int, int);
    extern void __QtAda_QPainter_drawRoundRect_QRectCR_int_int(QPainter*, const QRect*, int, int);
    extern void __QtAda_QPainter_drawRoundRect_int_int_int_int_int_int(QPainter*, int, int, int, int, int, int);
    extern void __QtAda_QPainter_drawText_QPointFCR_QStringCR(QPainter*, const QPointF*, const QString*);
    extern void __QtAda_QPainter_drawText_QPointCR_QStringCR(QPainter*, const QPoint*, const QString*);
    extern void __QtAda_QPainter_drawText_int_int_QStringCR(QPainter*, int, int, const QString*);
    extern void __QtAda_QPainter_drawText_QRectFCR_QStringCR_QTextOptionCR(QPainter*, const QRectF*, const QString*, const QTextOption*);
    extern void __QtAda_QPainter_drawTiledPixmap_QRectFCR_QPixmapCR_QPointFCR(QPainter*, const QRectF*, const QPixmap*, const QPointF*);
    extern void __QtAda_QPainter_drawTiledPixmap_QRectCR_QPixmapCR_QPointCR(QPainter*, const QRect*, const QPixmap*, const QPoint*);
    extern void __QtAda_QPainter_drawTiledPixmap_int_int_int_int_QPixmapCR_int_int(QPainter*, int, int, int, int, const QPixmap*, int, int);
    extern unsigned __QtAda_QPainter_end(QPainter*);
    extern void __QtAda_QPainter_eraseRect_QRectFCR(QPainter*, const QRectF*);
    extern void __QtAda_QPainter_eraseRect_QRectCR(QPainter*, const QRect*);
    extern void __QtAda_QPainter_eraseRect_int_int_int_int(QPainter*, int, int, int, int);
    extern void __QtAda_QPainter_fillPath_QPainterPathCR_QBrushCR(QPainter*, const QPainterPath*, const QBrush*);
    extern void __QtAda_QPainter_fillRect_QRectFCR_QBrushCR(QPainter*, const QRectF*, const QBrush*);
    extern void __QtAda_QPainter_fillRect_QRectCR_QBrushCR(QPainter*, const QRect*, const QBrush*);
    extern void __QtAda_QPainter_fillRect_int_int_int_int_QBrushCR(QPainter*, int, int, int, int, const QBrush*);
    extern void __QtAda_QPainter_font_Q(QFont*, const QPainter*);
    extern QFontInfo* __QtAda_QPainter_fontInfo_Q(const QPainter*, void*);
    extern QFontMetrics* __QtAda_QPainter_fontMetrics_Q(const QPainter*, void*);
    extern unsigned __QtAda_QPainter_hasClipping_Q(const QPainter*);
    extern unsigned __QtAda_QPainter_isActive_Q(const QPainter*);
    extern unsigned __QtAda_QPainter_layoutDirection_Q(const QPainter*);
    extern void __QtAda_QPainter_matrix_Q(QMatrix*, const QPainter*);
    extern unsigned __QtAda_QPainter_matrixEnabled_Q(const QPainter*);
    extern double __QtAda_QPainter_opacity_Q(const QPainter*);
    extern void __QtAda_QPainter_pen_Q(QPen*, const QPainter*);
    extern void __QtAda_QPainter_resetMatrix(QPainter*);
    extern void __QtAda_QPainter_resetTransform(QPainter*);
    extern void __QtAda_QPainter_restore(QPainter*);
    extern void __QtAda_QPainter_rotate_qreal(QPainter*, double);
    extern void __QtAda_QPainter_save(QPainter*);
    extern void __QtAda_QPainter_scale_qreal_qreal(QPainter*, double, double);
    extern void __QtAda_QPainter_setBackground_QBrushCR(QPainter*, const QBrush*);
    extern void __QtAda_QPainter_setBackgroundMode_BGMode(QPainter*, unsigned);
    extern void __QtAda_QPainter_setBrush_QBrushCR(QPainter*, const QBrush*);
    extern void __QtAda_QPainter_setBrush_BrushStyle(QPainter*, unsigned);
    extern void __QtAda_QPainter_setBrushOrigin_QPointFCR(QPainter*, const QPointF*);
    extern void __QtAda_QPainter_setBrushOrigin_QPointCR(QPainter*, const QPoint*);
    extern void __QtAda_QPainter_setBrushOrigin_int_int(QPainter*, int, int);
    extern void __QtAda_QPainter_setClipPath_QPainterPathCR_ClipOperation(QPainter*, const QPainterPath*, unsigned);
    extern void __QtAda_QPainter_setClipRect_QRectFCR_ClipOperation(QPainter*, const QRectF*, unsigned);
    extern void __QtAda_QPainter_setClipRect_int_int_int_int_ClipOperation(QPainter*, int, int, int, int, unsigned);
    extern void __QtAda_QPainter_setClipRect_QRectCR_ClipOperation(QPainter*, const QRect*, unsigned);
    extern void __QtAda_QPainter_setClipRegion_QRegionCR_ClipOperation(QPainter*, const QRegion*, unsigned);
    extern void __QtAda_QPainter_setClipping_bool(QPainter*, unsigned);
    extern void __QtAda_QPainter_setCompositionMode_CompositionMode(QPainter*, unsigned);
    extern void __QtAda_QPainter_setFont_QFontCR(QPainter*, const QFont*);
    extern void __QtAda_QPainter_setLayoutDirection_LayoutDirection(QPainter*, unsigned);
    extern void __QtAda_QPainter_setOpacity_qreal(QPainter*, double);
    extern void __QtAda_QPainter_setPen_QPenCR(QPainter*, const QPen*);
    extern void __QtAda_QPainter_setPen_QColorCR(QPainter*, const QColor*);
    extern void __QtAda_QPainter_setPen_PenStyle(QPainter*, unsigned);
    extern void __QtAda_QPainter_setRenderHint_RenderHint_bool(QPainter*, unsigned, unsigned);
    extern void __QtAda_QPainter_setMatrix_QMatrixCR_bool(QPainter*, const QMatrix*, unsigned);
    extern void __QtAda_QPainter_setMatrixEnabled_bool(QPainter*, unsigned);
    extern void __QtAda_QPainter_setTransform_QTransformCR_bool(QPainter*, const QTransform*, unsigned);
    extern void __QtAda_QPainter_setViewTransformEnabled_bool(QPainter*, unsigned);
    extern void __QtAda_QPainter_setViewport_QRectCR(QPainter*, const QRect*);
    extern void __QtAda_QPainter_setViewport_int_int_int_int(QPainter*, int, int, int, int);
    extern void __QtAda_QPainter_setWindow_QRectCR(QPainter*, const QRect*);
    extern void __QtAda_QPainter_setWindow_int_int_int_int(QPainter*, int, int, int, int);
    extern void __QtAda_QPainter_setWorldMatrix_QMatrixCR_bool(QPainter*, const QMatrix*, unsigned);
    extern void __QtAda_QPainter_setWorldMatrixEnabled_bool(QPainter*, unsigned);
    extern void __QtAda_QPainter_setWorldTransform_QTransformCR_bool(QPainter*, const QTransform*, unsigned);
    extern void __QtAda_QPainter_shear_qreal_qreal(QPainter*, double, double);
    extern void __QtAda_QPainter_strokePath_QPainterPathCR_QPenCR(QPainter*, const QPainterPath*, const QPen*);
    extern unsigned __QtAda_QPainter_testRenderHint_RenderHint_Q(const QPainter*, unsigned);
    extern void __QtAda_QPainter_transform_Q(QTransform*, const QPainter*);
    extern void __QtAda_QPainter_translate_QPointFCR(QPainter*, const QPointF*);
    extern void __QtAda_QPainter_translate_QPointCR(QPainter*, const QPoint*);
    extern void __QtAda_QPainter_translate_qreal_qreal(QPainter*, double, double);
    extern unsigned __QtAda_QPainter_viewTransformEnabled_Q(const QPainter*);
    extern void __QtAda_QPainter_viewport_Q(QRect*, const QPainter*);
    extern void __QtAda_QPainter_window_Q(QRect*, const QPainter*);
    extern void __QtAda_QPainter_worldMatrix_Q(QMatrix*, const QPainter*);
    extern unsigned __QtAda_QPainter_worldMatrixEnabled_Q(const QPainter*);
    extern void __QtAda_QPainter_worldTransform_Q(QTransform*, const QPainter*);

    extern void __Qt4Ada_QPainter_drawText_null_boundingRect_wrapper
                    (QPainter*, QRect*, int, QString*);
};
