//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2733 $ $Date: 2008-05-14 08:54:18 +0400 (Wed, 14 May 2008) $
//----------------------------------------------------------------------------

#include "qpalettewrapper.h"

extern "C"
{

    QPalette* __Qt4Ada_new_QPalette ()
    {
        return new QPalette ();
    }

    QPalette* __Qt4Ada_new_QPalette_button (const QColor* button)
    {
        return new QPalette (*button);
    }

    QPalette* __Qt4Ada_copy_QPalette (const QPalette* cpp_object)
    {
        return new QPalette (*cpp_object);
    }

    void __Qt4Ada_delete_QPalette (QPalette* cpp_object)
    {
        delete cpp_object;
    }

    void __Qt4Ada_assign_QPalette(QPalette*p1, const QPalette*p2)
    {
       *p1 = *p2;
    }

    void __Qt4Ada_QPalette_base_wrapper (QPalette*cpp_object, QBrush*ret)
    {
        *ret = cpp_object -> base ();
    }
    void __Qt4Ada_QPalette_color_wrapper (QPalette*cpp_object,QPalette::ColorRole role, QColor* ret)
    {
        *ret = cpp_object -> color (role);
    }

   void __Qt4Ada_QPalette_set_color_wrapper (QPalette*cpp_object,
                                             QPalette::ColorRole Role,
                                             QColor* color)
   {
      cpp_object->setColor (Role, *color);
   }
}
