//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QBrush>
#include <QColor>
#include <QString>
#include "qpenwrapper.h"

extern "C"
{

    QPen* __QtAda_inititialize_QPen(void* storage)
    {
        return new (storage) QPen();
    }

    QPen* __QtAda_inititialize_QPen_PenStyle(void* storage, unsigned style)
    {
        return new (storage) QPen((Qt::PenStyle)style);
    }

    QPen* __QtAda_inititialize_QPen_QColorCR(void* storage, const QColor* color)
    {
        return new (storage) QPen(*color);
    }

    QPen* __QtAda_inititialize_QPen_QBrushCR_qreal_PenStyle_PenCapStyle_PenJoinStyle(void* storage, const QBrush* brush, double width, unsigned s, unsigned c, unsigned j)
    {
        return new (storage) QPen(*brush, (qreal)width, (Qt::PenStyle)s, (Qt::PenCapStyle)c, (Qt::PenJoinStyle)j);
    }

    QPen* __QtAda_adjust_QPen(void* storage, const QPen* from)
    {
        return new (storage) QPen(*from);
    }

    void __QtAda_finalize_QPen(QPen *item)
    {
        item->~QPen();
    }

    void __QtAda_QPen_brush_Q(QBrush* returns, const QPen* self)
    {
        *returns = self->brush();
    }

    unsigned __QtAda_QPen_capStyle_Q(const QPen* self)
    {
        return (unsigned)self->capStyle();
    }

    void __QtAda_QPen_color_Q(QColor* returns, const QPen* self)
    {
        *returns = self->color();
    }

    double __QtAda_QPen_dashOffset_Q(const QPen* self)
    {
        return (double)self->dashOffset();
    }

    unsigned __QtAda_QPen_isCosmetic_Q(const QPen* self)
    {
        return (unsigned)self->isCosmetic();
    }

    unsigned __QtAda_QPen_isSolid_Q(const QPen* self)
    {
        return (unsigned)self->isSolid();
    }

    unsigned __QtAda_QPen_joinStyle_Q(const QPen* self)
    {
        return (unsigned)self->joinStyle();
    }

    double __QtAda_QPen_miterLimit_Q(const QPen* self)
    {
        return (double)self->miterLimit();
    }

    void __QtAda_QPen_setBrush_QBrushCR(QPen* self, const QBrush* brush)
    {
        self->setBrush(*brush);
    }

    void __QtAda_QPen_setCapStyle_PenCapStyle(QPen* self, unsigned style)
    {
        self->setCapStyle((Qt::PenCapStyle)style);
    }

    void __QtAda_QPen_setColor_QColorCR(QPen* self, const QColor* color)
    {
        self->setColor(*color);
    }

    void __QtAda_QPen_setCosmetic_bool(QPen* self, unsigned cosmetic)
    {
        self->setCosmetic((bool)cosmetic);
    }

    void __QtAda_QPen_setDashOffset_qreal(QPen* self, double doffset)
    {
        self->setDashOffset((qreal)doffset);
    }

    void __QtAda_QPen_setJoinStyle_PenJoinStyle(QPen* self, unsigned pcs)
    {
        self->setJoinStyle((Qt::PenJoinStyle)pcs);
    }

    void __QtAda_QPen_setMiterLimit_qreal(QPen* self, double limit)
    {
        self->setMiterLimit((qreal)limit);
    }

    void __QtAda_QPen_setStyle_PenStyle(QPen* self, unsigned style)
    {
        self->setStyle((Qt::PenStyle)style);
    }

    void __QtAda_QPen_setWidth_int(QPen* self, int width)
    {
        self->setWidth(width);
    }

    void __QtAda_QPen_setWidthF_qreal(QPen* self, double width)
    {
        self->setWidthF((qreal)width);
    }

    unsigned __QtAda_QPen_style_Q(const QPen* self)
    {
        return (unsigned)self->style();
    }

    int __QtAda_QPen_width_Q(const QPen* self)
    {
        return self->width();
    }

    double __QtAda_QPen_widthF_Q(const QPen* self)
    {
        return (double)self->widthF();
    }

    unsigned __QtAda_QPen_eq_QPenCR_Q(const QPen* self, const QPen* pen)
    {
        return (unsigned)self->operator==(*pen);
    }

};

