//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QBitmap>
#include <QMatrix>
#include <QPixmap>
#include <QRect>
#include <QSize>
#include <QString>
#include <QTransform>
#include "qpixmapwrapper.h"

extern "C"
{

    QPixmap* __QtAda_inititialize_QPixmap(void* storage)
    {
        return new (storage) QPixmap();
    }

    QPixmap* __QtAda_inititialize_QPixmap_int_int(void* storage, int width, int height)
    {
        return new (storage) QPixmap(width, height);
    }

    QPixmap* __QtAda_initialize_QPixmap_QStringCR_charP_QtImageConversionFlags(void* storage, QString* fileName, char* format, unsigned flags)
    {
        return new (storage) QPixmap(*fileName, format, (Qt::ImageConversionFlags)flags);
    }

    QPixmap* __QtAda_inititialize_QPixmap_QSizeCR(void* storage, const QSize* size)
    {
        return new (storage) QPixmap(*size);
    }

    QPixmap* __QtAda_adjust_QPixmap(void* storage, const QPixmap* from)
    {
        return new (storage) QPixmap(*from);
    }

    void __QtAda_finalize_QPixmap(QPixmap *item)
    {
        item->~QPixmap();
    }

    void __QtAda_QPixmap_alphaChannel_Q(QPixmap* returns, const QPixmap* self)
    {
        *returns = self->alphaChannel();
    }

    void __QtAda_QPixmap_copy_QRectCR_Q(QPixmap* returns, const QPixmap* self, const QRect* rect)
    {
        *returns = self->copy(*rect);
    }

    void __QtAda_QPixmap_copy_int_int_int_int_Q(QPixmap* returns, const QPixmap* self, int x, int y, int width, int height)
    {
        *returns = self->copy(x, y, width, height);
    }

    void __QtAda_QPixmap_createHeuristicMask_bool_Q(QPixmap* returns, const QPixmap* self, unsigned clipTight)
    {
        *static_cast<QBitmap*>(returns) = self->createHeuristicMask((bool)clipTight);
    }

    void __QtAda_QPixmap_createMaskFromColor_QColorCR_MaskMode_Q(QPixmap* returns, const QPixmap* self, const QColor* maskColor, unsigned mode)
    {
        *static_cast<QBitmap*>(returns) = self->createMaskFromColor(*maskColor, (Qt::MaskMode)mode);
    }

    void __QtAda_QPixmap_createMaskFromColor_QColorCR_Q(QPixmap* returns, const QPixmap* self, const QColor* maskColor)
    {
        *static_cast<QBitmap*>(returns) = self->createMaskFromColor(*maskColor);
    }

    int __QtAda_QPixmap_depth_Q(const QPixmap* self)
    {
        return self->depth();
    }

    void __QtAda_QPixmap_detach(QPixmap* self)
    {
        self->detach();
    }

    void __QtAda_QPixmap_fill_QColorCR(QPixmap* self, const QColor* fillColor)
    {
        self->fill(*fillColor);
    }

    unsigned __QtAda_QPixmap_hasAlpha_Q(const QPixmap* self)
    {
        return (unsigned)self->hasAlpha();
    }

    unsigned __QtAda_QPixmap_hasAlphaChannel_Q(const QPixmap* self)
    {
        return (unsigned)self->hasAlphaChannel();
    }

    int __QtAda_QPixmap_height_Q(const QPixmap* self)
    {
        return self->height();
    }

    unsigned __QtAda_QPixmap_isNull_Q(const QPixmap* self)
    {
        return (unsigned)self->isNull();
    }

    unsigned __QtAda_QPixmap_isQBitmap_Q(const QPixmap* self)
    {
        return (unsigned)self->isQBitmap();
    }

    void __QtAda_QPixmap_mask_Q(QPixmap* returns, const QPixmap* self)
    {
        *static_cast<QBitmap*>(returns) = self->mask();
    }

    void __QtAda_QPixmap_rect_Q(QRect* returns, const QPixmap* self)
    {
        *returns = self->rect();
    }

    void __QtAda_QPixmap_scaled_QSizeCR_AspectRatioMode_TransformationMode_Q(QPixmap* returns, const QPixmap* self, const QSize* s, unsigned aspectMode, unsigned mode)
    {
        *returns = self->scaled(*s, (Qt::AspectRatioMode)aspectMode, (Qt::TransformationMode)mode);
    }

    void __QtAda_QPixmap_scaled_int_int_AspectRatioMode_TransformationMode_Q(QPixmap* returns, const QPixmap* self, int width, int height, unsigned aspectMode, unsigned mode)
    {
        *returns = self->scaled(width, height, (Qt::AspectRatioMode)aspectMode, (Qt::TransformationMode)mode);
    }

    void __QtAda_QPixmap_scaledToHeight_int_TransformationMode_Q(QPixmap* returns, const QPixmap* self, int height, unsigned mode)
    {
        *returns = self->scaledToHeight(height, (Qt::TransformationMode)mode);
    }

    void __QtAda_QPixmap_scaledToWidth_int_TransformationMode_Q(QPixmap* returns, const QPixmap* self, int width, unsigned mode)
    {
        *returns = self->scaledToWidth(width, (Qt::TransformationMode)mode);
    }

    void __QtAda_QPixmap_setAlphaChannel_QPixmapCR(QPixmap* self, const QPixmap* alphaChannel)
    {
        self->setAlphaChannel(*alphaChannel);
    }

    void __QtAda_QPixmap_setMask_QBitmapCR(QPixmap* self, const QPixmap* mask)
    {
        self->setMask(*static_cast<const QBitmap*>(mask));
    }

    void __QtAda_QPixmap_size_Q(QSize* returns, const QPixmap* self)
    {
        *returns = self->size();
    }

    void __QtAda_QPixmap_transformed_QTransformCR_TransformationMode_Q(QPixmap* returns, const QPixmap* self, const QTransform* matrix, unsigned mode)
    {
        *returns = self->transformed(*matrix, (Qt::TransformationMode)mode);
    }

    void __QtAda_QPixmap_transformed_QMatrixCR_TransformationMode_Q(QPixmap* returns, const QPixmap* self, const QMatrix* matrix, unsigned mode)
    {
        *returns = self->transformed(*matrix, (Qt::TransformationMode)mode);
    }

    int __QtAda_QPixmap_width_Q(const QPixmap* self)
    {
        return self->width();
    }

    int __QtAda_QPixmap_defaultDepth_S()
    {
        return QPixmap::defaultDepth();
    }

    void __QtAda_QPixmap_trueMatrix_QTransformCR_int_int_S(QTransform* returns, const QTransform* matrix, int width, int height)
    {
        *returns = QPixmap::trueMatrix(*matrix, width, height);
    }

    void __QtAda_QPixmap_trueMatrix_QMatrixCR_int_int_S(QMatrix* returns, const QMatrix* matrix, int width, int height)
    {
        *returns = QPixmap::trueMatrix(*matrix, width, height);
    }

    QPaintDevice* __QtAda_QPixmap_QPaintDevice_View(QPixmap* self)
    {
        return static_cast<QPaintDevice*>(self);
    }

};

