//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2884 $ $Date: 2008-10-02 16:45:42 +0400 (Thu, 02 Oct 2008) $
//----------------------------------------------------------------------------

#include "qstyleoptionviewitemwrapper.h"
#include <QStyleOptionViewItem>

extern "C"
{
    QStyleOption* __Qt4Ada_new_QStyleOptionViewItem ()
    {
       return (qstyleoption_cast<QStyleOption*>(new QStyleOptionViewItem ()));
    }

    void __Qt4Ada_QStyleOptionViewItem_font_wrapper (QStyleOption*cpp_object, QFont*ret)
    {
       *ret = qstyleoption_cast<QStyleOptionViewItem*> (cpp_object)->font;
    }

    void __Qt4Ada_QStyleOptionViewItem_palette_wrapper (QStyleOption*cpp_object, QPalette*ret)
    {
       *ret = qstyleoption_cast<QStyleOptionViewItem*> (cpp_object) -> palette;
    }

    unsigned __Qt4Ada_QStyleOptionViewItem_state_wrapper (QStyleOption*cpp_object)
    {
       return (unsigned) (qstyleoption_cast<QStyleOptionViewItem*> (cpp_object) -> state);
    }

    void __Qt4Ada_QStyleOptionViewItem_setState_wrapper (QStyleOption*cpp_object,unsigned state)
    {
        qstyleoption_cast <QStyleOptionViewItem*> (cpp_object) -> state = (QStyle::State) state;
    }

    int __Qt4Ada_QStyleOptionViewItem_type_wrapper (QStyleOption*cpp_object)
    {
        return qstyleoption_cast <QStyleOptionViewItem*> (cpp_object) -> type;
    }

    int __Qt4Ada_QStyleOptionViewItem_version_wrapper (QStyleOption*cpp_object)
    {
       return qstyleoption_cast<QStyleOptionViewItem*> (cpp_object) -> version;
    }
}
