------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2012 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Icons;
with Qt4.Sizes;
with Qt4.Strings;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Abstract_Buttons is

   type Q_Abstract_Button is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Abstract_Button_Access is
     access all Q_Abstract_Button'Class;
   for Q_Abstract_Button_Access'Storage_Size use 0;

   type Q_Abstract_Button_Pointer is tagged;

   function Auto_Exclusive
    (Self : not null access constant Q_Abstract_Button'Class)
       return Standard.Boolean;

   function Auto_Repeat
    (Self : not null access constant Q_Abstract_Button'Class)
       return Standard.Boolean;

   function Icon
    (Self : not null access constant Q_Abstract_Button'Class)
       return Qt4.Icons.Q_Icon;

   function Icon_Size
    (Self : not null access constant Q_Abstract_Button'Class)
       return Qt4.Sizes.Q_Size;

   function Is_Checkable
    (Self : not null access constant Q_Abstract_Button'Class)
       return Standard.Boolean;

   function Is_Checked
    (Self : not null access constant Q_Abstract_Button'Class)
       return Standard.Boolean;

   function Is_Down
    (Self : not null access constant Q_Abstract_Button'Class)
       return Standard.Boolean;

   procedure Set_Auto_Exclusive
    (Self : not null access Q_Abstract_Button'Class;
     Enabled : Standard.Boolean);

   procedure Set_Auto_Repeat
    (Self : not null access Q_Abstract_Button'Class;
     Enabled : Standard.Boolean);

   procedure Set_Checkable
    (Self : not null access Q_Abstract_Button'Class;
     Checkable : Standard.Boolean);

   procedure Set_Down
    (Self : not null access Q_Abstract_Button'Class;
     Pressed : Standard.Boolean);

   procedure Set_Icon
    (Self : not null access Q_Abstract_Button'Class;
     Icon : Qt4.Icons.Q_Icon);

   procedure Set_Text
    (Self : not null access Q_Abstract_Button'Class;
     Text : Qt4.Strings.Q_String);

   function Text
    (Self : not null access constant Q_Abstract_Button'Class)
       return Qt4.Strings.Q_String;

   procedure Click
    (Self : not null access Q_Abstract_Button'Class);

   procedure Set_Checked
    (Self : not null access Q_Abstract_Button'Class;
     Checked : Standard.Boolean);

   procedure Set_Icon_Size
    (Self : not null access Q_Abstract_Button'Class;
     Size : Qt4.Sizes.Q_Size);

   procedure Toggle
    (Self : not null access Q_Abstract_Button'Class);

   package Q_Abstract_Button_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Abstract_Button, Q_Abstract_Button_Access);

   type Q_Abstract_Button_Pointer is
     new Q_Abstract_Button_Pointers.Q_Pointer with null record;

end Qt4.Abstract_Buttons;
