------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Strings;
with Qt4.Validators;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Abstract_Spin_Boxes is

   type Q_Abstract_Spin_Box is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Abstract_Spin_Box_Access is
     access all Q_Abstract_Spin_Box'Class;
   for Q_Abstract_Spin_Box_Access'Storage_Size use 0;

   type Q_Abstract_Spin_Box_Pointer is tagged;

   not overriding
   procedure Fixup
    (Self : not null access constant Q_Abstract_Spin_Box;
     Input : Qt4.Strings.Q_String)
       is abstract;

   function Has_Acceptable_Input
    (Self : not null access constant Q_Abstract_Spin_Box'Class)
       return Standard.Boolean;

   function Has_Frame
    (Self : not null access constant Q_Abstract_Spin_Box'Class)
       return Standard.Boolean;

   procedure Interpret_Text
    (Self : not null access Q_Abstract_Spin_Box'Class);

   function Is_Accelerated
    (Self : not null access constant Q_Abstract_Spin_Box'Class)
       return Standard.Boolean;

   function Is_Read_Only
    (Self : not null access constant Q_Abstract_Spin_Box'Class)
       return Standard.Boolean;

   procedure Set_Accelerated
    (Self : not null access Q_Abstract_Spin_Box'Class;
     On : Standard.Boolean);

   procedure Set_Frame
    (Self : not null access Q_Abstract_Spin_Box'Class;
     Enabled : Standard.Boolean);

   procedure Set_Read_Only
    (Self : not null access Q_Abstract_Spin_Box'Class;
     Enabled : Standard.Boolean);

   procedure Set_Special_Value_Text
    (Self : not null access Q_Abstract_Spin_Box'Class;
     Text : Qt4.Strings.Q_String);

   procedure Set_Wrapping
    (Self : not null access Q_Abstract_Spin_Box'Class;
     Enabled : Standard.Boolean);

   function Special_Value_Text
    (Self : not null access constant Q_Abstract_Spin_Box'Class)
       return Qt4.Strings.Q_String;

   not overriding
   procedure Step_By
    (Self : not null access Q_Abstract_Spin_Box;
     Steps : Qt4.Q_Integer)
       is abstract;

   function Text
    (Self : not null access constant Q_Abstract_Spin_Box'Class)
       return Qt4.Strings.Q_String;

   not overriding
   function Validate
    (Self : not null access constant Q_Abstract_Spin_Box;
     Input : Qt4.Strings.Q_String;
     Pos : Qt4.Q_Integer)
       return Qt4.Validators.Validator_State
         is abstract;

   function Wrapping
    (Self : not null access constant Q_Abstract_Spin_Box'Class)
       return Standard.Boolean;

   not overriding
   procedure Clear
    (Self : not null access Q_Abstract_Spin_Box)
       is abstract;

   procedure Select_All
    (Self : not null access Q_Abstract_Spin_Box'Class);

   procedure Step_Down
    (Self : not null access Q_Abstract_Spin_Box'Class);

   procedure Step_Up
    (Self : not null access Q_Abstract_Spin_Box'Class);

   package Q_Abstract_Spin_Box_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Abstract_Spin_Box, Q_Abstract_Spin_Box_Access);

   type Q_Abstract_Spin_Box_Pointer is
     new Q_Abstract_Spin_Box_Pointers.Q_Pointer with null record;

end Qt4.Abstract_Spin_Boxes;
