------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Objects;
with Qt4.Point_Fs;
with Qt4.Rect_Fs;
with Qt4.Size_Fs;
with Qt4.Strings;
with Qt4.Text_Blocks;
limited with Qt4.Text_Documents;
limited with Qt4.Text_Frames;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Abstract_Text_Document_Layouts is

   type Q_Abstract_Text_Document_Layout is limited interface
     and Qt4.Objects.Q_Object;

   type Q_Abstract_Text_Document_Layout_Access is
     access all Q_Abstract_Text_Document_Layout'Class;
   for Q_Abstract_Text_Document_Layout_Access'Storage_Size use 0;

   type Q_Abstract_Text_Document_Layout_Pointer is tagged;

   function Anchor_At
    (Self : not null access constant Q_Abstract_Text_Document_Layout'Class;
     Pos : Qt4.Point_Fs.Q_Point_F)
       return Qt4.Strings.Q_String;

   not overriding
   function Block_Bounding_Rect
    (Self : not null access constant Q_Abstract_Text_Document_Layout;
     Block : Qt4.Text_Blocks.Q_Text_Block)
       return Qt4.Rect_Fs.Q_Rect_F
         is abstract;

   function Document
    (Self : not null access constant Q_Abstract_Text_Document_Layout'Class)
       return not null access Qt4.Text_Documents.Q_Text_Document'Class;

   not overriding
   function Document_Size
    (Self : not null access constant Q_Abstract_Text_Document_Layout)
       return Qt4.Size_Fs.Q_Size_F
         is abstract;

   not overriding
   function Frame_Bounding_Rect
    (Self : not null access constant Q_Abstract_Text_Document_Layout;
     Frame : not null access Qt4.Text_Frames.Q_Text_Frame'Class)
       return Qt4.Rect_Fs.Q_Rect_F
         is abstract;

   not overriding
   function Hit_Test
    (Self : not null access constant Q_Abstract_Text_Document_Layout;
     Point : Qt4.Point_Fs.Q_Point_F;
     Accuracy : Qt4.Hit_Test_Accuracy)
       return Qt4.Q_Integer
         is abstract;

   not overriding
   function Page_Count
    (Self : not null access constant Q_Abstract_Text_Document_Layout)
       return Qt4.Q_Integer
         is abstract;

   procedure Register_Handler
    (Self : not null access Q_Abstract_Text_Document_Layout'Class;
     Object_Type : Qt4.Q_Integer;
     Component : not null access Qt4.Objects.Q_Object'Class);

   package Q_Abstract_Text_Document_Layout_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Abstract_Text_Document_Layout, Q_Abstract_Text_Document_Layout_Access);

   type Q_Abstract_Text_Document_Layout_Pointer is
     new Q_Abstract_Text_Document_Layout_Pointers.Q_Pointer with null record;

end Qt4.Abstract_Text_Document_Layouts;
