------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Qt4.Icons;
with Qt4.Objects;
with Qt4.Strings;

package Qt4.Actions.Constructors is

   function Create (Parent : not null access Qt4.Objects.Q_Object'Class)
     return not null Qt4.Actions.Q_Action_Access;
   --  Returns new QAction object.

   function Create (Text   : Qt4.Strings.Q_String;
                    Parent : not null access Qt4.Objects.Q_Object'Class)
     return not null Qt4.Actions.Q_Action_Access;
   --  Returns new QAction object.

   function Create (Icon   : Qt4.Icons.Q_Icon;
                    Text   : Qt4.Strings.Q_String;
                    Parent : not null access Qt4.Objects.Q_Object'Class)
     return not null Qt4.Actions.Q_Action_Access;
   --  Returns new QAction object.

end Qt4.Actions.Constructors;
