------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Core_Applications;
with Qt4.Cursors;
with Qt4.Session_Managers;
with Qt4.Strings;
with Qt4.Styles;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Applications is

   type Q_Application is limited interface
     and Qt4.Core_Applications.Q_Core_Application;

   type Q_Application_Access is
     access all Q_Application'Class;
   for Q_Application_Access'Storage_Size use 0;

   type Q_Application_Pointer is tagged;

   function Is_Session_Restored
    (Self : not null access constant Q_Application'Class)
       return Standard.Boolean;

   function Session_Id
    (Self : not null access constant Q_Application'Class)
       return Qt4.Strings.Q_String;

   function Session_Key
    (Self : not null access constant Q_Application'Class)
       return Qt4.Strings.Q_String;

   function Style_Sheet
    (Self : not null access constant Q_Application'Class)
       return Qt4.Strings.Q_String;

   procedure About_Qt
    (Self : not null access Q_Application'Class);

   procedure Close_All_Windows
    (Self : not null access Q_Application'Class);

   procedure Set_Style_Sheet
    (Self : not null access Q_Application'Class;
     Sheet : Qt4.Strings.Q_String);

   not overriding
   procedure Commit_Data
    (Self    : not null access Q_Application;
     Manager : not null access Qt4.Session_Managers.Q_Session_Manager'Class)
       is abstract;

   not overriding
   procedure Save_State
    (Self    : not null access Q_Application;
     Manager : not null access Qt4.Session_Managers.Q_Session_Manager'Class)
       is abstract;

   procedure Set_Override_Cursor (Cursor : Qt4.Cursors.Q_Cursor);

   procedure Restore_Override_Cursor;
   pragma Import (C,
                  Restore_Override_Cursor,
                  "__Qt4Ada_QApplication_restoreOverrideCursor_wrapper");

   function Exec return Qt4.Q_Integer;
   pragma Import (C, Exec, "__Qt4Ada_QApplication_exec_wrapper");

   procedure Set_Style (Style : not null access Qt4.Styles.Q_Style'Class);

   function Set_Style (Style : Qt4.Strings.Q_String'Class)
     return access Qt4.Styles.Q_Style'Class;

   function Style return not null access Qt4.Styles.Q_Style'Class;

   package Q_Application_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Application, Q_Application_Access);

   type Q_Application_Pointer is
     new Q_Application_Pointers.Q_Pointer with null record;

end Qt4.Applications;
