------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Layouts;
with Qt4.Rects;
limited with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Box_Layouts is

   type Q_Box_Layout is limited interface
     and Qt4.Layouts.Q_Layout;

   type Q_Box_Layout_Access is
     access all Q_Box_Layout'Class;
   for Q_Box_Layout_Access'Storage_Size use 0;

   type Q_Box_Layout_Pointer is tagged;

   procedure Add_Layout
    (Self : not null access Q_Box_Layout'Class;
     Layout : not null access Qt4.Layouts.Q_Layout'Class;
     Stretch : Qt4.Q_Integer
       :=  0);

   procedure Add_Spacing
    (Self : not null access Q_Box_Layout'Class;
     Size : Qt4.Q_Integer);

   procedure Add_Stretch
    (Self : not null access Q_Box_Layout'Class;
     Stretch : Qt4.Q_Integer
       :=  0);

   procedure Add_Strut
    (Self : not null access Q_Box_Layout'Class;
     Size : Qt4.Q_Integer);

   procedure Insert_Layout
    (Self : not null access Q_Box_Layout'Class;
     Index : Qt4.Q_Integer;
     Layout : not null access Qt4.Layouts.Q_Layout'Class;
     Stretch : Qt4.Q_Integer
       :=  0);

   procedure Insert_Spacing
    (Self : not null access Q_Box_Layout'Class;
     Index : Qt4.Q_Integer;
     Size : Qt4.Q_Integer);

   procedure Insert_Stretch
    (Self : not null access Q_Box_Layout'Class;
     Index : Qt4.Q_Integer;
     Stretch : Qt4.Q_Integer
       :=  0);

   function Set_Stretch_Factor
    (Self : not null access Q_Box_Layout'Class;
     W : not null access Qt4.Widgets.Q_Widget'Class;
     Stretch : Qt4.Q_Integer)
       return Standard.Boolean;

   function Set_Stretch_Factor
    (Self : not null access Q_Box_Layout'Class;
     L : not null access Qt4.Layouts.Q_Layout'Class;
     Stretch : Qt4.Q_Integer)
       return Standard.Boolean;

   procedure Set_Geometry
    (Self : not null access Q_Box_Layout'Class;
     R : Qt4.Rects.Q_Rect);

   type Direction is
    (Left_To_Right,
     Right_To_Left,
     Top_To_Bottom,
     Bottom_To_Top);
   pragma Convention (C, Direction);

   Down : constant Direction := Top_To_Bottom;
   Up   : constant Direction := Bottom_To_Top;

--   ---------------------------------------------------------------------------
--   --! <Subprogram>
--   --!    <Unit> Add_Widget
--   --!    <Purpose> Подпрограмма-обёртка вызова функции QBoxLayout::addWidget.
--   --!    <Exceptions>
--   ---------------------------------------------------------------------------
--   not overriding
--   procedure Add_Widget
--    (Self      : not null access Q_Box_Layout;
--     Widget    : not null access Qt4.Widgets.Q_Widget'Class;
--     Stretch   : Interfaces.C.int := 0;
--     Alignment : Qt4.Alignment    := +Align_Default)
--       is abstract;

   package Q_Box_Layout_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Box_Layout, Q_Box_Layout_Access);

   type Q_Box_Layout_Pointer is
     new Q_Box_Layout_Pointers.Q_Pointer with null record;

end Qt4.Box_Layouts;
