------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Check_Boxes.Constructors is

   function new_QCheckBox (Parent : access Qt_Ada.Internals.Objects.QObject)
     return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, new_QCheckBox, "__Qt4Ada_new_QCheckBox");

   function new_QCheckBox_with_QString
    (Title  : not null access Qt4.Strings.Internals.QString;
     Parent :          access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import
    (C, new_QCheckBox_with_QString, "__Qt4Ada_new_QCheckBox_with_QString");

   ------------
   -- Create --
   ------------

   function Create (Parent : access Widgets.Q_Widget'Class := null)
     return not null Qt4.Check_Boxes.Q_Check_Box_Access
   is
   begin
      return
        Qt4.Check_Boxes.Q_Check_Box_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QCheckBox
             (Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent))));
   end Create;

   ------------
   -- Create --
   ------------

   function Create (Title  : Qt4.Strings.Q_String;
                    Parent : access Widgets.Q_Widget'Class := null)
     return not null Qt4.Check_Boxes.Q_Check_Box_Access
   is
   begin
      return
        Qt4.Check_Boxes.Q_Check_Box_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QCheckBox_with_QString
             (Qt4.Strings.Internals.QString_View (Title),
              Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent))));
   end Create;

end Qt4.Check_Boxes.Constructors;
