------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;

with Qt_Ada.Internals.Objects.Color_Dialog_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Color_Dialog_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Color_Dialogs is

   procedure currentColor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Colors.Internals.QColor);
   pragma Import (C, currentColor_0_wrapper,
                     "__Qt4Ada_QColorDialog_currentColor_0_wrapper");

   procedure open_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, open_0_wrapper,
                     "__Qt4Ada_QColorDialog_open_0_wrapper");

   procedure selectedColor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Colors.Internals.QColor);
   pragma Import (C, selectedColor_0_wrapper,
                     "__Qt4Ada_QColorDialog_selectedColor_0_wrapper");

   procedure setCurrentColor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Color : not null access constant Qt4.Colors.Internals.QColor);
   pragma Import (C, setCurrentColor_0_wrapper,
                     "__Qt4Ada_QColorDialog_setCurrentColor_0_wrapper");

   procedure getColor_QColorCR_QWidgetP
    (Initial : not null access Qt4.Colors.Internals.QColor;
     Parent  : access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Colors.Internals.QColor);
   pragma Import
    (C, getColor_QColorCR_QWidgetP,
     "__QtAda_QColorDialog_getColor_QColorCR_QWidgetP");

   ---------------
   -- Get_Color --
   ---------------

   function Get_Color
    (Initial : Qt4.Colors.Q_Color'Class := Qt4.Colors.Create (Qt4.White);
     Parent  : access Qt4.Widgets.Q_Widget'Class := null)
       return Qt4.Colors.Q_Color
   is
      Returns : Qt4.Colors.Q_Color;

   begin
      getColor_QColorCR_QWidgetP
       (Qt4.Colors.Internals.QColor_View (Initial),
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
         (Parent),
        Qt4.Colors.Internals.QColor_View (Returns));

      return Returns;
   end Get_Color;

   pragma Style_Checks ("N");

   -------------------
   -- Current_Color --
   -------------------

   function Current_Color
    (Self : not null access constant Q_Color_Dialog'Class)
       return Qt4.Colors.Q_Color
   is
      Returns : Qt4.Colors.Q_Color;

   begin
      currentColor_0_wrapper
       (Self.QObject_View,
        Qt4.Colors.Internals.QColor_View (Returns));

      return Returns;
   end Current_Color;

   ----------
   -- Open --
   ----------

   procedure Open
    (Self : not null access Q_Color_Dialog'Class)
   is
   begin
      open_0_wrapper
       (Self.QObject_View);
   end Open;

   --------------------
   -- Selected_Color --
   --------------------

   function Selected_Color
    (Self : not null access constant Q_Color_Dialog'Class)
       return Qt4.Colors.Q_Color
   is
      Returns : Qt4.Colors.Q_Color;

   begin
      selectedColor_0_wrapper
       (Self.QObject_View,
        Qt4.Colors.Internals.QColor_View (Returns));

      return Returns;
   end Selected_Color;

   -----------------------
   -- Set_Current_Color --
   -----------------------

   procedure Set_Current_Color
    (Self : not null access Q_Color_Dialog'Class;
     Color : Qt4.Colors.Q_Color)
   is
   begin
      setCurrentColor_0_wrapper
       (Self.QObject_View,
        Qt4.Colors.Internals.QColor_View (Color));
   end Set_Current_Color;

end Qt4.Color_Dialogs;
