------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Abstract_Buttons;
limited with Qt4.Push_Buttons;
with Qt4.Strings;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Dialog_Button_Boxes is

   type Dialog_Button_Box_Button_Role is
    (Invalid_Role,
     Accept_Role,
     Reject_Role,
     Destructive_Role,
     Action_Role,
     Help_Role,
     Yes_Role,
     No_Role,
     Reset_Role,
     Apply_Role,
     N_Roles);
   pragma Convention (C, Dialog_Button_Box_Button_Role);
   for Dialog_Button_Box_Button_Role use
    (Invalid_Role =>     -16#1#,
     Accept_Role =>      16#0#,
     Reject_Role =>      16#1#,
     Destructive_Role =>      16#2#,
     Action_Role =>      16#3#,
     Help_Role =>      16#4#,
     Yes_Role =>      16#5#,
     No_Role =>      16#6#,
     Reset_Role =>      16#7#,
     Apply_Role =>      16#8#,
     N_Roles =>      16#9#);

   type Dialog_Button_Box_Standard_Button is
    (No_Button,
     Ok,
     Save,
     Save_All,
     Open,
     Yes,
     Yes_To_All,
     No,
     No_To_All,
     An_Abort,
     Retry,
     Ignore,
     Close,
     Cancel,
     Discard,
     Help,
     Apply,
     Reset,
     Restore_Defaults);
   pragma Convention (C, Dialog_Button_Box_Standard_Button);
   for Dialog_Button_Box_Standard_Button use
    (No_Button =>      16#0#,
     Ok =>    16#400#,
     Save =>    16#800#,
     Save_All =>   16#1000#,
     Open =>   16#2000#,
     Yes =>   16#4000#,
     Yes_To_All =>   16#8000#,
     No =>  16#10000#,
     No_To_All =>  16#20000#,
     An_Abort =>  16#40000#,
     Retry =>  16#80000#,
     Ignore => 16#100000#,
     Close => 16#200000#,
     Cancel => 16#400000#,
     Discard => 16#800000#,
     Help =>16#1000000#,
     Apply =>16#2000000#,
     Reset =>16#4000000#,
     Restore_Defaults =>16#8000000#);

   type Q_Dialog_Button_Box is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Dialog_Button_Box_Access is
     access all Q_Dialog_Button_Box'Class;
   for Q_Dialog_Button_Box_Access'Storage_Size use 0;

   type Q_Dialog_Button_Box_Pointer is tagged;

   procedure Add_Button
    (Self : not null access Q_Dialog_Button_Box'Class;
     Button : not null access Qt4.Abstract_Buttons.Q_Abstract_Button'Class;
     Role : Qt4.Dialog_Button_Boxes.Dialog_Button_Box_Button_Role);

   function Add_Button
    (Self : not null access Q_Dialog_Button_Box'Class;
     Text : Qt4.Strings.Q_String;
     Role : Qt4.Dialog_Button_Boxes.Dialog_Button_Box_Button_Role)
       return not null access Qt4.Push_Buttons.Q_Push_Button'Class;

   function Add_Button
    (Self : not null access Q_Dialog_Button_Box'Class;
     Button : Qt4.Dialog_Button_Boxes.Dialog_Button_Box_Standard_Button)
       return not null access Qt4.Push_Buttons.Q_Push_Button'Class;

   function Button
    (Self : not null access constant Q_Dialog_Button_Box'Class;
     Which : Qt4.Dialog_Button_Boxes.Dialog_Button_Box_Standard_Button)
       return access Qt4.Push_Buttons.Q_Push_Button'Class;

   function Button_Role
    (Self : not null access constant Q_Dialog_Button_Box'Class;
     Button : not null access Qt4.Abstract_Buttons.Q_Abstract_Button'Class)
       return Qt4.Dialog_Button_Boxes.Dialog_Button_Box_Button_Role;

   function Center_Buttons
    (Self : not null access constant Q_Dialog_Button_Box'Class)
       return Standard.Boolean;

   procedure Clear
    (Self : not null access Q_Dialog_Button_Box'Class);

   function Orientation
    (Self : not null access constant Q_Dialog_Button_Box'Class)
       return Qt4.Orientation;

   procedure Remove_Button
    (Self : not null access Q_Dialog_Button_Box'Class;
     Button : not null access Qt4.Abstract_Buttons.Q_Abstract_Button'Class);

   procedure Set_Center_Buttons
    (Self : not null access Q_Dialog_Button_Box'Class;
     Center : Standard.Boolean);

   procedure Set_Orientation
    (Self : not null access Q_Dialog_Button_Box'Class;
     Orientation : Qt4.Orientation);

   function Standard_Button
    (Self : not null access constant Q_Dialog_Button_Box'Class;
     Button : not null access Qt4.Abstract_Buttons.Q_Abstract_Button'Class)
       return Qt4.Dialog_Button_Boxes.Dialog_Button_Box_Standard_Button;

   package Q_Dialog_Button_Box_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Dialog_Button_Box, Q_Dialog_Button_Box_Access);

   type Q_Dialog_Button_Box_Pointer is
     new Q_Dialog_Button_Box_Pointers.Q_Pointer with null record;

end Qt4.Dialog_Button_Boxes;
