------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Actions;
with Qt4.Widgets;
with Qt4_Generic_Flags;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Dock_Widgets is

   type Q_Dock_Widget is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Dock_Widget_Access is
     access all Q_Dock_Widget'Class;
   for Q_Dock_Widget_Access'Storage_Size use 0;

   type Q_Dock_Widget_Pointer is tagged;

   function Is_Floating
    (Self : not null access constant Q_Dock_Widget'Class)
       return Standard.Boolean;

   procedure Set_Floating
    (Self : not null access Q_Dock_Widget'Class;
     Floating : Standard.Boolean);

   procedure Set_Title_Bar_Widget
    (Self : not null access Q_Dock_Widget'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   procedure Set_Widget
    (Self : not null access Q_Dock_Widget'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   function Title_Bar_Widget
    (Self : not null access constant Q_Dock_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Toggle_View_Action
    (Self : not null access constant Q_Dock_Widget'Class)
       return not null access Qt4.Actions.Q_Action'Class;

   function Widget
    (Self : not null access constant Q_Dock_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   type Dock_Widget_Feature is
     (No_Dock_Widget_Features,
      Dock_Widget_Closable,
      Dock_Widget_Movable,
      Dock_Widget_Floatable,
      Dock_Widget_Vertical_Title_Bar);
   pragma Convention (C, Dock_Widget_Feature);
   for Dock_Widget_Feature'Size use Interfaces.C.unsigned'Size;
   for Dock_Widget_Feature use
     (No_Dock_Widget_Features        => 16#00#,
      Dock_Widget_Closable           => 16#01#,
      Dock_Widget_Movable            => 16#02#,
      Dock_Widget_Floatable          => 16#04#,
      Dock_Widget_Vertical_Title_Bar => 16#08#);


   package Dock_Widget_Feature_Flags is
     new Qt4_Generic_Flags (Dock_Widget_Feature);

   type Dock_Widget_Features is new Dock_Widget_Feature_Flags.Flags;

   All_Dock_Widget_Features : constant Dock_Widget_Features
    := +Dock_Widget_Closable + Dock_Widget_Movable + Dock_Widget_Floatable;

   procedure Set_Allowed_Areas
    (Self  : not null access Q_Dock_Widget'Class;
     Areas : Qt4.Dock_Widget_Areas);

   procedure Set_Features
    (Self     : not null access Q_Dock_Widget'Class;
     Features : Dock_Widget_Features);

   package Q_Dock_Widget_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Dock_Widget, Q_Dock_Widget_Access);

   type Q_Dock_Widget_Pointer is
     new Q_Dock_Widget_Pointers.Q_Pointer with null record;

end Qt4.Dock_Widgets;
