------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3152 $ $Date: 2009-03-05 23:40:47 +0300 (Thu, 05 Mar 2009) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.File_Dialogs.Constructors is

   function new_QFileDialog_QWidgetP_QtWindowFlags
    (Parent : access Qt_Ada.Internals.Objects.QObject;
     Flag   : Qt4.Window_Flags)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import
    (C,
     new_QFileDialog_QWidgetP_QtWindowFlags,
     "__QtAda_new_QFileDialog_QWidgetP_QtWindowFlags");

   function new_QFileDialog_QWidgetP_QStringCR_QStringCR_QStringCR
    (Parent    : access Qt_Ada.Internals.Objects.QObject;
     Caption   : not null Qt4.Strings.Internals.QString_Access;
     Directory : not null Qt4.Strings.Internals.QString_Access;
     Filter    : not null Qt4.Strings.Internals.QString_Access)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import
    (C,
     new_QFileDialog_QWidgetP_QStringCR_QStringCR_QStringCR,
     "__QtAda_new_QFileDialog_QWidgetP_QStringCR_QStringCR_QStringCR");

   ------------
   -- Create --
   ------------

   function Create (Parent : access Qt4.Widgets.Q_Widget'Class := null;
                    Flags  : Qt4.Window_Flags)
     return not null Qt4.File_Dialogs.Q_File_Dialog_Access
   is
   begin
      return
        Qt4.File_Dialogs.Q_File_Dialog_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QFileDialog_QWidgetP_QtWindowFlags
             (Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent),
              Flags)));
   end Create;

   ------------
   -- Create --
   ------------

   function Create (Parent    : access Qt4.Widgets.Q_Widget'Class := null;
                    Caption   : Qt4.Strings.Q_String := Qt4.Strings.Create;
                    Directory : Qt4.Strings.Q_String := Qt4.Strings.Create;
                    Filter    : Qt4.Strings.Q_String := Qt4.Strings.Create)
     return not null Qt4.File_Dialogs.Q_File_Dialog_Access
   is
   begin
      return
        Qt4.File_Dialogs.Q_File_Dialog_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QFileDialog_QWidgetP_QStringCR_QStringCR_QStringCR
             (Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent),
              Qt4.Strings.Internals.QString_View (Caption),
              Qt4.Strings.Internals.QString_View (Directory),
              Qt4.Strings.Internals.QString_View (Filter))));
   end Create;

end Qt4.File_Dialogs.Constructors;
