------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3152 $ $Date: 2009-03-05 23:40:47 +0300 (Thu, 05 Mar 2009) $
------------------------------------------------------------------------------

package Qt4.File_Dialogs.Constructors is

   function Create (Parent : access Qt4.Widgets.Q_Widget'Class := null;
                    Flags  : Qt4.Window_Flags)
     return not null Qt4.File_Dialogs.Q_File_Dialog_Access;
   --  Returns new QFileDialog object.

   function Create (Parent    : access Qt4.Widgets.Q_Widget'Class := null;
                    Caption   : Qt4.Strings.Q_String := Qt4.Strings.Create;
                    Directory : Qt4.Strings.Q_String := Qt4.Strings.Create;
                    Filter    : Qt4.Strings.Q_String := Qt4.Strings.Create)
     return not null Qt4.File_Dialogs.Q_File_Dialog_Access;
   --  Returns new QFileDialog object.

end Qt4.File_Dialogs.Constructors;
