------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3855 $ $Date: 2011-06-29 18:40:53 +0400 (Wed, 29 Jun 2011) $
------------------------------------------------------------------------------
with Qt4.Graphics_Scene_Events;
with Qt4.Mime_Datas;
with Qt4.Point_Fs;

package Qt4.Graphics_Scene_Drag_Drop_Events is

   pragma Elaborate_Body;

   type Q_Graphics_Scene_Drag_Drop_Event is
     limited new Qt4.Graphics_Scene_Events.Q_Graphics_Scene_Event with private;

   function Mime_Data
    (Self : not null access constant Q_Graphics_Scene_Drag_Drop_Event'Class)
       return not null access Qt4.Mime_Datas.Q_Mime_Data'Class;

   function Pos
    (Self : not null access constant Q_Graphics_Scene_Drag_Drop_Event'Class)
       return Qt4.Point_Fs.Q_Point_F;

   function Scene_Pos
    (Self : not null access constant Q_Graphics_Scene_Drag_Drop_Event'Class)
       return Qt4.Point_Fs.Q_Point_F;

private

   type Q_Graphics_Scene_Drag_Drop_Event is
     limited new Qt4.Graphics_Scene_Events.Q_Graphics_Scene_Event
       with null record;

end Qt4.Graphics_Scene_Drag_Drop_Events;
