------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3791 $ $Date: 2010-10-28 19:45:44 +0400 (Thu, 28 Oct 2010) $
------------------------------------------------------------------------------
with Qt4.Events;
with Qt4.Widgets;

package Qt4.Graphics_Scene_Events is

   type Q_Graphics_Scene_Event is new Qt4.Events.Q_Event with private;

   procedure Set_Widget
    (Self   : not null access Q_Graphics_Scene_Event'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   function Widget
    (Self : not null access constant Q_Graphics_Scene_Event'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

private

   type Q_Graphics_Scene_Event is new Qt4.Events.Q_Event with null record;

end Qt4.Graphics_Scene_Events;
