------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3782 $ $Date: 2010-10-25 02:49:23 +0400 (Mon, 25 Oct 2010) $
------------------------------------------------------------------------------
with Qt4.Events;

package body Qt4.Graphics_Scene_Help_Events is

   function Create (The_Type : Qt4.Events.Event_Type)
     return not null access Qt4.Events.Q_Event'Class;
   pragma Unreferenced (Create);
   --  Функция пока не используется до разрешения конфликта с регистрацией
   --  событий QHelpEvent и QGraphicsSceneHelpEvent.

   ------------
   -- Create --
   ------------

   function Create (The_Type : Qt4.Events.Event_Type)
     return not null access Qt4.Events.Q_Event'Class
   is
      use type Qt4.Events.Event_Type;

   begin
      if The_Type /= Qt4.Events.Graphics_Scene_Help then
         raise Program_Error;
      end if;

      return new Q_Graphics_Scene_Help_Event;
   end Create;

end Qt4.Graphics_Scene_Help_Events;
