------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Interfaces.C;

with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Graphics_Scenes.Constructors is

   function new_QGraphicsScene
    (Parent : access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, new_QGraphicsScene, "__Qt4Ada_new_QGraphicsScene");

   function new_QGraphicsScene_With_Rect_F
    (Rect   : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Parent : access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C,
                  new_QGraphicsScene_With_Rect_F,
                  "__Qt4Ada_new_QGraphicsScene_With_RectF");

   function new_QGraphicsScene_From_Points
    (X      : Interfaces.C.double;
     Y      : Interfaces.C.double;
     Width  : Interfaces.C.double;
     Height : Interfaces.C.double;
     Parent : access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C,
                  new_QGraphicsScene_From_Points,
                  "__Qt4Ada_new_QGraphicsScene_From_Points");

   ------------
   -- Create --
   ------------

   function Create (Parent : access Qt4.Objects.Q_Object'Class := null)
     return not null Qt4.Graphics_Scenes.Q_Graphics_Scene_Access
   is
   begin
      return
        Qt4.Graphics_Scenes.Q_Graphics_Scene_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QGraphicsScene
             (Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent))));
   end Create;

   ------------
   -- Create --
   ------------

   function Create (Rect   : Qt4.Rect_Fs.Q_Rect_F;
                    Parent : access Qt4.Objects.Q_Object'Class := null)
     return not null Qt4.Graphics_Scenes.Q_Graphics_Scene_Access
   is
   begin
      return
        Qt4.Graphics_Scenes.Q_Graphics_Scene_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QGraphicsScene_With_Rect_F
             (Qt4.Rect_Fs.Internals.QRectF_View (Rect),
              Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent))));
   end Create;

   ------------
   -- Create --
   ------------

   function Create (X      : Q_Real;
                    Y      : Q_Real;
                    Width  : Q_Real;
                    Height : Q_Real;
                    Parent : access Qt4.Objects.Q_Object'Class := null)
     return not null Qt4.Graphics_Scenes.Q_Graphics_Scene_Access
   is
   begin
      return
        Qt4.Graphics_Scenes.Q_Graphics_Scene_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QGraphicsScene_From_Points
             (Interfaces.C.double (X),
              Interfaces.C.double (Y),
              Interfaces.C.double (Width),
              Interfaces.C.double (Height),
              Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent))));
   end Create;

end Qt4.Graphics_Scenes.Constructors;
