------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Child_Events;
limited with Qt4.Events;
limited with Qt4.Focus_Events;
with Qt4.Graphics_Items;
with Qt4.Graphics_Objects.Directors;
limited with Qt4.Graphics_Scene_Context_Menu_Events;
limited with Qt4.Graphics_Scene_Drag_Drop_Events;
limited with Qt4.Graphics_Scene_Hover_Events;
limited with Qt4.Graphics_Scene_Mouse_Events;
limited with Qt4.Graphics_Scene_Wheel_Events;
limited with Qt4.Input_Method_Events;
limited with Qt4.Key_Events;
with Qt4.Meta_Objects;
limited with Qt4.Objects;
with Qt4.Painter_Paths;
with Qt4.Painters;
with Qt4.Point_Fs;
with Qt4.Rect_Fs;
with Qt4.Style_Option_Graphics_Items;
limited with Qt4.Timer_Events;
with Qt4.Variants;
with Qt4.Widgets;

package Qt4.Graphics_Text_Items.Directors is

   type Q_Graphics_Text_Item_Director is
     new Qt4.Graphics_Objects.Directors.Q_Graphics_Object_Director
       and Q_Graphics_Text_Item with null record;

   overriding
   function Bounding_Rect
    (Self : not null access constant Q_Graphics_Text_Item_Director)
       return Qt4.Rect_Fs.Q_Rect_F;

   overriding
   function Contains
    (Self : not null access constant Q_Graphics_Text_Item_Director;
     Point : Qt4.Point_Fs.Q_Point_F)
       return Standard.Boolean;

   overriding
   function Is_Obscured_By
    (Self : not null access constant Q_Graphics_Text_Item_Director;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class)
       return Standard.Boolean;

   overriding
   function Opaque_Area
    (Self : not null access constant Q_Graphics_Text_Item_Director)
       return Qt4.Painter_Paths.Q_Painter_Path;

   overriding
   function Shape
    (Self : not null access constant Q_Graphics_Text_Item_Director)
       return Qt4.Painter_Paths.Q_Painter_Path;

   not overriding
   procedure Emit_Link_Activated
    (Self : not null access Q_Graphics_Text_Item_Director;
     Link : Qt4.Strings.Q_String);

   not overriding
   procedure Emit_Link_Hovered
    (Self : not null access Q_Graphics_Text_Item_Director;
     Link : Qt4.Strings.Q_String);

   overriding
   procedure Context_Menu_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Context_Menu_Events.Q_Graphics_Scene_Context_Menu_Event'Class);

   overriding
   procedure Drag_Enter_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class);

   overriding
   procedure Drag_Leave_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class);

   overriding
   procedure Drag_Move_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class);

   overriding
   procedure Drop_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class);

   overriding
   procedure Focus_In_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class);

   overriding
   procedure Focus_Out_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class);

   overriding
   procedure Hover_Enter_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Hover_Events.Q_Graphics_Scene_Hover_Event'Class);

   overriding
   procedure Hover_Move_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Hover_Events.Q_Graphics_Scene_Hover_Event'Class);

   overriding
   procedure Hover_Leave_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Hover_Events.Q_Graphics_Scene_Hover_Event'Class);

   overriding
   procedure Input_Method_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Input_Method_Events.Q_Input_Method_Event'Class);

   overriding
   function Input_Method_Query
    (Self : not null access constant Q_Graphics_Text_Item_Director;
     Query : Qt4.Input_Method_Query)
       return Qt4.Variants.Q_Variant;

   overriding
   procedure Key_Press_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class);

   overriding
   procedure Key_Release_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class);

   overriding
   procedure Mouse_Double_Click_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class);

   overriding
   procedure Mouse_Move_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class);

   overriding
   procedure Mouse_Press_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class);

   overriding
   procedure Mouse_Release_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class);

   overriding
   function Scene_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean;

   overriding
   procedure Emit_Enabled_Changed
    (Self : not null access Q_Graphics_Text_Item_Director);

   overriding
   procedure Emit_Opacity_Changed
    (Self : not null access Q_Graphics_Text_Item_Director);

   overriding
   procedure Emit_Parent_Changed
    (Self : not null access Q_Graphics_Text_Item_Director);

   overriding
   procedure Emit_Rotation_Changed
    (Self : not null access Q_Graphics_Text_Item_Director);

   overriding
   procedure Emit_Scale_Changed
    (Self : not null access Q_Graphics_Text_Item_Director);

   overriding
   procedure Emit_Visible_Changed
    (Self : not null access Q_Graphics_Text_Item_Director);

   overriding
   procedure Emit_X_Changed
    (Self : not null access Q_Graphics_Text_Item_Director);

   overriding
   procedure Emit_Y_Changed
    (Self : not null access Q_Graphics_Text_Item_Director);

   overriding
   procedure Emit_Z_Changed
    (Self : not null access Q_Graphics_Text_Item_Director);

   overriding
   procedure Child_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class);

   overriding
   procedure Custom_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   procedure Timer_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class);

   overriding
   function Sender
    (Self : not null access constant Q_Graphics_Text_Item_Director)
       return access Qt4.Objects.Q_Object'Class;

   overriding
   function Item_Change
    (Self : not null access Q_Graphics_Text_Item_Director;
     Change : Qt4.Graphics_Items.Graphics_Item_Graphics_Item_Change;
     Value : Qt4.Variants.Q_Variant)
       return Qt4.Variants.Q_Variant;

   overriding
   procedure Prepare_Geometry_Change
    (Self : not null access Q_Graphics_Text_Item_Director);

   overriding
   function Scene_Event_Filter
    (Self : not null access Q_Graphics_Text_Item_Director;
     Watched : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean;

   overriding
   procedure Wheel_Event
    (Self : not null access Q_Graphics_Text_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Wheel_Events.Q_Graphics_Scene_Wheel_Event'Class);

   overriding
   procedure Paint
    (Self    : not null access Q_Graphics_Text_Item_Director;
     Painter : in out Qt4.Painters.Q_Painter'Class;
     Option  :
       Qt4.Style_Option_Graphics_Items.Q_Style_Option_Graphics_Item'Class;
     Widget  : access Qt4.Widgets.Q_Widget'Class := null);

   Static_Meta_Object : access constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C, Static_Meta_Object,
                  "__Qt4Ada_QGraphicsTextItem_staticMetaObject");

end Qt4.Graphics_Text_Items.Directors;
