------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Colors;
with Qt4.Fonts;
with Qt4.Graphics_Objects;
with Qt4.Strings;
with Qt4.Text_Cursors;
limited with Qt4.Text_Documents;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Graphics_Text_Items is

   type Q_Graphics_Text_Item is limited interface
     and Qt4.Graphics_Objects.Q_Graphics_Object;

   type Q_Graphics_Text_Item_Access is
     access all Q_Graphics_Text_Item'Class;
   for Q_Graphics_Text_Item_Access'Storage_Size use 0;

   type Q_Graphics_Text_Item_Pointer is tagged;

   procedure Adjust_Size
    (Self : not null access Q_Graphics_Text_Item'Class);

   function Default_Text_Color
    (Self : not null access constant Q_Graphics_Text_Item'Class)
       return Qt4.Colors.Q_Color;

   function Document
    (Self : not null access constant Q_Graphics_Text_Item'Class)
       return not null access Qt4.Text_Documents.Q_Text_Document'Class;

   function Font
    (Self : not null access constant Q_Graphics_Text_Item'Class)
       return Qt4.Fonts.Q_Font;

   function Open_External_Links
    (Self : not null access constant Q_Graphics_Text_Item'Class)
       return Standard.Boolean;

   procedure Set_Default_Text_Color
    (Self : not null access Q_Graphics_Text_Item'Class;
     Col : Qt4.Colors.Q_Color);

   procedure Set_Document
    (Self : not null access Q_Graphics_Text_Item'Class;
     Document : not null access Qt4.Text_Documents.Q_Text_Document'Class);

   procedure Set_Font
    (Self : not null access Q_Graphics_Text_Item'Class;
     Font : Qt4.Fonts.Q_Font);

   procedure Set_Html
    (Self : not null access Q_Graphics_Text_Item'Class;
     Text : Qt4.Strings.Q_String);

   procedure Set_Open_External_Links
    (Self : not null access Q_Graphics_Text_Item'Class;
     Open : Standard.Boolean);

   procedure Set_Plain_Text
    (Self : not null access Q_Graphics_Text_Item'Class;
     Text : Qt4.Strings.Q_String);

   procedure Set_Tab_Changes_Focus
    (Self : not null access Q_Graphics_Text_Item'Class;
     B : Standard.Boolean);

   procedure Set_Text_Cursor
    (Self : not null access Q_Graphics_Text_Item'Class;
     Cursor : Qt4.Text_Cursors.Q_Text_Cursor);

   procedure Set_Text_Width
    (Self : not null access Q_Graphics_Text_Item'Class;
     Width : Qt4.Q_Real);

   function Tab_Changes_Focus
    (Self : not null access constant Q_Graphics_Text_Item'Class)
       return Standard.Boolean;

   function Text_Cursor
    (Self : not null access constant Q_Graphics_Text_Item'Class)
       return Qt4.Text_Cursors.Q_Text_Cursor;

   function Text_Width
    (Self : not null access constant Q_Graphics_Text_Item'Class)
       return Qt4.Q_Real;

   function To_Html
    (Self : not null access constant Q_Graphics_Text_Item'Class)
       return Qt4.Strings.Q_String;

   function To_Plain_Text
    (Self : not null access constant Q_Graphics_Text_Item'Class)
       return Qt4.Strings.Q_String;

   package Q_Graphics_Text_Item_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Graphics_Text_Item, Q_Graphics_Text_Item_Access);

   type Q_Graphics_Text_Item_Pointer is
     new Q_Graphics_Text_Item_Pointers.Q_Pointer with null record;

end Qt4.Graphics_Text_Items;
