------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Layouts;
with Qt4.Rects;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Grid_Layouts is

   type Q_Grid_Layout is limited interface
     and Qt4.Layouts.Q_Layout;

   type Q_Grid_Layout_Access is
     access all Q_Grid_Layout'Class;
   for Q_Grid_Layout_Access'Storage_Size use 0;

   type Q_Grid_Layout_Pointer is tagged;

   function Cell_Rect
    (Self : not null access constant Q_Grid_Layout'Class;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer)
       return Qt4.Rects.Q_Rect;

   function Column_Count
    (Self : not null access constant Q_Grid_Layout'Class)
       return Qt4.Q_Integer;

   function Column_Minimum_Width
    (Self : not null access constant Q_Grid_Layout'Class;
     Column : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Column_Stretch
    (Self : not null access constant Q_Grid_Layout'Class;
     Column : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Row_Count
    (Self : not null access constant Q_Grid_Layout'Class)
       return Qt4.Q_Integer;

   function Row_Minimum_Height
    (Self : not null access constant Q_Grid_Layout'Class;
     Row : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Row_Stretch
    (Self : not null access constant Q_Grid_Layout'Class;
     Row : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   procedure Set_Column_Minimum_Width
    (Self : not null access Q_Grid_Layout'Class;
     Column : Qt4.Q_Integer;
     Min_Size : Qt4.Q_Integer);

   procedure Set_Column_Stretch
    (Self : not null access Q_Grid_Layout'Class;
     Column : Qt4.Q_Integer;
     Stretch : Qt4.Q_Integer);

   procedure Set_Row_Minimum_Height
    (Self : not null access Q_Grid_Layout'Class;
     Row : Qt4.Q_Integer;
     Min_Size : Qt4.Q_Integer);

   procedure Set_Row_Stretch
    (Self : not null access Q_Grid_Layout'Class;
     Row : Qt4.Q_Integer;
     Stretch : Qt4.Q_Integer);

   procedure Add_Layout
    (Self      : not null access Q_Grid_Layout'Class;
     Layout    : not null access Qt4.Layouts.Q_Layout'Class;
     Row       : Qt4.Q_Integer;
     Column    : Qt4.Q_Integer;
     Alignment : Qt4.Alignment := +Qt4.Align_Default);

   procedure Add_Widget
    (Self      : not null access Q_Grid_Layout'Class;
     Widget    : not null access Qt4.Widgets.Q_Widget'Class;
     Row       : Qt4.Q_Integer;
     Column    : Qt4.Q_Integer;
     Alignment : Qt4.Alignment := +Qt4.Align_Default);

   procedure Add_Widget
    (Self        : not null access Q_Grid_Layout'Class;
     Widget      : not null access Qt4.Widgets.Q_Widget'Class;
     From_Row    : Qt4.Q_Integer;
     From_Column : Qt4.Q_Integer;
     Row_Span    : Qt4.Q_Integer;
     Column_Span : Qt4.Q_Integer;
     Alignment   : Qt4.Alignment := +Qt4.Align_Default);

   package Q_Grid_Layout_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Grid_Layout, Q_Grid_Layout_Access);

   type Q_Grid_Layout_Pointer is
     new Q_Grid_Layout_Pointers.Q_Pointer with null record;

end Qt4.Grid_Layouts;
