------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3593 $ $Date: 2009-09-16 17:11:46 +0400 (Wed, 16 Sep 2009) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects;

package body Qt4.H_Box_Layouts.Constructors is

   function new_QHBoxLayout
     return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, new_QHBoxLayout, "__Qt4Ada_new_QHBoxLayout");

   function new_QHBoxLayout_QWidgetP
    (Parent : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import
           (C, new_QHBoxLayout_QWidgetP, "__Qt4Ada_new_QHBoxLayout_QWidgetP");

   ------------
   -- Create --
   ------------

   function Create return not null Qt4.H_Box_Layouts.Q_H_Box_Layout_Access is
   begin
      return
        Qt4.H_Box_Layouts.Q_H_Box_Layout_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object (new_QHBoxLayout));
   end Create;

   ------------
   -- Create --
   ------------

   function Create
    (Parent : not null access Qt4.Widgets.Q_Widget'Class)
       return not null Qt4.H_Box_Layouts.Q_H_Box_Layout_Access
   is
   begin
      return
        Qt4.H_Box_Layouts.Q_H_Box_Layout_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QHBoxLayout_QWidgetP (Parent.QObject_View)));
   end Create;

end Qt4.H_Box_Layouts.Constructors;
