------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3723 $ $Date: 2010-04-08 10:24:09 +0400 (Thu, 08 Apr 2010) $
------------------------------------------------------------------------------
with Interfaces.C;

package Qt4.Image_IO_Handlers is

   --  QImageIOHandler::ImageOption

   type Image_Option is
    (Size,
     Clip_Rect,
     Description,
     Scaled_Clip_Rect,
     Scaled_Size,
     Compression_Ratio,
     Gamma,
     Quality,
     Name,
     Sub_Type,
     Incremental_Reading,
     Endianness,
     Animation,
     Background_Color,
     Image_Format);
   pragma Convention (C, Image_Option);
   for Image_Option'Size use Interfaces.C.unsigned'Size;

end Qt4.Image_IO_Handlers;
