------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Abstract_Item_Models;
with Qt4.Item_Selections;
with Qt4.Model_Indices;
with Qt4.Objects;
with Qt4_Generic_Flags;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Item_Selection_Models is

   type Q_Item_Selection_Model is limited interface
     and Qt4.Objects.Q_Object;

   type Q_Item_Selection_Model_Access is
     access all Q_Item_Selection_Model'Class;
   for Q_Item_Selection_Model_Access'Storage_Size use 0;

   type Q_Item_Selection_Model_Pointer is tagged;

   function Column_Intersects_Selection
    (Self : not null access constant Q_Item_Selection_Model'Class;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   function Current_Index
    (Self : not null access constant Q_Item_Selection_Model'Class)
       return Qt4.Model_Indices.Q_Model_Index;

   function Has_Selection
    (Self : not null access constant Q_Item_Selection_Model'Class)
       return Standard.Boolean;

   function Is_Column_Selected
    (Self : not null access constant Q_Item_Selection_Model'Class;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   function Is_Row_Selected
    (Self : not null access constant Q_Item_Selection_Model'Class;
     Row : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   function Is_Selected
    (Self : not null access constant Q_Item_Selection_Model'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   function Model
    (Self : not null access constant Q_Item_Selection_Model'Class)
       return not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class;

   function Row_Intersects_Selection
    (Self : not null access constant Q_Item_Selection_Model'Class;
     Row : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   not overriding
   procedure Clear
    (Self : not null access Q_Item_Selection_Model)
       is abstract;

   procedure Clear_Selection
    (Self : not null access Q_Item_Selection_Model'Class);

   not overriding
   procedure Reset
    (Self : not null access Q_Item_Selection_Model)
       is abstract;

   type Selection_Flag is
    (No_Update,
     Clear,

     --  XXX вместо QItemSelectionModel::Select в Аде используется Select_Item,
     --  т.к. Select зарезервированное слово
     Select_Item,
     Clear_And_Select,
     Deselect,
     Toggle,
     Current,
     Select_Current,
     Toggle_Current,
     Rows,
     Columns);

   pragma Convention (C, Selection_Flag);
   for Selection_Flag'Size use Interfaces.C.int'Size;
   for Selection_Flag use
    (No_Update         => 16#00000000#,
     Clear            => 16#00000001#,
     Select_Item      => 16#00000002#,
     Clear_And_Select => 16#00000003#,  --  ClearAndSelect Clear | Select
     Deselect         => 16#00000004#,
     Toggle           => 16#00000008#,
     Current          => 16#00000010#,
     Select_Current   => 16#00000012#, --  SelectCurrent Select | Current
     Toggle_Current   => 16#00000018#, --  ToggleCurrent Toggle | Current
     Rows             => 16#00000020#,
     Columns          => 16#00000040#);

   package Selection_Flags_Flags is new Qt4_Generic_Flags (Selection_Flag);

   type Selection_Flags is new Selection_Flags_Flags.Flags;

   not overriding
   procedure Select_Item
    (Self    : not null access Q_Item_Selection_Model;
     Index   : Qt4.Model_Indices.Q_Model_Index;
     Command : Selection_Flags)
       is abstract;

   not overriding
   procedure Select_Item
    (Self      : not null access Q_Item_Selection_Model;
     Selection : Qt4.Item_Selections.Q_Item_Selection;
     Command   : Selection_Flags)
       is abstract;

   procedure Set_Current_Index
    (Self    : not null access Q_Item_Selection_Model'Class;
     Index   : Qt4.Model_Indices.Q_Model_Index;
     Command : Selection_Flags);

   package Q_Item_Selection_Model_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Item_Selection_Model, Q_Item_Selection_Model_Access);

   type Q_Item_Selection_Model_Pointer is
     new Q_Item_Selection_Model_Pointers.Q_Pointer with null record;

end Qt4.Item_Selection_Models;
