------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Qt4_Entities;

package Qt4.Item_Selection_Ranges is

   package Thin is

      subtype QItemSelectionRange is Qt4_Entities.Cpp_Class;

      function copy_QItemSelectionRange
       (Cpp_Object : not null access QItemSelectionRange)
          return not null access QItemSelectionRange;
      pragma Import
       (C, copy_QItemSelectionRange, "__Qt4Ada_copy_QItemSelectionRange");

   end Thin;

   type Q_Item_Selection_Range is tagged private;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Bottom
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function Bottom (Self : Q_Item_Selection_Range) return Q_Integer;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Left
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function Left (Self : Q_Item_Selection_Range) return Q_Integer;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Right
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function Right (Self : Q_Item_Selection_Range) return Q_Integer;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Top
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function Top (Self : Q_Item_Selection_Range) return Q_Integer;

   package Internals is

      ------------------------------------------------------------------------
      --! <Subprogram>
      --!    <Unit> QItemSelectionRange_View
      --!    <Purpose> Возвращает ссылку на ассоциированный объект C++.
      --!    <Exceptions>
      ------------------------------------------------------------------------
      function QItemSelectionRange_View (Self : Q_Item_Selection_Range)
        return not null access Thin.QItemSelectionRange;

      ------------------------------------------------------------------------
      --! <Subprogram>
      --!    <Unit> To_Q_Item_Selection_Range
      --!    <Purpose> Возвращает эквивалентный объект Ada.
      --!    <Exceptions>
      ------------------------------------------------------------------------
      function To_Q_Item_Selection_Range
       (Item : not null access constant Thin.QItemSelectionRange)
          return Q_Item_Selection_Range;

   end Internals;

private

   type Q_Item_Selection_Range is new Qt4_Entities.Entity with null record;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Copy_Cpp_Object
   --!    <Purpose> Осуществляет копирование ассоциированного объекта C++.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   function Copy_Cpp_Object (Self : not null access Q_Item_Selection_Range)
     return not null access Qt4_Entities.Cpp_Class;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Delete_Cpp_Object
   --!    <Purpose> Осуществляет уничтожение ассоциированного объекта C++.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   procedure Delete_Cpp_Object (Self : not null access Q_Item_Selection_Range);

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Default_Cpp_Object
   --!    <Purpose> Возвращает новый пустой экземпляр
   --! класса QItemSelectionRange.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   function Default_Cpp_Object (Self : not null access Q_Item_Selection_Range)
     return access Qt4_Entities.Cpp_Class;

end Qt4.Item_Selection_Ranges;
