------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3361 $ $Date: 2009-05-09 14:25:08 +0400 (Sat, 09 May 2009) $
------------------------------------------------------------------------------
with Interfaces.C;

with Qt_Ada.Internals.Events.Registry;

package body Qt4.Key_Events.Constructors is

   function new_QKeyEvent
    (The_Type  : Interfaces.C.int;
     Key       : Interfaces.C.int;
     Modifiers : Keyboard_Modifier;
     Text      : Interfaces.C.char_array;
     Autorep   : Qt4.bool;
     Count     : Interfaces.C.unsigned_short)
       return not null Qt_Ada.Internals.Events.QEvent_Access;
   pragma Import (C, new_QKeyEvent, "__Qt4Ada_new_QKeyEvent_wrapper");

   ------------
   -- Create --
   ------------

   function Create
    (The_Type  : Qt4.Events.Event_Type;
     Key       : Q_Integer;
     Modifiers : Keyboard_Modifier;
     Text      : String := "";
     Autorep   : Boolean := False;
     Count     : Integer := 1)
       return not null access Q_Key_Event'Class
   is
   begin
      return
        Q_Key_Event'Class
         (Qt_Ada.Internals.Events.Registry.Create_Wrapper
           (new_QKeyEvent
             (Interfaces.C.int (The_Type),
              Interfaces.C.int (Key),
              Modifiers,
              Interfaces.C.To_C (Text),
              Qt4.To_bool (Autorep),
              Interfaces.C.unsigned_short (Count))).all)'Access;
   end Create;

end Qt4.Key_Events.Constructors;
