------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3779 $ $Date: 2010-10-24 14:24:12 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Qt4.Input_Events;
with Qt4.Strings;

package Qt4.Key_Events is

   type Q_Key_Event is new Qt4.Input_Events.Q_Input_Event with private;

   function Count
    (Self : not null access constant Q_Key_Event'Class) return Q_Integer;

   function Is_Auto_Repeat
    (Self : not null access constant Q_Key_Event'Class) return Boolean;

   function Key
    (Self : not null access constant Q_Key_Event'Class) return Qt4.Key;

   function Native_Modifiers
    (Self : not null access constant Q_Key_Event'Class)
       return Q_Unsigned_Integer;

   function Native_Scan_Code
    (Self : not null access constant Q_Key_Event'Class)
       return Q_Unsigned_Integer;

   function Native_Virtual_Key
    (Self : not null access constant Q_Key_Event'Class)
       return Q_Unsigned_Integer;

   function Text
    (Self : not null access constant Q_Key_Event'Class)
     return Qt4.Strings.Q_String;

private

   type Q_Key_Event is new Qt4.Input_Events.Q_Input_Event with null record;

end Qt4.Key_Events;
