------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
limited with Qt4.Layouts;
with Qt4.Sizes;
limited with Qt4.Widgets;

package Qt4.Layout_Items is

   type Q_Layout_Item is limited interface;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Expanding_Directions
   --!    <Purpose> Связка для функции QLayoutItem::expandingDirections.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Expanding_Directions
    (Self : not null access constant Q_Layout_Item)
       return Qt4.Orientations
         is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Has_Height_For_Width
   --!    <Purpose> Связка для функции QLayoutItem::hasHeightForWidth.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Has_Height_For_Width
    (Self : not null access constant Q_Layout_Item)
       return Boolean
         is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Height_For_Width
   --!    <Purpose> Связка для функции QLayoutItem::heightForWidth.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Height_For_Width (Self : not null access constant Q_Layout_Item;
                              W    : Qt4.Q_Integer)
     return Qt4.Q_Integer
       is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Invalidate
   --!    <Purpose> Связка для функции QLayoutItem::invalidate.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   procedure Invalidate (Self : not null access Q_Layout_Item)
     is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Is_Empty
   --!    <Purpose> Связка для функции QLayoutItem::isEmpty.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Is_Empty (Self : not null access constant Q_Layout_Item)
     return Boolean
       is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Layout
   --!    <Purpose> Связка для функции QLayoutItem::layout.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Layout (Self : not null access Q_Layout_Item)
     return not null access Qt4.Layouts.Q_Layout'Class
       is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Maximum_Size
   --!    <Purpose> Связка для функции QLayoutItem::maximumSize.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Maximum_Size (Self : not null access constant Q_Layout_Item)
     return Qt4.Sizes.Q_Size
       is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Minimum_Height_For_Width
   --!    <Purpose> Связка для функции QLayoutItem::minimumHeightForWidth.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Minimum_Height_For_Width
    (Self : not null access constant Q_Layout_Item;
     W    : Qt4.Q_Integer)
       return Qt4.Q_Integer
         is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Minimum_Size
   --!    <Purpose> Связка для функции QLayoutItem::minimumSize.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Minimum_Size (Self : not null access constant Q_Layout_Item)
     return Qt4.Sizes.Q_Size
       is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Set_Alignment
   --!    <Purpose> Связка для функции QLayoutItem::setAlignment.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
--    not overriding
--    procedure Set_Alignment (Alignment : Qt4.Alignment)
--      is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Size_Hint
   --!    <Purpose> Связка для функции QLayoutItem::sizeHint.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Size_Hint (Self : not null access constant Q_Layout_Item)
     return Qt4.Sizes.Q_Size
       is abstract;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Widget
   --!    <Purpose> Связка для функции QLayoutItem::widget.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   not overriding
   function Widget (Self : not null access Q_Layout_Item)
     return not null access Qt4.Widgets.Q_Widget'Class
       is abstract;

end Qt4.Layout_Items;
