------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Layout_Items;
with Qt4.Objects;
limited with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Layouts is

   type Q_Layout is limited interface
     and Qt4.Objects.Q_Object
     and Qt4.Layout_Items.Q_Layout_Item;

   type Q_Layout_Access is
     access all Q_Layout'Class;
   for Q_Layout_Access'Storage_Size use 0;

   type Q_Layout_Pointer is tagged;

   function Activate
    (Self : not null access Q_Layout'Class)
       return Standard.Boolean;

   not overriding
   procedure Add_Item
    (Self : not null access Q_Layout;
     Item : not null access Qt4.Layout_Items.Q_Layout_Item'Class)
       is abstract;

   procedure Add_Widget
    (Self : not null access Q_Layout'Class;
     W : not null access Qt4.Widgets.Q_Widget'Class);

   not overriding
   function Count
    (Self : not null access constant Q_Layout)
       return Qt4.Q_Integer
         is abstract;

   not overriding
   function Index_Of
    (Self : not null access constant Q_Layout;
     Widget : not null access Qt4.Widgets.Q_Widget'Class)
       return Qt4.Q_Integer
         is abstract;

   function Is_Enabled
    (Self : not null access constant Q_Layout'Class)
       return Standard.Boolean;

   function Margin
    (Self : not null access constant Q_Layout'Class)
       return Qt4.Q_Integer;

   function Menu_Bar
    (Self : not null access constant Q_Layout'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Parent_Widget
    (Self : not null access constant Q_Layout'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   procedure Remove_Item
    (Self : not null access Q_Layout'Class;
     Item : not null access Qt4.Layout_Items.Q_Layout_Item'Class);

   procedure Remove_Widget
    (Self : not null access Q_Layout'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   procedure Set_Contents_Margins
    (Self : not null access Q_Layout'Class;
     Left : Qt4.Q_Integer;
     Top : Qt4.Q_Integer;
     Right : Qt4.Q_Integer;
     Bottom : Qt4.Q_Integer);

   procedure Set_Enabled
    (Self : not null access Q_Layout'Class;
     Enable : Standard.Boolean);

   procedure Set_Margin
    (Self : not null access Q_Layout'Class;
     Margin : Qt4.Q_Integer);

   procedure Set_Menu_Bar
    (Self : not null access Q_Layout'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   procedure Set_Spacing
    (Self : not null access Q_Layout'Class;
     Margin : Qt4.Q_Integer);

   function Spacing
    (Self : not null access constant Q_Layout'Class)
       return Qt4.Q_Integer;

   procedure Update
    (Self : not null access Q_Layout'Class);

   package Q_Layout_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Layout, Q_Layout_Access);

   type Q_Layout_Pointer is
     new Q_Layout_Pointers.Q_Pointer with null record;

end Qt4.Layouts;
