------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Frames;
with Qt4.Strings;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.LCD_Numbers is

   type LCD_Number_Mode is
    (Hex,
     Dec,
     Oct,
     Bin);
   pragma Convention (C, LCD_Number_Mode);

   type LCD_Number_Segment_Style is
    (Outline,
     Filled,
     Flat);
   pragma Convention (C, LCD_Number_Segment_Style);

   type Q_LCD_Number is limited interface
     and Qt4.Frames.Q_Frame;

   type Q_LCD_Number_Access is
     access all Q_LCD_Number'Class;
   for Q_LCD_Number_Access'Storage_Size use 0;

   type Q_LCD_Number_Pointer is tagged;

   function Check_Overflow
    (Self : not null access constant Q_LCD_Number'Class;
     Num : Qt4.Q_Integer)
       return Standard.Boolean;

   function Check_Overflow
    (Self : not null access constant Q_LCD_Number'Class;
     Num : Qt4.Q_Real)
       return Standard.Boolean;

   function Int_Value
    (Self : not null access constant Q_LCD_Number'Class)
       return Qt4.Q_Integer;

   function Mode
    (Self : not null access constant Q_LCD_Number'Class)
       return Qt4.LCD_Numbers.LCD_Number_Mode;

   function Num_Digits
    (Self : not null access constant Q_LCD_Number'Class)
       return Qt4.Q_Integer;

   function Segment_Style
    (Self : not null access constant Q_LCD_Number'Class)
       return Qt4.LCD_Numbers.LCD_Number_Segment_Style;

   procedure Set_Mode
    (Self : not null access Q_LCD_Number'Class;
     Mode : Qt4.LCD_Numbers.LCD_Number_Mode);

   procedure Set_Num_Digits
    (Self : not null access Q_LCD_Number'Class;
     N_Digits : Qt4.Q_Integer);

   procedure Set_Segment_Style
    (Self : not null access Q_LCD_Number'Class;
     Style : Qt4.LCD_Numbers.LCD_Number_Segment_Style);

   function Small_Decimal_Point
    (Self : not null access constant Q_LCD_Number'Class)
       return Standard.Boolean;

   function Value
    (Self : not null access constant Q_LCD_Number'Class)
       return Qt4.Q_Real;

   procedure Display
    (Self : not null access Q_LCD_Number'Class;
     Str : Qt4.Strings.Q_String);

   procedure Display
    (Self : not null access Q_LCD_Number'Class;
     Num : Qt4.Q_Integer);

   procedure Display
    (Self : not null access Q_LCD_Number'Class;
     Num : Qt4.Q_Real);

   procedure Set_Bin_Mode
    (Self : not null access Q_LCD_Number'Class);

   procedure Set_Dec_Mode
    (Self : not null access Q_LCD_Number'Class);

   procedure Set_Hex_Mode
    (Self : not null access Q_LCD_Number'Class);

   procedure Set_Oct_Mode
    (Self : not null access Q_LCD_Number'Class);

   procedure Set_Small_Decimal_Point
    (Self : not null access Q_LCD_Number'Class;
     E : Standard.Boolean);

   package Q_LCD_Number_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_LCD_Number, Q_LCD_Number_Access);

   type Q_LCD_Number_Pointer is
     new Q_LCD_Number_Pointers.Q_Pointer with null record;

end Qt4.LCD_Numbers;
