------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Item_Views;
with Qt4.Sizes;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.List_Views is

   type Q_List_View is limited interface
     and Qt4.Abstract_Item_Views.Q_Abstract_Item_View;

   type Q_List_View_Access is
     access all Q_List_View'Class;
   for Q_List_View_Access'Storage_Size use 0;

   type Q_List_View_Pointer is tagged;

   function Batch_Size
    (Self : not null access constant Q_List_View'Class)
       return Qt4.Q_Integer;

   procedure Clear_Property_Flags
    (Self : not null access Q_List_View'Class);

   function Grid_Size
    (Self : not null access constant Q_List_View'Class)
       return Qt4.Sizes.Q_Size;

   function Is_Row_Hidden
    (Self : not null access constant Q_List_View'Class;
     Row : Qt4.Q_Integer)
       return Standard.Boolean;

   function Is_Wrapping
    (Self : not null access constant Q_List_View'Class)
       return Standard.Boolean;

   function Model_Column
    (Self : not null access constant Q_List_View'Class)
       return Qt4.Q_Integer;

   procedure Set_Batch_Size
    (Self : not null access Q_List_View'Class;
     Batch_Size : Qt4.Q_Integer);

   procedure Set_Grid_Size
    (Self : not null access Q_List_View'Class;
     Size : Qt4.Sizes.Q_Size);

   procedure Set_Model_Column
    (Self : not null access Q_List_View'Class;
     Column : Qt4.Q_Integer);

   procedure Set_Row_Hidden
    (Self : not null access Q_List_View'Class;
     Row : Qt4.Q_Integer;
     Hide : Standard.Boolean);

   procedure Set_Spacing
    (Self : not null access Q_List_View'Class;
     Space : Qt4.Q_Integer);

   procedure Set_Uniform_Item_Sizes
    (Self : not null access Q_List_View'Class;
     Enable : Standard.Boolean);

   procedure Set_Word_Wrap
    (Self : not null access Q_List_View'Class;
     On : Standard.Boolean);

   procedure Set_Wrapping
    (Self : not null access Q_List_View'Class;
     Enable : Standard.Boolean);

   function Spacing
    (Self : not null access constant Q_List_View'Class)
       return Qt4.Q_Integer;

   function Uniform_Item_Sizes
    (Self : not null access constant Q_List_View'Class)
       return Standard.Boolean;

   function Word_Wrap
    (Self : not null access constant Q_List_View'Class)
       return Standard.Boolean;

   package Q_List_View_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_List_View, Q_List_View_Access);

   type Q_List_View_Pointer is
     new Q_List_View_Pointers.Q_Pointer with null record;

end Qt4.List_Views;
