------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Byte_Arrays;
with Qt4.Dock_Widgets;
limited with Qt4.Menu_Bars;
with Qt4.Sizes;
limited with Qt4.Status_Bars;
with Qt4.Strings;
limited with Qt4.Tool_Bars;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Main_Windows is

   type Q_Main_Window is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Main_Window_Access is
     access all Q_Main_Window'Class;
   for Q_Main_Window_Access'Storage_Size use 0;

   type Q_Main_Window_Pointer is tagged;

   procedure Add_Tool_Bar
    (Self : not null access Q_Main_Window'Class;
     Toolbar : not null access Qt4.Tool_Bars.Q_Tool_Bar'Class);

   function Add_Tool_Bar
    (Self : not null access Q_Main_Window'Class;
     Title : Qt4.Strings.Q_String)
       return not null access Qt4.Tool_Bars.Q_Tool_Bar'Class;

   function Central_Widget
    (Self : not null access constant Q_Main_Window'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Icon_Size
    (Self : not null access constant Q_Main_Window'Class)
       return Qt4.Sizes.Q_Size;

   procedure Insert_Tool_Bar
    (Self : not null access Q_Main_Window'Class;
     Before : not null access Qt4.Tool_Bars.Q_Tool_Bar'Class;
     Toolbar : not null access Qt4.Tool_Bars.Q_Tool_Bar'Class);

   procedure Insert_Tool_Bar_Break
    (Self : not null access Q_Main_Window'Class;
     Before : not null access Qt4.Tool_Bars.Q_Tool_Bar'Class);

   function Is_Animated
    (Self : not null access constant Q_Main_Window'Class)
       return Standard.Boolean;

   function Is_Dock_Nesting_Enabled
    (Self : not null access constant Q_Main_Window'Class)
       return Standard.Boolean;

   function Menu_Bar
    (Self : not null access constant Q_Main_Window'Class)
       return not null access Qt4.Menu_Bars.Q_Menu_Bar'Class;

   function Menu_Widget
    (Self : not null access constant Q_Main_Window'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   procedure Remove_Tool_Bar
    (Self : not null access Q_Main_Window'Class;
     Toolbar : not null access Qt4.Tool_Bars.Q_Tool_Bar'Class);

   function Restore_State
    (Self : not null access Q_Main_Window'Class;
     State : Qt4.Byte_Arrays.Q_Byte_Array;
     Version : Qt4.Q_Integer
       :=  0)
       return Standard.Boolean;

   function Save_State
    (Self : not null access constant Q_Main_Window'Class;
     Version : Qt4.Q_Integer
       :=  0)
       return Qt4.Byte_Arrays.Q_Byte_Array;

   procedure Set_Central_Widget
    (Self : not null access Q_Main_Window'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   procedure Set_Icon_Size
    (Self : not null access Q_Main_Window'Class;
     Icon_Size : Qt4.Sizes.Q_Size);

   procedure Set_Menu_Bar
    (Self : not null access Q_Main_Window'Class;
     Menubar : not null access Qt4.Menu_Bars.Q_Menu_Bar'Class);

   procedure Set_Menu_Widget
    (Self : not null access Q_Main_Window'Class;
     Menubar : not null access Qt4.Widgets.Q_Widget'Class);

   procedure Set_Status_Bar
    (Self : not null access Q_Main_Window'Class;
     Statusbar : not null access Qt4.Status_Bars.Q_Status_Bar'Class);

   function Status_Bar
    (Self : not null access constant Q_Main_Window'Class)
       return not null access Qt4.Status_Bars.Q_Status_Bar'Class;

   procedure Set_Animated
    (Self : not null access Q_Main_Window'Class;
     Enabled : Standard.Boolean);

   procedure Set_Dock_Nesting_Enabled
    (Self : not null access Q_Main_Window'Class;
     Enabled : Standard.Boolean);

   procedure Add_Dock_Widget
    (Self        : not null access Q_Main_Window'Class;
     Area        : Qt4.Dock_Widget_Area;
     Dock_Widget : not null access Qt4.Dock_Widgets.Q_Dock_Widget'Class);

   procedure Add_Dock_Widget
    (Self        : not null access Q_Main_Window'Class;
     Area        : Qt4.Dock_Widget_Area;
     Dock_Widget : not null access Qt4.Dock_Widgets.Q_Dock_Widget'Class;
     Orientation : Qt4.Orientation);

   package Q_Main_Window_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Main_Window, Q_Main_Window_Access);

   type Q_Main_Window_Pointer is
     new Q_Main_Window_Pointers.Q_Pointer with null record;

end Qt4.Main_Windows;
