------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Scroll_Areas;
with Qt4.Brushes;
limited with Qt4.Mdi_Sub_Windows;
limited with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Mdi_Areas is

   type Mdi_Area_Window_Order is
    (Creation_Order,
     Stacking_Order);
   pragma Convention (C, Mdi_Area_Window_Order);

   type Q_Mdi_Area is limited interface
     and Qt4.Abstract_Scroll_Areas.Q_Abstract_Scroll_Area;

   type Q_Mdi_Area_Access is
     access all Q_Mdi_Area'Class;
   for Q_Mdi_Area_Access'Storage_Size use 0;

   type Q_Mdi_Area_Pointer is tagged;

   function Active_Sub_Window
    (Self : not null access constant Q_Mdi_Area'Class)
       return not null access Qt4.Mdi_Sub_Windows.Q_Mdi_Sub_Window'Class;

   function Background
    (Self : not null access constant Q_Mdi_Area'Class)
       return Qt4.Brushes.Q_Brush;

   function Current_Sub_Window
    (Self : not null access constant Q_Mdi_Area'Class)
       return not null access Qt4.Mdi_Sub_Windows.Q_Mdi_Sub_Window'Class;

   procedure Remove_Sub_Window
    (Self : not null access Q_Mdi_Area'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   procedure Set_Background
    (Self : not null access Q_Mdi_Area'Class;
     Background : Qt4.Brushes.Q_Brush);

   procedure Activate_Next_Sub_Window
    (Self : not null access Q_Mdi_Area'Class);

   procedure Activate_Previous_Sub_Window
    (Self : not null access Q_Mdi_Area'Class);

   procedure Cascade_Sub_Windows
    (Self : not null access Q_Mdi_Area'Class);

   procedure Close_Active_Sub_Window
    (Self : not null access Q_Mdi_Area'Class);

   procedure Close_All_Sub_Windows
    (Self : not null access Q_Mdi_Area'Class);

   procedure Set_Active_Sub_Window
    (Self : not null access Q_Mdi_Area'Class;
     Window : not null access Qt4.Mdi_Sub_Windows.Q_Mdi_Sub_Window'Class);

   procedure Tile_Sub_Windows
    (Self : not null access Q_Mdi_Area'Class);
   function Add_Sub_Window
    (Self   : not null access Q_Mdi_Area'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class;
     Flags  : Qt4.Window_Flags := +Qt4.Widget)
       return not null access Qt4.Mdi_Sub_Windows.Q_Mdi_Sub_Window'Class;

   package Q_Mdi_Area_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Mdi_Area, Q_Mdi_Area_Access);

   type Q_Mdi_Area_Pointer is
     new Q_Mdi_Area_Pointers.Q_Pointer with null record;

end Qt4.Mdi_Areas;
