------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Qt4.Paint_Engines;
with Qt4_Entities;

package Qt4.Paint_Devices.Impl is

   package Thin is

      subtype QPaintDevice is Qt4_Entities.Cpp_Class;

--     function paintEngine
--      (This : not null access Qt4.Paint_Devices.Internals.QPaintDevice)
--         return not null access Qt4.Paint_Engines.Q_Paint_Engine;
--     pragma Import
--      (C, paintEngine, Qt4.Gui_Link_Names.QPaintDevice_paintEngine);

      function paintEngine_virtual
       (This : not null access Qt4.Paint_Devices.Impl.Thin.QPaintDevice)
          return not null access Qt4.Paint_Engines.Q_Paint_Engine;
      pragma Import
       (C, paintEngine_virtual,
        "__Qt4Ada_QPaintDevice_paintEngine_virtual");

      function metric
       (This   : not null access Qt4.Paint_Devices.Impl.Thin.QPaintDevice;
        Metric : Paint_Device_Metric)
          return Q_Integer;
      pragma Import (C, metric, "__Qt4Ada_QPaintDevice_metric_wrapper");

   end Thin;

   --  Базовый интерфейс.

--   not overriding
--   function Metric
--    (Self   : not null access constant Q_Paint_Device_Impl_Base;
--     Metric : Paint_Device_Metric)
--       return Q_Integer
--         is abstract;

   --  Базовая реализация.

   type Q_Paint_Device_Impl is
     abstract new Qt4_Entities.Limited_Entity
       and Q_Paint_Device with private;

   overriding
   function Paint_Engine
    (Self : not null access Q_Paint_Device_Impl)
       return not null access Qt4.Paint_Engines.Q_Paint_Engine;

--   overriding
--   function Metric
--    (Self   : not null access constant Q_Paint_Device_Impl;
--     Metric : Paint_Device_Metric)
--       return Q_Integer;

private

   type Q_Paint_Device_Impl is
     abstract new Qt4_Entities.Limited_Entity
       and Q_Paint_Device with null record;

end Qt4.Paint_Devices.Impl;
