------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3781 $ $Date: 2010-10-25 01:48:22 +0400 (Mon, 25 Oct 2010) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Events.Registry;

package body Qt4.Paint_Events is

   procedure rect_wrapper
    (Self   : not null access constant Qt_Ada.Internals.Events.QEvent;
     Result : not null access Qt4.Rects.Internals.QRect);
   pragma Import (C, rect_wrapper, "__Qt4Ada_QPaintEvent_rect_wrapper");

   procedure region_wrapper
    (Self   : not null access constant Qt_Ada.Internals.Events.QEvent;
     Result : not null access Qt4.Regions.Internals.QRegion);
   pragma Import (C, region_wrapper, "__Qt4Ada_QPaintEvent_region_wrapper");

   function Create
    (Object : not null Qt_Ada.Internals.Events.QEvent_Access)
       return not null Qt4.Events.Q_Event_Access;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Events.QEvent_Access)
       return not null Qt4.Events.Q_Event_Access is
   begin
      return Result : constant not null Qt4.Events.Q_Event_Access
        := new Q_Paint_Event
      do
         Qt_Ada.Internals.Events.Initialize (Result, Object);
      end return;
   end Create;

   ----------
   -- Rect --
   ----------

   function Rect
    (Self : not null access constant Q_Paint_Event'Class)
       return Qt4.Rects.Q_Rect is
   begin
      return Result : Qt4.Rects.Q_Rect do
         rect_wrapper
          (Self.QEvent_View, Qt4.Rects.Internals.QRect_View (Result));
      end return;
   end Rect;

   ------------
   -- Region --
   ------------

   function Region
    (Self : not null access constant Q_Paint_Event'Class)
       return Qt4.Regions.Q_Region is
   begin
      return Result : Qt4.Regions.Q_Region do
         region_wrapper
          (Self.QEvent_View, Qt4.Regions.Internals.QRegion_View (Result));
      end return;
   end Region;

begin
   Qt_Ada.Internals.Events.Registry.Register
    (Qt4.Events.Paint, Create'Access);
end Qt4.Paint_Events;
