------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Plain_Text_Edits.Constructors is

   function new_QPlainTextEdit
    (Parent : access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, new_QPlainTextEdit, "__Qt4Ada_new_QPlainTextEdit");

   function new_QPlainTextEdit_With_String
    (Text   : not null access Qt4.Strings.Internals.QString;
     Parent : access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import
    (C, new_QPlainTextEdit_With_String, "__Qt4Ada_new_QPlainTextEdit_with_String");

   ------------
   -- Create --
   ------------

   function Create (Parent : access Qt4.Widgets.Q_Widget'Class := null)
     return not null Qt4.Plain_Text_Edits.Q_Plain_Text_Edit_Access
   is
   begin
      return
        Qt4.Plain_Text_Edits.Q_Plain_Text_Edit_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QPlainTextEdit
             (Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent))));
   end Create;

   ------------
   -- Create --
   ------------

   function Create (Text   : Qt4.Strings.Q_String;
                    Parent : access Qt4.Widgets.Q_Widget'Class := null)
     return not null Qt4.Plain_Text_Edits.Q_Plain_Text_Edit_Access
   is
   begin
      return
        Qt4.Plain_Text_Edits.Q_Plain_Text_Edit_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QPlainTextEdit_With_String
             (Qt4.Strings.Internals.QString_View (Text),
              Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent))));
   end Create;

end Qt4.Plain_Text_Edits.Constructors;
