------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Scroll_Areas.Directors;
limited with Qt4.Action_Events;
limited with Qt4.Child_Events;
limited with Qt4.Close_Events;
limited with Qt4.Context_Menu_Events;
limited with Qt4.Drag_Enter_Events;
limited with Qt4.Drag_Leave_Events;
limited with Qt4.Drag_Move_Events;
limited with Qt4.Drop_Events;
limited with Qt4.Events;
limited with Qt4.Focus_Events;
limited with Qt4.Hide_Events;
limited with Qt4.Input_Method_Events;
limited with Qt4.Key_Events;
with Qt4.Meta_Objects;
limited with Qt4.Mouse_Events;
limited with Qt4.Move_Events;
limited with Qt4.Objects;
with Qt4.Paint_Devices;
limited with Qt4.Paint_Events;
with Qt4.Point_Fs;
with Qt4.Rect_Fs;
limited with Qt4.Resize_Events;
limited with Qt4.Show_Events;
limited with Qt4.Tablet_Events;
with Qt4.Text_Blocks;
limited with Qt4.Timer_Events;
with Qt4.Variants;
limited with Qt4.Wheel_Events;
limited with Qt4.Widgets;

package Qt4.Plain_Text_Edits.Directors is

   type Q_Plain_Text_Edit_Director is
     new Qt4.Abstract_Scroll_Areas.Directors.Q_Abstract_Scroll_Area_Director
       and Q_Plain_Text_Edit with null record;

   not overriding
   procedure Emit_Block_Count_Changed
    (Self : not null access Q_Plain_Text_Edit_Director;
     New_Block_Count : Qt4.Q_Integer);

   not overriding
   procedure Emit_Copy_Available
    (Self : not null access Q_Plain_Text_Edit_Director;
     B : Standard.Boolean);

   not overriding
   procedure Emit_Cursor_Position_Changed
    (Self : not null access Q_Plain_Text_Edit_Director);

   not overriding
   procedure Emit_Modification_Changed
    (Self : not null access Q_Plain_Text_Edit_Director;
     B : Standard.Boolean);

   not overriding
   procedure Emit_Redo_Available
    (Self : not null access Q_Plain_Text_Edit_Director;
     B : Standard.Boolean);

   not overriding
   procedure Emit_Selection_Changed
    (Self : not null access Q_Plain_Text_Edit_Director);

   not overriding
   procedure Emit_Text_Changed
    (Self : not null access Q_Plain_Text_Edit_Director);

   not overriding
   procedure Emit_Undo_Available
    (Self : not null access Q_Plain_Text_Edit_Director;
     B : Standard.Boolean);

   not overriding
   procedure Emit_Update_Request
    (Self : not null access Q_Plain_Text_Edit_Director;
     Rect : Qt4.Rects.Q_Rect;
     Dy : Qt4.Q_Integer);

   not overriding
   function First_Visible_Block
    (Self : not null access constant Q_Plain_Text_Edit_Director)
       return Qt4.Text_Blocks.Q_Text_Block;

   not overriding
   function Content_Offset
    (Self : not null access constant Q_Plain_Text_Edit_Director)
       return Qt4.Point_Fs.Q_Point_F;

   not overriding
   function Block_Bounding_Rect
    (Self : not null access constant Q_Plain_Text_Edit_Director;
     Block : Qt4.Text_Blocks.Q_Text_Block)
       return Qt4.Rect_Fs.Q_Rect_F;

   not overriding
   function Block_Bounding_Geometry
    (Self : not null access constant Q_Plain_Text_Edit_Director;
     Block : Qt4.Text_Blocks.Q_Text_Block)
       return Qt4.Rect_Fs.Q_Rect_F;

   overriding
   function Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     E : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean;

   overriding
   procedure Timer_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class);

   overriding
   procedure Key_Press_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class);

   overriding
   procedure Key_Release_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class);

   overriding
   procedure Resize_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Resize_Events.Q_Resize_Event'Class);

   overriding
   procedure Paint_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Paint_Events.Q_Paint_Event'Class);

   overriding
   procedure Mouse_Double_Click_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Mouse_Events.Q_Mouse_Event'Class);

   overriding
   procedure Mouse_Move_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Mouse_Events.Q_Mouse_Event'Class);

   overriding
   procedure Mouse_Press_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Mouse_Events.Q_Mouse_Event'Class);

   overriding
   procedure Mouse_Release_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Mouse_Events.Q_Mouse_Event'Class);

   overriding
   function Focus_Next_Prev_Child
    (Self : not null access Q_Plain_Text_Edit_Director;
     Next : Standard.Boolean)
       return Standard.Boolean;

   overriding
   procedure Context_Menu_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Context_Menu_Events.Q_Context_Menu_Event'Class);

   overriding
   procedure Drag_Enter_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Drag_Enter_Events.Q_Drag_Enter_Event'Class);

   overriding
   procedure Drag_Leave_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Drag_Leave_Events.Q_Drag_Leave_Event'Class);

   overriding
   procedure Drag_Move_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Drag_Move_Events.Q_Drag_Move_Event'Class);

   overriding
   procedure Drop_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Drop_Events.Q_Drop_Event'Class);

   overriding
   procedure Focus_In_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class);

   overriding
   procedure Focus_Out_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class);

   overriding
   procedure Show_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Show_Events.Q_Show_Event'Class);

   overriding
   procedure Change_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   procedure Wheel_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Wheel_Events.Q_Wheel_Event'Class);

   overriding
   procedure Input_Method_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Input_Method_Events.Q_Input_Method_Event'Class);

   overriding
   function Input_Method_Query
    (Self : not null access constant Q_Plain_Text_Edit_Director;
     Query : Qt4.Input_Method_Query)
       return Qt4.Variants.Q_Variant;

   overriding
   procedure Scroll_Contents_By
    (Self : not null access Q_Plain_Text_Edit_Director;
     Dx : Qt4.Q_Integer;
     Dy : Qt4.Q_Integer);

   overriding
   procedure Setup_Viewport
    (Self : not null access Q_Plain_Text_Edit_Director;
     Viewport : not null access Qt4.Widgets.Q_Widget'Class);

   overriding
   procedure Set_Viewport_Margins
    (Self : not null access Q_Plain_Text_Edit_Director;
     Left : Qt4.Q_Integer;
     Top : Qt4.Q_Integer;
     Right : Qt4.Q_Integer;
     Bottom : Qt4.Q_Integer);

   overriding
   function Viewport_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean;

   overriding
   procedure Emit_Custom_Context_Menu_Requested
    (Self : not null access Q_Plain_Text_Edit_Director;
     Pos : Qt4.Points.Q_Point);

   overriding
   procedure Action_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Action_Events.Q_Action_Event'Class);

   overriding
   procedure Close_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Close_Events.Q_Close_Event'Class);

   overriding
   procedure Enter_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   function Focus_Next_Child
    (Self : not null access Q_Plain_Text_Edit_Director)
       return Standard.Boolean;

   overriding
   function Focus_Previous_Child
    (Self : not null access Q_Plain_Text_Edit_Director)
       return Standard.Boolean;

   overriding
   procedure Hide_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Hide_Events.Q_Hide_Event'Class);

   overriding
   procedure Leave_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   procedure Move_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Move_Events.Q_Move_Event'Class);

   overriding
   procedure Reset_Input_Context
    (Self : not null access Q_Plain_Text_Edit_Director);

   overriding
   procedure Tablet_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Tablet_Events.Q_Tablet_Event'Class);

   overriding
   function Metric
    (Self : not null access constant Q_Plain_Text_Edit_Director;
     Metric : Qt4.Paint_Devices.Paint_Device_Metric)
       return Qt4.Q_Integer;

   overriding
   procedure Child_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class);

   overriding
   procedure Custom_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   function Sender
    (Self : not null access constant Q_Plain_Text_Edit_Director)
       return access Qt4.Objects.Q_Object'Class;

   Static_Meta_Object : access constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C, Static_Meta_Object,
                  "__Qt4Ada_QPlainTextEdit_staticMetaObject");

end Qt4.Plain_Text_Edits.Directors;
