------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Strings;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Progress_Bars is

   type Progress_Bar_Direction is
    (Top_To_Bottom,
     Bottom_To_Top);
   pragma Convention (C, Progress_Bar_Direction);

   type Q_Progress_Bar is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Progress_Bar_Access is
     access all Q_Progress_Bar'Class;
   for Q_Progress_Bar_Access'Storage_Size use 0;

   type Q_Progress_Bar_Pointer is tagged;

   function Format
    (Self : not null access constant Q_Progress_Bar'Class)
       return Qt4.Strings.Q_String;

   function Inverted_Appearance
    (Self : not null access Q_Progress_Bar'Class)
       return Standard.Boolean;

   function Is_Text_Visible
    (Self : not null access constant Q_Progress_Bar'Class)
       return Standard.Boolean;

   function Maximum
    (Self : not null access constant Q_Progress_Bar'Class)
       return Qt4.Q_Integer;

   function Minimum
    (Self : not null access constant Q_Progress_Bar'Class)
       return Qt4.Q_Integer;

   function Orientation
    (Self : not null access constant Q_Progress_Bar'Class)
       return Qt4.Orientation;

   procedure Set_Alignment
    (Self : not null access Q_Progress_Bar'Class;
     Alignment : Qt4.Alignment);

   procedure Set_Format
    (Self : not null access Q_Progress_Bar'Class;
     Format : Qt4.Strings.Q_String);

   procedure Set_Inverted_Appearance
    (Self : not null access Q_Progress_Bar'Class;
     Invert : Standard.Boolean);

   procedure Set_Text_Direction
    (Self : not null access Q_Progress_Bar'Class;
     Text_Direction : Qt4.Progress_Bars.Progress_Bar_Direction);

   procedure Set_Text_Visible
    (Self : not null access Q_Progress_Bar'Class;
     Visible : Standard.Boolean);

   not overriding
   function Text
    (Self : not null access constant Q_Progress_Bar)
       return Qt4.Strings.Q_String
         is abstract;

   function Text_Direction
    (Self : not null access Q_Progress_Bar'Class)
       return Qt4.Progress_Bars.Progress_Bar_Direction;

   function Value
    (Self : not null access constant Q_Progress_Bar'Class)
       return Qt4.Q_Integer;

   procedure Reset
    (Self : not null access Q_Progress_Bar'Class);

   procedure Set_Maximum
    (Self : not null access Q_Progress_Bar'Class;
     Maximum : Qt4.Q_Integer);

   procedure Set_Minimum
    (Self : not null access Q_Progress_Bar'Class;
     Minimum : Qt4.Q_Integer);

   procedure Set_Orientation
    (Self : not null access Q_Progress_Bar'Class;
     Orientation : Qt4.Orientation);

   procedure Set_Range
    (Self : not null access Q_Progress_Bar'Class;
     Minimum : Qt4.Q_Integer;
     Maximum : Qt4.Q_Integer);

   procedure Set_Value
    (Self : not null access Q_Progress_Bar'Class;
     Value : Qt4.Q_Integer);

   package Q_Progress_Bar_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Progress_Bar, Q_Progress_Bar_Access);

   type Q_Progress_Bar_Pointer is
     new Q_Progress_Bar_Pointers.Q_Pointer with null record;

end Qt4.Progress_Bars;
