------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Push_Buttons.Constructors is

   function new_QPushButton
    (Parent : access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, new_QPushButton, "__Qt4Ada_new_QPushButton");

   function new_QPushButton_With_String
    (Text   : not null access Qt4.Strings.Internals.QString;
     Parent : access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import
    (C, new_QPushButton_With_String, "__Qt4Ada_new_QPushButton_With_String");

--   function new_QPushButton
--    (Icon   : not null access Qt4.Icons.Internals.QIcon;
--     Text   : not null access Qt4.Strings.Internals.QString;
--     Parent : access Qt_Ada.Internals.Objects.QObject)
--       return not null access Qt_Ada.Internals.Objects.QObject;
--   pragma Import
--   (C, new_QPushButton_With_String, "__Qt4Ada_new_QPushButton_With_String");

   ------------
   -- Create --
   ------------

   function Create (Parent : access Qt4.Widgets.Q_Widget'Class := null)
     return not null Qt4.Push_Buttons.Q_Push_Button_Access
   is
   begin
      return
        Qt4.Push_Buttons.Q_Push_Button_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QPushButton
             (Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent))));
   end Create;

   ------------
   -- Create --
   ------------

   function Create (Text   : Qt4.Strings.Q_String;
                    Parent : access Qt4.Widgets.Q_Widget'Class := null)
     return not null Qt4.Push_Buttons.Q_Push_Button_Access
   is
   begin
      return
        Qt4.Push_Buttons.Q_Push_Button_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QPushButton_With_String
             (Qt4.Strings.Internals.QString_View (Text),
              Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent))));
   end Create;

--   function Create (Icon   : Qt4.Icons.Q_Icon
--                    Text   : String;
--                    Parent : access Qt4.Objects.Q_Object'Class := null)
--     return not null access Q_Push_Button'Class
--   is
--   begin
--      return
--        Qt4.Push_Buttons.Q_Push_Button'Class
--         (Qt_Ada.Internals.Object_Registry.To_Q_Object
--           (new_QPushButton_With_String
--             (Qt4.Icons.Internals.QIcon_View (Icon),
--              Qt4.Strings.Internals.QString_View (Text),
--              Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
--               (Parent))).all)'Access;
--   end;

end Qt4.Push_Buttons.Constructors;
