------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3781 $ $Date: 2010-10-25 01:48:22 +0400 (Mon, 25 Oct 2010) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Events.Registry;

package body Qt4.Resize_Events is

   procedure oldSize_wrapper
    (Self  : not null access constant Qt_Ada.Internals.Events.QEvent;
     Point : not null access Qt4.Sizes.Internals.QSize);
   pragma Import (C, oldSize_wrapper, "__Qt4Ada_QResizeEvent_oldSize_wrapper");

   procedure size_wrapper
    (Self  : not null access constant Qt_Ada.Internals.Events.QEvent;
     Point : not null access Qt4.Sizes.Internals.QSize);
   pragma Import (C, size_wrapper, "__Qt4Ada_QResizeEvent_size_wrapper");

   function Create
    (Object : not null Qt_Ada.Internals.Events.QEvent_Access)
       return not null Qt4.Events.Q_Event_Access;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Events.QEvent_Access)
       return not null Qt4.Events.Q_Event_Access is
   begin
      return Result : constant not null Qt4.Events.Q_Event_Access
        := new Q_Resize_Event
      do
         Qt_Ada.Internals.Events.Initialize (Result, Object);
      end return;
   end Create;

   --------------
   -- Old_Size --
   --------------

   function Old_Size
    (Self : not null access constant Q_Resize_Event'Class)
       return Qt4.Sizes.Q_Size is
   begin
      return Result : Qt4.Sizes.Q_Size do
         oldSize_wrapper (Self.QEvent_View,
                          Qt4.Sizes.Internals.QSize_View (Result));

      end return;
   end Old_Size;

   ----------
   -- Size --
   ----------

   function Size
    (Self : not null access constant Q_Resize_Event'Class)
       return Qt4.Sizes.Q_Size is
   begin
      return Result : Qt4.Sizes.Q_Size do
         size_wrapper (Self.QEvent_View,
                       Qt4.Sizes.Internals.QSize_View (Result));
      end return;
   end Size;

begin
   Qt_Ada.Internals.Events.Registry.Register
    (Qt4.Events.Resize, Create'Access);
end Qt4.Resize_Events;
