------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Rubber_Band_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Rubber_Band_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Rubber_Bands is

   procedure move_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer);
   pragma Import (C, move_0_wrapper,
                     "__Qt4Ada_QRubberBand_move_0_wrapper");

   procedure move_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint);
   pragma Import (C, move_1_wrapper,
                     "__Qt4Ada_QRubberBand_move_1_wrapper");

   procedure resize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);
   pragma Import (C, resize_0_wrapper,
                     "__Qt4Ada_QRubberBand_resize_0_wrapper");

   procedure resize_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     S : not null access constant Qt4.Sizes.Internals.QSize);
   pragma Import (C, resize_1_wrapper,
                     "__Qt4Ada_QRubberBand_resize_1_wrapper");

   procedure setGeometry_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);
   pragma Import (C, setGeometry_0_wrapper,
                     "__Qt4Ada_QRubberBand_setGeometry_0_wrapper");

   procedure setGeometry_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     R : not null access constant Qt4.Rects.Internals.QRect);
   pragma Import (C, setGeometry_1_wrapper,
                     "__Qt4Ada_QRubberBand_setGeometry_1_wrapper");

   function shape_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Rubber_Bands.Rubber_Band_Shape;
   pragma Import (C, shape_0_wrapper,
                     "__Qt4Ada_QRubberBand_shape_0_wrapper");

   pragma Style_Checks ("N");

   ----------
   -- Move --
   ----------

   procedure Move
    (Self : not null access Q_Rubber_Band'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer)
   is
   begin
      move_0_wrapper
       (Self.QObject_View,
        X,
        Y);
   end Move;

   ----------
   -- Move --
   ----------

   procedure Move
    (Self : not null access Q_Rubber_Band'Class;
     Pos : Qt4.Points.Q_Point)
   is
   begin
      move_1_wrapper
       (Self.QObject_View,
        Qt4.Points.Internals.QPoint_View (Pos));
   end Move;

   ------------
   -- Resize --
   ------------

   procedure Resize
    (Self : not null access Q_Rubber_Band'Class;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer)
   is
   begin
      resize_0_wrapper
       (Self.QObject_View,
        W,
        H);
   end Resize;

   ------------
   -- Resize --
   ------------

   procedure Resize
    (Self : not null access Q_Rubber_Band'Class;
     S : Qt4.Sizes.Q_Size)
   is
   begin
      resize_1_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (S));
   end Resize;

   ------------------
   -- Set_Geometry --
   ------------------

   procedure Set_Geometry
    (Self : not null access Q_Rubber_Band'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer)
   is
   begin
      setGeometry_0_wrapper
       (Self.QObject_View,
        X,
        Y,
        W,
        H);
   end Set_Geometry;

   ------------------
   -- Set_Geometry --
   ------------------

   procedure Set_Geometry
    (Self : not null access Q_Rubber_Band'Class;
     R : Qt4.Rects.Q_Rect)
   is
   begin
      setGeometry_1_wrapper
       (Self.QObject_View,
        Qt4.Rects.Internals.QRect_View (R));
   end Set_Geometry;

   -----------
   -- Shape --
   -----------

   function Shape
    (Self : not null access constant Q_Rubber_Band'Class)
       return Qt4.Rubber_Bands.Rubber_Band_Shape
   is
   begin
      return
        shape_0_wrapper
         (Self.QObject_View);
   end Shape;

end Qt4.Rubber_Bands;
