------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Proxy_Models;
with Qt4.Reg_Exps;
with Qt4.Strings;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Sort_Filter_Proxy_Models is

   type Q_Sort_Filter_Proxy_Model is limited interface
     and Qt4.Abstract_Proxy_Models.Q_Abstract_Proxy_Model;

   type Q_Sort_Filter_Proxy_Model_Access is
     access all Q_Sort_Filter_Proxy_Model'Class;
   for Q_Sort_Filter_Proxy_Model_Access'Storage_Size use 0;

   type Q_Sort_Filter_Proxy_Model_Pointer is tagged;

   function Dynamic_Sort_Filter
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Standard.Boolean;

   function Filter_Case_Sensitivity
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Qt4.Case_Sensitivity;

   function Filter_Key_Column
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Qt4.Q_Integer;

   function Filter_Reg_Exp
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Qt4.Reg_Exps.Q_Reg_Exp;

   function Filter_Role
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Qt4.Q_Integer;

   function Is_Sort_Locale_Aware
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Standard.Boolean;

   procedure Set_Dynamic_Sort_Filter
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Enable : Standard.Boolean);

   procedure Set_Filter_Case_Sensitivity
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Cs : Qt4.Case_Sensitivity);

   procedure Set_Filter_Key_Column
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Column : Qt4.Q_Integer);

   procedure Set_Filter_Reg_Exp
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Reg_Exp : Qt4.Reg_Exps.Q_Reg_Exp);

   procedure Set_Filter_Role
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Role : Qt4.Q_Integer);

   procedure Set_Sort_Case_Sensitivity
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Cs : Qt4.Case_Sensitivity);

   procedure Set_Sort_Locale_Aware
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     On : Standard.Boolean);

   procedure Set_Sort_Role
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Role : Qt4.Q_Integer);

   function Sort_Case_Sensitivity
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Qt4.Case_Sensitivity;

   function Sort_Role
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Qt4.Q_Integer;

   procedure Invalidate
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class);

   procedure Set_Filter_Fixed_String
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Pattern : Qt4.Strings.Q_String);

   procedure Set_Filter_Reg_Exp
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Pattern : Qt4.Strings.Q_String);

   procedure Set_Filter_Wildcard
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Pattern : Qt4.Strings.Q_String);

   package Q_Sort_Filter_Proxy_Model_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Sort_Filter_Proxy_Model, Q_Sort_Filter_Proxy_Model_Access);

   type Q_Sort_Filter_Proxy_Model_Pointer is
     new Q_Sort_Filter_Proxy_Model_Pointers.Q_Pointer with null record;

end Qt4.Sort_Filter_Proxy_Models;
