------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3243 $ $Date: 2009-04-11 07:39:16 +0400 (Sat, 11 Apr 2009) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Splash_Screens.Constructors is

   function new_QSplashScreen_QPixmapCR_QtWindowFlags
    (Pixmap : not null Qt4.Pixmaps.Internals.QPixmap_Access;
     Flag   : Qt4.Window_Flags)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import
    (C,
     new_QSplashScreen_QPixmapCR_QtWindowFlags,
     "__QtAda_new_QSplashScreen_QPixmapCR_QtWindowFlags");

   function new_QSplashScreen_QWidgetP_QPixmapCR_QtWindowFlags
    (Parent : access Qt_Ada.Internals.Objects.QObject;
     Pixmap : not null Qt4.Pixmaps.Internals.QPixmap_Access;
     Flag   : Qt4.Window_Flags)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import
    (C,
     new_QSplashScreen_QWidgetP_QPixmapCR_QtWindowFlags,
     "__QtAda_new_QSplashScreen_QWidgetP_QPixmapCR_QtWindowFlags");

   ------------
   -- Create --
   ------------

   function Create
    (Pixmap : Qt4.Pixmaps.Q_Pixmap'Class := Qt4.Pixmaps.Create;
     Flags  : Qt4.Window_Flags           := +Qt4.Widget)
       return not null Qt4.Splash_Screens.Q_Splash_Screen_Access
   is
   begin
      return
        Qt4.Splash_Screens.Q_Splash_Screen_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QSplashScreen_QPixmapCR_QtWindowFlags
             (Qt4.Pixmaps.Internals.QPixmap_View (Pixmap),
              Flags)));
   end Create;

   ------------
   -- Create --
   ------------

   function Create
    (Parent : not null access Qt4.Widgets.Q_Widget'Class;
     Pixmap : Qt4.Pixmaps.Q_Pixmap'Class := Qt4.Pixmaps.Create;
     Flags  : Qt4.Window_Flags           := +Qt4.Widget)
       return not null Qt4.Splash_Screens.Q_Splash_Screen_Access
   is
   begin
      return
        Qt4.Splash_Screens.Q_Splash_Screen_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QSplashScreen_QWidgetP_QPixmapCR_QtWindowFlags
             (Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent),
              Qt4.Pixmaps.Internals.QPixmap_View (Pixmap),
              Flags)));
   end Create;

end Qt4.Splash_Screens.Constructors;
