------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Qt4.Fonts;
with Qt4.Palettes;
with Qt4.Styles;
with Qt4.Style_Options;
with Qt4_Entities;

package Qt4.Style_Option_View_Items is

   type Q_Style_Option_View_Item is
     new Qt4.Style_Options.Q_Style_Option with private;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Font
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function Font (Self : Q_Style_Option_View_Item) return Qt4.Fonts.Q_Font;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Get_Type
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function Get_Type (Self : Q_Style_Option_View_Item)
     return Q_Integer;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Palette
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function Palette (Self : Q_Style_Option_View_Item)
     return Qt4.Palettes.Q_Palette;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Set_State
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   procedure Set_State
    (Self : Q_Style_Option_View_Item; State : Qt4.Styles.State);

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> State
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding function State
    (Self : Q_Style_Option_View_Item) return Qt4.Styles.State;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Version
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function Version (Self : Q_Style_Option_View_Item)
     return Q_Integer;

 private
   type Q_Style_Option_View_Item is
     new Qt4.Style_Options.Q_Style_Option with null record;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Default_Cpp_Object
   --!    <Purpose> Возвращает новый пустой экземпляр класса QStyleOption.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   function Default_Cpp_Object
    (Self : not null access Q_Style_Option_View_Item)
     return access Qt4_Entities.Cpp_Class;

end Qt4.Style_Option_View_Items;
