------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Child_Events;
with Qt4.Colors;
limited with Qt4.Events;
with Qt4.Fonts;
with Qt4.Meta_Objects;
with Qt4.Objects.Directors;
with Qt4.Strings;
with Qt4.Text_Char_Formats;
with Qt4.Text_Edits;
limited with Qt4.Timer_Events;

package Qt4.Syntax_Highlighters.Directors is

   type Q_Syntax_Highlighter_Director is
     abstract new Qt4.Objects.Directors.Q_Object_Director
       and Q_Syntax_Highlighter with null record;

   not overriding
   function Current_Block_State
    (Self : not null access constant Q_Syntax_Highlighter_Director)
       return Qt4.Q_Integer;

   not overriding
   procedure Highlight_Block
    (Self : not null access Q_Syntax_Highlighter_Director;
     Text : Qt4.Strings.Q_String)
       is abstract;

   not overriding
   function Previous_Block_State
    (Self : not null access constant Q_Syntax_Highlighter_Director)
       return Qt4.Q_Integer;

   not overriding
   procedure Set_Current_Block_State
    (Self : not null access Q_Syntax_Highlighter_Director;
     New_State : Qt4.Q_Integer);

   not overriding
   procedure Set_Format
    (Self : not null access Q_Syntax_Highlighter_Director;
     Start : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Color : Qt4.Colors.Q_Color);

   not overriding
   procedure Set_Format
    (Self : not null access Q_Syntax_Highlighter_Director;
     Start : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Font : Qt4.Fonts.Q_Font);

   not overriding
   procedure Set_Format
    (Self : not null access Q_Syntax_Highlighter_Director;
     Start : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Format : Qt4.Text_Char_Formats.Q_Text_Char_Format'Class);

   overriding
   procedure Child_Event
    (Self : not null access Q_Syntax_Highlighter_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class);

   overriding
   procedure Custom_Event
    (Self : not null access Q_Syntax_Highlighter_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   procedure Timer_Event
    (Self : not null access Q_Syntax_Highlighter_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class);

   overriding
   function Sender
    (Self : not null access constant Q_Syntax_Highlighter_Director)
       return access Qt4.Objects.Q_Object'Class;

   package Constructors is

      procedure Initialize
       (Self   : not null access Q_Syntax_Highlighter_Director'Class;
        Parent : access Qt4.Objects.Q_Object'Class := null);
      --  Creates C++ director and associate it with the specified object.

   end Constructors;

   Static_Meta_Object : access constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C, Static_Meta_Object,
                  "__Qt4Ada_QSyntaxHighlighter_staticMetaObject");

end Qt4.Syntax_Highlighters.Directors;
