------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Item_Views;
limited with Qt4.Header_Views;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Table_Views is

   type Q_Table_View is limited interface
     and Qt4.Abstract_Item_Views.Q_Abstract_Item_View;

   type Q_Table_View_Access is
     access all Q_Table_View'Class;
   for Q_Table_View_Access'Storage_Size use 0;

   type Q_Table_View_Pointer is tagged;

   function Column_At
    (Self : not null access constant Q_Table_View'Class;
     X : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Column_Span
    (Self : not null access constant Q_Table_View'Class;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Column_Viewport_Position
    (Self : not null access constant Q_Table_View'Class;
     Column : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Column_Width
    (Self : not null access constant Q_Table_View'Class;
     Column : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Horizontal_Header
    (Self : not null access constant Q_Table_View'Class)
       return access Qt4.Header_Views.Q_Header_View'Class;

   function Is_Column_Hidden
    (Self : not null access constant Q_Table_View'Class;
     Column : Qt4.Q_Integer)
       return Standard.Boolean;

   function Is_Corner_Button_Enabled
    (Self : not null access constant Q_Table_View'Class)
       return Standard.Boolean;

   function Is_Row_Hidden
    (Self : not null access constant Q_Table_View'Class;
     Row : Qt4.Q_Integer)
       return Standard.Boolean;

   function Is_Sorting_Enabled
    (Self : not null access constant Q_Table_View'Class)
       return Standard.Boolean;

   function Row_At
    (Self : not null access constant Q_Table_View'Class;
     Y : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Row_Height
    (Self : not null access constant Q_Table_View'Class;
     Row : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Row_Span
    (Self : not null access constant Q_Table_View'Class;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Row_Viewport_Position
    (Self : not null access constant Q_Table_View'Class;
     Row : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   procedure Set_Column_Hidden
    (Self : not null access Q_Table_View'Class;
     Column : Qt4.Q_Integer;
     Hide : Standard.Boolean);

   procedure Set_Column_Width
    (Self : not null access Q_Table_View'Class;
     Column : Qt4.Q_Integer;
     Width : Qt4.Q_Integer);

   procedure Set_Corner_Button_Enabled
    (Self : not null access Q_Table_View'Class;
     Enable : Standard.Boolean);

   procedure Set_Horizontal_Header
    (Self : not null access Q_Table_View'Class;
     Header : access Qt4.Header_Views.Q_Header_View'Class);

   procedure Set_Row_Height
    (Self : not null access Q_Table_View'Class;
     Row : Qt4.Q_Integer;
     Height : Qt4.Q_Integer);

   procedure Set_Row_Hidden
    (Self : not null access Q_Table_View'Class;
     Row : Qt4.Q_Integer;
     Hide : Standard.Boolean);

   procedure Set_Sorting_Enabled
    (Self : not null access Q_Table_View'Class;
     Enable : Standard.Boolean);

   procedure Set_Span
    (Self : not null access Q_Table_View'Class;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Row_Span : Qt4.Q_Integer;
     Column_Span : Qt4.Q_Integer);

   procedure Set_Vertical_Header
    (Self : not null access Q_Table_View'Class;
     Header : access Qt4.Header_Views.Q_Header_View'Class);

   procedure Set_Word_Wrap
    (Self : not null access Q_Table_View'Class;
     On : Standard.Boolean);

   function Show_Grid
    (Self : not null access constant Q_Table_View'Class)
       return Standard.Boolean;

   function Vertical_Header
    (Self : not null access constant Q_Table_View'Class)
       return access Qt4.Header_Views.Q_Header_View'Class;

   function Word_Wrap
    (Self : not null access constant Q_Table_View'Class)
       return Standard.Boolean;

   procedure Hide_Column
    (Self : not null access Q_Table_View'Class;
     Column : Qt4.Q_Integer);

   procedure Hide_Row
    (Self : not null access Q_Table_View'Class;
     Row : Qt4.Q_Integer);

   procedure Resize_Column_To_Contents
    (Self : not null access Q_Table_View'Class;
     Column : Qt4.Q_Integer);

   procedure Resize_Columns_To_Contents
    (Self : not null access Q_Table_View'Class);

   procedure Resize_Row_To_Contents
    (Self : not null access Q_Table_View'Class;
     Row : Qt4.Q_Integer);

   procedure Resize_Rows_To_Contents
    (Self : not null access Q_Table_View'Class);

   procedure Select_Column
    (Self : not null access Q_Table_View'Class;
     Column : Qt4.Q_Integer);

   procedure Select_Row
    (Self : not null access Q_Table_View'Class;
     Row : Qt4.Q_Integer);

   procedure Set_Show_Grid
    (Self : not null access Q_Table_View'Class;
     Show : Standard.Boolean);

   procedure Show_Column
    (Self : not null access Q_Table_View'Class;
     Column : Qt4.Q_Integer);

   procedure Show_Row
    (Self : not null access Q_Table_View'Class;
     Row : Qt4.Q_Integer);

   package Q_Table_View_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Table_View, Q_Table_View_Access);

   type Q_Table_View_Pointer is
     new Q_Table_View_Pointers.Q_Pointer with null record;

end Qt4.Table_Views;
