------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Table_Views;
limited with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Table_Widgets is

   type Q_Table_Widget is limited interface
     and Qt4.Table_Views.Q_Table_View;

   type Q_Table_Widget_Access is
     access all Q_Table_Widget'Class;
   for Q_Table_Widget_Access'Storage_Size use 0;

   type Q_Table_Widget_Pointer is tagged;

   function Cell_Widget
    (Self : not null access constant Q_Table_Widget'Class;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Column_Count
    (Self : not null access constant Q_Table_Widget'Class)
       return Qt4.Q_Integer;

   function Current_Column
    (Self : not null access constant Q_Table_Widget'Class)
       return Qt4.Q_Integer;

   function Current_Row
    (Self : not null access constant Q_Table_Widget'Class)
       return Qt4.Q_Integer;

   procedure Remove_Cell_Widget
    (Self : not null access Q_Table_Widget'Class;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer);

   function Row_Count
    (Self : not null access constant Q_Table_Widget'Class)
       return Qt4.Q_Integer;

   procedure Set_Cell_Widget
    (Self : not null access Q_Table_Widget'Class;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   procedure Set_Column_Count
    (Self : not null access Q_Table_Widget'Class;
     Columns : Qt4.Q_Integer);

   procedure Set_Current_Cell
    (Self : not null access Q_Table_Widget'Class;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer);

   procedure Set_Row_Count
    (Self : not null access Q_Table_Widget'Class;
     Rows : Qt4.Q_Integer);

   procedure Sort_Items
    (Self : not null access Q_Table_Widget'Class;
     Column : Qt4.Q_Integer;
     Order : Qt4.Sort_Order
       := Qt4.Ascending_Order);

   procedure Visual_Column
    (Self : not null access constant Q_Table_Widget'Class;
     Logical_Column : Qt4.Q_Integer);

   procedure Visual_Row
    (Self : not null access constant Q_Table_Widget'Class;
     Logical_Row : Qt4.Q_Integer);

   procedure Clear
    (Self : not null access Q_Table_Widget'Class);

   procedure Clear_Contents
    (Self : not null access Q_Table_Widget'Class);

   procedure Insert_Column
    (Self : not null access Q_Table_Widget'Class;
     Column : Qt4.Q_Integer);

   procedure Insert_Row
    (Self : not null access Q_Table_Widget'Class;
     Row : Qt4.Q_Integer);

   procedure Remove_Column
    (Self : not null access Q_Table_Widget'Class;
     Column : Qt4.Q_Integer);

   procedure Remove_Row
    (Self : not null access Q_Table_Widget'Class;
     Row : Qt4.Q_Integer);

   package Q_Table_Widget_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Table_Widget, Q_Table_Widget_Access);

   type Q_Table_Widget_Pointer is
     new Q_Table_Widget_Pointers.Q_Pointer with null record;

end Qt4.Table_Widgets;
