------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3604 $ $Date: 2009-09-19 12:11:14 +0400 (Sat, 19 Sep 2009) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Tool_Bars.Constructors is

   function new_QToolBar_QStringCR_QWidgetP
    (Title  : not null Qt4.Strings.Internals.QString_Access;
     Parent : access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import
    (C, new_QToolBar_QStringCR_QWidgetP,
     "__QtAda_new_QToolBar_QStringCR_QWidgetP");

   function new_QToolBar_QWidgetP
    (Parent : access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, new_QToolBar_QWidgetP, "__QtAda_new_QToolBar_QWidgetP");

   ------------
   -- Create --
   ------------

   function Create
    (Title  : Qt4.Strings.Q_String;
     Parent : access Qt4.Widgets.Q_Widget'Class := null)
       return not null Qt4.Tool_Bars.Q_Tool_Bar_Access
   is
   begin
      return
        Qt4.Tool_Bars.Q_Tool_Bar_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QToolBar_QStringCR_QWidgetP
             (Qt4.Strings.Internals.QString_View (Title),
              Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent))));
   end Create;

   ------------
   -- Create --
   ------------

   function Create (Parent : access Qt4.Widgets.Q_Widget'Class := null)
     return not null Qt4.Tool_Bars.Q_Tool_Bar_Access
   is
   begin
      return
        Qt4.Tool_Bars.Q_Tool_Bar_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QToolBar_QWidgetP
             (Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent))));
   end Create;

end Qt4.Tool_Bars.Constructors;
