------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Buttons;
limited with Qt4.Actions;
limited with Qt4.Menus;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Tool_Buttons is

   type Tool_Button_Popup_Mode is
    (Delayed_Popup,
     Menu_Button_Popup,
     Instant_Popup);
   pragma Convention (C, Tool_Button_Popup_Mode);

   type Q_Tool_Button is limited interface
     and Qt4.Abstract_Buttons.Q_Abstract_Button;

   type Q_Tool_Button_Access is
     access all Q_Tool_Button'Class;
   for Q_Tool_Button_Access'Storage_Size use 0;

   type Q_Tool_Button_Pointer is tagged;

   function Arrow_Type
    (Self : not null access constant Q_Tool_Button'Class)
       return Qt4.Arrow_Type;

   function Auto_Raise
    (Self : not null access constant Q_Tool_Button'Class)
       return Standard.Boolean;

   function Default_Action
    (Self : not null access constant Q_Tool_Button'Class)
       return not null access Qt4.Actions.Q_Action'Class;

   function Menu
    (Self : not null access constant Q_Tool_Button'Class)
       return not null access Qt4.Menus.Q_Menu'Class;

   function Popup_Mode
    (Self : not null access constant Q_Tool_Button'Class)
       return Qt4.Tool_Buttons.Tool_Button_Popup_Mode;

   procedure Set_Arrow_Type
    (Self : not null access Q_Tool_Button'Class;
     The_type : Qt4.Arrow_Type);

   procedure Set_Auto_Raise
    (Self : not null access Q_Tool_Button'Class;
     Enable : Standard.Boolean);

   procedure Set_Menu
    (Self : not null access Q_Tool_Button'Class;
     Menu : not null access Qt4.Menus.Q_Menu'Class);

   procedure Set_Popup_Mode
    (Self : not null access Q_Tool_Button'Class;
     Mode : Qt4.Tool_Buttons.Tool_Button_Popup_Mode);

   function Tool_Button_Style
    (Self : not null access constant Q_Tool_Button'Class)
       return Qt4.Tool_Button_Style;

   procedure Set_Default_Action
    (Self : not null access Q_Tool_Button'Class;
     Action : not null access Qt4.Actions.Q_Action'Class);

   procedure Set_Tool_Button_Style
    (Self : not null access Q_Tool_Button'Class;
     Style : Qt4.Tool_Button_Style);

   procedure Show_Menu
    (Self : not null access Q_Tool_Button'Class);

   package Q_Tool_Button_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Tool_Button, Q_Tool_Button_Access);

   type Q_Tool_Button_Pointer is
     new Q_Tool_Button_Pointers.Q_Pointer with null record;

end Qt4.Tool_Buttons;
