------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Item_Views;
with Qt4.Model_Indices;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Tree_Views is

   type Q_Tree_View is limited interface
     and Qt4.Abstract_Item_Views.Q_Abstract_Item_View;

   type Q_Tree_View_Access is
     access all Q_Tree_View'Class;
   for Q_Tree_View_Access'Storage_Size use 0;

   type Q_Tree_View_Pointer is tagged;

   function All_Columns_Show_Focus
    (Self : not null access constant Q_Tree_View'Class)
       return Standard.Boolean;

   function Column_At
    (Self : not null access constant Q_Tree_View'Class;
     X : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Column_Viewport_Position
    (Self : not null access constant Q_Tree_View'Class;
     Column : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Column_Width
    (Self : not null access constant Q_Tree_View'Class;
     Column : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Indentation
    (Self : not null access constant Q_Tree_View'Class)
       return Qt4.Q_Integer;

   function Index_Above
    (Self : not null access constant Q_Tree_View'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index;

   function Index_Below
    (Self : not null access constant Q_Tree_View'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index;

   function Is_Animated
    (Self : not null access constant Q_Tree_View'Class)
       return Standard.Boolean;

   function Is_Column_Hidden
    (Self : not null access constant Q_Tree_View'Class;
     Column : Qt4.Q_Integer)
       return Standard.Boolean;

   function Is_Expanded
    (Self : not null access constant Q_Tree_View'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   function Is_Row_Hidden
    (Self : not null access constant Q_Tree_View'Class;
     Row : Qt4.Q_Integer;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   function Is_Sorting_Enabled
    (Self : not null access constant Q_Tree_View'Class)
       return Standard.Boolean;

   function Items_Expandable
    (Self : not null access constant Q_Tree_View'Class)
       return Standard.Boolean;

   function Root_Is_Decorated
    (Self : not null access constant Q_Tree_View'Class)
       return Standard.Boolean;

   procedure Set_All_Columns_Show_Focus
    (Self : not null access Q_Tree_View'Class;
     Enable : Standard.Boolean);

   procedure Set_Animated
    (Self : not null access Q_Tree_View'Class;
     Enable : Standard.Boolean);

   procedure Set_Column_Hidden
    (Self : not null access Q_Tree_View'Class;
     Column : Qt4.Q_Integer;
     Hide : Standard.Boolean);

   procedure Set_Column_Width
    (Self : not null access Q_Tree_View'Class;
     Column : Qt4.Q_Integer;
     Width : Qt4.Q_Integer);

   procedure Set_Expanded
    (Self : not null access Q_Tree_View'Class;
     Index : Qt4.Model_Indices.Q_Model_Index;
     Expand : Standard.Boolean);

   procedure Set_First_Column_Spanned
    (Self : not null access Q_Tree_View'Class;
     Row : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     Span : Standard.Boolean);

   procedure Set_Indentation
    (Self : not null access Q_Tree_View'Class;
     I : Qt4.Q_Integer);

   procedure Set_Items_Expandable
    (Self : not null access Q_Tree_View'Class;
     Enable : Standard.Boolean);

   procedure Set_Root_Is_Decorated
    (Self : not null access Q_Tree_View'Class;
     Enable : Standard.Boolean);

   procedure Set_Row_Hidden
    (Self : not null access Q_Tree_View'Class;
     Row : Qt4.Q_Integer;
     Index : Qt4.Model_Indices.Q_Model_Index;
     Hide : Standard.Boolean);

   procedure Set_Sorting_Enabled
    (Self : not null access Q_Tree_View'Class;
     Enable : Standard.Boolean);

   procedure Set_Uniform_Row_Heights
    (Self : not null access Q_Tree_View'Class;
     Uniform : Standard.Boolean);

   function Uniform_Row_Heights
    (Self : not null access Q_Tree_View'Class)
       return Standard.Boolean;

   procedure Collapse
    (Self : not null access Q_Tree_View'Class;
     Index : Qt4.Model_Indices.Q_Model_Index);

   procedure Collapse_All
    (Self : not null access Q_Tree_View'Class);

   procedure Expand
    (Self : not null access Q_Tree_View'Class;
     Index : Qt4.Model_Indices.Q_Model_Index);

   procedure Expand_All
    (Self : not null access Q_Tree_View'Class);

   procedure Hide_Column
    (Self : not null access Q_Tree_View'Class;
     Column : Qt4.Q_Integer);

   procedure Resize_Column_To_Contents
    (Self : not null access Q_Tree_View'Class;
     Column : Qt4.Q_Integer);

   procedure Show_Column
    (Self : not null access Q_Tree_View'Class;
     Column : Qt4.Q_Integer);

   package Q_Tree_View_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Tree_View, Q_Tree_View_Access);

   type Q_Tree_View_Pointer is
     new Q_Tree_View_Pointers.Q_Pointer with null record;

end Qt4.Tree_Views;
