------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3690 $ $Date: 2010-01-03 16:05:03 +0300 (Sun, 03 Jan 2010) $
------------------------------------------------------------------------------
--  This unit provides low level interface for interfacing between the
--  QGraphicsItem C++ obejcts and Ada objects.
------------------------------------------------------------------------------
with Qt4.Graphics_Items;
with Qt_Ada.Internals.Graphics_Items;

package Qt_Ada.Internals.Graphics_Item_Registry is

   function To_Q_Graphics_Item
    (Item : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return not null access
         Qt_Ada.Internals.Graphics_Items.Q_Graphics_Item_Base'Class;
   --  Returns associated Ada obejct or creates appropriate proxy Ada obejct,
   --  associate it and returns it.

   type Graphics_Item_Proxy_Constructor is
     access function
      (Object : not null Qt_Ada.Internals.Graphics_Items.QGraphicsItem_Access)
         return not null
           Qt_Ada.Internals.Graphics_Items.Q_Graphics_Item_Base_Access;

   procedure Register_QGraphicsItem_Subclass
    (Class_Type  : Qt4.Graphics_Items.Graphics_Item_Type;
     Constructor : Graphics_Item_Proxy_Constructor);

end Qt_Ada.Internals.Graphics_Item_Registry;
