------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Ada.Unchecked_Deallocation;

package body Qt_Ada.Internals.Graphics_Items is

   procedure associate
    (Cpp_Object : not null Qt_Ada.Internals.Graphics_Items.QGraphicsItem_Access;
     Ada_Object : not null
       Qt_Ada.Internals.Graphics_Items.Q_Graphics_Item_Base_Access);
   pragma Import
    (C, associate, "__QtAda_associate_Q_Graphics_Item_Impl");
   pragma Warnings (Off, associate);

   procedure Free_Q_Graphics_Item_Impl
    (Self : not null
      Qt_Ada.Internals.Graphics_Items.Q_Graphics_Item_Base_Access);
   pragma Export
    (C, Free_Q_Graphics_Item_Impl, "__QtAda_free_Q_Graphics_Item_Impl");
   pragma Warnings (Off, Free_Q_Graphics_Item_Impl);

   -------------------------------
   -- Free_Q_Graphics_Item_Impl --
   -------------------------------

   procedure Free_Q_Graphics_Item_Impl
    (Self : not null
      Qt_Ada.Internals.Graphics_Items.Q_Graphics_Item_Base_Access)
   is
      use type QGraphicsItem_Access;

      procedure Free is
        new Ada.Unchecked_Deallocation
             (Qt_Ada.Internals.Graphics_Items.Q_Graphics_Item_Base'Class,
              Qt_Ada.Internals.Graphics_Items.Q_Graphics_Item_Base_Access);

      Impl : Q_Graphics_Item_Impl_Base'Class
        renames Q_Graphics_Item_Impl_Base'Class (Self.all);
      Aux  : Qt_Ada.Internals.Graphics_Items.Q_Graphics_Item_Base_Access := Self;

   begin
      if Impl.Object /= null then
         Impl.Finalize;
         Impl.Object := null;
         Free (Aux);
      end if;
   end Free_Q_Graphics_Item_Impl;

   ----------------
   -- Initialize --
   ----------------

   procedure Initialize
    (Self   : not null access Q_Graphics_Item_Base'Class;
     Object : not null QGraphicsItem_Access)
   is
   begin
      if Self.all in Q_Graphics_Item_Impl_Base'Class then
         Q_Graphics_Item_Impl_Base'Class (Self.all).Object := Object;
      end if;

      associate (Object, Q_Graphics_Item_Base_Access (Self));
   end Initialize;

   ------------------------
   -- QGraphicsItem_View --
   ------------------------

   overriding function QGraphicsItem_View
    (Self : not null access constant Q_Graphics_Item_Impl_Base)
       return not null QGraphicsItem_Access
   is
   begin
      return Self.Object;
   end QGraphicsItem_View;

end Qt_Ada.Internals.Graphics_Items;
