------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Item_Models;
with Qt4.Abstract_Item_Views;
with Qt4.Item_Selection_Models;
with Qt4.Model_Indices;
with Qt4.Points;
with Qt4.Rects;
with Qt4.Strings;
with Qt_Ada.Internals.Objects.Abstract_Scroll_Area_Proxies;

package Qt_Ada.Internals.Objects.Abstract_Item_View_Proxies is

   pragma Elaborate_Body;

   type Q_Abstract_Item_View_Proxy is
     new Qt_Ada.Internals.Objects.Abstract_Scroll_Area_Proxies.Q_Abstract_Scroll_Area_Proxy
       and Qt4.Abstract_Item_Views.Q_Abstract_Item_View with null record;

   function Index_At
    (Self : not null access constant Q_Abstract_Item_View_Proxy;
     Point : Qt4.Points.Q_Point)
       return Qt4.Model_Indices.Q_Model_Index;

   procedure Keyboard_Search
    (Self : not null access Q_Abstract_Item_View_Proxy;
     Search : Qt4.Strings.Q_String);

   procedure Scroll_To
    (Self : not null access Q_Abstract_Item_View_Proxy;
     Index : Qt4.Model_Indices.Q_Model_Index;
     Hint : Qt4.Abstract_Item_Views.Abstract_Item_View_Scroll_Hint);

   procedure Set_Model
    (Self : not null access Q_Abstract_Item_View_Proxy;
     Model : not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class);

   procedure Set_Selection_Model
    (Self : not null access Q_Abstract_Item_View_Proxy;
     Selection_Model : not null access Qt4.Item_Selection_Models.Q_Item_Selection_Model'Class);

   function Size_Hint_For_Column
    (Self : not null access constant Q_Abstract_Item_View_Proxy;
     Column : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Size_Hint_For_Row
    (Self : not null access constant Q_Abstract_Item_View_Proxy;
     Row : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Visual_Rect
    (Self : not null access constant Q_Abstract_Item_View_Proxy;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Rects.Q_Rect;

   procedure Reset
    (Self : not null access Q_Abstract_Item_View_Proxy);

   procedure Select_All
    (Self : not null access Q_Abstract_Item_View_Proxy);

   procedure Set_Root_Index
    (Self : not null access Q_Abstract_Item_View_Proxy;
     Index : Qt4.Model_Indices.Q_Model_Index);

end Qt_Ada.Internals.Objects.Abstract_Item_View_Proxies;
