------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3698 $ $Date: 2010-01-03 18:12:05 +0300 (Sun, 03 Jan 2010) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;

package body Qt_Ada.Internals.Objects.Graphics_Object_Utilities is

   -------------------------------------
   -- Corresponding_Q_Graphics_Object --
   -------------------------------------

   function Corresponding_Q_Graphics_Object
    (Item : access Qt_Ada.Internals.Objects.QObject)
       return access Qt4.Graphics_Objects.Q_Graphics_Object'Class
   is
   begin
      if Item = null then
         return null;
      end if;

      return
        Qt4.Graphics_Objects.Q_Graphics_Object'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object (Item).all)'Access;
   end Corresponding_Q_Graphics_Object;

end Qt_Ada.Internals.Objects.Graphics_Object_Utilities;
