//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2733 $ $Date: 2008-05-14 08:54:18 +0400 (Wed, 14 May 2008) $
//----------------------------------------------------------------------------
#include "qtextcursorwrapper.h"

#include <QObject>
#include <QTextFrame>
#include <QTextTableFormat>
#include <QTextCharFormat>

extern "C"
{

    QTextCursor* __Qt4Ada_new_QTextCursor ()
    {
        return new QTextCursor ();
    }

    QTextCursor* __Qt4Ada_copy_QTextCursor (const QTextCursor* cpp_object)
    {
        return new QTextCursor (*cpp_object);
    }

    void __Qt4Ada_delete_QTextCursor (QTextCursor* cpp_object)
    {
        delete cpp_object;
    }

    void __Qt4Ada_assign_QTextCursor (QTextCursor*p1, const QTextCursor*p2)
    {
       *p1 = *p2;
    }

    bool __Qt4Ada_movePosition_wrapper (QTextCursor* cursor,
                                        unsigned     operation,
                                        unsigned     mode,
                                        int          n)
   {
        return cursor->movePosition ((QTextCursor::MoveOperation) operation,
                                     (QTextCursor::MoveMode)mode,
                                     n);
   }

   void __Qt4Ada_insertBlock_wrapper (QTextCursor* cursor)
   {
        return cursor->insertBlock();
   }

   bool __Qt4Ada_isNull_wrapper (QTextCursor*cursor)
   {
       return cursor->isNull ();
   }

   void __Qt4Ada_beginEditBlock_wrapper (QTextCursor*cursor)
   {
        cursor->beginEditBlock ();
   }

   void __Qt4Ada_endEditBlock_wrapper (QTextCursor*cursor)
   {
        cursor->endEditBlock ();
   }

   void __Qt4Ada_insertText_0_wrapper (QTextCursor*cursor, const QString *text)
   {
        cursor-> insertText (*text);
   }
   void __Qt4Ada_insertText_1_wrapper (QTextCursor*cursor, const QString * text, const QTextFormat * format)
   {
        cursor->insertText (*text, *(static_cast<const QTextCharFormat*>(format)));
   }

    void __Qt4Ada_setPosition_wrapper (QTextCursor*cpp_object, int pos, unsigned m)
    {
         cpp_object->setPosition (pos, (QTextCursor::MoveMode)m);
    }

   QObject* __Qt4Ada_QTextCursor_currentFrame_wrapper (QTextCursor*cpp_object)
   {
         return (dynamic_cast<QObject*>(cpp_object->currentFrame()));
   }

    void __Qt4Ada_QTextCursor_insertTable_0_wrapper (QTextCursor*cpp_object, int row, int col)
    {
         cpp_object->insertTable (row, col);
    }

    void __Qt4Ada_QTextCursor_insertTable_1_wrapper (QTextCursor*cpp_object, int row, int col, QTextFormat* format)
    {
       cpp_object->insertTable (row, col, *(static_cast<QTextTableFormat*>(format)));
    }

}
