//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QLine>
#include <QLineF>
#include <QMatrix>
#include <QPainterPath>
#include <QPoint>
#include <QPointF>
#include <QPolygon>
#include <QPolygonF>
#include <QRect>
#include <QRectF>
#include <QRegion>
#include <QString>
#include <QTransform>
#include "qtransformwrapper.h"

extern "C"
{

    QTransform* __QtAda_inititialize_QTransform(void* storage)
    {
        return new (storage) QTransform();
    }

    QTransform* __QtAda_inititialize_QTransform_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal(void* storage, double h11, double h12, double h13, double h21, double h22, double h23, double h31, double h32, double h33)
    {
        return new (storage) QTransform((qreal)h11, (qreal)h12, (qreal)h13, (qreal)h21, (qreal)h22, (qreal)h23, (qreal)h31, (qreal)h32, (qreal)h33);
    }

    QTransform* __QtAda_inititialize_QTransform_qreal_qreal_qreal_qreal_qreal_qreal(void* storage, double h11, double h12, double h21, double h22, double dx, double dy)
    {
        return new (storage) QTransform((qreal)h11, (qreal)h12, (qreal)h21, (qreal)h22, (qreal)dx, (qreal)dy);
    }

    QTransform* __QtAda_inititialize_QTransform_QMatrixCR(void* storage, const QMatrix* tx)
    {
        return new (storage) QTransform(*tx);
    }

    QTransform* __QtAda_adjust_QTransform(void* storage, const QTransform* from)
    {
        return new (storage) QTransform(*from);
    }

    void __QtAda_finalize_QTransform(QTransform *item)
    {
        item->~QTransform();
    }

    double __QtAda_QTransform_m11_Q(const QTransform* self)
    {
        return (double)self->m11();
    }

    double __QtAda_QTransform_m12_Q(const QTransform* self)
    {
        return (double)self->m12();
    }

    double __QtAda_QTransform_m13_Q(const QTransform* self)
    {
        return (double)self->m13();
    }

    double __QtAda_QTransform_m21_Q(const QTransform* self)
    {
        return (double)self->m21();
    }

    double __QtAda_QTransform_m22_Q(const QTransform* self)
    {
        return (double)self->m22();
    }

    double __QtAda_QTransform_m23_Q(const QTransform* self)
    {
        return (double)self->m23();
    }

    double __QtAda_QTransform_m31_Q(const QTransform* self)
    {
        return (double)self->m31();
    }

    double __QtAda_QTransform_m32_Q(const QTransform* self)
    {
        return (double)self->m32();
    }

    double __QtAda_QTransform_m33_Q(const QTransform* self)
    {
        return (double)self->m33();
    }

    void __QtAda_QTransform_adjoint_Q(QTransform* returns, const QTransform* self)
    {
        *returns = self->adjoint();
    }

    double __QtAda_QTransform_det_Q(const QTransform* self)
    {
        return (double)self->det();
    }

    double __QtAda_QTransform_determinant_Q(const QTransform* self)
    {
        return (double)self->determinant();
    }

    double __QtAda_QTransform_dx_Q(const QTransform* self)
    {
        return (double)self->dx();
    }

    double __QtAda_QTransform_dy_Q(const QTransform* self)
    {
        return (double)self->dy();
    }

    void __QtAda_QTransform_inverted_Q(QTransform* returns, const QTransform* self)
    {
        *returns = self->inverted();
    }

    unsigned __QtAda_QTransform_isAffine_Q(const QTransform* self)
    {
        return (unsigned)self->isAffine();
    }

    unsigned __QtAda_QTransform_isIdentity_Q(const QTransform* self)
    {
        return (unsigned)self->isIdentity();
    }

    unsigned __QtAda_QTransform_isInvertible_Q(const QTransform* self)
    {
        return (unsigned)self->isInvertible();
    }

    unsigned __QtAda_QTransform_isRotating_Q(const QTransform* self)
    {
        return (unsigned)self->isRotating();
    }

    unsigned __QtAda_QTransform_isScaling_Q(const QTransform* self)
    {
        return (unsigned)self->isScaling();
    }

    unsigned __QtAda_QTransform_isTranslating_Q(const QTransform* self)
    {
        return (unsigned)self->isTranslating();
    }

    void __QtAda_QTransform_map_qreal_qreal_qrealP_qrealP_Q(const QTransform* self, double x, double y, double* tx, double* ty)
    {
        self->map((qreal)x, (qreal)y, tx, ty);
    }

    void __QtAda_QTransform_map_int_int_intP_intP_Q(const QTransform* self, int x, int y, int* tx, int* ty)
    {
        self->map(x, y, tx, ty);
    }

    void __QtAda_QTransform_map_QPointCR_Q(QPoint* returns, const QTransform* self, const QPoint* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QTransform_map_QPointFCR_Q(QPointF* returns, const QTransform* self, const QPointF* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QTransform_map_QLineCR_Q(QLine* returns, const QTransform* self, const QLine* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QTransform_map_QLineFCR_Q(QLineF* returns, const QTransform* self, const QLineF* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QTransform_map_QPolygonCR_Q(QPolygon* returns, const QTransform* self, const QPolygon* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QTransform_map_QPolygonFCR_Q(QPolygonF* returns, const QTransform* self, const QPolygonF* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QTransform_map_QRegionCR_Q(QRegion* returns, const QTransform* self, const QRegion* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QTransform_map_QPainterPathCR_Q(QPainterPath* returns, const QTransform* self, const QPainterPath* p)
    {
        *returns = self->map(*p);
    }

    void __QtAda_QTransform_mapRect_QRectCR_Q(QRect* returns, const QTransform* self, const QRect* p)
    {
        *returns = self->mapRect(*p);
    }

    void __QtAda_QTransform_mapRect_QRectFCR_Q(QRectF* returns, const QTransform* self, const QRectF* p)
    {
        *returns = self->mapRect(*p);
    }

    void __QtAda_QTransform_mapToPolygon_QRectCR_Q(QPolygon* returns, const QTransform* self, const QRect* p)
    {
        *returns = self->mapToPolygon(*p);
    }

    void __QtAda_QTransform_reset(QTransform* self)
    {
        self->reset();
    }

    void __QtAda_QTransform_rotate_qreal_Axis(QTransform* self, double a, unsigned axis)
    {
        self->rotate((qreal)a, (Qt::Axis)axis);
    }

    void __QtAda_QTransform_rotateRadians_qreal_Axis(QTransform* self, double a, unsigned axis)
    {
        self->rotateRadians((qreal)a, (Qt::Axis)axis);
    }

    void __QtAda_QTransform_scale_qreal_qreal(QTransform* self, double sx, double sy)
    {
        self->scale((qreal)sx, (qreal)sy);
    }

    void __QtAda_QTransform_setMatrix_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal(QTransform* self, double m11, double m12, double m13, double m21, double m22, double m23, double m31, double m32, double m33)
    {
        self->setMatrix((qreal)m11, (qreal)m12, (qreal)m13, (qreal)m21, (qreal)m22, (qreal)m23, (qreal)m31, (qreal)m32, (qreal)m33);
    }

    void __QtAda_QTransform_shear_qreal_qreal(QTransform* self, double sh, double sv)
    {
        self->shear((qreal)sh, (qreal)sv);
    }

    void __QtAda_QTransform_toAffine_Q(QMatrix* returns, const QTransform* self)
    {
        *returns = self->toAffine();
    }

    void __QtAda_QTransform_translate_qreal_qreal(QTransform* self, double dx, double dy)
    {
        self->translate((qreal)dx, (qreal)dy);
    }

    void __QtAda_QTransform_transposed_Q(QTransform* returns, const QTransform* self)
    {
        *returns = self->transposed();
    }

    unsigned __QtAda_QTransform_eq_QTransformCR_Q(const QTransform* self, const QTransform* matrix)
    {
        return (unsigned)self->operator==(*matrix);
    }

    void __QtAda_QTransform_multiplication_QTransformCR_Q(QTransform* returns, const QTransform* self, const QTransform* o)
    {
        *returns = self->operator*(*o);
    }

    void __QtAda_multiplication_QPointCR_QTransformCR(QPoint* returns, const QPoint* p, const QTransform* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QPointFCR_QTransformCR(QPointF* returns, const QPointF* p, const QTransform* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QLineCR_QTransformCR(QLine* returns, const QLine* p, const QTransform* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QLineFCR_QTransformCR(QLineF* returns, const QLineF* p, const QTransform* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QPolygonCR_QTransformCR(QPolygon* returns, const QPolygon* p, const QTransform* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QPolygonFCR_QTransformCR(QPolygonF* returns, const QPolygonF* p, const QTransform* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QRegionCR_QTransformCR(QRegion* returns, const QRegion* p, const QTransform* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QPainterPathCR_QTransformCR(QPainterPath* returns, const QPainterPath* p, const QTransform* m)
    {
        *returns = operator*(*p, *m);
    }

    void __QtAda_multiplication_QTransformCR_qreal(QTransform* returns, const QTransform* a, double n)
    {
        *returns = operator*(*a, (qreal)n);
    }

    void __QtAda_division_QTransformCR_qreal(QTransform* returns, const QTransform* a, double n)
    {
        *returns = operator/(*a, (qreal)n);
    }

    void __QtAda_plus_QTransformCR_qreal(QTransform* returns, const QTransform* a, double n)
    {
        *returns = operator+(*a, (qreal)n);
    }

    void __QtAda_minus_QTransformCR_qreal(QTransform* returns, const QTransform* a, double n)
    {
        *returns = operator-(*a, (qreal)n);
    }

};

