//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2733 $ $Date: 2008-05-14 08:54:18 +0400 (Wed, 14 May 2008) $
//----------------------------------------------------------------------------
#include "qsqlrelationwrapper.h"

extern "C"
{

    QSqlRelation* __Qt4Ada_create_QSqlRelation (const QString* tableName,
                                                const QString* indexColumn,
                                                const QString* displayColumn)
    {
        return new QSqlRelation(*tableName, *indexColumn, *displayColumn);
    }

    QSqlRelation* __Qt4Ada_copy_QSqlRelation (const QSqlRelation* cpp_object)
    {
        return new QSqlRelation(*cpp_object);
    }

    void __Qt4Ada_delete_QSqlRelation (QSqlRelation* cpp_object)
    {
        delete cpp_object;
    }

    QSqlRelation* __Qt4Ada_new_QSqlRelation ()
    {
        return new QSqlRelation();
    }

    QString __Qt4Ada_QSqlRelation_displayColumn_wrapper (QSqlRelation* cpp_object)
    {
        return cpp_object->indexColumn();
    }

    QString __Qt4Ada_QSqlRelation_indexColumn_wrapper (QSqlRelation* cpp_object)
    {
        return cpp_object->indexColumn();
    }

    bool __Qt4Ada_QSqlRelation_isValid_wrapper (QSqlRelation* cpp_object)
    {
        return cpp_object->isValid();
    }

    QString __Qt4Ada_QSqlRelation_tableName_wrapper (QSqlRelation* cpp_object)
    {
        return cpp_object->tableName();
    }
    void __Qt4Ada_assign_QSqlRelation(QSqlRelation* r1, QSqlRelation* r2)
    {
        *r1 = *r2;
    }
}
