//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2733 $ $Date: 2008-05-14 08:54:18 +0400 (Wed, 14 May 2008) $
//----------------------------------------------------------------------------
#ifndef __QSQLRELATIONWRAPPER_H__
#define __QSQLRELATIONWRAPPER_H__

#include <QSqlRelation>

extern "C"
{
    // Constructors

    extern QSqlRelation* __Qt4Ada_create_QSqlRelation(const QString*,
                                                      const QString*,
                                                      const QString*);

    extern QSqlRelation* __Qt4Ada_new_QSqlRelation();
    extern QSqlRelation* __Qt4Ada_copy_QSqlRelation(const QSqlRelation*);
    extern void          __Qt4Ada_delete_QSqlRelation(QSqlRelation*);
    extern void          __Qt4Ada_assign_QSqlRelation(QSqlRelation*, QSqlRelation*);

    //  Public Functions

    extern QString __Qt4Ada_QSqlRelation_displayColumn_wrapper (QSqlRelation*);
    extern QString __Qt4Ada_QSqlRelation_indexColumn_wrapper (QSqlRelation*);
    extern bool __Qt4Ada_QSqlRelation_isValid_wrapper (QSqlRelation*);
    extern QString __Qt4Ada_QSqlRelation_tableName_wrapper (QSqlRelation*);

}

#endif // __QSQLRELATIONWRAPPER_H__
