------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Sql_Relational_Table_Models.Constructors is

   function new_QSqlRelationalTableModel
    (Parent : access Qt_Ada.Internals.Objects.QObject;
     DB     : not null access Qt4.Sql_Databases.Internals.QSqlDatabase)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import
    (C, new_QSqlRelationalTableModel, "__Qt4Ada_new_QSqlRelationalTableModel");

   ------------
   -- Create --
   ------------

   function Create (Parent : access Qt4.Objects.Q_Object'Class := null;
                    DB     : Qt4.Sql_Databases.Q_Sql_Database
                      := Qt4.Sql_Databases.Create)
     return not null
       Qt4.Sql_Relational_Table_Models.Q_Sql_Relational_Table_Model_Access
   is
   begin
      return
        Qt4.Sql_Relational_Table_Models.Q_Sql_Relational_Table_Model_Access
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (new_QSqlRelationalTableModel
             (Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
               (Parent),
              Qt4.Sql_Databases.Internals.QSqlDatabase_View (DB))));
   end Create;

end Qt4.Sql_Relational_Table_Models.Constructors;
