------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Qt4.Strings;
with Qt4_Entities;

package Qt4.Sql_Relations is

   package Thin is

      subtype QSqlRelation is Qt4_Entities.Cpp_Class;

      function copy_QSqlRelation (Cpp_Object : not null access QSqlRelation)
        return not null access QSqlRelation;
      pragma Import (C, copy_QSqlRelation, "__Qt4Ada_copy_QSqlRelation");

   end Thin;

   type Q_Sql_Relation is new Qt4_Entities.Entity with private;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Create
   --!    <Purpose> Возвращает новый экземпляр класса QSqlRelation
   --! с заданными параметрами.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function Create (Table_Name     : Qt4.Strings.Q_String;
                    Index_Column   : Qt4.Strings.Q_String;
                    Display_Column : Qt4.Strings.Q_String)
     return Q_Sql_Relation;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Display_Column
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function Display_Column (Self : Q_Sql_Relation)
     return Qt4.Strings.Q_String;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Index_Column
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function Index_Column (Self : Q_Sql_Relation)
     return Qt4.Strings.Q_String;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Is_Valid
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function Is_Valid (Self : Q_Sql_Relation)
     return Boolean;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Table_Name
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   function Table_Name (Self : Q_Sql_Relation)
     return Qt4.Strings.Q_String;

   package Internals is

      ------------------------------------------------------------------------
      --! <Subprogram>
      --!    <Unit> Cpp_Object
      --!    <Purpose> Возвращает ссылку на ассоциированный объект C++.
      --! Вместо этой подпрограммы необходимо использовать QSqlDatabase_View.
      --! Со временем эта подпрограмма будет удалена.
      --!    <Exceptions>
      ------------------------------------------------------------------------
      function Cpp_Object (Self : Q_Sql_Relation)
        return not null access Thin.QSqlRelation;

      ------------------------------------------------------------------------
      --! <Subprogram>
      --!    <Unit> QSqlDatabase_View
      --!    <Purpose> Возвращает ссылку на ассоциированный объект C++.
      --!    <Exceptions>
      ------------------------------------------------------------------------
      function QSqlRelation_View (Self : Q_Sql_Relation)
        return not null access Thin.QSqlRelation
          renames Cpp_Object;

       ------------------------------------------------------------------------
      --! <Subprogram>
      --!    <Unit> To_Q_Sql_Relation
      --!    <Purpose>
      --!    <Exceptions>
      ------------------------------------------------------------------------
      function To_Q_Sql_Relation (Item : not null access Thin.QSqlRelation)
        return Q_Sql_Relation;

   end Internals;

private

   type Q_Sql_Relation is new Qt4_Entities.Entity with null record;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Copy_Cpp_Object
   --!    <Purpose> Производит создание копии ассоциированного объекта C++.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   function Copy_Cpp_Object (Self : not null access Q_Sql_Relation)
     return not null access Qt4_Entities.Cpp_Class;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Default_Cpp_Object
   --!    <Purpose> Возвращает новый пустой экземпляр класса Q_SQL_Relation.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   function Default_Cpp_Object (Self : not null access Q_Sql_Relation)
     return access Qt4_Entities.Cpp_Class;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Delete_Cpp_Object
   --!    <Purpose> Осуществляет уничтожение ассоциированного объекта C++.
   --!    <Exceptions>
   ---------------------------------------------------------------------------
   overriding
   procedure Delete_Cpp_Object (Self : not null access Q_Sql_Relation);

end Qt4.Sql_Relations;
