------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Child_Events;
limited with Qt4.Events;
with Qt4.Meta_Objects;
limited with Qt4.Objects;
with Qt4.Sql_Query_Models.Directors;
limited with Qt4.Timer_Events;

package Qt4.Sql_Table_Models.Directors is

   type Q_Sql_Table_Model_Director is
     new Qt4.Sql_Query_Models.Directors.Q_Sql_Query_Model_Director
       and Q_Sql_Table_Model with null record;

   overriding
   function Insert_Rows
    (Self : not null access Q_Sql_Table_Model_Director;
     Row : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean;

   overriding
   function Remove_Columns
    (Self : not null access Q_Sql_Table_Model_Director;
     Column : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean;

   overriding
   function Remove_Rows
    (Self : not null access Q_Sql_Table_Model_Director;
     Row : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean;

   overriding
   procedure Revert_Row
    (Self : not null access Q_Sql_Table_Model_Director;
     Row : Qt4.Q_Integer);

   overriding
   function Select_Query
    (Self : not null access Q_Sql_Table_Model_Director)
       return Standard.Boolean;

   overriding
   procedure Set_Edit_Strategy
    (Self : not null access Q_Sql_Table_Model_Director;
     Strategy : Qt4.Sql_Table_Models.Sql_Table_Model_Edit_Strategy);

   overriding
   procedure Set_Filter
    (Self : not null access Q_Sql_Table_Model_Director;
     Filter : Qt4.Strings.Q_String);

   overriding
   procedure Set_Sort
    (Self : not null access Q_Sql_Table_Model_Director;
     Column : Qt4.Q_Integer;
     Order : Qt4.Sort_Order);

   overriding
   procedure Set_Table
    (Self : not null access Q_Sql_Table_Model_Director;
     Table_Name : Qt4.Strings.Q_String);

   overriding
   procedure Sort
    (Self : not null access Q_Sql_Table_Model_Director;
     Column : Qt4.Q_Integer;
     Order : Qt4.Sort_Order);

   overriding
   procedure Revert
    (Self : not null access Q_Sql_Table_Model_Director);

   overriding
   function Submit
    (Self : not null access Q_Sql_Table_Model_Director)
       return Standard.Boolean;

   not overriding
   procedure Emit_Before_Delete
    (Self : not null access Q_Sql_Table_Model_Director;
     Row : Qt4.Q_Integer);

   not overriding
   function Delete_Row_From_Table
    (Self : not null access Q_Sql_Table_Model_Director;
     Row : Qt4.Q_Integer)
       return Standard.Boolean;

   overriding
   function Index_In_Query
    (Self : not null access constant Q_Sql_Table_Model_Director;
     Item : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index;

   not overriding
   function Order_By_Clause
    (Self : not null access constant Q_Sql_Table_Model_Director)
       return Qt4.Strings.Q_String;

   not overriding
   function Select_Statement
    (Self : not null access constant Q_Sql_Table_Model_Director)
       return Qt4.Strings.Q_String;

   overriding
   procedure Query_Change
    (Self : not null access Q_Sql_Table_Model_Director);

   overriding
   procedure Emit_Data_Changed
    (Self : not null access Q_Sql_Table_Model_Director;
     Top_Left : Qt4.Model_Indices.Q_Model_Index;
     Bottom_Right : Qt4.Model_Indices.Q_Model_Index);

   overriding
   procedure Emit_Header_Data_Changed
    (Self : not null access Q_Sql_Table_Model_Director;
     Orientation : Qt4.Orientation;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   overriding
   procedure Emit_Layout_About_To_Be_Changed
    (Self : not null access Q_Sql_Table_Model_Director);

   overriding
   procedure Emit_Layout_Changed
    (Self : not null access Q_Sql_Table_Model_Director);

   overriding
   procedure Begin_Insert_Columns
    (Self : not null access Q_Sql_Table_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   overriding
   procedure Begin_Insert_Rows
    (Self : not null access Q_Sql_Table_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   overriding
   function Begin_Move_Columns
    (Self : not null access Q_Sql_Table_Model_Director;
     Source_Parent : Qt4.Model_Indices.Q_Model_Index;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : Qt4.Model_Indices.Q_Model_Index;
     Destination_Child : Qt4.Q_Integer)
       return Standard.Boolean;

   overriding
   function Begin_Move_Rows
    (Self : not null access Q_Sql_Table_Model_Director;
     Source_Parent : Qt4.Model_Indices.Q_Model_Index;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : Qt4.Model_Indices.Q_Model_Index;
     Destination_Child : Qt4.Q_Integer)
       return Standard.Boolean;

   overriding
   procedure Begin_Remove_Columns
    (Self : not null access Q_Sql_Table_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   overriding
   procedure Begin_Remove_Rows
    (Self : not null access Q_Sql_Table_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   overriding
   procedure Begin_Reset_Model
    (Self : not null access Q_Sql_Table_Model_Director);

   overriding
   procedure Change_Persistent_Index
    (Self : not null access Q_Sql_Table_Model_Director;
     From : Qt4.Model_Indices.Q_Model_Index;
     To : Qt4.Model_Indices.Q_Model_Index);

   overriding
   procedure End_Insert_Columns
    (Self : not null access Q_Sql_Table_Model_Director);

   overriding
   procedure End_Insert_Rows
    (Self : not null access Q_Sql_Table_Model_Director);

   overriding
   procedure End_Move_Columns
    (Self : not null access Q_Sql_Table_Model_Director);

   overriding
   procedure End_Move_Rows
    (Self : not null access Q_Sql_Table_Model_Director);

   overriding
   procedure End_Remove_Columns
    (Self : not null access Q_Sql_Table_Model_Director);

   overriding
   procedure End_Remove_Rows
    (Self : not null access Q_Sql_Table_Model_Director);

   overriding
   procedure End_Reset_Model
    (Self : not null access Q_Sql_Table_Model_Director);

   overriding
   procedure Reset
    (Self : not null access Q_Sql_Table_Model_Director);

   overriding
   procedure Child_Event
    (Self : not null access Q_Sql_Table_Model_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class);

   overriding
   procedure Custom_Event
    (Self : not null access Q_Sql_Table_Model_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   procedure Timer_Event
    (Self : not null access Q_Sql_Table_Model_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class);

   overriding
   function Sender
    (Self : not null access constant Q_Sql_Table_Model_Director)
       return access Qt4.Objects.Q_Object'Class;

   Static_Meta_Object : access constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C, Static_Meta_Object,
                  "__Qt4Ada_QSqlTableModel_staticMetaObject");

end Qt4.Sql_Table_Models.Directors;
