------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Model_Indices;
with Qt4.Sql_Databases;
with Qt4.Sql_Query_Models;
with Qt4.Sql_Records;
with Qt4.Strings;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Sql_Table_Models is

   type Sql_Table_Model_Edit_Strategy is
    (On_Field_Change,
     On_Row_Change,
     On_Manual_Submit);
   pragma Convention (C, Sql_Table_Model_Edit_Strategy);

   type Q_Sql_Table_Model is limited interface
     and Qt4.Sql_Query_Models.Q_Sql_Query_Model;

   type Q_Sql_Table_Model_Access is
     access all Q_Sql_Table_Model'Class;
   for Q_Sql_Table_Model_Access'Storage_Size use 0;

   type Q_Sql_Table_Model_Pointer is tagged;

   function Database
    (Self : not null access constant Q_Sql_Table_Model'Class)
       return Qt4.Sql_Databases.Q_Sql_Database;

   function Edit_Strategy
    (Self : not null access constant Q_Sql_Table_Model'Class)
       return Qt4.Sql_Table_Models.Sql_Table_Model_Edit_Strategy;

   function Field_Index
    (Self : not null access constant Q_Sql_Table_Model'Class;
     Field_Name : Qt4.Strings.Q_String)
       return Qt4.Q_Integer;

   function Filter
    (Self : not null access constant Q_Sql_Table_Model'Class)
       return Qt4.Strings.Q_String;

   function Insert_Record
    (Self : not null access Q_Sql_Table_Model'Class;
     Row : Qt4.Q_Integer;
     Rec : Qt4.Sql_Records.Q_Sql_Record)
       return Standard.Boolean;

   function Is_Dirty
    (Self : not null access constant Q_Sql_Table_Model'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   not overriding
   procedure Revert_Row
    (Self : not null access Q_Sql_Table_Model;
     Row : Qt4.Q_Integer)
       is abstract;

   not overriding
   function Select_Query
    (Self : not null access Q_Sql_Table_Model)
       return Standard.Boolean
         is abstract;

   not overriding
   procedure Set_Edit_Strategy
    (Self : not null access Q_Sql_Table_Model;
     Strategy : Qt4.Sql_Table_Models.Sql_Table_Model_Edit_Strategy)
       is abstract;

   not overriding
   procedure Set_Filter
    (Self : not null access Q_Sql_Table_Model;
     Filter : Qt4.Strings.Q_String)
       is abstract;

   function Set_Record
    (Self : not null access Q_Sql_Table_Model'Class;
     Row : Qt4.Q_Integer;
     Rec : Qt4.Sql_Records.Q_Sql_Record)
       return Standard.Boolean;

   not overriding
   procedure Set_Sort
    (Self : not null access Q_Sql_Table_Model;
     Column : Qt4.Q_Integer;
     Order : Qt4.Sort_Order)
       is abstract;

   not overriding
   procedure Set_Table
    (Self : not null access Q_Sql_Table_Model;
     Table_Name : Qt4.Strings.Q_String)
       is abstract;

   not overriding
   procedure Sort
    (Self : not null access Q_Sql_Table_Model;
     Column : Qt4.Q_Integer;
     Order : Qt4.Sort_Order)
       is abstract;

   function Table_Name
    (Self : not null access constant Q_Sql_Table_Model'Class)
       return Qt4.Strings.Q_String;

   procedure Revert_All
    (Self : not null access Q_Sql_Table_Model'Class);

   function Submit_All
    (Self : not null access Q_Sql_Table_Model'Class)
       return Standard.Boolean;

   procedure Select_Query (Self : not null access Q_Sql_Table_Model'Class);
   --  Convenience form of the QSqlTableModel::select() function. Raise
   --  Program_Error in the case of failure.

   package Q_Sql_Table_Model_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Sql_Table_Model, Q_Sql_Table_Model_Access);

   type Q_Sql_Table_Model_Pointer is
     new Q_Sql_Table_Model_Pointers.Q_Pointer with null record;

end Qt4.Sql_Table_Models;
