------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3236 $ $Date: 2009-04-10 11:25:49 +0400 (Fri, 10 Apr 2009) $
------------------------------------------------------------------------------

private package Amoc.Analizer.Types is

   procedure Process_Qt_Types;
   --  Searches ASIS context for known Qt types and fill known types table

   function Resolve (Declaration : Asis.Element) return Natural;
   --  Resolve type delaration to internal type identifier.
   --  XXX Replace to Positive in the future!

   function Is_Derived_From_Q_Object_Director
    (Declaration : Asis.Element;
     Only_Public : Boolean)
       return Boolean;
   --  Returns True is specified type derived from Q_Object_Director tagged
   --  type.

end Amoc.Analizer.Types;
