------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3763 $ $Date: 2010-10-23 23:13:06 +0400 (Sat, 23 Oct 2010) $
------------------------------------------------------------------------------
--  GNAT ASIS specific operations.
------------------------------------------------------------------------------
with Asis;

package Amoc.Asis_Implementation_Gnat is

   Asis_Gnat                          : constant Boolean := True;

   Supports_Semantic_Dependence_Order : constant Boolean := False;
   --  ASIS Implementation supports Semantic_Dependence_Order query.
   --  ASIS for GNAT supports this query, but has a bug in the implementation:
   --  control never returns to the caller.

   procedure Prepare_Asis_Context (Context : in out Asis.Context);
   --  Initialize ASIS implementation, associate and open ASIS context.

   procedure Cleanup_Asis_Context (Context : in out Asis.Context);
   --  Dissociate ASIS context, finalize ASIS implementation, cleanup
   --  ALI and tree files.

   function Progenitor_List (Declaration : Asis.Declaration)
     return Asis.Name_List;

   function Has_Null_Exclusion (Element : Asis.Element) return Boolean;

   function Object_Declaration_Subtype
    (Element : Asis.Element) return Asis.Element;

end Amoc.Asis_Implementation_Gnat;
