------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3206 $ $Date: 2009-03-30 16:09:09 +0400 (Mon, 30 Mar 2009) $
------------------------------------------------------------------------------
with Ada.Strings.Unbounded;

package Amoc.Generator is

   use Ada.Strings.Unbounded;

   type Q_Meta_Type_Record is record
      Img : Unbounded_String;
      Id  : Integer;
   end record;

   type Q_Meta_Types_Array is array (1 .. 256) of Q_Meta_Type_Record;

   Types_Array : Q_Meta_Types_Array
    := ((Img =>  To_Unbounded_String ("C_Void"),         Id => 0),
        (Img =>  To_Unbounded_String ("C_Bool"),         Id => 1),
        (Img =>  To_Unbounded_String ("C_Int "),         Id => 2),
        (Img =>  To_Unbounded_String ("C_U_Int"),        Id => 3),
        (Img =>  To_Unbounded_String ("C_Long_Long"),    Id => 4),
        (Img =>  To_Unbounded_String ("C_U_Long_Long"),  Id => 5),
        (Img =>  To_Unbounded_String ("C_Double"),       Id => 6),
        (Img =>  To_Unbounded_String ("Q_Char"),         Id => 7),
        (Img =>  To_Unbounded_String ("Q_Variant_Map"),  Id => 8),
        (Img =>  To_Unbounded_String ("Q_Variant_List"), Id => 9),
        (Img =>  To_Unbounded_String ("Q_String"),       Id => 10),
        (Img =>  To_Unbounded_String ("Q_String_List"),  Id => 11),
        (Img =>  To_Unbounded_String ("Q_Byte_Array"),   Id => 12),
        (Img =>  To_Unbounded_String ("Q_Bit_Array"),    Id => 13),
        (Img =>  To_Unbounded_String ("Q_Date"),         Id => 14),
        (Img =>  To_Unbounded_String ("Q_Time"),         Id => 15),
        (Img =>  To_Unbounded_String ("Q_Date_Time"),    Id => 16),
        (Img =>  To_Unbounded_String ("Q_Url"),          Id => 17),
        (Img =>  To_Unbounded_String ("Q_Locale"),       Id => 18),
        (Img =>  To_Unbounded_String ("Q_Rect"),         Id => 19),
        (Img =>  To_Unbounded_String ("Q_Rect_F"),       Id => 20),
        (Img =>  To_Unbounded_String ("Q_Size"),         Id => 21),
        (Img =>  To_Unbounded_String ("Q_Size_F"),       Id => 22),
        (Img =>  To_Unbounded_String ("Q_Line"),         Id => 23),
        (Img =>  To_Unbounded_String ("Q_Line_F"),       Id => 24),
        (Img =>  To_Unbounded_String ("Q_Point"),        Id => 25),
        (Img =>  To_Unbounded_String ("Q_Point_F"),      Id => 26),
        (Img =>  To_Unbounded_String ("Q_Reg_Exp"),      Id => 27),
--      (Img =>  To_Unbounded_String ("Last_Core_Type"), Id => Last_Core_Type),
--      (Img =>  To_Unbounded_String ("First_Gui_Type"), Id => First_Gui_Type),
        (Img =>  To_Unbounded_String ("Q_Font"),         Id => 64),
        (Img =>  To_Unbounded_String ("Q_Pixmap"),       Id => 65),
        (Img =>  To_Unbounded_String ("Q_Brush"),        Id => 66),
        (Img =>  To_Unbounded_String ("Q_Color"),        Id => 67),
        (Img =>  To_Unbounded_String ("Q_Palette"),      Id => 68),
        (Img =>  To_Unbounded_String ("Q_Icon"),         Id => 69),
        (Img =>  To_Unbounded_String ("Q_Image"),        Id => 70),
        (Img =>  To_Unbounded_String ("Q_Polygon"),      Id => 71),
        (Img =>  To_Unbounded_String ("Q_Region"),       Id => 72),
        (Img =>  To_Unbounded_String ("Q_Bitmap"),       Id => 73),
        (Img =>  To_Unbounded_String ("Q_Cursor"),       Id => 74),
        (Img =>  To_Unbounded_String ("Q_Size_Policy"),  Id => 75),
        (Img =>  To_Unbounded_String ("Q_Key_Sequence"), Id => 76),
        (Img =>  To_Unbounded_String ("Q_Key_Sequence"), Id => 77),
        (Img =>  To_Unbounded_String ("Q_Text_Length"),  Id => 78),
        (Img =>  To_Unbounded_String ("Q_Text_Format"),  Id => 79),
        (Img =>  To_Unbounded_String ("Q_Matrix"),       Id => 80),
--        (Img =>  To_Unbounded_String ("Last_Gui_Type"), Id => Last_Gui_Type),
--        (Img =>  To_Unbounded_String ("First_Core_Ext_Type"),
--                                                  Id => First_Core_Ext_Type),
        (Img =>  To_Unbounded_String ("C_Void_Star"),    Id => 128),
        (Img =>  To_Unbounded_String ("C_Long"),         Id => 129),
        (Img =>  To_Unbounded_String ("C_Short"),        Id => 130),
        (Img =>  To_Unbounded_String ("C_Char"),         Id => 131),
        (Img =>  To_Unbounded_String ("C_U_Long"),       Id => 132),
        (Img =>  To_Unbounded_String ("C_U_Short"),      Id => 133),
        (Img =>  To_Unbounded_String ("C_U_Char"),       Id => 134),
        (Img =>  To_Unbounded_String ("C_Float"),        Id => 135),
        (Img =>  To_Unbounded_String ("Q_Object_Star"),  Id => 136),
        (Img =>  To_Unbounded_String ("Q_Widget_Star"),  Id => 137),
--        (Img =>  To_Unbounded_String ("Last_Core_Ext_Type"),
--                                                   Id => Last_Core_Ext_Type),
--        (Img =>  To_Unbounded_String ("User"),           Id => User),
         others => (Img => To_Unbounded_String (""), Id => -1));

   procedure Generate;

   function Get_Short_Type_Name (Full_Type : String) return String;
   --  Возвращает имя типа без указания пакета.
   --  Qt4.Strings.Q_String => Q_String

end Amoc.Generator;
