------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3056 $ $Date: 2009-01-08 23:27:35 +0300 (Thu, 08 Jan 2009) $
------------------------------------------------------------------------------
with Ada.Containers.Indefinite_Vectors;

package Amoc.Parameters is

   package Wide_String_Vectors is
     new Ada.Containers.Indefinite_Vectors (Positive, Wide_String);

   function Source_File_Name return Wide_String;
   --  Returns the name of the source file.

   function Source_File_Search_Paths return Wide_String_Vectors.Vector;
   --  Returns the vector of the file search paths.

   function Help return Boolean;
   --  Returns True if usage information was requested by the user.

   function Version return Boolean;
   --  Returns True if version information was requested by the user.

   function Verbose return Boolean;
   --  Returns True if verbose output was requsted by the user.

   function Output_Dependencies return Boolean;
   --  Returns True if dependencies output was requested by the user.

end Amoc.Parameters;
