package body Asis.Gela.Elements.Clause.Rep is

   function Mod_Clause_Expression
     (Element : Record_Representation_Clause_Node) return Asis.Expression is
   begin
      return Element.Mod_Clause_Expression;
   end Mod_Clause_Expression;

   procedure Set_Mod_Clause_Expression
     (Element : in out Record_Representation_Clause_Node;
      Value   : in     Asis.Expression) is
   begin
      Element.Mod_Clause_Expression := Value;
   end Set_Mod_Clause_Expression;

   function Component_Clauses
     (Element : Record_Representation_Clause_Node;
      Include_Pragmas : in Boolean := False) return Asis.Element_List is
   begin
      return Primary_Clause_Lists.To_Element_List
        (Element.Component_Clauses, Include_Pragmas);
   end Component_Clauses;

   procedure Set_Component_Clauses
     (Element : in out Record_Representation_Clause_Node;
      Value   : in     Asis.Element) is
   begin
      Element.Component_Clauses := Primary_Clause_Lists.List (Value);
   end Set_Component_Clauses;

   function Component_Clauses_List
     (Element : Record_Representation_Clause_Node) return Asis.Element is
   begin
      return Asis.Element (Element.Component_Clauses);
   end Component_Clauses_List;

   function Representation_Clause_Kind (Element : Record_Representation_Clause_Node)
      return Asis.Representation_Clause_Kinds is
   begin
      return A_Record_Representation_Clause;
   end;

   function Children (Element : access Record_Representation_Clause_Node)
     return Traverse_List is
   begin
      return ((False, Element.Representation_Clause_Name'Access),
        (False, Element.Mod_Clause_Expression'Access),
        (True, Asis.Element (Element.Component_Clauses)));
   end Children;

   function Clone
     (Element : Record_Representation_Clause_Node;
      Parent  : Asis.Element)
     return Asis.Element
   is
      Result : constant Record_Representation_Clause_Ptr := new Record_Representation_Clause_Node;
   begin
      Result.Enclosing_Element := Parent;
      Result.Is_Part_Of_Implicit := Element.Is_Part_Of_Implicit;
      Result.Is_Part_Of_Inherited := Element.Is_Part_Of_Inherited;
      Result.Is_Part_Of_Instance := Element.Is_Part_Of_Instance;
      Result.Start_Position := Element.Start_Position;
      Result.End_Position := Element.End_Position;
      Result.Enclosing_Compilation_Unit :=
        Enclosing_Compilation_Unit (Parent.all);
      Result.Hash := Element.Hash;
      Result.Place := Element.Place;
      return Asis.Element (Result);
   end Clone;

   procedure Copy
     (Source : in     Asis.Element;
      Target : access Record_Representation_Clause_Node;
      Cloner : in     Cloner_Class;
      Parent : in     Asis.Element)
   is
   begin
      Target.Representation_Clause_Name :=
        Copy (Cloner, Representation_Clause_Name (Source.all), Asis.Element (Target));
      Target.Mod_Clause_Expression :=
        Copy (Cloner, Mod_Clause_Expression (Source.all), Asis.Element (Target));
      Set_Component_Clauses
        (Target.all,
         Primary_Clause_Lists.Deep_Copy 
           (Component_Clauses (Source.all), Cloner, Asis.Element (Target)));
   end Copy;

   function Representation_Clause_Expression
     (Element : At_Clause_Node) return Asis.Expression is
   begin
      return Element.Representation_Clause_Expression;
   end Representation_Clause_Expression;

   procedure Set_Representation_Clause_Expression
     (Element : in out At_Clause_Node;
      Value   : in     Asis.Expression) is
   begin
      Element.Representation_Clause_Expression := Value;
   end Set_Representation_Clause_Expression;

   function Representation_Clause_Kind (Element : At_Clause_Node)
      return Asis.Representation_Clause_Kinds is
   begin
      return An_At_Clause;
   end;

   function Children (Element : access At_Clause_Node)
     return Traverse_List is
   begin
      return ((False, Element.Representation_Clause_Name'Access),
        (False, Element.Representation_Clause_Expression'Access));
   end Children;

   function Clone
     (Element : At_Clause_Node;
      Parent  : Asis.Element)
     return Asis.Element
   is
      Result : constant At_Clause_Ptr := new At_Clause_Node;
   begin
      Result.Enclosing_Element := Parent;
      Result.Is_Part_Of_Implicit := Element.Is_Part_Of_Implicit;
      Result.Is_Part_Of_Inherited := Element.Is_Part_Of_Inherited;
      Result.Is_Part_Of_Instance := Element.Is_Part_Of_Instance;
      Result.Start_Position := Element.Start_Position;
      Result.End_Position := Element.End_Position;
      Result.Enclosing_Compilation_Unit :=
        Enclosing_Compilation_Unit (Parent.all);
      Result.Hash := Element.Hash;
      Result.Place := Element.Place;
      return Asis.Element (Result);
   end Clone;

   procedure Copy
     (Source : in     Asis.Element;
      Target : access At_Clause_Node;
      Cloner : in     Cloner_Class;
      Parent : in     Asis.Element)
   is
   begin
      Target.Representation_Clause_Name :=
        Copy (Cloner, Representation_Clause_Name (Source.all), Asis.Element (Target));
      Target.Representation_Clause_Expression :=
        Copy (Cloner, Representation_Clause_Expression (Source.all), Asis.Element (Target));
   end Copy;

   function Representation_Clause_Kind (Element : Attribute_Definition_Clause_Node)
      return Asis.Representation_Clause_Kinds is
   begin
      return An_Attribute_Definition_Clause;
   end;

   function Clone
     (Element : Attribute_Definition_Clause_Node;
      Parent  : Asis.Element)
     return Asis.Element
   is
      Result : constant Attribute_Definition_Clause_Ptr := new Attribute_Definition_Clause_Node;
   begin
      Result.Enclosing_Element := Parent;
      Result.Is_Part_Of_Implicit := Element.Is_Part_Of_Implicit;
      Result.Is_Part_Of_Inherited := Element.Is_Part_Of_Inherited;
      Result.Is_Part_Of_Instance := Element.Is_Part_Of_Instance;
      Result.Start_Position := Element.Start_Position;
      Result.End_Position := Element.End_Position;
      Result.Enclosing_Compilation_Unit :=
        Enclosing_Compilation_Unit (Parent.all);
      Result.Hash := Element.Hash;
      Result.Place := Element.Place;
      return Asis.Element (Result);
   end Clone;

   procedure Copy
     (Source : in     Asis.Element;
      Target : access Attribute_Definition_Clause_Node;
      Cloner : in     Cloner_Class;
      Parent : in     Asis.Element)
   is
   begin
      Target.Representation_Clause_Name :=
        Copy (Cloner, Representation_Clause_Name (Source.all), Asis.Element (Target));
      Target.Representation_Clause_Expression :=
        Copy (Cloner, Representation_Clause_Expression (Source.all), Asis.Element (Target));
   end Copy;

   function Representation_Clause_Kind (Element : Enumeration_Representation_Clause_Node)
      return Asis.Representation_Clause_Kinds is
   begin
      return An_Enumeration_Representation_Clause;
   end;

   function Clone
     (Element : Enumeration_Representation_Clause_Node;
      Parent  : Asis.Element)
     return Asis.Element
   is
      Result : constant Enumeration_Representation_Clause_Ptr := new Enumeration_Representation_Clause_Node;
   begin
      Result.Enclosing_Element := Parent;
      Result.Is_Part_Of_Implicit := Element.Is_Part_Of_Implicit;
      Result.Is_Part_Of_Inherited := Element.Is_Part_Of_Inherited;
      Result.Is_Part_Of_Instance := Element.Is_Part_Of_Instance;
      Result.Start_Position := Element.Start_Position;
      Result.End_Position := Element.End_Position;
      Result.Enclosing_Compilation_Unit :=
        Enclosing_Compilation_Unit (Parent.all);
      Result.Hash := Element.Hash;
      Result.Place := Element.Place;
      return Asis.Element (Result);
   end Clone;

   procedure Copy
     (Source : in     Asis.Element;
      Target : access Enumeration_Representation_Clause_Node;
      Cloner : in     Cloner_Class;
      Parent : in     Asis.Element)
   is
   begin
      Target.Representation_Clause_Name :=
        Copy (Cloner, Representation_Clause_Name (Source.all), Asis.Element (Target));
      Target.Representation_Clause_Expression :=
        Copy (Cloner, Representation_Clause_Expression (Source.all), Asis.Element (Target));
   end Copy;

end Asis.Gela.Elements.Clause.Rep;
