package Asis.Gela.Elements.Defs.Rng is

   --------------------------------------
   -- Discrete_Subtype_Indication_Node --
   --------------------------------------

   type Discrete_Subtype_Indication_Node is 
      new Discrete_Range_Node with private;

   type Discrete_Subtype_Indication_Ptr is
      access all Discrete_Subtype_Indication_Node;
   for Discrete_Subtype_Indication_Ptr'Storage_Pool use Lists.Pool;

   function Get_Subtype_Mark
     (Element : Discrete_Subtype_Indication_Node) return Asis.Expression;

   procedure Set_Subtype_Mark
     (Element : in out Discrete_Subtype_Indication_Node;
      Value   : in     Asis.Expression);

   function Subtype_Constraint
     (Element : Discrete_Subtype_Indication_Node) return Asis.Constraint;

   procedure Set_Subtype_Constraint
     (Element : in out Discrete_Subtype_Indication_Node;
      Value   : in     Asis.Constraint);

   function Discrete_Range_Kind (Element : Discrete_Subtype_Indication_Node)
      return Asis.Discrete_Range_Kinds;

   function Children (Element : access Discrete_Subtype_Indication_Node)
     return Traverse_List;

   function Clone
     (Element : Discrete_Subtype_Indication_Node;
      Parent  : Asis.Element)
     return Asis.Element;

   procedure Copy
     (Source : in     Asis.Element;
      Target : access Discrete_Subtype_Indication_Node;
      Cloner : in     Cloner_Class;
      Parent : in     Asis.Element);

   ---------------------------------------------
   -- Discrete_Range_Attribute_Reference_Node --
   ---------------------------------------------

   type Discrete_Range_Attribute_Reference_Node is 
      new Discrete_Range_Node with private;

   type Discrete_Range_Attribute_Reference_Ptr is
      access all Discrete_Range_Attribute_Reference_Node;
   for Discrete_Range_Attribute_Reference_Ptr'Storage_Pool use Lists.Pool;

   function Range_Attribute
     (Element : Discrete_Range_Attribute_Reference_Node) return Asis.Expression;

   procedure Set_Range_Attribute
     (Element : in out Discrete_Range_Attribute_Reference_Node;
      Value   : in     Asis.Expression);

   function Discrete_Range_Kind (Element : Discrete_Range_Attribute_Reference_Node)
      return Asis.Discrete_Range_Kinds;

   function Children (Element : access Discrete_Range_Attribute_Reference_Node)
     return Traverse_List;

   function Clone
     (Element : Discrete_Range_Attribute_Reference_Node;
      Parent  : Asis.Element)
     return Asis.Element;

   procedure Copy
     (Source : in     Asis.Element;
      Target : access Discrete_Range_Attribute_Reference_Node;
      Cloner : in     Cloner_Class;
      Parent : in     Asis.Element);

   -------------------------------------------
   -- Discrete_Simple_Expression_Range_Node --
   -------------------------------------------

   type Discrete_Simple_Expression_Range_Node is 
      new Discrete_Range_Node with private;

   type Discrete_Simple_Expression_Range_Ptr is
      access all Discrete_Simple_Expression_Range_Node;
   for Discrete_Simple_Expression_Range_Ptr'Storage_Pool use Lists.Pool;

   function Lower_Bound
     (Element : Discrete_Simple_Expression_Range_Node) return Asis.Expression;

   procedure Set_Lower_Bound
     (Element : in out Discrete_Simple_Expression_Range_Node;
      Value   : in     Asis.Expression);

   function Upper_Bound
     (Element : Discrete_Simple_Expression_Range_Node) return Asis.Expression;

   procedure Set_Upper_Bound
     (Element : in out Discrete_Simple_Expression_Range_Node;
      Value   : in     Asis.Expression);

   function Discrete_Range_Kind (Element : Discrete_Simple_Expression_Range_Node)
      return Asis.Discrete_Range_Kinds;

   function Children (Element : access Discrete_Simple_Expression_Range_Node)
     return Traverse_List;

   function Clone
     (Element : Discrete_Simple_Expression_Range_Node;
      Parent  : Asis.Element)
     return Asis.Element;

   procedure Copy
     (Source : in     Asis.Element;
      Target : access Discrete_Simple_Expression_Range_Node;
      Cloner : in     Cloner_Class;
      Parent : in     Asis.Element);

private


   type Discrete_Subtype_Indication_Node is 
      new Discrete_Range_Node with
      record
         Subtype_Mark                   : aliased Asis.Expression;
         Subtype_Constraint             : aliased Asis.Constraint;
      end record;


   type Discrete_Range_Attribute_Reference_Node is 
      new Discrete_Range_Node with
      record
         Range_Attribute                : aliased Asis.Expression;
      end record;


   type Discrete_Simple_Expression_Range_Node is 
      new Discrete_Range_Node with
      record
         Lower_Bound                    : aliased Asis.Expression;
         Upper_Bound                    : aliased Asis.Expression;
      end record;

end Asis.Gela.Elements.Defs.Rng;
