package Asis.Gela.Elements.Defs.Sub is

   ----------------------------------------
   -- S_Discrete_Subtype_Indication_Node --
   ----------------------------------------

   type S_Discrete_Subtype_Indication_Node is 
      new Discrete_Subtype_Definition_Node with private;

   type S_Discrete_Subtype_Indication_Ptr is
      access all S_Discrete_Subtype_Indication_Node;
   for S_Discrete_Subtype_Indication_Ptr'Storage_Pool use Lists.Pool;

   function Get_Subtype_Mark
     (Element : S_Discrete_Subtype_Indication_Node) return Asis.Expression;

   procedure Set_Subtype_Mark
     (Element : in out S_Discrete_Subtype_Indication_Node;
      Value   : in     Asis.Expression);

   function Subtype_Constraint
     (Element : S_Discrete_Subtype_Indication_Node) return Asis.Constraint;

   procedure Set_Subtype_Constraint
     (Element : in out S_Discrete_Subtype_Indication_Node;
      Value   : in     Asis.Constraint);

   function Discrete_Range_Kind (Element : S_Discrete_Subtype_Indication_Node)
      return Asis.Discrete_Range_Kinds;

   function Children (Element : access S_Discrete_Subtype_Indication_Node)
     return Traverse_List;

   function Clone
     (Element : S_Discrete_Subtype_Indication_Node;
      Parent  : Asis.Element)
     return Asis.Element;

   procedure Copy
     (Source : in     Asis.Element;
      Target : access S_Discrete_Subtype_Indication_Node;
      Cloner : in     Cloner_Class;
      Parent : in     Asis.Element);

   -----------------------------------------------
   -- S_Discrete_Range_Attribute_Reference_Node --
   -----------------------------------------------

   type S_Discrete_Range_Attribute_Reference_Node is 
      new Discrete_Subtype_Definition_Node with private;

   type S_Discrete_Range_Attribute_Reference_Ptr is
      access all S_Discrete_Range_Attribute_Reference_Node;
   for S_Discrete_Range_Attribute_Reference_Ptr'Storage_Pool use Lists.Pool;

   function Range_Attribute
     (Element : S_Discrete_Range_Attribute_Reference_Node) return Asis.Expression;

   procedure Set_Range_Attribute
     (Element : in out S_Discrete_Range_Attribute_Reference_Node;
      Value   : in     Asis.Expression);

   function Discrete_Range_Kind (Element : S_Discrete_Range_Attribute_Reference_Node)
      return Asis.Discrete_Range_Kinds;

   function Children (Element : access S_Discrete_Range_Attribute_Reference_Node)
     return Traverse_List;

   function Clone
     (Element : S_Discrete_Range_Attribute_Reference_Node;
      Parent  : Asis.Element)
     return Asis.Element;

   procedure Copy
     (Source : in     Asis.Element;
      Target : access S_Discrete_Range_Attribute_Reference_Node;
      Cloner : in     Cloner_Class;
      Parent : in     Asis.Element);

   ---------------------------------------------
   -- S_Discrete_Simple_Expression_Range_Node --
   ---------------------------------------------

   type S_Discrete_Simple_Expression_Range_Node is 
      new Discrete_Subtype_Definition_Node with private;

   type S_Discrete_Simple_Expression_Range_Ptr is
      access all S_Discrete_Simple_Expression_Range_Node;
   for S_Discrete_Simple_Expression_Range_Ptr'Storage_Pool use Lists.Pool;

   function Lower_Bound
     (Element : S_Discrete_Simple_Expression_Range_Node) return Asis.Expression;

   procedure Set_Lower_Bound
     (Element : in out S_Discrete_Simple_Expression_Range_Node;
      Value   : in     Asis.Expression);

   function Upper_Bound
     (Element : S_Discrete_Simple_Expression_Range_Node) return Asis.Expression;

   procedure Set_Upper_Bound
     (Element : in out S_Discrete_Simple_Expression_Range_Node;
      Value   : in     Asis.Expression);

   function Discrete_Range_Kind (Element : S_Discrete_Simple_Expression_Range_Node)
      return Asis.Discrete_Range_Kinds;

   function Children (Element : access S_Discrete_Simple_Expression_Range_Node)
     return Traverse_List;

   function Clone
     (Element : S_Discrete_Simple_Expression_Range_Node;
      Parent  : Asis.Element)
     return Asis.Element;

   procedure Copy
     (Source : in     Asis.Element;
      Target : access S_Discrete_Simple_Expression_Range_Node;
      Cloner : in     Cloner_Class;
      Parent : in     Asis.Element);

private


   type S_Discrete_Subtype_Indication_Node is 
      new Discrete_Subtype_Definition_Node with
      record
         Subtype_Mark                   : aliased Asis.Expression;
         Subtype_Constraint             : aliased Asis.Constraint;
      end record;


   type S_Discrete_Range_Attribute_Reference_Node is 
      new Discrete_Subtype_Definition_Node with
      record
         Range_Attribute                : aliased Asis.Expression;
      end record;


   type S_Discrete_Simple_Expression_Range_Node is 
      new Discrete_Subtype_Definition_Node with
      record
         Lower_Bound                    : aliased Asis.Expression;
         Upper_Bound                    : aliased Asis.Expression;
      end record;

end Asis.Gela.Elements.Defs.Sub;
