------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.IO_Devices;
with Qt4.Widgets;
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;
with Qt_Ada.Internals.Objects.Widget_Utilities;

with Qt_Ada.Internals.Objects.Ui_Loader_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Ui_Loader_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Ui_Loaders is

   procedure addPluginPath_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Path : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, addPluginPath_0_wrapper,
                     "__Qt4Ada_QUiLoader_addPluginPath_0_wrapper");

   procedure clearPluginPaths_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clearPluginPaths_0_wrapper,
                     "__Qt4Ada_QUiLoader_clearPluginPaths_0_wrapper");

   function load_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Device : not null access Qt_Ada.Internals.Objects.QObject;
     Parent_Widget : access Qt_Ada.Internals.Objects.QObject)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, load_0_wrapper,
                     "__Qt4Ada_QUiLoader_load_0_wrapper");

   pragma Style_Checks ("N");

   ---------------------
   -- Add_Plugin_Path --
   ---------------------

   procedure Add_Plugin_Path
    (Self : not null access Q_Ui_Loader'Class;
     Path : Qt4.Strings.Q_String)
   is
   begin
      addPluginPath_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Path));
   end Add_Plugin_Path;

   ------------------------
   -- Clear_Plugin_Paths --
   ------------------------

   procedure Clear_Plugin_Paths
    (Self : not null access Q_Ui_Loader'Class)
   is
   begin
      clearPluginPaths_0_wrapper
       (Self.QObject_View);
   end Clear_Plugin_Paths;

   ----------
   -- Load --
   ----------

   function Load
    (Self : not null access Q_Ui_Loader'Class;
     Device : not null access Qt4.IO_Devices.Q_IO_Device'Class;
     Parent_Widget : access Qt4.Widgets.Q_Widget'Class)
       return access Qt4.Widgets.Q_Widget'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Widget_Utilities.Corresponding_Q_Widget
         (load_0_wrapper
           (Self.QObject_View,
            Device.QObject_View,
            Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject (Parent_Widget)));
   end Load;

end Qt4.Ui_Loaders;
