//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QDomAttr>
#include <QDomCDATASection>
#include <QDomComment>
#include <QDomDocumentFragment>
#include <QDomDocumentType>
#include <QDomElement>
#include <QDomEntityReference>
#include <QDomImplementation>
#include <QDomNode>
#include <QDomNodeList>
#include <QDomProcessingInstruction>
#include <QDomText>
#include <QString>
#include "qdomdocumentwrapper.h"

extern "C"
{

    QDomNode* __QtAda_inititialize_QDomDocument(void* storage)
    {
        return new (storage) QDomDocument();
    }

    QDomNode* __QtAda_inititialize_QDomDocument_QStringCR(void* storage, const QString* name)
    {
        return new (storage) QDomDocument(*name);
    }

    QDomNode* __QtAda_inititialize_QDomDocument_QDomDocumentTypeCR(void* storage, const QDomNode* doctype)
    {
        return new (storage) QDomDocument(*static_cast<const QDomDocumentType*>(doctype));
    }

    QDomNode* __QtAda_adjust_QDomDocument(void* storage, const QDomNode* from)
    {
        return new (storage) QDomDocument(*static_cast<const QDomDocument*>(from));
    }

    void __QtAda_finalize_QDomDocument(QDomNode *item)
    {
        static_cast<const QDomDocument*>(item)->~QDomDocument();
    }

    void __QtAda_QDomDocument_createAttribute_QStringCR(QDomNode* returns, QDomNode* self, const QString* name)
    {
        *static_cast<QDomAttr*>(returns) = static_cast<QDomDocument*>(self)->createAttribute(*name);
    }

    void __QtAda_QDomDocument_createAttributeNS_QStringCR_QStringCR(QDomNode* returns, QDomNode* self, const QString* nsURI, const QString* qName)
    {
        *static_cast<QDomAttr*>(returns) = static_cast<QDomDocument*>(self)->createAttributeNS(*nsURI, *qName);
    }

    void __QtAda_QDomDocument_createCDATASection_QStringCR(QDomNode* returns, QDomNode* self, const QString* data)
    {
        *static_cast<QDomCDATASection*>(returns) = static_cast<QDomDocument*>(self)->createCDATASection(*data);
    }

    void __QtAda_QDomDocument_createComment_QStringCR(QDomNode* returns, QDomNode* self, const QString* data)
    {
        *static_cast<QDomComment*>(returns) = static_cast<QDomDocument*>(self)->createComment(*data);
    }

    void __QtAda_QDomDocument_createDocumentFragment(QDomNode* returns, QDomNode* self)
    {
        *static_cast<QDomDocumentFragment*>(returns) = static_cast<QDomDocument*>(self)->createDocumentFragment();
    }

    void __QtAda_QDomDocument_createElement_QStringCR(QDomNode* returns, QDomNode* self, const QString* tagName)
    {
        *static_cast<QDomElement*>(returns) = static_cast<QDomDocument*>(self)->createElement(*tagName);
    }

    void __QtAda_QDomDocument_createElementNS_QStringCR_QStringCR(QDomNode* returns, QDomNode* self, const QString* nsURI, const QString* qName)
    {
        *static_cast<QDomElement*>(returns) = static_cast<QDomDocument*>(self)->createElementNS(*nsURI, *qName);
    }

    void __QtAda_QDomDocument_createEntityReference_QStringCR(QDomNode* returns, QDomNode* self, const QString* name)
    {
        *static_cast<QDomEntityReference*>(returns) = static_cast<QDomDocument*>(self)->createEntityReference(*name);
    }

    void __QtAda_QDomDocument_createProcessingInstruction_QStringCR_QStringCR(QDomNode* returns, QDomNode* self, const QString* target, const QString* data)
    {
        *static_cast<QDomProcessingInstruction*>(returns) = static_cast<QDomDocument*>(self)->createProcessingInstruction(*target, *data);
    }

    void __QtAda_QDomDocument_createTextNode_QStringCR(QDomNode* returns, QDomNode* self, const QString* data)
    {
        *static_cast<QDomText*>(returns) = static_cast<QDomDocument*>(self)->createTextNode(*data);
    }

    void __QtAda_QDomDocument_doctype_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomDocumentType*>(returns) = static_cast<const QDomDocument*>(self)->doctype();
    }

    void __QtAda_QDomDocument_documentElement_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomElement*>(returns) = static_cast<const QDomDocument*>(self)->documentElement();
    }

    void __QtAda_QDomDocument_elementById_QStringCR(QDomNode* returns, QDomNode* self, const QString* elementId)
    {
        *static_cast<QDomElement*>(returns) = static_cast<QDomDocument*>(self)->elementById(*elementId);
    }

    void __QtAda_QDomDocument_elementsByTagName_QStringCR_Q(QDomNodeList* returns, const QDomNode* self, const QString* tagname)
    {
        *returns = static_cast<const QDomDocument*>(self)->elementsByTagName(*tagname);
    }

    void __QtAda_QDomDocument_elementsByTagNameNS_QStringCR_QStringCR(QDomNodeList* returns, QDomNode* self, const QString* nsURI, const QString* localName)
    {
        *returns = static_cast<QDomDocument*>(self)->elementsByTagNameNS(*nsURI, *localName);
    }

    void __QtAda_QDomDocument_implementation_Q(QDomImplementation* returns, const QDomNode* self)
    {
        *returns = static_cast<const QDomDocument*>(self)->implementation();
    }

    void __QtAda_QDomDocument_importNode_QDomNodeCR_bool(QDomNode* returns, QDomNode* self, const QDomNode* importedNode, unsigned deep)
    {
        *returns = static_cast<QDomDocument*>(self)->importNode(*importedNode, (bool)deep);
    }

    unsigned __QtAda_QDomDocument_nodeType_Q(const QDomNode* self)
    {
        return (unsigned)static_cast<const QDomDocument*>(self)->nodeType();
    }

    unsigned __QtAda_QDomDocument_setContent_QStringCR_bool(QDomNode* self, const QString* text, unsigned namespaceProcessing)
    {
        return (unsigned)static_cast<QDomDocument*>(self)->setContent(*text, (bool)namespaceProcessing);
    }

    unsigned __QtAda_QDomDocument_setContent_QIODeviceP_QStringP_intP_intP(QDomNode* self, QObject* dev, QString* errorMsg, int* errorLine, int* errorColumn)
    {
        return (unsigned)static_cast<QDomDocument*>(self)->setContent(dynamic_cast<QIODevice*>(dev), errorMsg, errorLine, errorColumn);
    }

    void __QtAda_QDomDocument_toString_int_Q(QString* returns, const QDomNode* self, int indent)
    {
        *returns = static_cast<const QDomDocument*>(self)->toString(indent);
    }

};

