//------------------------------------------------------------------------------
//--                                                                          --
//--                An Ada2005 binding to the Qt C++ framework                --
//--                                                                          --
//------------------------------------------------------------------------------
//--                                                                          --
//-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//--                                                                          --
//-- QtAda is free software;  you can  redistribute it and/or modify it under --
//-- terms of the  GNU General Public License as published  by the Free Soft- --
//-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
//-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
//-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
//-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
//-- for  more details.  You should have  received  a copy of the GNU General --
//-- Public License distributed with QtAda;  see file COPYING.  If not, write --
//-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
//-- Boston, MA 02110-1301, USA.                                              --
//--                                                                          --
//------------------------------------------------------------------------------
//--  $Revision: 3583 $ $Date: 2009-09-09 08:48:15 +0400 (Wed, 09 Sep 2009) $
//------------------------------------------------------------------------------
#include <iostream>

#include <QtPlugin>

Q_PLUGIN_VERIFICATION_DATA

int main()
{
    int item = 1;

    std::cout << "-----------------------------------------------------------"
	         "-------------------" << std::endl;
    std::cout << "--                                                         "
	         "                 --" << std::endl;
    std::cout << "--                An Ada2005 binding to the Qt C++ framewor"
	         "k                --" << std::endl;
    std::cout << "--                                                         "
	         "                 --" << std::endl;
    std::cout << "-----------------------------------------------------------"
	         "-------------------" << std::endl;
    std::cout << "--                                                         "
	         "                 --" << std::endl;
    std::cout << "-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>     "
	         "                 --" << std::endl;
    std::cout << "--                                                         "
	         "                 --" << std::endl;
    std::cout << "-- QtAda is free software;  you can  redistribute it and/or"
	         " modify it under --" << std::endl;
    std::cout << "-- terms of the  GNU General Public License as published  b"
	         "y the Free Soft- --" << std::endl;
    std::cout << "-- ware  Foundation;  either version 2,  or (at your option"
	         ") any later ver- --" << std::endl;
    std::cout << "-- sion. QtAda is distributed in the hope that it will be u"
	         "seful, but WITH- --" << std::endl;
    std::cout << "-- OUT ANY WARRANTY;  without even the  implied warranty of"
	         " MERCHANTABILITY --" << std::endl;
    std::cout << "-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Genera"
	         "l Public License --" << std::endl;
    std::cout << "-- for  more details.  You should have  received  a copy of"
	         " the GNU General --" << std::endl;
    std::cout << "-- Public License distributed with QtAda;  see file COPYING"
	         ".  If not, write --" << std::endl;
    std::cout << "-- to  the  Free Software Foundation,  51  Franklin  Street"
	         ",  Fifth  Floor, --" << std::endl;
    std::cout << "-- Boston, MA 02110-1301, USA.                             "
	         "                 --" << std::endl;
    std::cout << "--                                                         "
	         "                 --" << std::endl;
    std::cout << "-- As a special exception,  if other files  instantiate  ge"
	         "nerics from this --" << std::endl;
    std::cout << "-- unit, or you link  this unit with other files  to produc"
	         "e an executable, --" << std::endl;
    std::cout << "-- this  unit  does not  by itself cause  the resulting  ex"
	         "ecutable  to  be --" << std::endl;
    std::cout << "-- covered  by the  GNU  General  Public  License.  This ex"
	         "ception does not --" << std::endl;
    std::cout << "-- however invalidate  any other reasons why  the executabl"
	         "e file  might be --" << std::endl;
    std::cout << "-- covered by the  GNU Public License.                     "
	         "                 --" << std::endl;
    std::cout << "--                                                         "
	         "                 --" << std::endl;
    std::cout << "-----------------------------------------------------------"
	         "-------------------" << std::endl;
    std::cout << "--    This file has been generated automatically. Please do"
	         "n't edit it.     --" << std::endl;
    std::cout << "-----------------------------------------------------------"
	         "-------------------" << std::endl;

    std::cout << std::endl;
    std::cout << "package Amoc.Plugin_Verification is" << std::endl;
    std::cout << std::endl;
    std::cout << "   pragma Pure;" << std::endl;
    std::cout << std::endl;
    std::cout << "   type String_Access is access constant String;"
              << std::endl;
    std::cout << "   for String_Access'Storage_Size use 0;" << std::endl;
    std::cout << std::endl;
    std::cout << "   Data_N : aliased constant String" << std::endl;
    std::cout << "     := \"          & Interfaces.C.char (Ada.Characters.L"
                 "atin_1.LF)\";"
              << std::endl;
    std::cout << "   Data_T : aliased constant String" << std::endl;
    std::cout << "     := \"          & Interfaces.C.char (Ada.Characters.L"
                 "atin_1.Nul);\";"
              << std::endl;
    std::cout << "   Data_" << item++ << " : aliased constant String"
              << std::endl;
    std::cout << "     := \"     := \"\"";

    for(int j=0; qt_plugin_verification_data[j]; j++)
    {
        if (qt_plugin_verification_data[j] == '\n')
        {
            std::cout << "\"\"\";" << std::endl;
            std::cout << "   Data_" << item++ << " : aliased constant String"
                      << std::endl;
            std::cout << "     := \"          & \"\"";
        } else
        {
            std::cout << qt_plugin_verification_data[j];
        }
    }

    std::cout << "\"\"\";" << std::endl;
    std::cout << std::endl;
    std::cout << "   Data : constant array (Positive range <>) of "
                 "String_Access" << std::endl;

    for(int j=1, k=1; j<item; j++)
    {
        if (j==1)
        {
            std::cout << "      := (" << k++ << " => Data_" << j << "'Access,"
                      << std::endl;
        } else
        {
            std::cout << "          " << k++ << " => Data_N'Access,"
                      << std::endl;
            std::cout << "          " << k++ << " => Data_" << j << "'Access";

            if (j == item-1)
            {
                std::cout << "," << std::endl;
                std::cout << "          " << k++ << " => Data_T'Access);"
                          << std::endl;
            } else
            {
                std::cout << "," << std::endl;
            }
        }
    }

    std::cout << std::endl;
    std::cout << "end Amoc.Plugin_Verification;" << std::endl;

    return 0;
}
