//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 3764 $ $Date: 2010-10-23 23:13:39 +0400 (Sat, 23 Oct 2010) $
//----------------------------------------------------------------------------
#include <iostream>

#include <QChar>
#include <QByteArray>
#include <QDate>
#include <QDateTime>
#include <QDir>
#include <QFileInfo>
#include <QLine>
#include <QLineF>
#include <QModelIndex>
#include <QPoint>
#include <QPointF>
#include <QProcessEnvironment>
#include <QRectF>
#include <QRegExp>
#include <QSize>
#include <QSizeF>
#include <QString>
#include <QStringList>
#include <QTime>
#include <QUrl>
#include <QVariant>

#include <QBrush>
#include <QColor>
#include <QCursor>
#include <QFont>
#include <QFontInfo>
#include <QFontMetrics>
#include <QIcon>
#include <QImage>
#include <QImageReader>
#include <QImageWriter>
#include <QGradient>
#include <QKeySequence>
#include <QMatrix>
#include <QPainter>
#include <QPainterPath>
#include <QPen>
#include <QPixmap>
#include <QPolygon>
#include <QPolygonF>
#include <QPrinter>
#include <QRegion>
#include <QTextLength>
#include <QTextFormat>
#include <QTextBlockFormat>
#include <QTextCharFormat>
#include <QTextImageFormat>
#include <QTextTableCellFormat>
#include <QTextFrameFormat>
#include <QTextTableFormat>
#include <QTextListFormat>
#include <QTransform>

#include <QDomAttr>
#include <QDomCDATASection>
#include <QDomCharacterData>
#include <QDomComment>
#include <QDomDocument>
#include <QDomDocumentFragment>
#include <QDomDocumentType>
#include <QDomElement>
#include <QDomEntity>
#include <QDomEntityReference>
#include <QDomImplementation>
#include <QDomNamedNodeMap>
#include <QDomNode>
#include <QDomNodeList>
#include <QDomNotation>
#include <QDomProcessingInstruction>
#include <QDomText>

#include <QSqlDatabase>
#include <QSqlError>
#include <QSqlField>
#include <QSqlIndex>
#include <QSqlQuery>
#include <QSqlRecord>

#define MAX(T1,T2) (T1>T2?T1:T2)
#define MAX2(T1,T2) MAX(sizeof(T1),sizeof(T2))
#define MAX3(T1,T2,T3) MAX(MAX2(T1,T2),sizeof(T3))
#define MAX4(T1,T2,T3,T4) MAX(MAX3(T1,T2,T3),sizeof(T4))
#define MAX5(T1,T2,T3,T4,T5) MAX(MAX4(T1,T2,T3,T4),sizeof(T5))
#define MAX6(T1,T2,T3,T4,T5,T6) MAX(MAX5(T1,T2,T3,T4,T5),sizeof(T6))
#define MAX7(T1,T2,T3,T4,T5,T6,T7) MAX(MAX6(T1,T2,T3,T4,T5,T6),sizeof(T7))
#define MAX8(T1,T2,T3,T4,T5,T6,T7,T8) MAX(MAX7(T1,T2,T3,T4,T5,T6,T7),sizeof(T8))
#define MAX9(T1,T2,T3,T4,T5,T6,T7,T8,T9) \
    MAX(MAX8(T1,T2,T3,T4,T5,T6,T7,T8),sizeof(T9))
#define MAX10(T1,T2,T3,T4,T5,T6,T7,T8,T9,T10) \
    MAX(MAX9(T1,T2,T3,T4,T5,T6,T7,T8,T9),sizeof(T10))
#define MAX11(T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11) \
    MAX(MAX10(T1,T2,T3,T4,T5,T6,T7,T8,T9,T10),sizeof(T11))
#define MAX12(T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12) \
    MAX(MAX11(T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11),sizeof(T12))
#define MAX13(T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13) \
    MAX(MAX12(T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12),sizeof(T13))
#define MAX14(T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13,T14) \
    MAX(MAX13(T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13),sizeof(T14))
#define SIZE_FOR(T) \
    std::cout << "   " #T "_C_Size_Of : constant := " \
        << sizeof(T) << ";" << std::endl;
#define SIZE_FOR2(T1,T2) \
    std::cout << "   " #T1 "_C_Size_Of : constant := " \
        << MAX2(T1,T2) \
        << ";" << std::endl;
#define SIZE_FOR8(T1,T2,T3,T4,T5,T6,T7,T8) \
    std::cout << "   " #T1 "_C_Size_Of : constant := " \
        << MAX8(T1,T2,T3,T4,T5,T6,T7,T8) \
        << ";" << std::endl;
#define SIZE_FOR14(T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13,T14) \
    std::cout << "   " #T1 "_C_Size_Of : constant := " \
        << MAX14(T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13,T14) \
        << ";" << std::endl;

int main()
{
    std::cout << "-----------------------------------------------------------"
	         "-------------------" << std::endl;
    std::cout << "--                                                         "
	         "                 --" << std::endl;
    std::cout << "--                An Ada2005 binding to the Qt C++ framewor"
	         "k                --" << std::endl;
    std::cout << "--                                                         "
	         "                 --" << std::endl;
    std::cout << "-----------------------------------------------------------"
	         "-------------------" << std::endl;
    std::cout << "--                                                         "
	         "                 --" << std::endl;
    std::cout << "-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>"
	         "                 --" << std::endl;
    std::cout << "--                                                         "
	         "                 --" << std::endl;
    std::cout << "-- QtAda is free software;  you can  redistribute it and/or"
	         " modify it under --" << std::endl;
    std::cout << "-- terms of the  GNU General Public License as published  b"
	         "y the Free Soft- --" << std::endl;
    std::cout << "-- ware  Foundation;  either version 2,  or (at your option"
	         ") any later ver- --" << std::endl;
    std::cout << "-- sion. QtAda is distributed in the hope that it will be u"
	         "seful, but WITH- --" << std::endl;
    std::cout << "-- OUT ANY WARRANTY;  without even the  implied warranty of"
	         " MERCHANTABILITY --" << std::endl;
    std::cout << "-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Genera"
	         "l Public License --" << std::endl;
    std::cout << "-- for  more details.  You should have  received  a copy of"
	         " the GNU General --" << std::endl;
    std::cout << "-- Public License distributed with QtAda;  see file COPYING"
	         ".  If not, write --" << std::endl;
    std::cout << "-- to  the  Free Software Foundation,  51  Franklin  Street"
	         ",  Fifth  Floor, --" << std::endl;
    std::cout << "-- Boston, MA 02110-1301, USA.                             "
	         "                 --" << std::endl;
    std::cout << "--                                                         "
	         "                 --" << std::endl;
    std::cout << "-- As a special exception,  if other files  instantiate  ge"
	         "nerics from this --" << std::endl;
    std::cout << "-- unit, or you link  this unit with other files  to produc"
	         "e an executable, --" << std::endl;
    std::cout << "-- this  unit  does not  by itself cause  the resulting  ex"
	         "ecutable  to  be --" << std::endl;
    std::cout << "-- covered  by the  GNU  General  Public  License.  This ex"
	         "ception does not --" << std::endl;
    std::cout << "-- however invalidate  any other reasons why  the executabl"
	         "e file  might be --" << std::endl;
    std::cout << "-- covered by the  GNU Public License.                     "
	         "                 --" << std::endl;
    std::cout << "--                                                         "
	         "                 --" << std::endl;
    std::cout << "-----------------------------------------------------------"
	         "-------------------" << std::endl;
    std::cout << "--    This file has been generated automatically. Please do"
	         "n't edit it.     --" << std::endl;
    std::cout << "-----------------------------------------------------------"
	         "-------------------" << std::endl;

    std::cout << std::endl;
    std::cout << "package Qt_Ada.Internals.Value_Class_Sizes is" << std::endl;
    std::cout << "" << std::endl;
    std::cout << "   pragma Pure;" << std::endl;
    std::cout << "" << std::endl;

    SIZE_FOR(QChar)
    SIZE_FOR(QByteArray)
    SIZE_FOR(QDate)
    SIZE_FOR(QDateTime)
    SIZE_FOR(QDir)
    SIZE_FOR(QFileInfo)
    SIZE_FOR(QLine)
    SIZE_FOR(QLineF)
    SIZE_FOR(QModelIndex)
    SIZE_FOR(QPoint)
    SIZE_FOR(QPointF)
    SIZE_FOR(QProcessEnvironment)
    SIZE_FOR(QRect)
    SIZE_FOR(QRectF)
    SIZE_FOR(QRegExp)
    SIZE_FOR(QSize)
    SIZE_FOR(QSizeF)
    SIZE_FOR(QString)
    SIZE_FOR(QStringList)
    SIZE_FOR(QTime)
    SIZE_FOR(QUrl)
    SIZE_FOR(QVariant)

    std::cout << "   QListOfQByteArray_C_Size_Of : constant := "
        << sizeof(QList<QByteArray>) << ";" << std::endl;
    std::cout << "   QListOfQObject_C_Size_Of : constant := "
        << sizeof(QList<QObject*>) << ";" << std::endl;
    std::cout << "   QListOfint_C_Size_Of : constant := "
        << sizeof(QList<int>) << ";" << std::endl;

    std::cout << std::endl;

    SIZE_FOR(QBrush)
    SIZE_FOR(QColor)
    SIZE_FOR(QCursor)
    SIZE_FOR(QFont)
    SIZE_FOR(QFontInfo)
    SIZE_FOR(QFontMetrics)
    SIZE_FOR(QIcon)
    SIZE_FOR(QImage)
    SIZE_FOR(QImageReader)
    SIZE_FOR(QImageWriter)
    SIZE_FOR(QGradient)
    SIZE_FOR(QKeySequence)
    SIZE_FOR(QMatrix)
    SIZE_FOR(QPainter)
    SIZE_FOR(QPainterPath)
    SIZE_FOR(QPen)
    SIZE_FOR(QPixmap)
    SIZE_FOR(QPolygon)
    SIZE_FOR(QPolygonF)
    SIZE_FOR(QPrinter)
    SIZE_FOR(QRegion)
    SIZE_FOR(QTextLength)
    SIZE_FOR8(QTextFormat, QTextBlockFormat, QTextCharFormat, QTextImageFormat, QTextTableCellFormat, QTextFrameFormat, QTextTableFormat, QTextListFormat)
    SIZE_FOR(QTransform)

    std::cout << "   QListOfQKeySequence_C_Size_Of : constant := "
        << sizeof(QList<int>) << ";" << std::endl;

    std::cout << std::endl;

    SIZE_FOR14(QDomNode, QDomAttr, QDomCharacterData, QDomComment, QDomText, QDomCDATASection, QDomDocument, QDomDocumentFragment, QDomDocumentType, QDomElement, QDomEntity, QDomEntityReference, QDomNotation, QDomProcessingInstruction)
    SIZE_FOR(QDomImplementation)
    SIZE_FOR(QDomNamedNodeMap)
    SIZE_FOR(QDomNodeList)

    std::cout << std::endl;

    SIZE_FOR(QSqlDatabase)
    SIZE_FOR(QSqlError)
    SIZE_FOR(QSqlField)
    SIZE_FOR(QSqlQuery)
    SIZE_FOR2(QSqlRecord, QSqlIndex)

    std::cout << std::endl;
    std::cout << "end Qt_Ada.Internals.Value_Class_Sizes;" << std::endl;

    return 0;
}
